<?php

namespace App\Exports;

use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;

use App\Models\StudentAttendance;

class AttendanceConsolidateExport implements FromView
{
    protected $students;
    protected $subjects;
    protected $data;

    /**
     * Constructor to initialize the data.
     *
     * @param array $students
     * @param array $subjects
     * @param array $data
     */
    public function __construct($students, $subjects, $data)
    {
        $this->students = $students;
        $this->subjects = $subjects;
        $this->data = $data;
    }
    
    /**
     * Returns the view for the Excel export.
     *
     * @return View
     */
    
    public function view(): View
    {
        return view('student-attendance.export-consolidate', [
            'students' => $this->students,
            'subjects' => $this->subjects,
            'data'     => $this->data,
        ]);
    }
}
