<?php
namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Auth;

use App\Models\User;
use App\Models\UserType;
use App\Models\Course;
use App\Models\Semester;
use App\Models\Promote;
use App\Models\Student;
use App\Models\ClassTeacher;


use DB;

class Logins extends Controller
{
    public function student(Request $request){
        
        try{
             $acyearId = getAcyear();
            $user = Auth::user();
            $userId = $user->user_id;
            $uType = $user->type_id;
            if(in_array($uType, [1,2,13])) {
            $courses = Course::all();
            $courseId = $request->course ?? null;
            $semesters = [];
            if($courseId!=null){
                $semesters = Semester::where('course_id', $courseId)->get();
            }
            $semesterId = $request->semester ?? null;
            $acyearId = getAcyear();
            $students = collect();
            if($courseId!=null && $semesterId!=null){
                $students = Promote::join('students','promotes.student_id','=','students.student_id')
                               ->where('promotes.ac_id',$acyearId)
                               ->where('promotes.course_id',$courseId)
                               ->where('promotes.semester_id',$semesterId)
                               ->where('students.tcstatus','0')
                               ->select('students.*')
                               ->groupBy('promotes.student_id')
                               ->get();
            }
        //         if ($uType != 1 || $uType != 2 || $uType != 13 ) {
        //     return redirect()->route('home')->withErrors('Permission Denied');
        // }

        }
        
        else {
                $courses = ClassTeacher::join('courses', 'classteacher.course_id', '=', 'courses.course_id')->where('classteacher.ac_id', $acyearId)->where('classteacher.user_id', $userId)->select('courses.*')->groupBy('classteacher.course_id')->get();
        if($courses->count() > 0){
                    $courseId = $request->course ?? null;
                    $semesters = [];
                    if($courseId!=null){
     $semesters = ClassTeacher::join('semesters', 'classteacher.semester_id', '=', 'semesters.semester_id')
                        ->where('classteacher.ac_id', $acyearId)
                        ->where('classteacher.user_id', $userId)
                        ->where('semesters.course_id', $courseId) 
                        ->select('semesters.*')
                        ->groupBy('classteacher.semester_id')
                        ->get();
                    }
        }
       $semesterId = $request->semester ?? null;
       $acyearId = getAcyear();
            $students = collect();
                      if($courseId!=null && $semesterId!=null){
                          
                            $semesterAssigned = ClassTeacher::where('classteacher.ac_id', $acyearId)
                    ->where('classteacher.user_id', $userId)
                    ->where('classteacher.course_id', $courseId)
                    ->where('classteacher.semester_id', $semesterId)
                    ->exists();
                       if (!$semesterAssigned) {
                    return back()->withErrors('Access denied');
                }    
                          
                $students = Promote::join('students','promotes.student_id','=','students.student_id')
                               ->where('promotes.ac_id',$acyearId)
                               ->where('promotes.course_id',$courseId)
                               ->where('promotes.semester_id',$semesterId)
                               ->where('students.tcstatus','0')
                               ->select('students.*')
                               ->groupBy('promotes.student_id')
                               ->get();
            }
  
        }
            return view('logins.student',compact('courses', 'courseId', 'semesters', 'semesterId', 'students'));
        } catch (\Exception $e) {
            Log::error('Failed to fetch Students: '.$e->getMessage());
            return back()->withErrors('Failed to load Students.');
        }
    }
    
    public function print_student(Request $request)
    {
        try{
            $ins_det = instituteDetails();
            $courseId = $request->course ?? null;
            $semesterId = $request->semester ?? null;
            if($courseId!=null && $semesterId!=null){
                $course = Course::find($courseId);
                $semester = Semester::find($semesterId);
                $acyearId = getAcyear();
                $students = Promote::join('students','promotes.student_id','=','students.student_id')
                                ->leftJoin('student_log','students.student_id','=','student_log.student_id')
                                ->where('promotes.ac_id',$acyearId)
                                ->where('promotes.course_id',$courseId)
                                ->where('promotes.semester_id',$semesterId)
                                ->where('students.tcstatus','0')
                                ->select('students.*','student_log.password as pwd')
                                ->groupBy('promotes.student_id')
                                ->get();
            
                return view('logins.print_student',compact('course', 'semester', 'students', 'ins_det'));
            }else{
                return back()->with(['message' => 'Invalid Course or Semester', 'alert-type' => 'error']);
            }
        } catch (\Exception $e) {
            Log::error('Failed to fetch Student Details: '.$e->getMessage());
            return back()->with(['message' => 'Failed to load Student Details.', 'alert-type' => 'error']);
        }
    }
    
    public function edit_student(Request $request){
        
        try{
            $studentId = $request->student_id ? decrypt($request->student_id):null;
            $courseId = $request->course ?? null;
            $semesterId = $request->semester ?? null;
            if($studentId!=null && $courseId!=null && $semesterId!=null){
                $student = Student::findOrFail($studentId);
                
                return view('logins.edit_student',compact('student', 'courseId', 'semesterId'));
            }else{
                return back()->with(['message' => 'Invalid Data.', 'alert-type' => 'error']);
            }
        } catch (\Exception $e) {
            Log::error('Failed to fetch Staff Details: '.$e->getMessage());
            return back()->with(['message' => 'Failed to load Student Details.', 'alert-type' => 'error']);
        }
    }
    
    public function update_student(Request $request, $sid)
    {
        $validated = $request->validate([
                'password' => ['required', 'confirmed'],
            ]);
            
        try {  
            $student = Student::findOrFail(decrypt($sid));
            $updated = $student->update(['password' => bcrypt($validated['password'])]);
            if($updated){
                DB::table('student_log')->updateOrInsert(['student_id' => decrypt($sid)], ['password' => $validated['password']]);
                
                $msg_array = array('message'=>'Student Password Updated Successfully !','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Student Password Could not be Updated !','alert-type'=>'error');
            }
        } catch (\Exception $e) {
            Log::error('Student Password update failed: '.$e->getMessage());
            $msg_array = array('message'=>'Student Password Could not be Updated !','alert-type'=>'error');
        }
        
        return redirect()->route('logins.student',['course' => $request->course, 'semester' => $request->semester])->with($msg_array);
    }
    
    public function block_student(Request $request){
        
        try{
            $studentId = $request->student_id ? decrypt($request->student_id):null;
            $status = $request->status ?? null;
            $courseId = $request->course ?? null;
            $semesterId = $request->semester ?? null;
            if($studentId!=null && $courseId!=null && $semesterId!=null){
                $student = Student::find($studentId);
                $updated = $student->update(['status' => $status]);
                if($updated){
                    $msg_array = array('message'=>'Student Status Updated Successfully !','alert-type'=>'success');
                }else{
                    $msg_array = array('message'=>'Student Status Could not be Updated !','alert-type'=>'error');
                }
                return redirect()->route('logins.student',['course' => $courseId, 'semester' => $semesterId])->with($msg_array);
            }else{
                return back()->with(['message' => 'Invalid Data.', 'alert-type' => 'error']);
            }
        } catch (\Exception $e) {
            Log::error('Failed to fetch Student Details: '.$e->getMessage());
            return back()->withErrors('Failed to load Student Details.');
        }
   }
    
    public function staff(Request $request){
        
        try{
            $types = UserType::all();
            $typeId = $request->type ?? null;
            
            $query = User::query();
            if($typeId!=null){
                $query->where('type_id', $typeId);
            }
            $staffs = $query->get();
            
            return view('logins.staff',compact('types', 'typeId', 'staffs'));
        } catch (\Exception $e) {
            Log::error('Failed to fetch Staff Logins: '.$e->getMessage());
            return back()->withErrors('Failed to load Staff Logins.');
        }
    }
    
    public function edit_staff($sid){
        
        try{
            $staff = User::find(decrypt($sid));
            
            return view('logins.edit_staff',compact('staff'));
        } catch (\Exception $e) {
            Log::error('Failed to fetch Staff Details: '.$e->getMessage());
            return back()->withErrors('Failed to load Staff Details.');
        }
    }
   
    public function update_staff(Request $request, $sid)
    {
        $validated = $request->validate([
                'password' => ['required', 'confirmed'],
            ]);
            
        try {    
            $staff = User::findOrFail(decrypt($sid));
            $updated = $staff->update(['password' => bcrypt($validated['password'])]);
            if($updated){
                DB::table('user_log')->updateOrInsert(['user_id' => decrypt($sid)], ['password' => $validated['password']]);
                
                $msg_array = array('message'=>'Staff Password Updated Successfully !','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Staff Password Could not be Updated !','alert-type'=>'error');
            }
        } catch (\Exception $e) {
            Log::error('Staff Password update failed: '.$e->getMessage());
            $msg_array = array('message'=>'Staff Password Could not be Updated !','alert-type'=>'error');
        }
        
        return redirect()->route('logins.staff')->with($msg_array);
    }
    
    public function block_staff($sid, $status){
        
        try{
            $staff = User::find(decrypt($sid));
            $updated = $staff->update(['status' => $status]);
            if($updated){
                $msg_array = array('message'=>'Staff Status Updated Successfully !','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Staff Status Could not be Updated !','alert-type'=>'error');
            }
            return redirect()->route('logins.staff')->with($msg_array);
        } catch (\Exception $e) {
            Log::error('Failed to fetch Staff Details: '.$e->getMessage());
            return back()->withErrors('Failed to load Staff Details.');
        }
   }
   
    public function print_staff(Request $request)
    {
        try{
            $ins_det = instituteDetails();
            $type = $request->type ?? null;
            $query = User::leftJoin('user_log','users.user_id','=','user_log.user_id');
            if($type!=null){
                $query->where('type_id', $type);
            }
            $staffs = $query->select('users.*','user_log.password as pwd')->get();
            
            return view('logins.print_staff',compact('staffs','ins_det'));
        } catch (\Exception $e) {
            Log::error('Failed to fetch Staff Details: '.$e->getMessage());
            return back()->withErrors('Failed to load Staff Details.');
        }
    }
}