<?php
namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Auth;
use App\Models\User;
use App\Models\UserType;
use App\Models\Course;
use App\Models\Semester;
use App\Models\Promote;
use App\Models\Student;
use App\Models\ClassTeacher;
use App\Models\NotificationStudent;
use App\Models\StaffSubject;



use DB;

class Notification extends Controller
{
    public function notification()
    {
    try {
    $acyearId = getAcyear();
    $user = Auth::user();
    $userId = $user->user_id;
    $uType = $user->type_id;

    $courses = [];
    $semesters = [];
    $courseId = $request->course ?? null;
    $semesterId = $request->semester ?? null;

    if ($uType == 17) {
        $departmentId = $user->dept_id;
        $courses = Course::where('department_id', $departmentId)->get();
    } 
    else if (in_array($uType, [1, 2, 13])) {
        $courses = Course::all(); 
    }
    else if(in_array($uType, [12, 20, 21,36])){
         $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $acyearId)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
    }

    if ($courseId != null) {
        $semesters = Semester::where('course_id', $courseId)->get();
    }

    return view('notification.student', compact('courses', 'courseId', 'semesters', 'semesterId','uType'));

} 

       catch (\Exception $e) {
            Log::error('Failed to fetch Students: '.$e->getMessage());
            return back()->withErrors('Failed to load Students.');
        } 
         
    }
    public function notification_send(Request $request)
{
    $request->validate([
    'course' => 'required|string', 
    'semester' => 'nullable|exists:semesters,semester_id',
    'notification' => 'required|string',
]);

$userId = Auth::id();
$ac_id = getAcyear();
$date = today();
$courseId = $request->course;  
$semesterId = $request->semester;


if ($courseId == "all") {
    $courseId = 0;  
    $semesterId = 0; 

    $notification = NotificationStudent::create([
        'course_id' => $courseId,
        'semester_id' => $semesterId,
        'ac_id' => $ac_id,
        'notification' => $request->notification,
        'user_id' => $userId,
        'date' => $date,
    ]);
} else {
  
    if ($semesterId) {
        $notification = NotificationStudent::create([
            'course_id' => $courseId,
            'semester_id' => $semesterId,
            'ac_id' => $ac_id,
            'notification' => $request->notification,
            'user_id' => $userId,
            'date' => $date,
        ]);
    } else {
        $semesters = Semester::where('course_id', $courseId)->get();
        foreach ($semesters as $semester) {
            NotificationStudent::create([
                'course_id' => $courseId,
                'semester_id' => $semester->semester_id,
                'ac_id' => $ac_id,
                'notification' => $request->notification,
                'user_id' => $userId,
                'date' => $date,
            ]);
        }
        $notification = true;  
    }
}

if ($notification) {
    $msg_array = ['Message' => 'Message submitted successfully!', 'status' => 'success'];
} else {
    $msg_array = ['Message' => 'Message could not submit!', 'status' => 'error'];
}

return redirect()->back()->with($msg_array);

}


//     {
       
//          $request->validate([
//             'course' => 'required|exists:courses,course_id',
//              'semester' => 'nullable|exists:semesters,semester_id',
//             'notification' => 'required|string',
//         ]);
//         $userId=Auth::id();
//         $ac_id=getAcyear();
//         $date=today();
//         $courseId = $request->course;
//         $semesterId = $request->semester;
//         if ($courseId == "all") {
//     $courseId = 0; 
//     $semesterId = 0; 
//     $notification = NotificationStudent::create([
//         'course_id' => $courseId,
//         'semester_id' => $semesterId,
//         'ac_id' => $ac_id,
//         'notification' => $request->notification,
//         'user_id' => $userId,
//         'date' => $date,
//     ]);
// } 
// else
// {
    

//     if ($semesterId) {
//         $notification = NotificationStudent::create([
//             'course_id' => $courseId,
//             'semester_id' => $semesterId,
//             'ac_id' => $ac_id,
//             'notification' => $request->notification,
//             'user_id' => $userId,
//             'date'=>$date
//         ]);
//     } 

//     else {
//         $semesters = Semester::where('course_id', $courseId)->get();
//         foreach ($semesters as $semester) {
//             NotificationStudent::create([
//                 'course_id' => $courseId,
//                 'semester_id' => $semester->semester_id,
//                 'ac_id' => $ac_id,
//                 'notification' => $request->notification,
//                 'user_id' => $userId,
//                 'date'=>$date
//             ]);
//         }
//         $notification = true; 
//     }
// } 
//      if ($notification) {
//         $msg_array = ['Message' => 'Notification submitted successfully!', 'status' => 'success'];
//     } else {
//         $msg_array = ['Message' => 'Notification could not submit!', 'status' => 'error'];
//     }

//     return redirect()->back()->with($msg_array);
    
    
//         }
    
    
    
    
}