<?php
namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Auth;
use App\Models\User;
use App\Models\Course;
use App\Models\Semester;
use App\Models\Subject;
use App\Models\Questionbank;
use App\Models\HOD;
use App\Models\Lessonplanner;
use App\Models\StaffSubject;
use App\Models\Chapters;
use App\Models\Lessonplannernewhour;


use DB;

class QBANK extends Controller
{
    public function questionbank()
    {
      
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           { 
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $staffsubject = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
      return view('questionbank.questionbank',compact('staffsubject'));
    }
    
    
    public function questionbank_save(Request $request)
    {
     
        $validated = $request->validate([
            'course_id' => 'required',
            'semester_id' => 'required',
            'subject_id'=>'required',
         'questions'=>'required',
            ]);
       $acyear=getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
     $questions="";
       if($request->hasFile('questions')){
            $file = $request->questions;
            $ext = $file->extension();
            $questions = 'questions_'.time().'.'.$ext;
            
            $file->storeAs('staff/questions',$questions);
        }
        $questionbank = Questionbank::create([
            'ac_id'=>$acyear,
            'course_id' =>$request->course_id,
            'semester_id' => $request->semester_id,
            'subject_id' => $request->subject_id,
            'user_id'=>$userId,
            'file' => $questions,
        ]);
         if($questionbank){
            $msg_array = array('message' => 'Questions Uploaded Successfully !', 'alert-type' => 'success');
        }else{
            $msg_array = array('message' => 'Questions Could not upload !', 'alert-type' => 'error');
        }
        return redirect()->route('questionbank')->with($msg_array); 
    }
    public function questionbank_report()
        {
      
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           { 
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $staffsubject = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
      return view('questionbank.report',compact('staffsubject'));
    }
public function questionbank_report_get(Request $request)
{
    
    $courseId=$request->course;
    $semId=$request->semester_id;
    $subId=$request->sub;
    $acId=getAcyear();
    $query=Questionbank::join('courses','courses.course_id','=','question_bank.course_id')->join('semesters','semesters.semester_id','=','question_bank.semester_id')
    ->join('subjects','subjects.subject_id','=','question_bank.subject_id')
    ->where('question_bank.ac_id',$acId)
    ->where('question_bank.course_id',$courseId)
    ->where('question_bank.semester_id',$semId);
    if(!empty($subId))
    {
       $query->where('question_bank.subject_id',$subId); 
    }
    $questionbanks=$query->select('subjects.subject_name','courses.course_name','semesters.semester_name','question_bank.file')->get();
    
    //  ->select('subjects.subject_name','courses.course_name','semesters.semester_name','question_bank.file')
    //  ->get();
     return view('questionbank.questionbank_report_get',compact('questionbanks'));
   
}
public function lessonplanner()
{
     $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           { 
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $staffsubject = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
       if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
       {
           
     
       $lessonplanner=Lessonplanner::join('courses','courses.course_id','=','lesson_planner.course_id')
       ->join('semesters','semesters.semester_id','=','lesson_planner.semester_id')
       ->join('subjects','subjects.subject_id','=','lesson_planner.subject_id')
       ->join('users','users.user_id','=','lesson_planner.user_id')
       ->select('courses.course_name','semesters.semester_name','users.name','lesson_planner.topic','lesson_planner.hours','subjects.subject_name')
       ->get();
       }
       else
       {
            
              $lessonplanner=Lessonplanner::join('courses','courses.course_id','=','lesson_planner.course_id')
       ->join('semesters','semesters.semester_id','=','lesson_planner.semester_id')
       ->join('subjects','subjects.subject_id','=','lesson_planner.subject_id')
       ->join('users','users.user_id','=','lesson_planner.user_id')
      ->where('lesson_planner.user_id',$userId)
       ->select('courses.course_name','semesters.semester_name','users.name','lesson_planner.topic','lesson_planner.hours','subjects.subject_name')
       ->get();
       }
       
      return view('questionbank.lessonplanner',compact('staffsubject','lessonplanner'));
}



public function lessonplanner_save(Request $request)
{
    $request->validate([
        'course_id' => 'required',
        'semester_id' => 'required',
        'subject_id' => 'required',
        'chapter' => 'array',
        'chapter.*' => 'string',
        'topic' => 'array',
        'topic.*' => 'array',  
        'hours' => 'array',
        'hours.*' => 'array',  
    ]);

    $ac_id = getAcyear();
    $user = Auth::user();
    $userId = $user->user_id;
    $date = today();
    
    $course_id = $request->input('course_id');
    $semester_id = $request->input('semester_id');
    $subject_id = $request->input('subject_id');
    $saved = 0;

    if ($course_id && $semester_id && $subject_id) {
        foreach ($request->input('chapter') as $i => $chapter) {
            if ($chapter) {
                DB::table('chapters')->insert([
                    'course_id' => $course_id,
                    'semester_id' => $semester_id,
                    'subject_id' => $subject_id,
                    'chapter_name' => $chapter,
                    'user_id' => $userId,
                    'ac_id' => $ac_id,
                ]);

                $chapter_id = DB::getPdo()->lastInsertId();
                $saved++;

                $topics = $request->input("topic.{$i}");
                $hours = $request->input("hours.{$i}");

                if ($topics && $hours) {
                    foreach ($topics as $index => $topic) {
                        if ($topic && isset($hours[$index]) && $hours[$index]) {
                            DB::table('lesson_planner')->insert([
                                'course_id' => $course_id,
                                'semester_id' => $semester_id,
                                'subject_id' => $subject_id,
                                'chapter_id' => $chapter_id,
                                'topic' => $topic,
                                'hours' => $hours[$index],
                                'user_id' => $userId,
                                'date' => $date,
                                'ac_id' => $ac_id,
                            ]);
                        }
                    }
                }
            }
        }
    }

    if ($saved > 0) {
        return redirect()->back()->with('success', 'Chapter has been added successfully!');
    } else {
        return redirect()->back()->with('error', 'Chapter could not be added!');
    }
}

public function lessonplanner_report()
{
    $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           { 
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $staffsubject = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
      return view('questionbank.lessonplanner_report',compact('staffsubject')); 
}
   public function lessonplanner_report_get(Request $request)
   {
     $course=$request->course;
     $sem=$request->sem;
     $sub=$request->sub;
     
     $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
     
      if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
       {
           
     
       $lessonplanner=Lessonplanner::join('courses','courses.course_id','=','lesson_planner.course_id')
       ->join('semesters','semesters.semester_id','=','lesson_planner.semester_id')
       ->join('subjects','subjects.subject_id','=','lesson_planner.subject_id')
       ->join('users','users.user_id','=','lesson_planner.user_id')
       ->join('chapters','chapters.id','=','lesson_planner.chapter_id')
       ->where('lesson_planner.course_id',$course)
       ->where('lesson_planner.semester_id',$sem)
       ->where('lesson_planner.subject_id',$sub)
        ->where('lesson_planner.ac_id',$ac_id)
       ->select('courses.course_name','semesters.semester_name','users.name','lesson_planner.topic','lesson_planner.hours','subjects.subject_name','chapters.chapter_name')
       ->get();
       }
       else
       {
            
              $lessonplanner=Lessonplanner::join('courses','courses.course_id','=','lesson_planner.course_id')
       ->join('semesters','semesters.semester_id','=','lesson_planner.semester_id')
       ->join('subjects','subjects.subject_id','=','lesson_planner.subject_id')
       ->join('users','users.user_id','=','lesson_planner.user_id')
        ->join('chapters','chapters.id','=','lesson_planner.chapter_id')
      ->where('lesson_planner.user_id',$userId)
      ->where('lesson_planner.course_id',$course)
       ->where('lesson_planner.semester_id',$sem)
       ->where('lesson_planner.subject_id',$sub)
        ->where('lesson_planner.ac_id',$ac_id)
       ->select('courses.course_name','semesters.semester_name','users.name','lesson_planner.topic','lesson_planner.hours','subjects.subject_name','chapters.chapter_name')
       ->get();
       }
           return view('questionbank.lessonplanner_report_get',compact('lessonplanner')); 
  
       
   }
   public function lessonplanner_add()
   {
     
      
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           { 
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $staffsubject = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
      return view('questionbank.lessonplanner_add',compact('staffsubject'));
      
   }
   
   public function get_chapter(Request $request)
{
    $sem = $request->sem;
    $course = $request->course;
    $sub = $request->sub;

    $chapter = [];
    $rows = Chapters::where('course_id', $course)
                    ->where('semester_id', $sem)
                    ->where('subject_id', $sub)
                    ->get();

    if ($rows->isEmpty()) {
        return response()->json(['message' => 'No chapters found'], 404);
    }

    foreach ($rows as $row) {
        $chapter[$row->id] = $row->chapter_name;
    }

    return response()->json($chapter);
}

public function get_add_planner(Request $request)
{
  
  $course=$request->course;  
  $sem=$request->sem; 
  $sub=$request->sub; 
  $chapter=$request->chapter;
   $user = Auth::user(); 
       $userId = $user->user_id; 
       $ac_id=getAcyear();
    if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
    {
        
    
 $lessonplanner=Lessonplanner::join('chapters','chapters.id','=','lesson_planner.chapter_id')
  ->join('users','users.user_id','=','lesson_planner.user_id')
  ->leftJoin('newhours_lessonplanner', 'newhours_lessonplanner.lesson_planner_id', '=', 'lesson_planner.id')
 ->where('lesson_planner.chapter_id',$chapter)
 ->where('lesson_planner.course_id',$course)
 ->where('lesson_planner.semester_id',$sem)
 ->where('lesson_planner.subject_id',$sub)
 ->select('lesson_planner.topic','lesson_planner.hours','users.name','lesson_planner.id','newhours_lessonplanner.new_hours','newhours_lessonplanner.ac_id')
 ->get();
    }
    else
    {
       $lessonplanner=Lessonplanner::join('chapters','chapters.id','=','lesson_planner.chapter_id')
       ->join('users','users.user_id','=','lesson_planner.user_id')
        ->leftJoin('newhours_lessonplanner', 'newhours_lessonplanner.lesson_planner_id', '=', 'lesson_planner.id')
 ->where('lesson_planner.chapter_id',$chapter)
 ->where('lesson_planner.course_id',$course)
 ->where('lesson_planner.semester_id',$sem)
 ->where('lesson_planner.subject_id',$sub)
 ->where('lesson_planner.user_id',$userId)
 ->select('lesson_planner.topic','lesson_planner.hours','users.name','lesson_planner.id','newhours_lessonplanner.new_hours','newhours_lessonplanner.ac_id')
 ->get(); 
    }


  return view('questionbank.get_add_planner',compact('lessonplanner','course','sem','sub','chapter','userId','ac_id'));
}
public function get_add_planner_save(Request $request)
{
    
   
    $lessonplannerIds = $request->lessonplanner; 
    $newHours = $request->newhours; 
    $postedIds = $request->posted; 
$ac_id=getAcyear();
$user = Auth::user(); 
       $userId = $user->user_id; 
       
    foreach ($lessonplannerIds as $index => $lessonplannerId) {
        if (in_array($lessonplannerId, $postedIds)) {
            if (isset($newHours[$index]) && !is_null($newHours[$index])) {
               $existingLesson = Lessonplannernewhour::where('lesson_planner_id', $lessonplannerId)->first();
                if ($existingLesson) {
                $updated=$existingLesson->update([
                    'new_hours' => $newHours[$index], 
                ]);
            
               if($updated)
    {
        $msg_array=array('message'=>'Lesson planner hours updated successfully!','success');
    }
    else
    {
        $msg_array=array('message'=>'Lesson planner hours could not update!','error');
    }     
                    
                }
            else {
                $newlesson=Lessonplannernewhour::create([
                    'lesson_planner_id' => $lessonplannerId,
                    'new_hours' => $newHours[$index], 
                    'ac_id' => $ac_id,
                    'user_id' => $userId,
                    'status'=>0,
                ]);
              if($newlesson)
    {
        $msg_array=array('message'=>'Lesson planner hours added successfully!','success');
    }
    else
    {
        $msg_array=array('message'=>'Lesson planner hours could not add!','error');
    }     
           
           
            }
               

            }
        }
    }
    

    return redirect()->route('lessonplanner.add')->with($msg_array);
}

    
 public function lessonplanner_newhrs_report(Request $request)
 
     {
      
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           { 
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $staffsubject = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
      return view('questionbank.lessonplanner_newhrs_report',compact('staffsubject'));
      
     }

   public function lessonplanner_newhrs_report_get(Request $request)
   {
     $course=$request->course;  
  $sem=$request->sem; 
  $sub=$request->sub; 
  $chapter=$request->chapter;
   $user = Auth::user(); 
       $userId = $user->user_id; 
       $ac_id=getAcyear();
    // if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
    // {
      $newhrslessonplanner=Lessonplannernewhour::join('lesson_planner','lesson_planner.id','=','newhours_lessonplanner.lesson_planner_id')
      ->where('newhours_lessonplanner.ac_id',$ac_id)
      ->where('lesson_planner.course_id',$course)
      ->where('lesson_planner.semester_id',$sem)
       ->where('lesson_planner.subject_id',$sub)
         ->where('lesson_planner.chapter_id',$chapter)
      ->select('lesson_planner.topic','newhours_lessonplanner.new_hours','newhours_lessonplanner.id','newhours_lessonplanner.remarks','newhours_lessonplanner.status')
      ->get();
    // }
    // else
    // {
        
    // }
    
    return view('questionbank.lessonplanner_newhrs_report_get',compact('newhrslessonplanner','course','sem','sub','chapter','userId','ac_id'));
   }
    
    
public function lessonplanner_newhrs_report_save(Request $request)
{
    
       $user = Auth::user(); 
       $userId = $user->user_id;
    $postedLessons = $request->posted; 
    $remarks = $request->remarks;

    if ($postedLessons && count($postedLessons) > 0) {
        foreach ($postedLessons as $index => $lessonId) {
            $lesson = Lessonplannernewhour::find($lessonId); 
            
            if ($lesson) {
                $lesson->completed_by = $userId;
                $lesson->status = 1; 
                $lesson->remarks = $remarks[$index];
                $lesson->save();
            }
        }
    }
if($lesson)
{
    $msg_array=array('message'=>'Chapters marked as completed','success');
}
else
{
    $msg_array=array('message'=>'Chapters could not mark','error');
}
    return redirect()->back()->with($msg_array);

}

    


   
   
   
}