<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Course;
use App\Models\Semester;
use App\Models\Student;
use App\Models\Studentleavetype;
use App\Models\StudentAttendance;
use App\Models\Acyear;
use App\Models\Subject;
use App\Models\RollOutStudents;
use App\Models\SemesterYear;
use App\Models\Promote;
use App\Models\Timetable;
use App\Models\AcHoliday;

 
use Carbon\Carbon;
 
class Attendance extends Controller
{
    
    public function student_attendance()
    {
        $course=Course::all();
        return view('Attendance.student_attendance',compact('course'));
    }
    
   public function student_attendance_get(Request $request)
   {
    
    $course = Course::find($request->tid);
    $sem = Semester::find($request->did);
    $sub=Subject::find($request->sub);
    $month = $request->input('month');
    
    
    
    
    
 
    $year = date('Y', strtotime($month));
    $month = date('m', strtotime($month));

    $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
    $current_academic_year_id = $cur_acyear->ac_id;
$ac_id= $cur_acyear->ac_id;
    $student = Student::join('promotes', 'students.student_id', '=', 'promotes.student_id')
        ->where('promotes.ac_id', $current_academic_year_id)
        ->where('promotes.course_id', $request->tid)
        ->where('promotes.semester_id', $request->did)
        ->get();

    $studentleav = Studentleavetype::all();
    
  
    $startOfMonth = \Carbon\Carbon::create($year, $month, 1);
    
    
    $daysInMonth = $startOfMonth->daysInMonth;
 
   
    $dates = [];
    for ($i = 1; $i <= $daysInMonth; ++$i) {
        $dates[] = $startOfMonth->copy()->day($i)->format('Y-m-d');
    } 

    $absences = StudentAttendance::whereMonth('date', $month)
        ->whereYear('date', $year)
        ->where('subject_id',$sub->subject_id)
        ->get()
        ->groupBy('student_id');
 
    $attendanceStatus = [];
    foreach ($absences as $studentId => $attendances) {
        foreach ($attendances as $attendance) {
            $attendanceStatus[$studentId][$attendance->date] = [
                'am' => $attendance->am,
                'pm' => $attendance->pm,
                'subject_id' => $attendance->subject_id,
                'stuleav_id'=>$attendance->stuleav_id,
            ];
        }
    }


    $acholiday=AcHoliday::where('student','1')->get();
    return view('Attendance.student_attendance_get', compact('acholiday','ac_id','course', 'sem','sub','month', 'student', 'studentleav', 'absences', 'attendanceStatus', 'dates'));

 
       
       
   }
    

    
public function student_attendance_save(Request $request)
{
    $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
$ac_id = $cur_acyear->ac_id;
$data = $request->all();

if (!isset($data['attendance']) || !is_array($data['attendance'])) {
    return redirect()->back()->withErrors('Invalid attendance data.');
}

$course = $data['course_id'];
$sem = $data['semester_id'];
$sub = $data['subject_id'];
$studentId = $data['student_id'];
$dates = $data['attendance'];
$i=0;
foreach ($studentId as $students) {
    if (isset($dates[$students])) {
        foreach ($dates[$students] as $date => $status) {
            
            $existingattendance = StudentAttendance::where('student_id', $students)
                ->where('date', $status)
                ->where('subject_id', $sub)
                ->first();
            
            if ($existingattendance) {
                continue;
            }

            $dayOfWeek = \Carbon\Carbon::parse($status)->format('l');
        
            $timetable = Timetable::join('periods','periods.id','=','timetable.period_id')
            ->where('timetable.subject_id', $sub)
                ->where('timetable.course', $course)
                ->where('timetable.semester', $sem)
                ->where('timetable.acyear', $ac_id)
                ->where('timetable.day_of_week', $dayOfWeek)
                ->first();
              
            if ($timetable && !$existingattendance) {
                
                $period_id = $timetable->period_id;

                $attendance = new StudentAttendance();
                $attendance->course_id = $course;
                 $attendance->ac_id = $ac_id;
                $attendance->semester_id = $sem;
                $attendance->subject_id = $sub;
                $attendance->date = $status;
                $attendance->student_id = $students;
                $attendance->period_id = $period_id;
                $attendance->month = \Carbon\Carbon::parse($status)->format('m');
                $attendance->year = \Carbon\Carbon::parse($status)->format('Y');
                
                $attendance->save();
                $i++;
            }
        }
    }
}
if($i>0)
{
    return redirect()->back()->with('message', 'Student Attendance Marked Successfully!');

}
else
{
     return redirect()->back()->with('message', 'Attendance Could not  Marked'); 
}

    
}
    
  public function student_absent_save(Request $request)
{
    
$am = 0;
$pm = 0;
$amChecked = $request->amChecked; 
$pmChecked = $request->pmChecked;
$course = $request->course;
$cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
$ac_id = $cur_acyear->ac_id;
$sem = $request->sem;
$sub = $request->sub;
$student_id = $request->studentId;
$absentDate = $request->absentDate;
$dayOfWeek = \Carbon\Carbon::parse($absentDate)->format('l');
$convertedDate = Carbon::createFromFormat('d-m-Y', $absentDate)->format('Y-m-d');

$timetable = Timetable::join('periods', 'periods.id', '=', 'timetable.period_id')
    ->where('timetable.subject_id', $sub)
    ->where('timetable.course', $course)
    ->where('timetable.semester', $sem)
    ->where('timetable.acyear', $ac_id)
    ->where('timetable.day_of_week', $dayOfWeek)
    ->first();

$absentmarked = StudentAttendance::where('course_id', $course)
    ->where('semester_id', $sem)
    ->where('subject_id', $sub)
    ->where('student_id', $student_id)
    ->where('date', $convertedDate)
    ->exists();

if ($timetable && !$absentmarked) {
    $period_id = $timetable->period_id;

    $leaveType = $request->leaveType;

   if ($leaveType == 2) {
 
    if ($amChecked && $pmChecked) {
    
        $am = 1;
        $pm = 1;
    } elseif ($amChecked) {
     
        $am = 1;
        $pm = 0;
    } elseif ($pmChecked) {
       
        $am = 0;
        $pm = 1;
    } else {
      
        $am = 0;
        $pm = 0;
    }
} elseif ($leaveType == 1 || $leaveType == 3) {
  
    $am = 0;
    $pm = 0;
} else {
   
    $am = 0;
    $pm = 0;
}
    $attendance = new StudentAttendance();
    $attendance->course_id = $request->course;
    $attendance->semester_id = $request->sem;
    $attendance->subject_id = $request->sub;
    $attendance->student_id = $request->studentId;
    $attendance->stuleav_id = $leaveType;
    $attendance->date = $convertedDate;
    $attendance->month = \Carbon\Carbon::parse($absentDate)->format('m');
    $attendance->year = \Carbon\Carbon::parse($absentDate)->format('Y');
    $attendance->am = $am;
    $attendance->pm = $pm;
    $attendance->period_id = $period_id;
    $attendance->reason = $request->reason;

    $attendance->save();
}

return redirect()->back()->with('success', 'Absent details saved successfully.');
}
public function updatePresentToAbsent(Request $request)
{
    $am = 1;  
    $pm = 1; 
    $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
    $ac_id = $cur_acyear->ac_id;
    $sem=$request->sem;
    $sub=$request->sub;
    $course = $request->course;
    $leavetype=$request->leaveType;

    
   $student_id=$request->studentId;
  
     $absentDate =$request->absentDate;
  $reason=$request->reason;
    // $convertedDate = Carbon::createFromFormat('d-m-Y', $absentDate)->format('Y-m-d');
    $attendance = StudentAttendance::where('course_id', $course)
        ->where('semester_id', $sem)
        ->where('subject_id', $sub)
        ->where('student_id', $student_id)
        ->where('date', $absentDate)
        ->first();
     if ($leavetype == 2) {
 
    $am = 1;
    $pm = 1;
} else {
 
    $am = 0;
    $pm = 0;
}
          if ($attendance) {
     
        $attendance->am = $am;  
        $attendance->pm = $pm;  
        $attendance->stuleav_id = $leavetype; 
        $attendance->reason=$reason;
        $attendance->save();
         
    } 
     return redirect()->back()->with('success', 'Student marked as absent successfully.');
   
    
}
   
   
    public function updateAbsentToPresent(Request $request)
   {
    //   dd($request->all());

    $am = 0;  
    $pm = 0;
     $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
    $ac_id = $cur_acyear->ac_id;
    $sem=$request->sem;
    $sub=$request->sub;
    $course = $request->course;
    
    $student_id=$request->studentId;
     $absentDate =$request->absentDate;
    $attendance = StudentAttendance::where('course_id', $course)
        ->where('semester_id', $sem)
        ->where('subject_id', $sub)
        ->where('student_id', $student_id)
        ->where('date', $absentDate)
        ->first();
        
            if ($attendance) {
     
        $attendance->am = $am;  
        $attendance->pm = $pm;  
        $attendance->stuleav_id = null;
        $attendance->reason=null;
        $attendance->save();

         
    } 

    return redirect()->back()->with('success', 'Student marked as present successfully.');
    
 
          
}

   
   
   
   
   
   
   
   
    
  public function student_attendance_report()
  {
      $course=Course::all();
      return view('Attendance.student_attendance_report',compact('course'));
  }
    
   public function student_attendance_report_get(Request $request)
   {
        
       $course=Course::find($request->tid);
       $sem=Semester::find($request->did);
       $sub=Subject::find($request->sub);
       $fdate=$request->input('fdate');
       $tdate=$request->input('tdate');
       
       
        $currentAcyear=Acyear::where('default1',1)->whereNull('deleted_at')->first();
    $ac_id = $currentAcyear->ac_id;
  $students = Student::join('promotes','promotes.student_id','=','students.student_id')->
  where('promotes.course_id', $request->tid)
                        ->where('promotes.semester_id', $request->did)->where('promotes.ac_id',$ac_id)
                        ->get();
    
    $studentAttendance = StudentAttendance::where('course_id', $request->tid)
                                          ->where('semester_id', $request->did)
                                          ->where('subject_id', $request->sub)
                                          ->whereBetween('date', [$fdate, $tdate])
                                          ->get()
                                          ->groupBy('student_id');

    $attendanceSummary = [];

$markedDays = StudentAttendance::where('course_id', $request->tid)
                                   ->where('semester_id', $request->did)
                                   ->where('subject_id', $request->sub)
                                   ->whereBetween('date', [$fdate, $tdate])
                                   ->distinct('date')
                                   ->count('date');
foreach ($students as $student) {
    $presentDays = 0;
    $absentDays = 0;
$halfDayLeaves=0;
    // if (isset($studentAttendance[$student->student_id])) {
    //     foreach ($studentAttendance[$student->student_id] as $attendance) {
          
    //         if ($attendance->am == 0 && $attendance->pm == 0) {
    //             $presentDays++;
    //         } else {
               
    //             $absentDays++;
    //         }
    //     }
    // }

 if (isset($studentAttendance[$student->student_id])) {
        foreach ($studentAttendance[$student->student_id] as $attendance) {
          
          
            if ($attendance->am == 0 && $attendance->pm == 0) {
                $presentDays++;
            } 
         
            elseif ($attendance->am == 1 && $attendance->pm == 1) {
                $absentDays++;
            }
           
            elseif (($attendance->am == 1 && $attendance->pm == 0) || ($attendance->am == 0 && $attendance->pm == 1)) {
                $halfDayLeaves++;
            }
        }
    }



   $totalDays = $presentDays + $absentDays + ($halfDayLeaves * 0.5); 
    $attendancePercentage = $totalDays > 0 ? ($presentDays + ($halfDayLeaves * 0.5)) / $totalDays * 100 : 0;

   
    // $totalDays = $presentDays + $absentDays;
    // $attendancePercentage = $totalDays > 0 ? ($presentDays / $totalDays) * 100 : 0;

    $attendanceSummary[] = [
        'student_name' => $student->name,
        'admission_number' => $student->adno,
        'present_days' => $presentDays,
        'absent_days' => $absentDays,
         'half_day_leaves' => $halfDayLeaves,
        'attendance_percentage' => round($attendancePercentage, 2)
    ];
}



   return view('Attendance.student_attendance_report_get',compact('course','sem','sub','fdate','tdate','attendanceSummary','markedDays'));
       
   }
  
    
    
    public function student_attendance_report_print($course_id, $semester_id,$subject_id,$fdate,$tdate)
    {
        $ins_det = instituteDetails(); 
        $course = Course::find($course_id);
        $sem=Semester::find($semester_id);
        $sub=Subject::find($subject_id);

      
        $currentAcyear=Acyear::where('default1',1)->whereNull('deleted_at')->first();
    $ac_id = $currentAcyear->ac_id;
   
  $students = Student::join('promotes','promotes.student_id','=','students.student_id')->
  where('promotes.course_id', $course_id)
                        ->where('promotes.semester_id',$semester_id)->where('promotes.ac_id',$ac_id)
                        ->get();
  
    $studentAttendance = StudentAttendance::where('course_id',$course_id)
                                          ->where('semester_id',$semester_id)
                                          ->where('subject_id',$subject_id)
                                          ->whereBetween('date', [$fdate, $tdate])
                                          ->get()
                                          ->groupBy('student_id');
  
    $attendanceSummary = [];
//  $totalDays = (new \DateTime($tdate))->diff(new \DateTime($fdate))->days + 1;
$markedDays = StudentAttendance::where('course_id',$course_id)
                                   ->where('semester_id',$semester_id)
                                   ->where('subject_id',$subject_id)
                                   ->whereBetween('date', [$fdate, $tdate])
                                   ->distinct('date')
                                   ->count('date');
    foreach ($students as $student) {
        $presentDays = 0;
$absentDays = 0;
$halfDayLeaves=0;

        // if (isset($studentAttendance[$student->student_id])) {
        //     foreach ($studentAttendance[$student->student_id] as $attendance) {
        //         if ($attendance->am == 0 && $attendance->pm == 0) {
        //             $presentDays++;
        //         }
        //     }
        // }
         if (isset($studentAttendance[$student->student_id])) {
        foreach ($studentAttendance[$student->student_id] as $attendance) {
          
          
            if ($attendance->am == 0 && $attendance->pm == 0) {
                $presentDays++;
            } 
         
            elseif ($attendance->am == 1 && $attendance->pm == 1) {
                $absentDays++;
            }
           
            elseif (($attendance->am == 1 && $attendance->pm == 0) || ($attendance->am == 0 && $attendance->pm == 1)) {
                $halfDayLeaves++;
            }
        }
    }

     $totalDays = $presentDays + $absentDays + ($halfDayLeaves * 0.5); 
    $attendancePercentage = $totalDays > 0 ? ($presentDays + ($halfDayLeaves * 0.5)) / $totalDays * 100 : 0;   
        
//   $attendancePercentage = $markedDays > 0 ? ($presentDays / $markedDays) * 100 : 0;
        $attendanceSummary[] = [
            'student_name' => $student->name,
            'admission_number' => $student->adno,
            'present_days' => $presentDays,
            'absent_days' => $absentDays,
         'half_day_leaves' => $halfDayLeaves,
             'attendance_percentage' => round($attendancePercentage, 2)
        ];
    }

return view('Attendance.student_attendance_report_print',compact('course','sem','sub','fdate','tdate','attendanceSummary','markedDays','ins_det'));
 
    }
    
    
    
    public function roll_out()
{
   $course=Course::all();
   $acyear=Acyear::all();
   
   return view('students.roll_out',compact('course','acyear'));
}
   
public function roll_out_get(Request $request)
{
$ac_det = Acyear::find($request->aid);
$crs_det = Course::find($request->cid);
$sem_det = Semester::find($request->sid);



$sem_year_setting = SemesterYear::where('course_id', $request->cid)
    ->where('semester_id', $request->sid)
    ->where('ac_id', $request->aid)
    ->select('start_date', 'end_date')
    ->first();


if ($sem_year_setting) {
    $startDate = $sem_year_setting->start_date;
    $endDate = $sem_year_setting->end_date;

    
    $students = Student::join('promotes', 'students.student_id', '=', 'promotes.student_id')
        ->where([
            'promotes.ac_id' => $request->aid,
            'promotes.course_id' => $request->cid,
            'promotes.semester_id' => $request->sid
        ])
        ->select('students.*')
        ->latest()
        ->get();

   
    $studentsWithExcessiveAbsences = [];

    foreach ($students as $student) {
      
        $attendanceRecords = StudentAttendance::where('student_id', $student->student_id)
            ->where('course_id', $request->cid)
            ->where('semester_id', $request->sid)
            ->whereBetween('date', [$startDate, $endDate])
            ->get();

    
        $absentDays = $attendanceRecords->filter(function ($record) {
            return $record->am == 1 && $record->pm == 1; 
        })->count();

     
        if ($absentDays > 14) {
            $studentsWithExcessiveAbsences[] = [
                'student_id' => $student->student_id,
                'name' => $student->name, 
                'adno'=>$student->adno,
                'absent_days' => $absentDays,
                'total_days' => $attendanceRecords->count(), 
            ];
        }
    }
} else {
    $studentsWithExcessiveAbsences = collect();
}

return view('students.roll_out_get', compact('crs_det','sem_det','studentsWithExcessiveAbsences','ac_det'));

}

    
    
    
    
    
    
    
    
   
    public function roll_out_save(Request $request)
    {
    $ac_id = $request->ac_id;
    $course_id = $request->course_id;
    $sem_id = $request->semester_id;
    $student_id = $request->student_id;
    $selected_students = $request->selected_students;
    $fdate = $request->fdate;
    $tdate = $request->tdate;
    $student = Student::where('student_id', $student_id)->first();
   
    $student_name=$student->name;
   
    $rollout = null; 

    if ($selected_students) {
        foreach ($selected_students as $index => $student_id) {
            $fromdate = $fdate[$index];
            $todate = $tdate[$index];

         
            $existingrolloutstu = RollOutStudents::where('student_id', $student_id)
                ->where('course_id', $course_id)
                ->where('semester_id', $sem_id)
                ->where('ac_id', $ac_id)
                ->first();

           
            if (!$existingrolloutstu) {
                $rollout = RollOutStudents::create([
                    'ac_id' => $ac_id,
                    'course_id' => $course_id,
                    'semester_id' => $sem_id,
                    'student_id' => $student_id,
                    'fdate' => $fromdate,
                    'tdate' => $todate,
                ]);
                 $promote = Promote::where('student_id', $student_id)
                    ->where('ac_id', $ac_id)
                    ->where('course_id', $course_id)
                    ->where('semester_id', $sem_id)
                    ->first();

                if ($promote) {
                    $promote->semester_id = null;
                    $promote->save();
                }
                
            } else {
               
                $msgarray = [
                    'message' => "$student_name is already rolled out for the given course and Semester!",
                    'alert-type' => 'warning'
                ];
              
                return redirect()->back()->with($msgarray);
            }
        }
    }

  
    if ($rollout) {
        $msgarray = ['message' => 'Student Roll-Out Successful!', 'alert-type' => 'success'];
    } else {
        $msgarray = ['message' => 'Student Roll-Out Failure!', 'alert-type' => 'error'];
    }

    return redirect()->back()->with($msgarray);
}
public function roll_out_view()
{
     $course=Course::all();
     $acyear=Acyear::all();
   
   return view('students.roll_out_view',compact('course','acyear'));
}
    public function roll_out_view_get(Request $request)
    {
       $ac_det = Acyear::find($request->aid);
       $crs_det = Course::find($request->cid);
       $sem_det = Semester::find($request->sid); 
       
       $rollout=RollOutStudents::join('students','students.student_id','=','roll_out_students.student_id')
       ->where('roll_out_students.course_id',$request->cid)
       ->where('roll_out_students.semester_id',$request->sid)
       ->where('roll_out_students.ac_id',$request->aid)
       ->select('students.name','students.adno','roll_out_students.*')
       ->get();
       return view('students.roll_out_view_get',compact('rollout'));
       
       
    }
    
    
    
    
    
}
