<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\CertificateTemplate;
use App\Models\Acyear;
use App\Models\Student;
use App\Models\GenerateStuCertificate;
use App\Models\CertificateStaffTemplate;
use App\Models\User;
use App\Models\GenerateStaffCertificate;
use App\Models\EventTemplate;
use App\Models\AddCompetition;
use App\Models\AddEvent;
use App\Models\EventGenerate;

 
class Certificate extends Controller
{
   public function certificate_stu_temp()
   {
       return view('certificate.certificate_stu_temp');
   }

    public function certificate_stu_temp_save(Request $request)
    {
        $name=$request->name;
        $title=$request->title;
        $code=$request->code;
        $content=$request->content;
        $certificate=CertificateTemplate::create([
            'name'=>$name,
            'title'=>$title,
            'code'=>$code,
            'content'=>$content,
            
            ]);
             if($certificate)
    {
        $msg_array=array('message'=>'New template created successfully!!','Success');
        
    }
    else
    {
        $msg_array=array('message'=>'Template could not be created. Please try again.!!','error'); 
    }
     return redirect()->route('certificate.student.template')->with($msg_array);
    }
  
  public function certificate_stu_report()
  
 {
     $certificate=CertificateTemplate::all();
     return view('certificate.certificate_stu_report',compact('certificate'));
 }
    
  public function certificate_stu_temp_delete($template_id)
  {
    $template=CertificateTemplate::find(decrypt($template_id));
if ($template) {
      
        $isInUse = GenerateStuCertificate::where('template_id',$id)->exists();

        if ($isInUse) {
            $msg_array = [
                'message' => 'Template could not be deleted, it is currently in use!',
                'alert-type' => 'error'
            ];
        } else {
            $template->delete();
            $msg_array = [
                'message' => 'Template deleted successfully!',
                'alert-type' => 'success'
            ];
        }
    } else {
        $msg_array = [
            'message' => 'Template not found!',
            'alert-type' => 'error'
        ];
    }


   return redirect()->route('certificate.student.report')->with($msg_array);    
  }
    

    
  public function templateview($template_id)
  {
      $institution = instituteDetails();  
      $template=CertificateTemplate::find($template_id);
     
      $template=CertificateTemplate::where('template_id',$template_id)->first();
      
      return view('certificate.templateview',compact('template','institution'));
  }
    
   public function templateedit($template_id) 
   {
        $template=CertificateTemplate::find($template_id);
        $templates=CertificateTemplate::where('template_id',$template_id)->first();
        return view('certificate.templateedit',compact('templates'));
   }
    
    public function templateupdate(Request $request)
    {
        $template_id=$request->template_id;
        $template=CertificateTemplate::find($template_id);
       $template->update([
           'name'=>$request->name,
           'title'=>$request->title,
           'code'=>$request->code,
           'content'=>$request->content,
           ]);
           if($template)
           {
               $msg_array=array('message'=>'Template updated successfully!!','success');
           }
           else
           {
               $msg_array=array('message'=>'Template could not be update!!','error');
           }
          return redirect()->route('certificate.student.report')->with($msg_array); 
            
            
    }
    
    public function templatedelete($template_id)
    {
        $template=CertificateTemplate::find($template_id);
        if ($template) {
      
        $isInUse = GenerateStuCertificate::where('template_id',$template_id)->exists();

        if ($isInUse) {
            $msg_array = [
                'message' => 'Template could not be deleted, it is currently in use!',
                'alert-type' => 'error'
            ];
        } else {
            $template->delete();
            $msg_array = [
                'message' => 'Template deleted successfully!',
                'alert-type' => 'success'
            ];
        }
    } else {
        $msg_array = [
            'message' => 'Template not found!',
            'alert-type' => 'error'
        ];
    }
       
       return redirect()->route('certificate.student.report')->with($msg_array);
        }
   
   
   public function certificate_stu_temp_gen()
   {
       $acyears=Acyear::all();
       $student=Student::whereNull('deleted_at')->where('tcstatus','0')->get();
       $certificate=CertificateTemplate::whereNull('deleted_at')->get();
       $certifcate_no=GenerateStuCertificate::max('certificate_number');
      if ($certifcate_no) {
  
    preg_match('/\d+/', $certifcate_no, $matches);
    $nextNumber = $matches ? intval($matches[0]) + 1 : 1; 
} else {
    $nextNumber = 1; 
}
$nxt_cert_no = 'GC/' . str_pad($nextNumber, 2, '0', STR_PAD_LEFT);
return view('certificate.certificate_stu_temp_gen',compact('acyears','student','certificate','nxt_cert_no'));
   }
   
   public function certificate_stu_temp_gen_save(Request $request)
   {
      $validated = $request->validate([
            'ac_id' => 'required',
            'student_id' =>'required',
            'template_id'=>'required',
            'certificate_number'=>'required|unique:generate_stu_certificate,certificate_number',
            'date'=>'required',
        ]); 
        $ac_id=$request->ac_id;
        $student_id=$request->student_id;
        $template_id=$request->template_id;
        $certificate_no=$request->certificate_number;
        $date=$request->date;
        $generate_exists=GenerateStuCertificate::where('student_id',$student_id)->where('template_id',$template_id)->where('ac_id',$ac_id)->exists();
        if(!$generate_exists)
        {
            $generate=GenerateStuCertificate::create([
            'ac_id'=>$ac_id,
            'student_id'=>$student_id,
            'template_id'=>$template_id,
            'certificate_number'=>$certificate_no,
            'date'=>$date,
            ]); 
            
             if($generate)
        {
            $msg_array=array('message'=>'Student Certificate Generated Successfully!!','success');
        }
        else
        {
           $msg_array=array('message'=>'Student Certificate could not be generated!!','error'); 
        }
        }
            
           
       
        
        return redirect()->route('certificate.student.generate')->with($msg_array);
   }
   
   public function certificate_generated()
   {
       $certificate=GenerateStuCertificate::whereNull('deleted_at')->get();
       return view('certificate.certificate_generated',compact('certificate'));
   }
    
    
    public function certificate_generated_view($id)
    {
         
        $institution = instituteDetails(); 
        $certificate_gen=GenerateStuCertificate::join('certificate_template','certificate_template.template_id','=','generate_stu_certificate.template_id')->
        join('students','generate_stu_certificate.student_id','=','students.student_id')->
        where('generate_stu_certificate.genstucert_id',$id)->
        select('certificate_template.content','certificate_template.title','generate_stu_certificate.*','students.*')->
        get();
       
        foreach($certificate_gen as $cert)
        {
            $cert->content=str_replace(
                [
                
                '{name}',
                '{fname}',
                '{mname}',
                '{paddress}',
                '{adno}',
                '{course_id}',
                '{dob}'
                
                
                ],
                
                [
                  $cert->name,
                  $cert->fname,
                  $cert->mname,
                  $cert->paddress,
                  $cert->adno,
                  $cert->course->course_name,
                  date('d-m-Y', strtotime($cert->dob)), 
                    
                    ],
                $cert->content
                );
        }
        return view('certificate.certificate_generated_view',compact('certificate_gen','institution'));
    }
    
    
    public function certificate_generated_print($id)
    {
         $institution = instituteDetails(); 
        $certificate_gen=GenerateStuCertificate::join('certificate_template','certificate_template.template_id','=','generate_stu_certificate.template_id')->
        join('students','generate_stu_certificate.student_id','=','students.student_id')->
        where('generate_stu_certificate.genstucert_id',$id)->
        select('certificate_template.content','certificate_template.title','generate_stu_certificate.*','students.*')->
        get();
        
        foreach($certificate_gen as $cert)
        {
            $cert->content=str_replace(
                [
                
                '{name}',
                '{fname}',
                '{mname}',
                '{paddress}',
                '{adno}',
                '{course_id}',
                '{dob}'
                
                
                ],
                
                [
                  $cert->name,
                  $cert->fname,
                  $cert->mname,
                  $cert->paddress,
                  $cert->adno,
                  $cert->course->course_name,
                 date('d-m-Y', strtotime($cert->dob)),  
                 
                    ],
                $cert->content
                );
        }
        
        return view('certificate.certificate_generated_print',compact('certificate_gen','institution'));
    }
    
    
    
    public function certificate_staff_temp()
    {
        return view('certificate.certificate_staff_temp');
    }
    
   public function certificate_staff_temp_save(Request $request)
   {
        $name=$request->name;
        $title=$request->title;
        $code=$request->code;
        $content=$request->content;
        $certificate=CertificateStaffTemplate::create([
            'name'=>$name,
            'title'=>$title,
            'code'=>$code,
            'content'=>$content,
            
            ]);
             if($certificate)
    {
        $msg_array=array('message'=>'New template created successfully!!','Success');
        
    }
    else
    {
        $msg_array=array('message'=>'Template could not be created. Please try again.!!','error'); 
    }
     return redirect()->route('certificate.staff.template')->with($msg_array);
   }
    
    public function certificate_staff_temp_report()
    {
        $certificate=CertificateStaffTemplate::all();
        return view('certificate.certificate_staff_temp_report',compact('certificate'));
    }
    
    public function templateview_staff($id)
    {
       $institution = instituteDetails();  
      $template=CertificateStaffTemplate::find($id);
     
      $template=CertificateStaffTemplate::where('templatestaff_id',$id)->first();
      
      return view('certificate.templateview_staff',compact('template','institution'));
    }
    
    public function templateedit_staff($id)
    {
         $template=CertificateStaffTemplate::find($id);
        $templates=CertificateStaffTemplate::where('templatestaff_id',$id)->first();
        return view('certificate.templateedit_staff',compact('templates'));
    }
    public function templateupdate_staff(Request $request)
    {
         $template_id=$request->templatestaff_id;
        $template=CertificateStaffTemplate::find($template_id);
       $template->update([
           'name'=>$request->name,
           'title'=>$request->title,
           'code'=>$request->code,
           'content'=>$request->content,
           ]);
           if($template)
           {
               $msg_array=array('message'=>'Template updated successfully!!','success');
           }
           else
           {
               $msg_array=array('message'=>'Template could not be update!!','error');
           }
          return redirect()->route('certificate.staff.template.report')->with($msg_array); 
            
    }
    public function templatedelete_staff($id)
    {
      $template=CertificateStaffTemplate::find($id);
        if ($template) {
        $isInUse = GenerateStaffCertificate::where('templatestaff_id', $id)->exists();

        if ($isInUse) {
            $msg_array = [
                'message' => 'Template could not be deleted, it is currently in use!',
                'alert-type' => 'error'
            ];
        } else {
            $template->delete();
            $msg_array = [
                'message' => 'Template deleted successfully!',
                'alert-type' => 'success'
            ];
        }
    } else {
        $msg_array = [
            'message' => 'Template not found!',
            'alert-type' => 'error'
        ];
    }
       
       
       
       return redirect()->route('certificate.staff.template.report')->with($msg_array);  
    }
    
    public function certificate_staff_temp_gen()
    {
       $staff=User::whereNull('deleted_at')->where('status','1')->get();
       $certificate=CertificateStaffTemplate::whereNull('deleted_at')->get();
       $certifcate_no=GenerateStaffCertificate::max('certificate_number');
      if ($certifcate_no) {
  
    preg_match('/\d+/', $certifcate_no, $matches);
    $nextNumber = $matches ? intval($matches[0]) + 1 : 1; 
} else {
    $nextNumber = 1; 
}
$nxt_cert_no = 'GC-EM/' . str_pad($nextNumber, 2, '0', STR_PAD_LEFT);
return view('certificate.certificate_staff_temp_gen',compact('staff','certificate','nxt_cert_no'));
   }
    
    public function certificate_staff_temp_gen_save(Request $request)
    {
    $validated = $request->validate([
           
            'user_id' =>'required',
            'templatestaff_id'=>'required',
            'certificate_number'=>'required|unique:generate_stu_certificate,certificate_number',
            'date'=>'required',
        ]); 
       
        $user_id=$request->user_id;
        $template_id=$request->templatestaff_id;
        $certificate_no=$request->certificate_number;
        $date=$request->date;
        $generate_exists=GenerateStaffCertificate::where('user_id',$user_id)->where('templatestaff_id',$template_id)->exists();
        if(!$generate_exists)
        {
            $generate=GenerateStaffCertificate::create([
            'user_id'=>$user_id,
            'templatestaff_id'=>$template_id,
            'certificate_number'=>$certificate_no,
            'date'=>$date,
            ]); 
            
            
             if($generate)
        {
            $msg_array=array('message'=>'Staff Certificate Generated Successfully!!','success');
        }
        else
        {
           $msg_array=array('message'=>'Staff Certificate could not be generated!!','error'); 
        }
        }
            
           
       
        
        return redirect()->route('certificate.staff.generate')->with($msg_array);    
    }
    
    
    public function certificate_generated_staff()
    {
         $certificate=GenerateStaffCertificate::whereNull('deleted_at')->get();
       return view('certificate.certificate_generated_staff',compact('certificate'));
    }
    

    
    public function certificate_generated_view_staff($id)
    {
        $institution = instituteDetails(); 
        $certificate_gen=GenerateStaffCertificate::join('certificate_template_staff','certificate_template_staff.templatestaff_id','=','generate_staff_certificate.templatestaff_id')->
        join('users','generate_staff_certificate.user_id','=','users.user_id')->
        where('generate_staff_certificate.genstafcert_id',$id)->
        select('certificate_template_staff.content','certificate_template_staff.title','generate_staff_certificate.*','users.*')->
        get();
       
        foreach($certificate_gen as $cert)
        {
            $cert->content=str_replace(
                [
                
                '{name}{lname}',
                '{employee_id_num}',
                '{type_id}',
                '{image}',
                '{staftyp_id}',
                '{dateof_join}',
                
                
                
                ],
                
                [
                  $cert->name,
                  $cert->lname,
                  $cert->employee_id_num,
                  $cert->UserType->type_name,
                  $cert->image,
                  
                  date('d-m-Y', strtotime($cert->dateof_join)),
                    
                    ],
                $cert->content
                );
        }
        return view('certificate.certificate_generated_view_staff',compact('certificate_gen','institution'));
    }
    
    
    
    
    public function certificate_generated_print_staff($id)
    {
        
    $institution = instituteDetails(); 
        $certificate_gen=GenerateStaffCertificate::join('certificate_template_staff','certificate_template_staff.templatestaff_id','=','generate_staff_certificate.templatestaff_id')->
        join('users','generate_staff_certificate.user_id','=','users.user_id')->
        where('generate_staff_certificate.genstafcert_id',$id)->
        select('certificate_template_staff.content','certificate_template_staff.title','generate_staff_certificate.*','users.*')->
        get();
       
        foreach($certificate_gen as $cert)
        {
     $imagePath = asset('public/uploads/staff/photo' . $cert->image); 

            $cert->content=str_replace(
                [
                
                '{name}{lname}',
                '{employee_id_num}',
                '{type_id}',
                '{image}',
                '{staftyp_id}',
                '{dateof_join}',
                
                
                
                ],
                
                [
                  $cert->name,
                  $cert->lname,
                  $cert->employee_id_num,
                  $cert->UserType->type_name,
                '<img src="' . $imagePath . '" alt="Staff Image" style="max-width: 100px; height: auto;" />', 
                  date('d-m-Y', strtotime($cert->dateof_join)),
                    
                    ],
                $cert->content
                );
        }
        return view('certificate.certificate_generated_print_staff',compact('certificate_gen','institution'));
    }
    
    
    
    public function event_template()
    {
        return view('certificate.event_template');
    }
    
    
    
  public function event_template_save(Request $request)
  {
      $validated=$request->validate([
          'name'=>'required',
          'title'=>'required',
          'code'=>'required',
          ]);
 $template=EventTemplate::create([
     'name'=>$request->name,
     'title'=>$request->title,
     'code'=>$request->code,
     'content'=>$request->content,
     ]);
     if($template)
     {
         $msg_array=array('message','Template added successfully','success');
     }
     else
     {
        $msg_array=array('message','Template could not added','success');

     }
     return redirect()->route('certificate.event.template')->with($msg_array);
     
 
  }
    
    public function event_template_report()
    {
        $template=EventTemplate::all();
        return view('certificate..event_template_report',compact('template'));
        
    }
    
    public function event_template_report_view($id)
    {
        $template=EventTemplate::find($id);
       
        $institution = instituteDetails(); 
        return view('certificate.event_template_report_view',compact('template','institution'));
    }
    public function event_template_report_edit($id)
    {
        $template=EventTemplate::find($id);
       
       
        return view('certificate.event_template_report_edit',compact('template'));
    }
    

    public function event_template_report_update(Request $request)
    {
        $template=EventTemplate::find($request->evnttem_id);
        $template->update([
            'name'=>$request->name,
            'title'=>$request->title,
            'code'=>$request->code,
            'content'=>$request->content,
            ]);
            if($template)
        {
            $msg_array=array('message','Updated successfully','success');
        }
        else{
            $msg_array=array('message','Could not Update','error');
        }
        
        return redirect()->route('certificate.event.template.report')->with($msg_array);
    }
    
   public function event_template_report_delete($id)
   {
       $template=EventTemplate::find($id);
if ($template) {
       
      
        $isInUse = EventGenerate::where('evnttem_id', $id)->exists();

        if ($isInUse) {
            $msg_array = [
                'message' => 'Template could not be deleted, it is currently in use!',
                'alert-type' => 'error'
            ];
        } else {
            $template->delete();
            $msg_array = [
                'message' => 'Template deleted successfully!',
                'alert-type' => 'success'
            ];
        }
    } else {
        $msg_array = [
            'message' => 'Template not found!',
            'alert-type' => 'error'
        ];
    }
    return redirect()->route('certificate.event.template.report')->with($msg_array);    
   }
    
    
    
    
    public function event_template_generate()
    {
        
        $currentAcyear=Acyear::where('default1',1)->whereNull('deleted_at')->first();
        $ac_id = $currentAcyear->ac_id;
        $students=Student::whereNull('deleted_at')->where('tcstatus','0')->get();
        $template=EventTemplate::all();
        $compt=AddCompetition::all();
        $event=AddEvent::where('ac_id',$ac_id)->get();
        
        $certifcate_no=EventGenerate::max('certificate_number');
      if ($certifcate_no) {
  
    preg_match('/\d+/', $certifcate_no, $matches);
    $nextNumber = $matches ? intval($matches[0]) + 1 : 1; 
} else {
    $nextNumber = 1; 
}
$nxt_cert_no = 'GC/' . str_pad($nextNumber, 2, '0', STR_PAD_LEFT);
        
        return view('certificate.event_template_generate',compact('students','template','compt','event','nxt_cert_no'));
    }
    
    
    
    
   public function event_template_generate_save(Request $request)
   {
       $validated=$request->validate([
           'student_id'=>'required',
            'addevent_id'=>'required',
            'addcompt_id'=>'required',
             'evnttem_id'=>'required', 
            'certificate_number'=>'required|unique:generate_event_certificate,certificate_number', 
            'date'=>'required',
           ]);
           $generate=EventGenerate::create([
               'student_id'=>$request->student_id,
               'addevent_id'=>$request->addevent_id,
               'addcompt_id'=>$request->addcompt_id,
               'evnttem_id'=>$request->evnttem_id,
               'grade'=>$request->grade,
               'position'=>$request->position,
               'certificate_number'=>$request->certificate_number,
               'date'=>$request->date,
               ]);
             if($generate)
    {
        $msg_array=array('message'=>'template Generated successfully!!','Success');
        
    }
    else
    {
        $msg_array=array('message'=>'Template could not be Generated. Please try again.!!','error'); 
    }
     return redirect()->route('certificate.event.template.generate')->with($msg_array);
           
           
           
           
   }
    
  public function event_gen_report()
  {
      $eventgenerate=EventGenerate::all();
      return view('certificate.event_gen_report',compact('eventgenerate'));
      
  }
    
    
   public function event_gen_report_view($id)
   {
       $eventgenerate_id=EventGenerate::find($id);
       $institution = instituteDetails(); 
      $eventgenerate=EventGenerate::join('students','generate_event_certificate.student_id','students.student_id')->
      join('event_template','generate_event_certificate.evnttem_id','=','event_template.evnttem_id')->
      join('add_events','generate_event_certificate.addevent_id','=','add_events.addevent_id')->
      join('add_competition','generate_event_certificate.addcompt_id','=','add_competition.addcompt_id')->
      where('generate_event_certificate.evntgen_id',$id)->select('students.*','generate_event_certificate.*','add_competition.compt','event_template.title','event_template.content','add_events.event')->get();
     
      foreach($eventgenerate as $cert)
        {
            $cert->content=str_replace(
                [
                
            '{name}',
            '{adno}',
            '{event}',
            '{compt}',
            '{position}',
            '{grade}',
            '{date}',
            '{certificate_no}',

                
                
                ],
                
                [
                  $cert->name,
                  $cert->adno,
                  $cert->event,
                  $cert->compt,
                  $cert->position,
                  $cert->grade,
                  date('d-m-Y', strtotime($cert->date)),
                  $cert->certificate_number,
                    
                    ],
                $cert->content
                );
        }
            return view('certificate.event_gen_report_view',compact('eventgenerate','institution'));
   
   }
    
    
   public function event_gen_report_print($id)
   {
      $eventgenerate_id=EventGenerate::find($id);
      $institution = instituteDetails(); 
      $eventgenerate=EventGenerate::join('students','generate_event_certificate.student_id','students.student_id')->
      join('event_template','generate_event_certificate.evnttem_id','=','event_template.evnttem_id')->
      join('add_events','generate_event_certificate.addevent_id','=','add_events.addevent_id')->
      join('add_competition','generate_event_certificate.addcompt_id','=','add_competition.addcompt_id')->
      where('generate_event_certificate.evntgen_id',$id)->select('students.*','generate_event_certificate.*','add_competition.compt','event_template.title','event_template.content','add_events.event')->get();
     
      foreach($eventgenerate as $cert)
        {
            $cert->content=str_replace(
                [
                
            '{name}',
            '{adno}',
            '{event}',
            '{compt}',
            '{position}',
            '{grade}',
            '{date}',
            '{certificate_no}',

                
                
                ],
                
                [
                  $cert->name,
                  $cert->adno,
                  $cert->event,
                  $cert->compt,
                  $cert->position,
                  $cert->grade,
                  date('d-m-Y', strtotime($cert->date)),
                  $cert->certificate_number,
                    
                    ],
                $cert->content
                );
        }
            return view('certificate..event_gen_report_print',compact('eventgenerate','institution'));
   

   }
    
    
    
public function certificate_generated_edit($id)
{
   
    $generateStucert=GenerateStuCertificate::find($id);
    $acyears=Acyear::all();
    $student=Student::whereNull('deleted_at')->where('tcstatus','0')->get();
    $certificate=CertificateTemplate::whereNull('deleted_at')->get();
   
   return view('certificate.certificate_generated_edit',compact('generateStucert','acyears','student','certificate'));
   
   
    
}
    
public function certificate_generated_update(Request $request)
{
  
  $generated_id=$request->genstucert_id;
        $generated=GenerateStuCertificate::find($generated_id);
   
       $generated->update([
           'ac_id'=>$request->ac_id,
           'student_id'=>$request->student_id,
           'template_id'=>$request->template_id,
           'certificate_number'=>$request->certificate_number,
           'date'=>$request->date,
           ]);
           if($generated)
           {
               $msg_array=array('message'=>'Template updated successfully!!','success');
           }
           else
           {
               $msg_array=array('message'=>'Template could not be update!!','error');
           }
  
  return redirect()->route('certificate.generated')->with($msg_array);

}
  
  public function certificate_generated_delete($id)
  {
      $generated=GenerateStuCertificate::find($id);
     if($generated){
            if($generated->count() > 0){
                $generated->delete();
                $msg_array = array('message'=>'Deleted!','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Could not be Deleted !','alert-type'=>'error');
            }
        }
   return redirect()->route('certificate.generated')->with($msg_array);    
  }
    
    
    public function certificate_generated_edit_staff($id)
    {
        $staff=User::whereNull('deleted_at')->where('status','1')->get();
       $certificate=CertificateStaffTemplate::whereNull('deleted_at')->get();
       $gen_id=GenerateStaffCertificate::find($id);
       return view('certificate.certificate_generated_edit_staff',compact('staff','certificate','gen_id'));
    }
    
    public function certificate_generated_update_staff(Request $request)
    {
        $generated_id=$request->genstafcert_id;
        $generated=GenerateStaffCertificate::find($generated_id);
   
       $generated->update([
            'user_id'=>$request->user_id,
            'templatestaff_id'=>$request->templatestaff_id,
            'certificate_number'=>$request->certificate_number,
            'date'=>$request->date,
           ]);
           if($generated)
           {
               $msg_array=array('message'=>'updated successfully!!','success');
           }
           else
           {
               $msg_array=array('message'=>'could not be update!!','error');
           }
  
  return redirect()->route('certificate.staff.generated')->with($msg_array);
    }
    
    public function certificate_generated_delete_staff($id)
    {
         $template=GenerateStaffCertificate::find($id);
     if($template){
            if($template->count() > 0){
                $template->delete();
                $msg_array = array('message'=>'Deleted!','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Could not be Deleted !','alert-type'=>'error');
            }
        }
   return redirect()->route('certificate.staff.generated')->with($msg_array);    
    }
    
   public function event_gen_report_edit($id)
   {
       $gen_id=EventGenerate::find($id);
       $currentAcyear=Acyear::where('default1',1)->whereNull('deleted_at')->first();
        $ac_id = $currentAcyear->ac_id;
        $students=Student::whereNull('deleted_at')->where('tcstatus','0')->get();
        $template=EventTemplate::all();
        $compt=AddCompetition::all();
        $event=AddEvent::where('ac_id',$ac_id)->get();
        return view('certificate.event_gen_report_edit',compact('gen_id','ac_id','students','template','compt','event'));
   }
    
     public function event_gen_report_update(Request $request)
     {
         $generated_id=$request->evntgen_id;
        $generated=EventGenerate::find($generated_id);
   
       $generated->update([
           'student_id'=>$request->student_id,
               'addevent_id'=>$request->addevent_id,
               'addcompt_id'=>$request->addcompt_id,
               'evnttem_id'=>$request->evnttem_id,
               'grade'=>$request->grade,
               'position'=>$request->position,
               'certificate_number'=>$request->certificate_number,
               'date'=>$request->date,
           ]);
           if($generated)
           {
               $msg_array=array('message'=>'updated successfully!!','success');
           }
           else
           {
               $msg_array=array('message'=>'could not be update!!','error');
           }
  
  return redirect()->route('certificate.event.template.generate.report')->with($msg_array);
     }
    
    
    public function event_gen_report_delete($id)
    {
          $template=EventGenerate::find($id);
     if($template){
            if($template->count() > 0){
                $template->delete();
                $msg_array = array('message'=>'Deleted!','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Could not be Deleted !','alert-type'=>'error');
            }
        }
   return redirect()->route('certificate.event.template.generate.report')->with($msg_array);    
    }
    
    
    
    
}
