<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Acyear;
use App\Models\User;
use App\Models\Clubs;
use App\Models\RequestJoinClub;
use App\Models\Course;
use App\Models\Semester;
use App\Models\SubCategory;
use App\Models\Subject;
use App\Models\PracticalExam;
use App\Models\StudentExamSubjectPract;
use App\Models\AcademicCalendar;
use App\Models\Student;
use App\Models\Enrolment;
use App\Models\MainstreamPracExamMarks;
use App\Models\Promote;

use App\Models\HOD;
use App\Models\ClassTeacher;
use App\Models\StaffSubject;
use DB;


use Illuminate\Support\Facades\Auth;

class Club extends Controller
{
    public function add()
    {
        $acyears = Acyear::all();
        $staff=User::all();
        $clubs=Clubs::all();
       return view('clubs.add',compact('acyears','staff','clubs')); 
    }

    public function add_save(Request $request)
    {

$validated = $request->validate([
    'club_name' => 'required|unique:add_clubs,club_name',
    'user_id' => 'required|array',
]);

$club_name = $request->club_name;
$staff = $request->user_id; 
$acyear = $request->ac_id;

$user_ids = implode(',',$staff);

$club = Clubs::create([
    'ac_id' => $acyear,
    'club_name' => $club_name,
    'user_ids' =>$user_ids,
]);

if ($club) {
    $msg_array = ['message' => 'Club Added Successfully!', 'alert-type' => 'success'];
} else {
    $msg_array = ['message' => 'Club Could not be Added!', 'alert-type' => 'error'];
}

return redirect()->route('clubs.add')->with($msg_array);

    } 
    
    
    
   public function report()
   {
       $clubs=Clubs::all();
      return view('clubs.report',compact('clubs'));  
   }
    
    public function club_ajax(Request $request)

{
    
    $col_order = ['club_name', 'user_ids', 'ac_id'];
    $total_data = Clubs::whereNull('deleted_at')->count();
    $limit = $request->input('length');
    $start = $request->input('start');
    $order = $col_order[$request->input('order.0.column')];
    $dir = $request->input('order.0.dir');

    $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
    $current_academic_year_id = $cur_acyear->ac_id;

    $query = Clubs::where('ac_id', $current_academic_year_id)->with('users');
    dd($query);

    if (!empty($request->input('search.value'))) {
        $search = $request->input('search.value');
        $query->where('club_name', 'like', '%' . $search . '%');
    }

    $total_filtered = $query->count();
    $clubs = $query->select('add_clubs.*')->offset($start)->limit($limit)->orderBy($order, $dir)->get();

    $data = [];
    foreach ($clubs as $club) {
        $data[] = [
           
            'club_name' => $club->club_name,
            'user_ids' => implode(', ', $club->users->pluck('name')->toArray()), 
            'ac_id' => date('Y', strtotime($club->acyear->sdate)) . '-' . date('Y', strtotime($club->acyear->edate)),
        ];
    }

    $json = [
        'draw' => intval($request->input('draw')),
        'recordsTotal' => intval($total_data),
        'recordsFiltered' => intval($total_filtered),
        'data' => $data,
    ];

    return response()->json($json);
}
    
   public function report_edit($id)
   {
      $club_id=Clubs::find($id);
       $acyears = Acyear::all();
        $staff=User::all();
        $clubs=Clubs::all();
     return view('clubs.report_edit',compact('club_id','acyears','staff','clubs'));
     
   }
    
    public function report_update(Request $request)
    {
        $validated = $request->validate([
    'club_name' => 'required|unique:add_clubs,club_name',
    'user_id' => 'required|array',
]);
        $club_id=$request->club_id;
        $club=Clubs::where('club_id',$club_id)->first();
        $club_name = $request->club_name;
        $staff = $request->user_id; 
         $acyear = $request->ac_id;
        





$user_ids = implode(',',$staff);

$club->update([
            'club_name'=>$club_name,
            'ac_id' => $acyear,
    'club_name' => $club_name,
    'user_ids' =>$user_ids,
            ]);
            

if ($club) {
    $msg_array = ['message' => 'Club Added Successfully!', 'alert-type' => 'success'];
} else {
    $msg_array = ['message' => 'Club Could not be Added!', 'alert-type' => 'error'];
}

return redirect()->route('clubs.report')->with($msg_array);

   
    }
 
 public function report_delete($id)
 {
       $club_id=Clubs::find($id)->delete();
       if($club_id)
       {
           $msg_array=array('message','Club name deleted successfully!!','success');
       }
        else
       {
           $msg_array=array('message','Club name could not be deleted!!','error');
       }
       return redirect()->route('clubs.report')->with($msg_array);
 }
 
 
 public function studentrequest()
 {    
     $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
    $current_academic_year_id = $cur_acyear->ac_id;
     $userId=Auth::id();
     $joinrequest=RequestJoinClub::where('user_id',$userId)->get();
    return view('clubs.studentrequest',compact('joinrequest','userId'));
 }
 
 public function studentrequest_actions($id)
 {
      $userId=Auth::id();
      $joinrequest=RequestJoinClub::join('students','join_request_club.student_id','students.student_id')
      ->join('add_clubs','add_clubs.club_id','=','join_request_club.club_id')
      ->where('join_request_club.user_id',$userId)
      ->where('join_request_club.joinclub_id',$id)
      ->select('students.name','students.adno','join_request_club.*','add_clubs.club_name')
      ->first();
    
    //  $joinrequest=RequestJoinClub::where('user_id',$userId)->where('joinclub_id',$id)->get();
    return view('clubs.studentrequest_actions',compact('joinrequest','userId'));
 } 
 public function studentrequest_actions_approve($id)
 {
     $request = RequestJoinClub::find($id);

        
        if ($request) {
          
            $request->status = 1;
            $request->save();
            
        
            return redirect()->route('club.request')->with('success','Request approved successfully.');
        }
 
 }
 public function studentrequest_actions_reject($id)
   {
        $request =  RequestJoinClub::find($id);

        if ($request) {
            $request->status = 2;
            $request->save();
            
          
            return redirect()->back()->with('success', 'Request rejected successfully.');
        }
   }
 
 
 
 
 public function studentexam_add_practical()
 {
   $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
    return view('internalassessment.studentexam_add_practical',compact('courses'));
 }
 
 
 public function studentexam_get_p(Request $request)
 {
      $course =$request->course;
     
        $semester_id = $request->semester_id;
        $exam_name = $request->exam_name;
         
       
        $ac_id = getAcyear();
         $subjects = collect();
        $sem_name = Semester::where('semester_id',$request->semester_id)->first();
         $subcategories = SubCategory::all();
         foreach ($subcategories as $subcategory) {
                 $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                                ->where('subjects.subject_categ', $subcategory->id)
                                ->where('course_subject.semester_id', $sem_name->semester_name);
                if (!in_array($subcategory->id, [2, 3, 4])) {
                    $query->where('course_subject.course_id', $sem_name->course_id);
                }
             $subjects = $subjects->merge($query->select('subjects.*')->get());
            }
            return view('internalassessment.studentexam_get_p',compact('course','semester_id','subjects','ac_id','exam_name'));
 }
 
 public function studentexam_add_save_p(Request $request)
 {
      $course = $request->course;
        $sem_id = $request->sem_id;
       
        $exam_name =$request->exam_name;
        $ac_id = getAcyear();
        $i=0;
      
        $check = PracticalExam::where([
                'ac_id' => $ac_id,
                'semester_id' => $sem_id,
                'course_id' => $course,
                'exam_name' => $exam_name
               
            ])->first();
            if(!$check){
                
                 $examlist = PracticalExam::create([
                     'course_id' => $course,
                        'ac_id' => $ac_id,
                        'course_id' => $course,
                        'semester_id' => $sem_id,
                        'exam_name' => $exam_name,
                        
                    ]);
            }
            else {
  
    $examlist = $check;
}
        foreach($request->posted as $ids)
        {
            $max_mark = $request->input("max_mark".$ids);
            $exam_date = $request->input("exam_date".$ids);
            $s_time = $request->input("s_time".$ids);
            $e_time = $request->input("e_time".$ids);
            if($max_mark =='')
            {
               $max_mark = 0; 
            }
                        $exmsub = StudentExamSubjectPract::create([
                            'pexam_id' => $examlist->pexam_id,
                            'subject_id' => $ids,
                            'max_mark' => $max_mark,
                            'date' => $exam_date,
                            's_time'=>$s_time,
                            'e_time'=>$e_time,
                        ]);
                        
                         $accalendar = AcademicCalendar::create([
                            'type' => 4,
                            'tb_id' => $exmsub->exsbp_id,
                            'event' => $exam_name,
                            'ev_date' => $exam_date,
                            'ac_id' => $ac_id,
                           
                        ]);   
                        $i++;
                 
                
           
            
        }
        if($i>0){
            $msg_array = array('message'=>'Exam addedd Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Exam Could not be Saved !','alert-type'=>'error');
        }
        return redirect()->route('pexam.add')->with($msg_array);
 }
 
public function studentexam_view_p()
{
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
        return view('internalassessment.studentexam_view_p',compact('ac_id','courses'));  
}
 public function studentexamviewgetp(Request $request)
 {
      $course_id=  $request->get('course');
        $sem_id=   $request->get('semester_id');
        $ac_id = getAcyear();
        $exam = array();
        $rows = PracticalExam::where('course_id', $course_id)->where('semester_id', $sem_id)->where('ac_id', $ac_id)->get();
        foreach($rows as $row){
        $exam[$row->pexam_id ] = $row->exam_name;
        }
      
        return json_encode($exam);
 }


public function stuexamviewget_p(Request $request)
{
        $course =$request->cid;
      
        $semester_id = $request->sid;
        $exam_id = $request->eid;
        
        $ac_id = getAcyear();
        $exam_name = PracticalExam::where('pexam_id',$request->eid)->first();
       
        $examsubjects = StudentExamSubjectPract::where('pexam_id',$request->eid)->get();
        $subjects = collect();
    
        $sem_name = Semester::where('semester_id',$request->sid)->first();
        $subcategories = SubCategory::all();
        foreach ($subcategories as $subcategory) {
             $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                            ->where('subjects.subject_categ', $subcategory->id)
                            ->where('course_subject.semester_id', $sem_name->semester_name);
            if (!in_array($subcategory->id, [2, 3, 4])) {
                $query->where('course_subject.course_id', $sem_name->course_id);
            }
         $subjects = $subjects->merge($query->select('subjects.*')->get());
        }
       
        return view('internalassessment.stuexamviewget_p',compact('course','semester_id','examsubjects','ac_id','exam_id','exam_name','subjects')); 
}
 public function examupdatep(Request $request)
{
   
       $crs_id = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $exam_id = decrypt($request->exam_id);
        
         $exmnamecheck = PracticalExam::where([
                'pexam_id' => $exam_id])->first();
        
              if($exmnamecheck){
            $exmnamecheck->update([
                'exam_name' => $request->exam_name,
            ]);
            
             }
        $ac_id = getAcyear();
        $eseexamsub = StudentExamSubjectPract::where('pexam_id',$exam_id)->get();
     
        $i=0;
        
        foreach($eseexamsub as $essm)
        {
            $exmcheck = StudentExamSubjectPract::where([
                'exsbp_id' =>$essm->exsbp_id 
               
            ])->first();
             if($exmcheck){
            $exmcheck->update([
                'max_mark' => $request->input("max_mark$essm->exsbp_id"),
                'date' => $request->input("exam_date$essm->exsbp_id"),
                's_time' => $request->input("s_time$essm->exsbp_id"),
                'e_time' => $request->input("e_time$essm->exsbp_id"),
            ]);
             $accheck = AcademicCalendar::where('tb_id', $exmcheck->exsbp_id)->where('type', 4)->first();
             if ($accheck) {
                $accheck->update([
            'event' => $request->exam_name,
            'ev_date' => $request->input("exam_date$essm->exsbp_id"),
            ]);
            } else {
        
        AcademicCalendar::create([
            'type' => 4,
            'tb_id' => $exmcheck->exsbp_id,
            'event' => $request->exam_name,
            'ev_date' => $request->input("exam_date$essm->exsbp_id"),
            'ac_id' => $ac_id,
        ]);
    }
             $i++; 
             }
        }
       
      if($i>0){
            $msg_array = array('message'=>'Exam Details has been Updated Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Exam Details Could not be Updated !','alert-type'=>'error');
        }
          
          return redirect()->route('pexam.view')->with($msg_array);  
}

 public function pexamdelete($id)
 {
    $subjectexam= StudentExamSubjectPract::find($id)->delete();
       if($subjectexam)
       {
           $msg_array=array('message','Exam deleted successfully!!','success');
       }
        else
       {
           $msg_array=array('message','Exam could not be deleted!!','error');
       }
       return redirect()->route('stu.pexam.view')->with($msg_array); 
 }
 public function pexamchart()
 { 
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
     
     return view('internalassessment.pexamchart',compact('courses'));
     
 }
 public function examchart_get_p(Request $request)
 {
     $crs=Course::find($request->cid);
     $sem=Semester::find($request->sid);
      $course_id=$request->cid;
     $sem_id=$request->sid;
     $exm=$request->eid;
    
     $exam=PracticalExam::join('student_exam_subjects_practical','student_exam_subjects_practical.pexam_id','=','practical_exam_inter.pexam_id')
     ->where('practical_exam_inter.course_id',$request->cid)
     ->where('practical_exam_inter.semester_id',$request->sid)
     ->where('practical_exam_inter.pexam_id',$request->eid)
     ->select('student_exam_subjects_practical.*','practical_exam_inter.*')
     ->get();
   
     return view('internalassessment.examchart_get_p',compact('exm','exam','sem','crs','course_id','sem_id')); 
 }
 public function pexamchart_print($semid,$crsid,$eid)
 {
    $ins_det = instituteDetails();
       $crs=Course::find($crsid);
       $sem=Semester::find($semid);
      
       $exm=PracticalExam::where('pexam_id',$eid)->first();
        $course_name = Course::where('course_id',$crsid)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semid)->whereNull('deleted_at')->first(); 
        $exam=PracticalExam::join('student_exam_subjects_practical','student_exam_subjects_practical.pexam_id','=','practical_exam_inter.pexam_id')
     ->where('practical_exam_inter.course_id',$crsid)
     ->where('practical_exam_inter.semester_id',$semid)
      ->where('practical_exam_inter.pexam_id',$eid)
     ->select('student_exam_subjects_practical.*','practical_exam_inter.*')
     ->get();
    $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 

      return view('internalassessment.pexamchart_print',compact('exm','eid','cur_acyear','exam','ins_det','course_name','sem_name'));
   }
 public function admitcardp()
 {
    
     $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
    return view('internalassessment.admitcardp',compact('courses')); 
 }
 public function padmitcard_get(Request $request)
 {
  $crs = $request->cid;
$sem = $request->sid;
$exm = $request->eid;  

$ac_id = getAcyear();
$student = Student::join('promotes', 'promotes.student_id', '=', 'students.student_id')
                  ->where('promotes.ac_id', $ac_id)
                  ->where('promotes.semester_id', $sem)
                  ->where('promotes.course_id', $crs)
                  ->select('students.*')
                  ->get();

return view('internalassessment.padmitcard_get', compact('student', 'crs', 'sem', 'exm'));   
 }
public function admitcard_printp($id,$exmid)
{
   $student_id=Student::find($id);
    //  $exm=PracticalExam::find($exmid);
    
     $register_no=Enrolment::where('student_id',$id)->first();
     $ac_id = getAcyear();
     $students=Student::where('student_id',$id)->first();
     $ins_det = instituteDetails();
    $acyear=Acyear::where('ac_id',$ac_id)->first();
    $sdate=$acyear->sdate;
    $edate=$acyear->edate;
     $exam=PracticalExam::join('student_exam_subjects_practical','student_exam_subjects_practical.pexam_id','=','practical_exam_inter.pexam_id')
     ->join('subjects','subjects.subject_id','=','student_exam_subjects_practical.subject_id')
     ->where('student_exam_subjects_practical.pexam_id',$exmid)
     ->where('practical_exam_inter.ac_id',$ac_id)
     ->select('subjects.subject_name','student_exam_subjects_practical.*','practical_exam_inter.exam_name')
     ->get();
    return view('internalassessment.admitcard_printp',compact('exam','students','ac_id','sdate','edate','ins_det','register_no'));
       
}
public function pexam_marks()
{
      $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
     return view('internalassessment.pexam_marks',compact('courses'));  
}
public function subwise_exm_mrksp(Request $request)
{
      $course = $request->course;
        $semester_id = $request->semester_id;
        $exam_id = $request->exam_id;
        
        $ac_id = getAcyear();
        $semesters = Semester::where('course_id',$course)->get();
        $exam_name = PracticalExam::where('pexam_id',$exam_id)->first();
        $examsubjects = StudentExamSubjectPract::where('pexam_id',$exam_id)->get();

        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('students.*')->get();
        $marks = MainstreamPracExamMarks::where([
        'ac_id' => $ac_id,
        'course_id' => $course,
        'semester_id' => $semester_id,
        'pexam_id' => $exam_id
    ])->get();     
    $marksByStudent = [];
    foreach ($marks as $mark) {
        $marksByStudent[$mark->student_id][$mark->subject_id] = $mark->mark;
    }
         return view('internalassessment.subwise_exm_mrksp',compact('marksByStudent','course','semester_id','examsubjects','ac_id','semesters','exam_id','students','exam_name','marks'));
}
public function subwise_pexm_mrks_save(Request $request)
{
   $crs_id = decrypt($request->course);
    $sem_id = decrypt($request->sem_id);
    $exm_id = decrypt($request->exam_id);
    $ac_id = getAcyear();
    
    $examsubject = StudentExamSubjectPract::where('pexam_id', $exm_id)->get();
    
   
    if (!empty($request->posted)) {
        foreach ($request->posted as $ids) {
           
            foreach ($examsubject as $exam) {
                
                
                $check = MainstreamPracExamMarks::where([
                    'ac_id' => $ac_id,
                    'course_id' => $crs_id,
                    'semester_id' => $sem_id,
                    'pexam_id' => $exm_id,
                    'subject_id' => $exam->subject_id,
                    'student_id' => $ids,
                ])->first();

               
                $MarkValue = $request->input("mark" . $ids . "_" . $exam->subject_id);

                if($MarkValue == "AB" || $MarkValue == "ab" || $MarkValue == "Ab")
                    {
                        $MarkValue = -1;
                    }
                if ($MarkValue !== null && $MarkValue !== '') {
                    if (!$check) {
                       
                        MainstreamPracExamMarks::create([
                            'student_id' => $ids,
                            'ac_id' => $ac_id,
                            'course_id' => $crs_id,
                            'semester_id' => $sem_id,
                            'pexam_id' => $exm_id,
                            'subject_id' => $exam->subject_id,  
                            'mark' => $MarkValue,
                        ]);
                    } else {
                       
                        $check->update(['mark' => $MarkValue]);
                    }
                }
            }
        }
        
     
        $msg_arry=array('message'=>'Marks have been successfully saved!','success');
    } else {
      
       $msg_arry=array('message'=>'Marks could not save!','error');
    }
    
  
    return redirect()->back()->with($msg_arry);  
 }
 
  public function subwise_exm_mrks_printp($course_id,$sem_id,$exm_id)
  {
      $ins_det = instituteDetails();
        $ac_id = getAcyear();
        
        $course_name = Course::where('course_id',$course_id)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$sem_id)->whereNull('deleted_at')->first(); 
        $exam_name = PracticalExam::where('pexam_id',$exm_id)->first();
        $examsubjects = StudentExamSubjectPract::where('pexam_id',$exm_id)->get();
       $marks = MainstreamPracExamMarks::where([
        'ac_id' => $ac_id,
        'course_id' => $course_id,
        'semester_id' => $sem_id,
        'pexam_id' => $exm_id
    ])->get();     
    $marksByStudent = [];
    foreach ($marks as $mark) {
        $marksByStudent[$mark->student_id][$mark->subject_id] = $mark->mark;
    }

        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course_id,'promotes.semester_id'=>$sem_id))->select('students.*')->get();
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('internalassessment.subwise_exm_mrks_printp',compact('marksByStudent','students','exam_name','ac_id','ins_det','cur_acyear','course_name','sem_name','exm_id','examsubjects','course_id','sem_id')); 
  }
public function pexam_marks_sub()
{
      $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
     return view('internalassessment.exam_marks_subjectp',compact('courses'));
}
public function exam_marks_subject_ajxp(Request $request)
{
        $exam_id=   $request->get('exam_id');
        $course_id=  $request->get('course');
        $sem_id=   $request->get('semester_id');
        $ac_id = getAcyear();
        $examsub = array();
        $rows = StudentExamSubjectPract::where('pexam_id', $exam_id)->get();
        foreach($rows as $row){
            
            $examsub[$row->subject_id] = $row->esesubn->subject_code.' - '.$row->esesubn->subject_name;
        }
        
        return json_encode($examsub);  
}
public function mainstexmsbwisep(Request $request)
{
   
   $course = $request->course;
        $semester_id = $request->semester_id;
        $exam_id = $request->exam_id;
        $sub_id = $request->sub_id;
       
        $ac_id = getAcyear();
        $semesters = Semester::where('course_id',$course)->get();
        $exam_name = PracticalExam::where('pexam_id',$exam_id)->first();
        $examsubjects = StudentExamSubjectPract::where('pexam_id',$exam_id)->where('subject_id',$sub_id)->first();
       
        $subject_name = Subject::where('subject_id',$sub_id)->first();

        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('students.*')->get();
        $marks = MainstreamPracExamMarks::where([
        'ac_id' => $ac_id,
        'course_id' => $course,
        'semester_id' => $semester_id,
        'pexam_id' => $exam_id,
        'subject_id'=>$sub_id
    ])->get();     
    $marksByStudent = [];
    foreach ($marks as $mark) {
        $marksByStudent[$mark->student_id][$mark->subject_id] = $mark->mark;
    }
        return view('internalassessment.mainstexmsbwisep',compact('marksByStudent','course','semester_id','examsubjects','ac_id','semesters','exam_id','students','exam_name','sub_id','subject_name'));
           
}
 public function mainstpexmsbwise_print($course,$semester_id,$exam_id,$sub_id)
 {
      $ins_det = instituteDetails();
        
       
        $ac_id = getAcyear();
         $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
        $exam_name = PracticalExam::where('pexam_id',$exam_id)->first();
        $subject_name=Subject::where('subject_id',$sub_id)->whereNull('deleted_at')->first();
        $examsubjects = StudentExamSubjectPract::where('pexam_id',$exam_id)->where('subject_id',$sub_id)->first();

        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('students.*')->get();
               $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
  $marks = MainstreamPracExamMarks::where([
        'ac_id' => $ac_id,
        'course_id' => $course,
        'semester_id' => $semester_id,
        'pexam_id' => $exam_id,
        'subject_id'=>$sub_id
          ])->get(); 
 $marksByStudent = [];
    foreach ($marks as $mark) {
        $marksByStudent[$mark->student_id][$mark->subject_id] = $mark->mark;
    }
        return view('internalassessment.mainstpexmsbwise_print',compact('marksByStudent','sem_name','course_name','cur_acyear','ins_det','examsubjects','course','semester_id','examsubjects','ac_id','exam_id','students','exam_name','sub_id','subject_name'));
 }
 public function mainstpexmsbwise_save(Request $request)
 {
       $crs_id = decrypt($request->course);
    $sem_id = decrypt($request->sem_id);
    $exm_id = decrypt($request->exam_id);
    $sub_id = decrypt($request->sub_id);
    $ac_id = getAcyear();
    
    $examsubject = StudentExamSubjectPract::where('pexam_id', $exm_id)->where('subject_id',$sub_id)->get();
    
   
    if (!empty($request->posted)) {
        foreach ($request->posted as $ids) {
           
            foreach ($examsubject as $exam) {
                
                
                $check = MainstreamPracExamMarks::where([
                    'ac_id' => $ac_id,
                    'course_id' => $crs_id,
                    'semester_id' => $sem_id,
                    'pexam_id' => $exm_id,
                    'subject_id' => $sub_id,
                    'student_id' => $ids,
                ])->first();

               
                $MarkValue = $request->input("mark" . $ids . "_" . $sub_id);
                 if($MarkValue=="ab" || $MarkValue=="AB" || $MarkValue=="Ab")
                 {
                     $MarkValue="-1";
                 }
                
                if ($MarkValue !== null && $MarkValue !== '') {
                    if (!$check) {
                       
                        MainstreamPracExamMarks::create([
                            'student_id' => $ids,
                            'ac_id' => $ac_id,
                            'course_id' => $crs_id,
                            'semester_id' => $sem_id,
                            'pexam_id' => $exm_id,
                            'subject_id' => $sub_id,  
                            'mark' => $MarkValue,
                        ]);
                    } else {
                       
                        $check->update(['mark' => $MarkValue]);
                    }
                }
            }
        }
        
     
        $msg_arry=array('message'=>'Marks have been successfully saved!','success');
    } else {
      
       $msg_arry=array('message'=>'Marks could not save!','error');
    }
    
  
    return redirect()->back()->with($msg_arry);  
 }
 
 
 
}
