<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Acyear;
use App\Models\User;
use App\Models\Course;
use App\Models\SubjectType; 
use App\Models\Semester;
use App\Models\Subject;
use App\Models\Promote;
use App\Models\SubCategory;
use App\Models\FYUGPPATHWAY;
use App\Models\FyugpStudSub;
use App\Models\FYUGP_Grade;
use App\Models\FyugpExams;
use App\Models\FyugpExamSubject;
use App\Models\FyugpSubjectCredit;
use App\Models\FA;
use App\Models\SA;
use App\Models\FA_ASSIGN;
use App\Models\SA_ASSIGN;
use App\Models\STUDFAMARKS;
use App\Models\STUDSAMARKS;
use App\Models\STUDEXMMARKS;
use App\Models\Enrolment;
use App\Models\FyugpStudSubPreferences;
use App\Models\FYUGPSTUDPATHWAY;
use App\Models\Student;
use App\Models\Seatallotment;
use App\Models\PathwaySettings;
use App\Models\CourseSubject;
use App\Models\AcademicCalendar;
use App\Models\HOD;
use App\Models\StaffSubject;
use App\Models\ClassTeacher;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
//use PDF;
use Barryvdh\DomPDF\Facade\Pdf;
use Dompdf\Dompdf;
use Dompdf\Options;

class Fyugp extends Controller
{
    
     public function set_pathway_valid(){
        $pathwaysettings = PathwaySettings::all();
       
       
        return view('fyugp.settings.set_pathway_valid',compact('pathwaysettings'));
    }
    
     public function pathway_valid_update($acid){
          PathwaySettings::query()->update(['ch_pathway' => 0]);
          $psettings = PathwaySettings::find(decrypt($acid));
        $psettings->update(['ch_pathway'=>1]);
        if($psettings){
            $msg_array = array('message'=>'Set Default Pathway Status Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Default Pathway Status Could not be Set !','alert-type'=>'error');
        }
        return redirect()->route('fyugp.pathway.valid')->with($msg_array);
     }
    public function add_pathway(){
        $pathway = FYUGPPATHWAY::all();
       
       
        return view('fyugp.settings.add_pathway',compact('pathway'));
    }   
    
    public function pathway_save(Request $request)
    {
         
         $validated = $request->validate([
                'pathway' => 'required',
              
            ]);
            $pathways = FYUGPPATHWAY::create([
                'pathway' => $request->pathway,
               
            ]); 
            if($pathways){
            $msg_array = array('message'=>'Pathway Added Successfully !','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Pathway Could not be Added !','alert-type'=>'error');
            }
            return redirect()->route('fyugp.pathway')->with($msg_array); 
         
    }  
    public function pathway_delete($aid){
        
        $pathway = FYUGPPATHWAY::find(decrypt($aid));
       
        if($pathway){
             $studpathways = FYUGPSTUDPATHWAY::where('pathway_id', decrypt($aid))->count();
           if ($studpathways == 0) {
                $pathway->delete();
                $msg_array = array('message'=>'Pathway Deleted Successfully !','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Domain Could not be Deleted !','alert-type'=>'error');
            }
        }
        else
        {
             $msg_array = array('message'=>'Pathway not Found !','alert-type'=>'error');
        }
        return redirect()->route('fyugp.pathway')->with($msg_array);
    } 
    
    public function pathway_edit($aid)
    {
            
            
            $pathway = FYUGPPATHWAY::find(decrypt($aid));
            
            return view('fyugp.settings.edit_pathway',compact(array('pathway')));
        
    
    }  
    
    public function pathway_update(Request $request)
    {
          $pathway_id=decrypt($request->pathway_id);
          $validated=$request->validate([
                 'pathway' => 'required|unique:fyugp_pathway,pathway,'.$pathway_id.',id',
              
              ]);
              $pathways=FYUGPPATHWAY::find($pathway_id);
              $pathways->update([
    
                  'pathway'=>$request->pathway,
                  ]);
                  if($pathways)
                  {
                      $msg_array=array('message'=>'Pathway updated successfully','success');
                      
                  }
                  else
                  {
                     $msg_array=array('message'=>'Pathway could not be updated','error'); 
                  }
                  return redirect()->route('fyugp.pathway')->with($msg_array);
    } 
        
     public function studpreferences(){
     
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCourses = Course::where('department_id',$user->dept_id)->get();
           $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
           $courses = $deptCourses->merge($staffCourses)->unique('course_id');  
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCourses = Course::where('department_id',$hod_dept->id)->get();
               $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
               $courses = $deptCourses->merge($staffCourses)->unique('course_id'); 
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $deptCourses = Course::where('department_id',$user->dept_id)->get();
                   $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
                   $courses = $deptCourses->merge($staffCourses)->unique('course_id');
               }
           }
       }
       $pathway = FYUGPPATHWAY::all();
       $subCategories = SubCategory::whereIn('id', [2, 3, 4])->whereNull('deleted_at')->get();
       
        return view('fyugp.preferences.studpreferences_add',compact('courses','subCategories','pathway'));
    }  
    
    public function get_fyugpstudpreferences(Request $request)
    {
      
        $course_id = $request->course;
        $semester_id = $request->semester_id;
        $category_id = $request->category_id;
        $pathway = FYUGPPATHWAY::all();
        $ac_id = getAcyear();
        $subjects = Subject::where('course_id',$course_id)->where('semester_id',$semester_id)->get();
        $categ_name = SubCategory::where('id',$category_id)->whereNull('deleted_at')->first();
        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course_id,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->orderBy('students.clno', 'ASC')->get();
        
       $courses = Course::all();
       
        $sem_name = Semester::where('semester_id',$semester_id)->first();
        $minors = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                ->where([
                    'subjects.subject_categ' => $category_id,
                    'course_subject.semester_id' => $sem_name->semester_name,
                ])
                ->select('subjects.*')
                ->get();
                
        $pathwaysetings = PathwaySettings::where('type','Active')->first();
        $valid_period = $pathwaysetings->ch_pathway;
        
        return view('fyugp.preferences.studpreferences_get',compact('course_id','semester_id','subjects','ac_id','students','minors','category_id','categ_name','pathway','valid_period'));
         
    }
    public function studpreferences_save(Request $request){
        $course = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $categ_id = decrypt($request->categ_id);
        $ac_id = getAcyear();
        $i=0;
        if (is_array($request->posted)) {
        foreach($request->posted as $ids)
        {
            $pathway_Id = !is_null($request->input("pathway_id".$ids)) ? $request->input("pathway_id".$ids) : ''; 
            $p_sgpa = !is_null($request->input("p_sgpa".$ids)) ? $request->input("p_sgpa".$ids) : ''; 
            $pref_I = !is_null($request->input("pref_I".$ids)) ? $request->input("pref_I".$ids) : ''; 
            $pref_II = !is_null($request->input("pref_II".$ids)) ? $request->input("pref_II".$ids) : ''; 
            $pref_III = !is_null($request->input("pref_III".$ids)) ? $request->input("pref_III".$ids) : ''; 
            $pref_IV = !is_null($request->input("pref_IV".$ids)) ? $request->input("pref_IV".$ids) : ''; 
            $pref_V = !is_null($request->input("pref_V".$ids)) ? $request->input("pref_V".$ids) : ''; 
            
            if(!is_null($pathway_Id))
            { 
                $checkpathway = FYUGPSTUDPATHWAY::where([
                'stud_id' => $ids,'course_id' =>$course,'sem_id'=>$sem_id,'ac_id'=>$ac_id
                ])->first();
                if(!$checkpathway){
                    FYUGPSTUDPATHWAY::create([
                        'stud_id' => $ids,
                        'pathway_id' => $pathway_Id,
                        'course_id'=>$course,
                        'sem_id'=>$sem_id,
                        'ac_id'=> $ac_id,
                            ]);
                }
                else
                {
                     $checkpathway->update([
                    'pathway_id' => $pathway_Id,
                   
                ]);
                }
                
            }
            
            if (!is_null($pref_I)) { 
            $check = FyugpStudSubPreferences::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => $categ_id,
                'type' => 1,
                'stud_id' => $ids
            ])->first();
           
            if(!$check){
                    
                         $preferencelist = FyugpStudSubPreferences::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'pref_Id' => $pref_I,
                        
                        'type' => 1,
                        'sub_cat' =>$categ_id,
                        'sgpa' =>$p_sgpa,
                    ]);
                    if($preferencelist){ 
                        
                         $minorIlist = FyugpStudSub::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'sub_id' => $pref_I,
                        'sub_cat' =>$categ_id,
                        'p_sgpa' =>$p_sgpa,
                    ]);
                        
                        $i++; }
                    
                 }
                 else
                {
                    $check->update([
                    'pref_Id' => $pref_I,
                    'sgpa' =>$p_sgpa,
                   
                ]);
                
                $checkminor = FyugpStudSub::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => $categ_id,
                'stud_id' => $ids
            ])->first();
                $checkminor->update([
                    'sub_id' => $pref_I,
                    'p_sgpa' =>$p_sgpa,
                   
                ]);
                
                 $i++;
                }
            }
            
           if (!is_null($pref_II)) { 
            $checkII = FyugpStudSubPreferences::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => $categ_id,
                'type' => 2,
                'stud_id' => $ids
            ])->first();
           
            if(!$checkII){
                    
                         $preferencelistII = FyugpStudSubPreferences::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'pref_Id' => $pref_II,
                        
                        'type' => 2,
                        'sub_cat' =>$categ_id,
                        'sgpa' =>$p_sgpa,
                        
                    ]);
                    if($preferencelistII){ $i++; }
                    
                 }
                 else
                {
                    $checkII->update([
                    'pref_Id' => $pref_II,
                    'sgpa' =>$p_sgpa,
                ]);
                 $i++;
                }
            } 
            
            if (!is_null($pref_III)) { 
            $checkIII = FyugpStudSubPreferences::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => $categ_id,
                'type' => 3,
                'stud_id' => $ids
            ])->first();
           
            if(!$checkIII){
                    
                         $preferencelistIII = FyugpStudSubPreferences::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'pref_Id' => $pref_III,
                        
                        'type' => 3,
                        'sub_cat' =>$categ_id,
                        'sgpa' =>$p_sgpa,
                        
                    ]);
                    if($preferencelistIII){ $i++; }
                    
                 }
                 else
                {
                    $checkIII->update([
                    'pref_Id' => $pref_III,
                    'sgpa' =>$p_sgpa,
                   
                ]);
                 $i++;
                }
            }
           
           if (!is_null($pref_IV)) { 
            $checkIV = FyugpStudSubPreferences::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => $categ_id,
                'type' => 4,
                'stud_id' => $ids
            ])->first();
           
            if(!$checkIV){
                    
                         $preferencelistIV = FyugpStudSubPreferences::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'pref_Id' => $pref_IV,
                        
                        'type' => 4,
                        'sub_cat' =>$categ_id,
                        'sgpa' =>$p_sgpa,
                        
                    ]);
                    if($preferencelistIV){ $i++; }
                    
                 }
                 else
                {
                    $checkIV->update([
                    'pref_Id' => $pref_IV,
                    'sgpa' =>$p_sgpa,
                   
                ]);
                 $i++;
                }
            }
            
            if (!is_null($pref_V)) { 
            $checkV = FyugpStudSubPreferences::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => $categ_id,
                'type' => 5,
                'stud_id' => $ids
            ])->first();
           
            if(!$checkV){
                    
                         $preferencelistV = FyugpStudSubPreferences::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'pref_Id' => $pref_V,
                        'type' => 5,
                        'sub_cat' =>$categ_id,
                        'sgpa' =>$p_sgpa,
                        
                    ]);
                    if($preferencelistV){ $i++; }
                    
                 }
                 else
                {
                    $checkV->update([
                    'pref_Id' => $pref_V,
                    'sgpa' =>$p_sgpa,
                   
                ]);
                 $i++;
                }
            }
            
        } }
        if($i>0){
            $msg_array = array('message'=>'Student Preferences has been Saved Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Student Preferences Could not be Saved !','alert-type'=>'error');
        }
          return redirect()->route('fyugp.studpreferences')->with($msg_array);
        
    }
    
     public function studsub(){
        
       
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCourses = Course::where('department_id',$user->dept_id)->get();
           $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
           $courses = $deptCourses->merge($staffCourses)->unique('course_id');  
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCourses = Course::where('department_id',$hod_dept->id)->get();
               $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
               $courses = $deptCourses->merge($staffCourses)->unique('course_id'); 
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $deptCourses = Course::where('department_id',$user->dept_id)->get();
                   $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
                   $courses = $deptCourses->merge($staffCourses)->unique('course_id');
               }
           }
       }
       
       
        return view('fyugp.studsub_add',compact('courses'));
    }  
    
    
     public function get_fyugpstudsub(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $pathway = FYUGPPATHWAY::all();
        $ac_id = getAcyear();
        $subjects = Subject::where('course_id',$course)->where('semester_id',$semester_id)->get();
        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->orderBy('students.clno', 'ASC')->get();

        return view('fyugp.studsub_get',compact('course','semester_id','subjects','ac_id','students','pathway'));
         
     }
     
      public function studsub_save(Request $request){
        $course = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $ac_id = getAcyear();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$sem_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->get();
        $i=0;
        if (is_array($request->posted)) {
        foreach($request->posted as $ids)
        {
            
                $check = FyugpStudSub::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => 2,
                'stud_id' => $ids
            ])->first();
             $minorI = $request->input("minorI".$ids);
              if(!$check){
                     if (!is_null($minorI)) {
                         $minorIlist = FyugpStudSub::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'sub_id' => $minorI,
                        'sub_cat' =>2,
                        
                    ]);
                    if($minorIlist){ $i++; }
                     }
                 }
                 else
                {
                    $check->update([
                    'sub_id' => $minorI,
                ]);
                 $i++;
                }
              $checkII = FyugpStudSub::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => 3,
                'stud_id' => $ids
            ])->first();
             $minorII = $request->input("minorII".$ids);
              if(!$checkII){
                     if (!is_null($minorII)) {
                         $minorIIlist = FyugpStudSub::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'sub_id' => $minorII,
                        'sub_cat' =>3,
                        
                    ]);
                    if($minorIIlist){ $i++; }
                     }
                 }
                 else
                {
                    $checkII->update([
                    'sub_id' => $minorII,
                ]);
                 $i++;
                }  
                $checkmdcI = FyugpStudSub::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => 4,
                'stud_id' => $ids
            ])->first();
                $mdcugI = $request->input("mdcugI".$ids);
              if(!$checkmdcI){
                     if (!is_null($mdcugI)) {
                         $mdcIlist = FyugpStudSub::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'sub_id' => $mdcugI,
                        'sub_cat' =>4,
                        
                    ]);
                    if($mdcIlist){ $i++; }
                     }
                 }
                 else
                {
                    $checkmdcI->update([
                    'sub_id' => $mdcugI,
                ]);
                 $i++;
                }  
                
                
                
        } }
         if($i>0){
            $msg_array = array('message'=>'FYUGP has been Saved Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'FYUGP Could not be Saved !','alert-type'=>'error');
        }
          return redirect()->route('fyugp.studsub')->with($msg_array);
          
      }
      
      public function fyugpstudsubprint($course,$semester_id){
        $ins_det = instituteDetails();
        $ac_id = getAcyear();
       
       
        $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
        $subjects = Subject::where('course_id',$course)->where('semester_id',$semester_id)->get();
        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->orderBy('students.clno', 'ASC')->get();
        $minorIsub =  Subject::where('course_id',$course)->where('semester_id',$semester_id)->where('subject_categ',2)->get();
        $minorIIsub =  Subject::where('course_id',$course)->where('semester_id',$semester_id)->where('subject_categ',3)->get();
        $mdcIsub =  Subject::where('course_id',$course)->where('semester_id',$semester_id)->where('subject_categ',4)->get();
          
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('fyugp.print_studsub_report',compact('ac_id','ins_det','cur_acyear','course_name','sem_name','semester_id','subjects','students','minorIsub','minorIIsub','mdcIsub','course'));
    }
      
      
      public function subrep(){
        $ac_id = getAcyear();
        $user = Auth::user();
        
       $userId = $user->user_id;  
        if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
        }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
            }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
               }
           }
       }
       
       
        return view('fyugp.subwise_report',compact('courses'));
    } 
     public function fyugpsubrep(Request $request)
     {
        $course = $request->course;
        $semester_id = $request->semester_id;
        $sub_id = $request->sub_id;
        $ac_id = getAcyear();
        $semesters = Semester::where('course_id',$course)->get();
       
        $sem_name = Semester::where('semester_id',$semester_id)->first();
        $sem_cnt =[];
        $sem_array = Semester::where('semester_name',$sem_name->semester_name)->get(); 
        foreach($sem_array as $sem)
        {
          $sem_cnt[]  = $sem->semester_id;
        }
        
        $fyugpstudsubjects = FyugpStudSub::where('sub_id',$sub_id)->where('acyear_id',$ac_id)->where('status',1)->whereIn('sem',$sem_cnt)->get();  
        return view('fyugp.subwisestud_report',compact('course','semester_id','ac_id','fyugpstudsubjects','semesters','sub_id'));
         
     }
     
     public function fyugpsubrepprint($course,$semester_id,$sub_id){
        $ins_det = instituteDetails();
        $ac_id = getAcyear();
       
        $subjects_name = Subject::where('subject_id',$sub_id)->whereNull('deleted_at')->first(); 
        $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
         $sem_name = Semester::where('semester_id',$semester_id)->first();
        $sem_cnt =[];
        $sem_array = Semester::where('semester_name',$sem_name->semester_name)->get(); 
        foreach($sem_array as $sem)
        {
          $sem_cnt[]  = $sem->semester_id;
        }
        $fyugpstudsubjects = FyugpStudSub::where('sub_id',$sub_id)->where('acyear_id',$ac_id)->where('status',1)->whereIn('sem',$sem_cnt)->get();  
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('fyugp.print_subwisestud_report',compact('subjects_name','ac_id','ins_det','cur_acyear','course_name','sem_name','fyugpstudsubjects','sub_id'));
    }
    
     public function deprep(){
        
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
               }
           }
       }
       $subCategory = SubCategory::whereIn('id', [2, 3, 4])->whereNull('deleted_at')->get();
       
        return view('fyugp.depwise_report',compact('courses','subCategory'));
    }
    
    public function fyugpdeprep(Request $request)
     {
        $course = $request->course;
        $semester_id = $request->semester_id;
        $category_id = $request->category_id;
        $ac_id = getAcyear();
        
       $fyugpstudsubjects = FyugpStudSub::Join('students','fyugp_stud_sub.stud_id','=','students.student_id')->where('fyugp_stud_sub.course',$course)->where('fyugp_stud_sub.sem',$semester_id)->where('fyugp_stud_sub.status',1)->where('fyugp_stud_sub.sub_cat',$category_id)->where('fyugp_stud_sub.acyear_id',$ac_id)->select('fyugp_stud_sub.*')->orderBy('students.clno', 'ASC')->get();  

      /*  $fyugpstudsubjects = FyugpStudSub::where('course',$course)->where('sem',$semester_id)->where('acyear_id',$ac_id)->where('status',1)->where('sub_cat',$category_id)->get();  */
        return view('fyugp.depwisestud_report',compact('course','ac_id','fyugpstudsubjects','category_id','semester_id'));
         
     }
     public function fyugpdeprepprint($course,$semester_id,$category_id){
        $ins_det = instituteDetails();
        $ac_id = getAcyear();
       
       $sem_name = Semester::where('semester_id',$semester_id)->first();
        $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $categ_name = SubCategory::where('id',$category_id)->whereNull('deleted_at')->first(); 
        $fyugpstudsubjects = FyugpStudSub::Join('students','fyugp_stud_sub.stud_id','=','students.student_id')->where('fyugp_stud_sub.course',$course)->where('fyugp_stud_sub.sem',$semester_id)->where('fyugp_stud_sub.status',1)->where('fyugp_stud_sub.sub_cat',$category_id)->where('fyugp_stud_sub.acyear_id',$ac_id)->select('fyugp_stud_sub.*')->orderBy('students.rollno', 'ASC')->get();  

       /*$fyugpstudsubjects = FyugpStudSub::where('course',$course)->where('sem',$semester_id)->where('acyear_id',$ac_id)->where('status',1)->where('sub_cat',$category_id)->get();  */  
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('fyugp.print_depwisestud_report',compact('ac_id','ins_det','cur_acyear','course_name','categ_name','fyugpstudsubjects','category_id','sem_name'));
    }
    
       public function grade(){
          $ac_id = getAcyear();
        $previous_acyear = Acyear::where('ac_id', '<', $ac_id)
                              ->orderBy('ac_id', 'desc')
                              ->first();
       $previousAcId = $previous_acyear ? $previous_acyear->ac_id : null;
       $pgrading = FYUGP_Grade::where('ac_year_id', $previousAcId)->get(); 
       if(!FYUGP_Grade::where('ac_year_id', $ac_id)->exists())
        {
            foreach ($pgrading as $pgd) {
                    $pgding_n1 = FYUGP_Grade::create([
                    'p_from' => $pgd->p_from,
                    'p_to' => $pgd->p_to,
                    'gp' => $pgd->gp,
                    'gp_to' => $pgd->gp_to,
                    'gp_from' => $pgd->gp_from,
                    'grade' => $pgd->grade,
                    'description' => $pgd->description,
                    'ac_year_id' => $ac_id,
                   
                    ]); 
            }
            
        }
       $grading = FYUGP_Grade::where('ac_year_id',$ac_id)->get();
       
       
        return view('fyugp.set_grade',compact('grading'));
    }   
    
    public function grade_save(Request $request)
 {
     
     $validated = $request->validate([
            'p_from' => 'required',
            'p_to' => 'required',
            'gp' => 'required',
            'gp_from' => 'required',
            'gp_to' => 'required',
            'grade' => 'required',
            'description' => 'required',
            
        ]);
         $ac_id = getAcyear();
          $checkgd = FYUGP_Grade::where([
                'ac_year_id' => $ac_id,
                'grade' => $request->grade,
               
            ])->first();
            if(!$checkgd){
            $grading = FYUGP_Grade::create([
                'p_from' => $request->p_from,
                'p_to' => $request->p_to,
                'gp' => $request->gp,
                'gp_to' => $request->gp_to,
                 'gp_from' => $request->gp_from,
                'grade' => $request->grade,
                'description' => $request->description,
                'ac_year_id' => $ac_id,
    
            ]); 
            }
        if($grading){
            $msg_array = array('message'=>'Grading Added Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Grading Could not be Added !','alert-type'=>'error');
        }
        return redirect()->route('fyugp.grade')->with($msg_array); 
     
     
 }
  public function grade_delete($aid){
        
        $grading = FYUGP_Grade::find(decrypt($aid));
        
        if($grading){
            if($grading->count() > 0){
                $grading->delete();
                $msg_array = array('message'=>'Grade Deleted Successfully !','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Grade Could not be Deleted !','alert-type'=>'error');
            }
        }
        
        return redirect()->route('fyugp.grade')->with($msg_array);
    } 
    
    public function exam(){
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
               }
           }
       }
        return view('fyugp.add_exams',compact('ac_id','courses'));
    }
    
    public function get_exam(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $exam_name = $request->exam_name;
        $ac_id = getAcyear();
        $crs_det = Course::where('course_id',$course)->first();
        $department_id = $crs_det->department_id;
        /*$subjects = Subject::where('course_id',$course)->where('semester_id',$semester_id)->get();*/
        $subjects = collect();
            
            $sem_name = Semester::where('semester_id',$semester_id)->first();
            $subcategories = SubCategory::all();
            foreach ($subcategories as $subcategory) {
                 $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                                ->where('subjects.subject_categ', $subcategory->id)
                                ->where('subjects.department_id', $department_id)
                                ->where('course_subject.semester_id', $sem_name->semester_name);
                //if (!in_array($subcategory->id, [2, 3, 4])) {
                    $query->where('course_subject.course_id', $sem_name->course_id);
                //}
             $subjects = $subjects->merge($query->select('subjects.*')->get());
            }
        return view('fyugp.examsub_get',compact('course','semester_id','subjects','ac_id','exam_name'));
         
     }
     
     public function exam_save(Request $request){
        $course = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $exam_name = decrypt($request->exam_name);
        $ac_id = getAcyear();
        $i=0;
        $check = FyugpExams::where([
                'ac_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'exam_name' => $exam_name
               
            ])->first();
            if(!$check){
                
                 $examlist = FyugpExams::create([
                        'course' => $course,
                        'ac_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'exam_name' => $exam_name,
                        
                    ]);
           
        foreach($request->posted as $ids)
        {
            $max_mark = $request->input("max_mark".$ids);
            $max_markp = $request->input("max_markp".$ids);
            $exam_date = $request->input("exam_date".$ids);
            $s_time = $request->input("s_time".$ids);
            $e_time = $request->input("e_time".$ids);
            if($max_mark =='')
            {
               $max_mark = 0; 
            }
            if($max_markp =='')
            {
               $max_markp = 0; 
            }
                    
                         $exmsub = FyugpExamSubject::create([
                            'exam_id' => $examlist->id,
                            'subject' => $ids,
                            'max_mark' => $max_mark,
                            'pmax_mark'=>$max_markp,
                            'date' => $exam_date,
                            's_time'=>$s_time,
                            'e_time'=>$e_time,
                        ]);
                       
                         $accalendar = AcademicCalendar::create([
                            'type' => 1,
                            'tb_id' => $exmsub->id,
                            'event' => $exam_name,
                            'ev_date' => $exam_date,
                            'ac_id' => $ac_id,
                           
                        ]);
                        
                        $i++;
                 
                
           
            
        } }
        if($i>0){
            $msg_array = array('message'=>'Exam addedd Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Exam Could not be Saved !','alert-type'=>'error');
        }
        return redirect()->route('fyugp.exam')->with($msg_array);
     }
     
     public function viewexam(){
        $ac_id = getAcyear();
         $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
               }
           }
       }
        return view('fyugp.view_exams',compact('ac_id','courses'));
    }
    
    public function get_viewexam(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $exam_id = $request->exam_id;
        $ac_id = getAcyear();
        $exam_name = FyugpExams::where('id',$exam_id)->first();
        $examsubjects = FyugpExamSubject::where('exam_id',$exam_id)->get();
        $crs_det = Course::where('course_id',$course)->first();
        $department_id = $crs_det->department_id;
        /*$subjects = Subject::where('course_id',$course)->where('semester_id',$semester_id)->get();*/
        $subjects = collect();
    
        $sem_name = Semester::where('semester_id',$semester_id)->first();
        $subcategories = SubCategory::all();
        foreach ($subcategories as $subcategory) {
             $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                            ->where('subjects.subject_categ', $subcategory->id)
                             ->where('subjects.department_id', $department_id)
                            ->where('course_subject.semester_id', $sem_name->semester_name);
            //if (!in_array($subcategory->id, [2, 3, 4])) {
                $query->where('course_subject.course_id', $sem_name->course_id);
            //}
         $subjects = $subjects->merge($query->select('subjects.*')->get());
        }
        return view('fyugp.eseexamsub_get',compact('course','semester_id','examsubjects','ac_id','exam_id','exam_name','subjects'));
         
     }
      public function exam_update(Request $request){
        $crs_id = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $exam_id = decrypt($request->exam_id);
        
         $exmnamecheck = FyugpExams::where([
                'id' => $exam_id
               
            ])->first();
              if($exmnamecheck){
            $exmnamecheck->update([
                'exam_name' => $request->exam_name,
               
            ]);
            
             }
        
        $ac_id = getAcyear();
        $eseexamsub = FyugpExamSubject::where('exam_id',$exam_id)->get();  
        $i=0;
        
        foreach($eseexamsub as $essm)
        {
            $exmcheck = FyugpExamSubject::where([
                'id' => $essm->id
               
            ])->first();
             if($exmcheck){
            $exmcheck->update([
                'max_mark' => $request->input("max_mark$essm->id"),
                'pmax_mark' => $request->input("pmax_mark$essm->id"),
                'date' => $request->input("exam_date$essm->id"),
                's_time' => $request->input("s_time$essm->id"),
                'e_time' => $request->input("e_time$essm->id"),
            ]);
            $accheck = AcademicCalendar::where('tb_id', $exmcheck->id)->where('type', 1)->first();
            if ($accheck) {
                $accheck->update([
            'event' => $request->exam_name,
            'ev_date' => $request->input("exam_date$essm->id"),
            ]);
            } else {
        
        AcademicCalendar::create([
            'type' => 1,
            'tb_id' => $exmcheck->id,
            'event' => $request->exam_name,
            'ev_date' => $request->input("exam_date$essm->id"),
            'ac_id' => $ac_id,
        ]);
    }
            
            
             $i++; 
             }
        }
        if($request->posted !='')
        {
        foreach($request->posted as $ids)
        {
            $max_mark = $request->input("max_marks".$ids);
            $pmax_mark = $request->input("pmax_mark".$ids);
            if($max_mark == '')
            {
                $max_mark = 0;
            }
            if($pmax_mark == '')
            {
                $pmax_mark = 0;
            }
            $exam_date = $request->input("exam_dates".$ids);
            $s_time = $request->input("s_times".$ids);
            $e_time = $request->input("e_times".$ids);
            
                    
                         $exmsub = FyugpExamSubject::create([
                            'exam_id' => $exam_id,
                            'subject' => $ids,
                            'max_mark' => $max_mark,
                            'pmax_mark' => $pmax_mark,
                            'date' => $exam_date,
                            's_time'=>$s_time,
                            'e_time'=>$e_time,
                        ]);
                        $i++;
        } }
      if($i>0){
            $msg_array = array('message'=>'Exam Details has been Updated Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Exam Details Could not be Updated !','alert-type'=>'error');
        }
          return redirect()->route('fyugp.viewexam')->with($msg_array);   
        
     }
     
     public function examsub_delete($aid){
        
        $eseexamsub = FyugpExamSubject::find(decrypt($aid));
       
        if($eseexamsub){
                $faassign = STUDEXMMARKS::where('subject', $eseexamsub['subject'])->where('exam_id', $eseexamsub['exam_id'])->count();
            if($faassign == 0){
                $eseexamsub->delete();
                $msg_array = array('message'=>'Subject Deleted Successfully !','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Subject Could not be Deleted !','alert-type'=>'error');
            }
        }
        
        return redirect()->route('fyugp.viewexam')->with($msg_array);
    } 
    
     public function exam_delete($aid){
        
        $eseexam = FyugpExams::find(decrypt($aid));
        
        if($eseexam){
              $faassign = STUDEXMMARKS::where('exam_id', decrypt($aid))->count();
            if($faassign == 0){
                $eseexam->delete();
                $msg_array = array('message'=>'Exam Deleted Successfully !','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'Exam Could not be Deleted !','alert-type'=>'error');
            }
        }
        
        return redirect()->route('fyugp.viewexam')->with($msg_array);
    } 
    
     public function fyugpviewexamprint($course,$semester_id,$exam_id){
        $ins_det = instituteDetails();
        $ac_id = getAcyear();
        $exam_name = FyugpExams::where('id',$exam_id)->first();
        $examsubjects = FyugpExamSubject::where('exam_id',$exam_id)->get();
       
        $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
       
            
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('fyugp.print_exam_report',compact('ac_id','ins_det','cur_acyear','course_name','sem_name','semester_id','examsubjects','exam_name','exam_id'));
    }
    
     public function addcredit(){
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCourses = Course::where('department_id',$user->dept_id)->get();
           $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
           $courses = $deptCourses->merge($staffCourses)->unique('course_id')->where('category','0');  
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCourses = Course::where('department_id',$hod_dept->id)->get();
               $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
               $courses = $deptCourses->merge($staffCourses)->unique('course_id')->where('category','0'); 
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $deptCourses = Course::where('department_id',$user->dept_id)->get();
                   $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
                   $courses = $deptCourses->merge($staffCourses)->unique('course_id')->where('category','0');
               }
           }
       }
        return view('fyugp.add_credit',compact('ac_id','courses'));
    }
    
    public function get_credit(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $ac_id = getAcyear();
        //$subjects = Subject::where('course_id',$course)->where('semester_id',$semester_id)->get();
       $subjects = collect();
    
       $user = Auth::user(); 
       $userId = $user->user_id;  
       $crs_det = Course::where('course_id',$course)->first();
        $department_id = $crs_det->department_id;
        $sem_name = Semester::where('semester_id',$semester_id)->first();
        $subcategories = SubCategory::all();
        $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
        $classtch_cnt = ClassTeacher::where('user_id',$userId)->where('ac_id',$ac_id)->where('course_id',$course)->where('semester_id',$semester_id)->count();  
        if($user->staftyp_id == '1')
        {
            if($user->type_id == '17' || $hod_cnt > 0 || $classtch_cnt > 0 || $user->type_id == '13')
            {
                   foreach ($subcategories as $subcategory) {
                     $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                                    ->where('subjects.subject_categ', $subcategory->id)
                                    ->where('subjects.department_id', $department_id)
                                    ->where('course_subject.semester_id', $sem_name->semester_name);
                    //if (!in_array($subcategory->id, [2, 3, 4])) {
                        $query->where('course_subject.course_id', $sem_name->course_id);
                    //}
                    $subjects = $subjects->merge($query->select('subjects.*')->get());
                  } 
            }
            else
            {
               foreach ($subcategories as $subcategory) {
                     $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                     ->join('staff_subject', 'staff_subject.subject_id', '=', 'subjects.subject_id')
                     ->where('staff_subject.course_id', $course)->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)
                                    ->where('subjects.subject_categ', $subcategory->id)
                                    ->where('subjects.department_id', $department_id)
                                    ->where('course_subject.semester_id', $sem_name->semester_name);
                    //if (!in_array($subcategory->id, [2, 3, 4])) {
                        $query->where('course_subject.course_id', $sem_name->course_id);
                    //}
                    $subjects = $subjects->merge($query->select('subjects.*')->get());
                  }  
            }
        }
        else
        {
            foreach ($subcategories as $subcategory) {
                 $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                                ->where('subjects.subject_categ', $subcategory->id)
                                ->where('subjects.department_id', $department_id)
                                ->where('course_subject.semester_id', $sem_name->semester_name);
               // if (!in_array($subcategory->id, [2, 3, 4])) {
                    $query->where('course_subject.course_id', $sem_name->course_id);
                //}
             $subjects = $subjects->merge($query->select('subjects.*')->get());
            }
        }
          
        return view('fyugp.credit_get',compact('course','semester_id','subjects','ac_id'));
         
     }
     
     public function credit_save(Request $request){
        $crs_id = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $ac_id = getAcyear();
        $i=0;
        if($request->posted !='')
        {
        foreach($request->posted as $ids)
        {
            $maxmark = $request->input("maxmark".$ids);
            $creditl = $request->input("creditl".$ids);
            $ccal = $request->input("ccal".$ids);
            $esel = $request->input("esel".$ids);
            
            $creditp = $request->input("creditp".$ids);
            $ccap = $request->input("ccap".$ids);
            $esep = $request->input("esep".$ids);
            
            if (is_null($creditl))
            {
                $creditl =0;
            }
            if (is_null($ccal))
            {
                $ccal =0;
            }
            if (is_null($esel))
            {
                $esel =0;
            }
            if (is_null($creditp))
            {
                $creditp =0;
            }
            if (is_null($ccap))
            {
                $ccap =0;
            }
            if (is_null($esep))
            {
                $esep =0;
            }
            if (is_null($maxmark))
            {
                $maxmark =0;
            }
            
        $check = FyugpSubjectCredit::where([
                'ac_id' => $ac_id,
                'sem_id' => $sem_id,
                'course_id' => $crs_id,
                'subject' => $ids
               
            ])->first();
            if(!$check){
                $exmsub = FyugpSubjectCredit::create([
                  'course_id' => $crs_id,
                  'sem_id' => $sem_id,
                  'subject' => $ids,
                  'max_mark' => $maxmark,
                  'credit_l' => $creditl,
                  'cca_l'=>$ccal,
                  'ese_l'=>$esel,
                  'cca_p'=>$ccap,
                  'ese_p'=>$esep,
                  'credit_p' => $creditp,
                  'ac_id' => $ac_id,
                            
                 ]);
                 $i++;
            }
            else
            {
               $check->update([
                'max_mark' => $maxmark,   
                'credit_l' => $creditl,
                'cca_l'=>$ccal,
                'ese_l'=>$esel,
                'cca_p'=>$ccap,
                'ese_p'=>$esep,
                'credit_p' => $creditp,
                
               
            ]);
             $i++;   
            }
        } }
      if($i>0){
            $msg_array = array('message'=>'credit has been Addedd Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'credit Could not be Addedd !','alert-type'=>'error');
        }
          return redirect()->route('fyugp.addcredit')->with($msg_array);   
     }
     
     public function ccafa(){
        
         $fa = FA::all(); 
       
       
        return view('fyugp.fa_add',compact('fa'));
    } 
    
    public function ccafa_save(Request $request)
 {
     
     $validated = $request->validate([
            'method' => 'required',
          
        ]);
        $fa = FA::create([
            'method' => $request->method,
           
        ]); 
        if($fa){
        $msg_array = array('message'=>'FA Added Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'FA Could not be Added !','alert-type'=>'error');
        }
        return redirect()->route('Fyugp.ccafa')->with($msg_array); 
     
 }  
 
 public function ccafa_delete($aid){
        
        $fa = FA::find(decrypt($aid));
       
        if($fa){
             $faassign = FA_ASSIGN::where('fa_id', decrypt($aid))->count();
             $activitiesmrks = STUDFAMARKS::where('fa_id', decrypt($aid))->count();
           if ($faassign == 0 && $activitiesmrks == 0) {
                $fa->delete();
                $msg_array = array('message'=>'FA Deleted Successfully !','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'FA Could not be Deleted !','alert-type'=>'error');
            }
        }
        else
        {
             $msg_array = array('message'=>'FA not Found !','alert-type'=>'error');
        }
        return redirect()->route('Fyugp.ccafa')->with($msg_array);
    }  
    
     public function ccasa(){
        
        
         
         $sa = SA::all(); 
       
       
        return view('fyugp.sa_add',compact('sa'));
    } 
        public function ccasa_save(Request $request)
 {
     
     $validated = $request->validate([
            'smethod' => 'required',
          
        ]);
        $sa = SA::create([
            'smethod' => $request->smethod,
           
        ]); 
        if($sa){
        $msg_array = array('message'=>'SA Added Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'SA Could not be Added !','alert-type'=>'error');
        }
        return redirect()->route('Fyugp.ccasa')->with($msg_array); 
     
 }  
 
 public function ccasa_delete($aid){
        
        $sa = SA::find(decrypt($aid));
      
        if($sa){
             $activities = SA_ASSIGN::where('sa_id', decrypt($aid))->count();
              $activitiesmrks = STUDSAMARKS::where('sa_id', decrypt($aid))->count();
           if ($activities == 0 && $activitiesmrks == 0) {
                $sa->delete();
                $msg_array = array('message'=>'SA Deleted Successfully !','alert-type'=>'success');
            }else{
                $msg_array = array('message'=>'SA Could not be Deleted !','alert-type'=>'error');
            }
        }
        else
        {
             $msg_array = array('message'=>'SA not Found !','alert-type'=>'error');
        }
        return redirect()->route('Fyugp.ccasa')->with($msg_array);
    }
    
    
    public function setfa()
    {
        $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
               }
           }
       }
        $subtype = SubjectType::all();
        return view('fyugp.set_fa',compact('courses','subtype'));
    } 
    
     public function get_viewfa(Request $request)
     {
      
        $course = $request->course;
        $subtyp_id = $request->subtyp_id;
        $ac_id = getAcyear();
        $course_name = Course::where('course_id',$course)->first();
        $fa = FA::all();
        return view('fyugp.cca_fa_get',compact('course','ac_id','course_name','fa','subtyp_id'));
         
     }
     
     public function setfa_save(Request $request){
        $crs_id = decrypt($request->course);
        $subtyp_id = decrypt($request->subtyp_id);
        $ac_id = getAcyear();
        $i=0;
       /* $activities = ObeActivity::where('domain_id', decrypt($aid))->count();
           if ($activities == 0) {*/
          $fassgn = FA_ASSIGN::where('course', $crs_id)->where('subtyp_id', $subtyp_id)->where('ac_id', $ac_id)->get(); 
          foreach ($fassgn as $fgd) {
              $faa = FA_ASSIGN::find($fgd->id);
              if($faa){
                $faa->delete();
                }
          }
        //}
        if($request->posted !='')
        {
            foreach($request->posted as $ids)
            {
                $max_mark = $request->input("max_marks".$ids);
                if($max_mark == '')
                {
                    $max_mark =0;
                }
             $faecheck = FA_ASSIGN::where([
                    'fa_id' => $ids,'course' => $crs_id,'subtyp_id' => $subtyp_id,'ac_id'=> $ac_id
                   
                ])->first();
                  if($faecheck){
                $faecheck->update([
                    'max_mark' => $max_mark,
                   
                ]);
                $i++;
                 }
                 else
                 {
                        
                    $famax = FA_ASSIGN::create([
                                'course' => $crs_id,
                                'subtyp_id' => $subtyp_id,
                                'fa_id' => $ids,
                                'max_mark' => $max_mark,
                                'ac_id' => $ac_id,
                              
                            ]);
                    $i++;
                 }          
            } 
            
        }
         if($i>0){
            $msg_array = array('message'=>'FA has been Assigned Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'FA Details Could not be Assigned !','alert-type'=>'error');
        }
          return redirect()->route('Fyugp.setfa')->with($msg_array);   
        
     }
     
     
     
    public function setsa()
    {
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
               }
           }
       }
        $subtype = SubjectType::all();
        return view('fyugp.set_sa',compact('courses','subtype'));
    }
    
     public function get_viewsa(Request $request)
     {
      
        $course = $request->course;
        $subtyp_id = $request->subtyp_id;
        $ac_id = getAcyear();
        $course_name = Course::where('course_id',$course)->first();
        $sa = SA::all();
        return view('fyugp.cca_sa_get',compact('course','ac_id','course_name','sa','subtyp_id'));
         
     }
    
    
      public function setsa_save(Request $request){
        $crs_id = decrypt($request->course);
        $subtyp_id = decrypt($request->subtyp_id);
        $ac_id = getAcyear();
        $i=0;
       /* $activities = ObeActivity::where('domain_id', decrypt($aid))->count();
           if ($activities == 0) {*/
          $sassgn = SA_ASSIGN::where('course', $crs_id)->where('subtyp_id', $subtyp_id)->where('ac_id', $ac_id)->get(); 
          foreach ($sassgn as $sgd) {
              $saa = SA_ASSIGN::find($sgd->id);
              if($saa){
                $saa->delete();
                }
          }
        //}
        if($request->posted !='')
        {
            foreach($request->posted as $ids)
            {
                $max_mark = $request->input("max_marks".$ids);
                if($max_mark == '')
                {
                    $max_mark =0;
                }
             $saecheck = SA_ASSIGN::where([
                    'sa_id' => $ids,'course' => $crs_id,'subtyp_id' => $subtyp_id,'ac_id'=> $ac_id
                   
                ])->first();
                  if($saecheck){
                $saecheck->update([
                    'max_mark' => $max_mark,
                   
                ]);
                $i++;
                 }
                 else
                 {
                        
                    $samax = SA_ASSIGN::create([
                                'course' => $crs_id,
                                 'subtyp_id' => $subtyp_id,
                                'sa_id' => $ids,
                                'max_mark' => $max_mark,
                                'ac_id' => $ac_id,
                              
                            ]);
                    $i++;
                 }          
            } 
            
        }
         if($i>0){
            $msg_array = array('message'=>'FA has been Assigned Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'FA Details Could not be Assigned !','alert-type'=>'error');
        }
          return redirect()->route('Fyugp.setsa')->with($msg_array);   
        
     }
     
    public function studfa()
    {
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->where('category','0')->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('courses.category','0')->where('courses.department_id', $user->dept_id)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
          
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->where('category','0')->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('courses.department_id', $user->dept_id)->where('courses.category','0')->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::where('category','0')->get();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->where('category','0')->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('courses.department_id', $user->dept_id)->where('staff_subject.user_id', $userId)->where('courses.category','0')->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
       //echo "<pre>";print_r($courses);
        return view('fyugp.set_studfa',compact('courses','ac_id'));
    }
    
     public function get_viewstudfa(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $sub_id = $request->sub_id;
        $batch_id = $request->batch_id;
        $ac_id = getAcyear();
        $semesters = Semester::where('course_id',$course)->get();
         $crs_det = Course::where('course_id',$course)->first();
        $department_id = $crs_det->department_id;
        /*$subjects = Subject::where('course_id',$course)->where('semester_id',$semester_id)->get();*/
        $subjects = collect();
    
            $sem_name = Semester::where('semester_id',$semester_id)->first();
            $subcategories = SubCategory::all();
            foreach ($subcategories as $subcategory) {
                 $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                                ->where('subjects.subject_categ', $subcategory->id)
                                 ->where('subjects.department_id', $department_id)
                                ->where('course_subject.semester_id', $sem_name->semester_name);
                //if (!in_array($subcategory->id, [2, 3, 4])) {
                    $query->where('course_subject.course_id', $sem_name->course_id);
                //}
             $subjects = $subjects->merge($query->select('subjects.*')->get());
            }
        $fa_theory = FA_ASSIGN::where('course',$course)->where('ac_id',$ac_id)->where('subtyp_id',1)->get();
        $fa_practical = FA_ASSIGN::where('course',$course)->where('ac_id',$ac_id)->where('subtyp_id',2)->get();
        $subject_categ = Subject::where('subject_id',$sub_id)->first();
        
        $students = array();
        $subject = Subject::find($sub_id);
        $semester = Semester::find($semester_id);
                $semesterIds = Semester::where('semester_name', $semester->semester_name)->pluck('semester_id')->toArray();
       $query = Promote::join('students', 'promotes.student_id', '=', 'students.student_id')
                    ->join('courses', 'promotes.course_id', '=', 'courses.course_id');
                if(in_array($subject->subject_categ, [2,3,4,5,6])) {
                    $query->join('fyugp_stud_sub', 'promotes.student_id', '=', 'fyugp_stud_sub.stud_id');
                if ($batch_id != null && $batch_id != '') {
                    $courses = DB::table('group_courses')->where('group_id', $batch_id)->pluck('course_id')->toArray();
                    $query->whereIn('promotes.course_id', $courses);
                }
                $query->where('fyugp_stud_sub.acyear_id', $ac_id)
                      ->where('fyugp_stud_sub.sub_id', $sub_id)
                      ->whereIn('promotes.semester_id', $semesterIds)
                      ->whereIn('fyugp_stud_sub.sem', $semesterIds);
                } else {
                    $query->where('promotes.course_id', $course)
                        ->where('promotes.semester_id', $semester_id);
                }
                $students = $query->where('promotes.ac_id', $ac_id)
                    ->select('students.student_id','students.adno','students.name','students.rollno','students.clno','courses.course_name','promotes.course_id','promotes.semester_id')
                    ->groupBy('promotes.student_id')
                    ->orderBy('students.clno', 'ASC')
                    ->get(); 
        
        //$students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->get();
       
        return view('fyugp.view_studfa',compact('course','semester_id','subjects','ac_id','semesters','sub_id','students','fa_theory','fa_practical','subject_categ'));
         
     }
     
      public function studfa_save(Request $request)
      {
        $crs_id = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $sub_id = decrypt($request->sub_id);
        $ac_id = getAcyear();
        $i=0;
        $fa_theory = FA_ASSIGN::where('course',$crs_id)->where('ac_id',$ac_id)->where('subtyp_id',1)->get();
        $fa_practical = FA_ASSIGN::where('course',$crs_id)->where('ac_id',$ac_id)->where('subtyp_id',2)->get();
        
        if($request->posted !='')
        {
            foreach($request->posted as $ids)
            {
                $studcrs = $request->input("studcrs".$ids);
                $studsem = $request->input("studsem".$ids);
                foreach($fa_theory as $fm)
                {
                    
                    $check = STUDFAMARKS::where([
                    'ac_id' => $ac_id,
                    'sem_id' => $studsem,
                    'course' => $studcrs,
                    'sub_id' => $sub_id,
                    'subtype_id'=>1,
                    'fa_id' => $fm->fa_id,
                    'stud_id' => $ids,
                    'sub_crs'=>$crs_id,
                    'sub_sem'=>$sem_id
                    ])->first();
                    $MarkValue = $request->input("fa_marks".$ids."_".$fm->fa_id);
                 
                     if(!$check)
                     {
                         if (!is_null($MarkValue)) 
                         {
                             $marklist = STUDFAMARKS::create([
                            'stud_id' => $ids,
                            'ac_id' => $ac_id,
                            'course' => $studcrs,
                            'sem_id' => $studsem,
                            'sub_id' => $sub_id,
                            'subtype_id'=>1,
                            'fa_id' =>$fm->fa_id,
                            'mark' =>$MarkValue,
                            'sub_crs'=>$crs_id,
                            'sub_sem'=>$sem_id,
                            
                    ]);
                    if($marklist){ $i++; }
                             
                         }
                        
                         
                     }
                     else
                     {
                         $check->update([
                        'mark' => $request->input("fa_marks".$ids."_".$fm->fa_id),
                        ]);
                        $i++;
                     }
                    
                }
                
                foreach($fa_practical as $fpm)
                {
                    $check1 = STUDFAMARKS::where([
                    'ac_id' => $ac_id,
                    'sem_id' => $studsem,
                    'course' => $studcrs,
                    'sub_id' => $sub_id,
                    'subtype_id'=>2,
                    'fa_id' => $fpm->fa_id,
                    'stud_id' => $ids,
                    'sub_crs'=>$crs_id,
                    'sub_sem'=>$sem_id
                    ])->first();
                    $MarkValue1 = $request->input("fa_pmarks".$ids."_".$fpm->fa_id);
                   
                     if(!$check1)
                     {
                         if (!is_null($MarkValue1)) 
                         {
                             $marklist = STUDFAMARKS::create([
                            'stud_id' => $ids,
                            'ac_id' => $ac_id,
                            'course' => $studcrs,
                            'sem_id' => $studsem,
                            'sub_id' => $sub_id,
                            'subtype_id'=>2,
                            'fa_id' =>$fpm->fa_id,
                            'mark' =>$MarkValue1,
                            'sub_crs'=>$crs_id,
                            'sub_sem'=>$sem_id,
                            
                    ]);
                    if($marklist){ $i++; }
                             
                         }
           
                        
                     }
                     else
                     {
                         $check1->update([
                        'mark' => $request->input("fa_pmarks".$ids."_".$fpm->fa_id),
                        ]);
                        $i++;
                     }
                    
                }
                
            }
        }
        
         if($i>0){
            $msg_array = array('message'=>'FA Mark has been Saved Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'FA Mark Could not be Saved !','alert-type'=>'error');
        }
          return redirect()->route('Fyugp.studfa')->with($msg_array);
        
      }
      
      
       public function studsa()
    {
        $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
            $deptCoursesQuery = Course::where('department_id',$user->dept_id)->where('category','0')->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('courses.category','0')->where('courses.department_id', $user->dept_id)->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
          
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->where('category','0')->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('courses.category','0')->where('courses.department_id', $user->dept_id)->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::where('category','0')->get();
               }
               else
               {
                  $deptCoursesQuery = Course::where('department_id', $user->dept_id)->where('category','0')->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('courses.category','0')->where('staff_subject.user_id', $userId)->where('courses.department_id', $user->dept_id)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
        return view('fyugp.set_studsa',compact('courses','ac_id'));
    }
    
    public function get_viewstudsa(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $sub_id = $request->sub_id;
        $batch_id = $request->batch_id;
        $ac_id = getAcyear();
        $semesters = Semester::where('course_id',$course)->get();
        /*$subjects = Subject::where('course_id',$course)->where('semester_id',$semester_id)->get();*/
        $subjects = collect();
    
        $sem_name = Semester::where('semester_id',$semester_id)->first();
        $subcategories = SubCategory::all();
        foreach ($subcategories as $subcategory) {
             $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                            ->where('subjects.subject_categ', $subcategory->id)
                            ->where('course_subject.semester_id', $sem_name->semester_name);
            if (!in_array($subcategory->id, [2, 3, 4])) {
                $query->where('course_subject.course_id', $sem_name->course_id);
            }
         $subjects = $subjects->merge($query->select('subjects.*')->get());
        }
        $sa_theory = SA_ASSIGN::where('course',$course)->where('ac_id',$ac_id)->where('subtyp_id',1)->get();
        $sa_practical = SA_ASSIGN::where('course',$course)->where('ac_id',$ac_id)->where('subtyp_id',2)->get();
        //$sa = SA_ASSIGN::where('course',$course)->where('ac_id',$ac_id)->get();
        $subject_categ = Subject::where('subject_id',$sub_id)->first();
        $students = array();
        
         $subject = Subject::find($sub_id);
        $semester = Semester::find($semester_id);
                $semesterIds = Semester::where('semester_name', $semester->semester_name)->pluck('semester_id')->toArray();
       $query = Promote::join('students', 'promotes.student_id', '=', 'students.student_id')
                    ->join('courses', 'promotes.course_id', '=', 'courses.course_id');
                if(in_array($subject->subject_categ, [2,3,4,5,6])) {
                    $query->join('fyugp_stud_sub', 'promotes.student_id', '=', 'fyugp_stud_sub.stud_id');
                if ($batch_id != null && $batch_id != '') {
                    $courses = DB::table('group_courses')->where('group_id', $batch_id)->pluck('course_id')->toArray();
                    $query->whereIn('promotes.course_id', $courses);
                }
                $query->where('fyugp_stud_sub.acyear_id', $ac_id)
                      ->where('fyugp_stud_sub.sub_id', $sub_id)
                      ->whereIn('promotes.semester_id', $semesterIds)
                      ->whereIn('fyugp_stud_sub.sem', $semesterIds);
                } else {
                    $query->where('promotes.course_id', $course)
                        ->where('promotes.semester_id', $semester_id);
                }
                $students = $query->where('promotes.ac_id', $ac_id)
                    ->select('students.student_id','students.adno','students.name','students.rollno','students.clno','courses.course_name','promotes.course_id','promotes.semester_id')
                    ->groupBy('promotes.student_id')
                    ->orderBy('students.clno', 'ASC')
                    ->get(); 
        
        return view('fyugp.view_studsa',compact('course','semester_id','subjects','ac_id','semesters','sub_id','students','sa_theory','sa_practical','subject_categ'));
         
     }
     
     
     public function studsa_save(Request $request)
      {
        $crs_id = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $sub_id = decrypt($request->sub_id);
        $ac_id = getAcyear();
        $i=0;
        $sa_theory = SA_ASSIGN::where('course',$crs_id)->where('ac_id',$ac_id)->where('subtyp_id',1)->get();
        $sa_practical = SA_ASSIGN::where('course',$crs_id)->where('ac_id',$ac_id)->where('subtyp_id',2)->get();
        //$sa = SA_ASSIGN::where('course',$crs_id)->where('ac_id',$ac_id)->get();
        if($request->posted !='')
        {
            foreach($request->posted as $ids)
            {
                $studcrs = $request->input("studcrs".$ids);
                $studsem = $request->input("studsem".$ids);
                foreach($sa_theory as $sm)
                {
                    $check = STUDSAMARKS::where([
                    'ac_id' => $ac_id,
                    'sem_id' => $studsem,
                    'course' => $studcrs,
                    'sub_id' => $sub_id,
                    'subtype_id' => 1,
                    'sa_id' => $sm->sa_id,
                    'stud_id' => $ids,
                    'sub_crs'=>$crs_id,
                    'sub_sem'=>$sem_id
                    ])->first();
                    $MarkValue = $request->input("sa_marks".$ids."_".$sm->sa_id);
                    //$MarkpValue = $request->input("sa_pmarks".$ids."_".$sm->sa_id);
                     if(!$check)
                     {
                         if (!is_null($MarkValue)) 
                         {
                            $marklist = STUDSAMARKS::create([
                            'stud_id' => $ids,
                            'ac_id' => $ac_id,
                            'course' => $studcrs,
                            'sem_id' => $studsem,
                            'sub_id' => $sub_id,
                            'subtype_id' => 1,
                            'sa_id' =>$sm->sa_id,
                            'mark' =>$MarkValue,
                            'sub_crs'=>$crs_id,
                            'sub_sem'=>$sem_id,
                            
                    ]);
                    if($marklist){ $i++; }
                             
                         }
                        
                     }
                     else
                     {
                         $check->update([
                        'mark' => $request->input("sa_marks".$ids."_".$sm->sa_id),
                        ]);
                        $i++;
                     }
                    
                }
                
                
                foreach($sa_practical as $spm)
                {
                    $check1 = STUDSAMARKS::where([
                    'ac_id' => $ac_id,
                    'sem_id' => $studsem,
                    'course' => $studcrs,
                    'sub_id' => $sub_id,
                    'subtype_id' => 2,
                    'sa_id' => $spm->sa_id,
                    'stud_id' => $ids,
                    'sub_crs'=>$crs_id,
                    'sub_sem'=>$sem_id
                    ])->first();
                  
                    $MarkpValue = $request->input("sa_pmarks".$ids."_".$spm->sa_id);
                     if(!$check1)
                     {
                         if (!is_null($MarkpValue)) 
                         {
                            $marklist = STUDSAMARKS::create([
                            'stud_id' => $ids,
                            'ac_id' => $ac_id,
                            'course' => $studcrs,
                            'sem_id' => $studsem,
                            'sub_id' => $sub_id,
                            'subtype_id' => 2,
                            'sa_id' =>$spm->sa_id,
                            'mark' =>$MarkpValue,
                            'sub_crs'=>$crs_id,
                            'sub_sem'=>$sem_id,
                            
                    ]);
                    if($marklist){ $i++; }
                             
                         }
                        
                     }
                     else
                     {
                         $check1->update([
                        'mark' => $request->input("sa_marks".$ids."_".$spm->sa_id),
                        ]);
                        $i++;
                     }
                    
                }
                
            }
        }
        
         if($i>0){
            $msg_array = array('message'=>'SA Mark has been Saved Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'SA Mark Could not be Saved !','alert-type'=>'error');
        }
          return redirect()->route('Fyugp.studsa')->with($msg_array);
        
      }
      
    public function addexammark()
    {
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->select('course_id','course_name')->get();


       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
                 $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->select('course_id','course_name')->get();
            }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::where('category','0')->get();
               }
               else
               {
                   $courses = Course::where('department_id', $user->dept_id)->where('category','0')->select('course_id', 'course_name')->get();


               }
           }
       }
        return view('fyugp.add_studexammark',compact('courses','ac_id'));
    }
    
     public function get_viewstudexammrk(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $exam_id = $request->exam_id;
        
        $ac_id = getAcyear();
        $semesters = Semester::where('course_id',$course)->get();
        $exam_name = FyugpExams::where('id',$exam_id)->first();
        $examsubjects = FyugpExamSubject::where('exam_id',$exam_id)->get();

        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->get();
       
        return view('fyugp.add_exam_mark',compact('course','semester_id','examsubjects','ac_id','semesters','exam_id','students','exam_name'));
         
     }
     
     public function studexammrk_save(Request $request)
      {
        $crs_id = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $exam_id = decrypt($request->exam_id);
        $ac_id = getAcyear();
        $i=0;
        $examsub = FyugpExamSubject::where('exam_id',$exam_id)->get();
        if($request->posted !='')
        {
            foreach($request->posted as $ids)
            {
                foreach($examsub as $esubj)
                {
                    $check = STUDEXMMARKS::where([
                    'ac_id' => $ac_id,
                    'sem_id' => $sem_id,
                    'course' => $crs_id,
                    'exam_id' => $exam_id,
                    'subject' => $esubj->subject,
                    'stud_id' => $ids
                    ])->first();
                    $MarkValue = $request->input("mark".$ids."_".$esubj->subject);
                    $MarkpValue = $request->input("pmark".$ids."_".$esubj->subject);
                    if($MarkValue == "AB" || $MarkValue == "ab" || $MarkValue == "Ab")
                    {
                        $MarkValue = -1;
                    }
                    if($MarkpValue == "AB" || $MarkpValue == "ab" || $MarkpValue == "Ab")
                    {
                        $MarkpValue = -1;
                    }
                     if(!$check)
                     {
                         if (!is_null($MarkValue) && !is_null($MarkpValue)) 
                         {
                             $marklist = STUDEXMMARKS::create([
                            'stud_id' => $ids,
                            'ac_id' => $ac_id,
                            'course' => $crs_id,
                            'sem_id' => $sem_id,
                            'exam_id' => $exam_id,
                            'subject' =>$esubj->subject,
                            'mark' =>$MarkValue,
                            'pmark' =>$MarkpValue,
                    ]);
                    if($marklist){ $i++; }
                             
                         }
                         else if (!is_null($MarkpValue)) 
                         {
                             $markplist = STUDEXMMARKS::create([
                            'stud_id' => $ids,
                            'ac_id' => $ac_id,
                            'course' => $crs_id,
                            'sem_id' => $sem_id,
                            'exam_id' => $exam_id,
                            'subject' =>$esubj->subject,
                            
                            'pmark' =>$MarkpValue, 
                            ]);
                            if($markplist){ $i++; }
                         }
                         else if (!is_null($MarkValue)) 
                         {
                             $markplist = STUDEXMMARKS::create([
                            'stud_id' => $ids,
                            'ac_id' => $ac_id,
                            'course' => $crs_id,
                            'sem_id' => $sem_id,
                            'exam_id' => $exam_id,
                            'subject' =>$esubj->subject,
                            
                            'mark' =>$MarkValue, 
                            ]);
                            if($markplist){ $i++; }
                         }
                     }
                     else
                     {
                         $check->update([
                        'mark' => $request->input("mark".$ids."_".$esubj->subject),'pmark' => $request->input("pmark".$ids."_".$esubj->subject),
                        ]);
                        $i++;
                     }
                    
                }
                
            }
        }
        
         if($i>0){
            $msg_array = array('message'=>'Student Mark has been Saved Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Student Mark Could not be Saved !','alert-type'=>'error');
        }
          return redirect()->route('Fyugp.studexammrk')->with($msg_array);
        
      }
      
       public function studexammrkprint($course,$semester_id,$exam_id){
        $ins_det = instituteDetails();
        $ac_id = getAcyear();
        
        $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
        $exam_name = FyugpExams::where('id',$exam_id)->first();
        $examsubjects = FyugpExamSubject::where('exam_id',$exam_id)->get();


        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->get();
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('fyugp.print_stud_exam_mark_print',compact('students','exam_name','ac_id','ins_det','cur_acyear','course_name','sem_name','exam_id','examsubjects','course','semester_id'));
    }
    
    
    public function addsubexammark()
    {
        $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
            $deptCoursesQuery = Course::where('department_id',$user->dept_id)->where('category','0')->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('courses.department_id',$user->dept_id)->where('courses.category','0')->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
    
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
              $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->where('category','0')->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('courses.department_id',$user->dept_id)->where('courses.category','0')->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
         
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::where('category','0')->get();
               }
               else
               {
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->where('category','0')->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('courses.department_id',$user->dept_id)->where('staff_subject.acyear_id', $ac_id)->where('courses.category','0')->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
        return view('fyugp.add_sub_exam_mark',compact('courses','ac_id'));
    }
    
    public function get_viewstudsubexmmark(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $exam_id = $request->exam_id;
        $sub_id = $request->sub_id;
        $batch_id = $request->batch_id;
        
        $ac_id = getAcyear();
        $semesters = Semester::where('course_id',$course)->get();
        $exam_name = FyugpExams::where('id',$exam_id)->first();
        $examsubjects = FyugpExamSubject::where('exam_id',$exam_id)->where('subject',$sub_id)->first();
        $subject_name = Subject::where('subject_id',$sub_id)->first();
        $subject_categ = Subject::where('subject_id',$sub_id)->first();
        
        $students = array();
         $subject = Subject::find($sub_id);
        $semester = Semester::find($semester_id);
                $semesterIds = Semester::where('semester_name', $semester->semester_name)->pluck('semester_id')->toArray();
       $query = Promote::join('students', 'promotes.student_id', '=', 'students.student_id')
                    ->join('courses', 'promotes.course_id', '=', 'courses.course_id');
                if(in_array($subject->subject_categ, [2,3,4,5,6])) {
                    $query->join('fyugp_stud_sub', 'promotes.student_id', '=', 'fyugp_stud_sub.stud_id');
                if ($batch_id != null && $batch_id != '' && $batch_id != 0) {
                    $courses = DB::table('group_courses')->where('group_id', $batch_id)->pluck('course_id')->toArray();
                    $query->whereIn('promotes.course_id', $courses);
                }
                $query->where('fyugp_stud_sub.acyear_id', $ac_id)
                      ->where('fyugp_stud_sub.sub_id', $sub_id)
                      ->whereIn('promotes.semester_id', $semesterIds)
                      ->whereIn('fyugp_stud_sub.sem', $semesterIds);
                } else {
                    $query->where('promotes.course_id', $course)
                        ->where('promotes.semester_id', $semester_id);
                }
                $students = $query->where('promotes.ac_id', $ac_id)
                    ->select('students.student_id','students.adno','students.name','students.rollno','students.clno','courses.course_name','promotes.course_id','promotes.semester_id')
                    ->groupBy('promotes.student_id')
                    ->orderBy('students.clno', 'ASC')
                    ->get(); 
        
        return view('fyugp.add_stud_sub_exam_mark',compact('course','semester_id','examsubjects','ac_id','semesters','exam_id','students','exam_name','sub_id','subject_name','subject_categ','batch_id'));
         
     }
     
      public function studsubexmmark_save(Request $request)
      {
        $crs_id = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $exam_id = decrypt($request->exam_id);
        $sub_id = decrypt($request->sub_id);
        $ac_id = getAcyear();
        $i=0;
       
        if($request->posted !='')
        {
            foreach($request->posted as $ids)
            {
                $studcrs = $request->input("studcrs".$ids);
                $studsem = $request->input("studsem".$ids);
                    $check = STUDEXMMARKS::where([
                    'ac_id' => $ac_id,
                    'sem_id' => $studsem,
                    'course' => $studcrs,
                    'exam_id' => $exam_id,
                    'subject' => $sub_id,
                    'stud_id' => $ids,
                    'sub_crs' => $crs_id,
                    'sub_sem' => $sem_id
                    ])->first();
                    $MarkValue = $request->input("mark".$ids);
                    $MarkpValue = $request->input("pmark".$ids);
                     if($MarkValue == "AB" || $MarkValue == "ab" || $MarkValue == "Ab")
                    {
                        $MarkValue = -1;
                    }
                    if($MarkpValue == "AB" || $MarkpValue == "ab" || $MarkpValue == "Ab")
                    {
                        $MarkpValue = -1;
                    }
                     if(!$check)
                     {
                         if (!is_null($MarkValue) && !is_null($MarkpValue)) 
                         {
                             $marklist = STUDEXMMARKS::create([
                            'stud_id' => $ids,
                            'ac_id' => $ac_id,
                            'course' => $studcrs,
                            'sem_id' => $studsem,
                            'exam_id' => $exam_id,
                            'subject' =>$sub_id,
                            'mark' =>$MarkValue,
                            'pmark' =>$MarkpValue,
                            'sub_crs' => $crs_id,
                            'sub_sem' => $sem_id
                    ]);
                    if($marklist){ $i++; }
                             
                         }
                         else if (!is_null($MarkpValue)) 
                         {
                             $markplist = STUDEXMMARKS::create([
                            'stud_id' => $ids,
                            'ac_id' => $ac_id,
                            'course' => $studcrs,
                            'sem_id' => $studsem,
                            'exam_id' => $exam_id,
                            'subject' =>$sub_id,
                            
                            'pmark' =>$MarkpValue, 
                             'sub_crs' => $crs_id,
                            'sub_sem' => $sem_id,
                            ]);
                            if($markplist){ $i++; }
                         }
                         else if (!is_null($MarkValue)) 
                         {
                             $markplist = STUDEXMMARKS::create([
                            'stud_id' => $ids,
                            'ac_id' => $ac_id,
                            'course' => $studcrs,
                            'sem_id' => $studsem,
                            'exam_id' => $exam_id,
                            'subject' =>$sub_id,
                            
                            'mark' =>$MarkValue, 
                             'sub_crs' => $crs_id,
                            'sub_sem' => $sem_id,
                            ]);
                            if($markplist){ $i++; }
                         }
                     }
                     else
                     {
                         $check->update([
                        'mark' => $request->input("mark".$ids),'pmark' => $request->input("pmark".$ids),
                        ]);
                        $i++;
                     }
                    
                
                
            }
        }
        
         if($i>0){
            $msg_array = array('message'=>'Student Mark has been Saved Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Student Mark Could not be Saved !','alert-type'=>'error');
        }
          return redirect()->route('Fyugp.studsubexmmark')->with($msg_array);
        
      }
      
    
      public function studsubexmmarkprint($course,$semester_id,$exam_id,$sub_id,$batch_id){
        $ins_det = instituteDetails();
        $ac_id = getAcyear();
        
        $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
        $exam_name = FyugpExams::where('id',$exam_id)->first();
        $examsubjects = FyugpExamSubject::where('exam_id',$exam_id)->where('subject',$sub_id)->first();
        $subject_name = Subject::where('subject_id',$sub_id)->first();
        $subject_categ = Subject::where('subject_id',$sub_id)->first();
        $students = array();
         $subject = Subject::find($sub_id);
        $semester = Semester::find($semester_id);
                $semesterIds = Semester::where('semester_name', $semester->semester_name)->pluck('semester_id')->toArray();
       $query = Promote::join('students', 'promotes.student_id', '=', 'students.student_id')
                    ->join('courses', 'promotes.course_id', '=', 'courses.course_id');
                if(in_array($subject->subject_categ, [2,3,4,5,6])) {
                    $query->join('fyugp_stud_sub', 'promotes.student_id', '=', 'fyugp_stud_sub.stud_id');
                if ($batch_id != null && $batch_id != '') {
                    $courses = DB::table('group_courses')->where('group_id', $batch_id)->pluck('course_id')->toArray();
                    $query->whereIn('promotes.course_id', $courses);
                }
                $query->where('fyugp_stud_sub.acyear_id', $ac_id)
                      ->where('fyugp_stud_sub.sub_id', $sub_id)
                      ->whereIn('promotes.semester_id', $semesterIds)
                      ->whereIn('fyugp_stud_sub.sem', $semesterIds);
                } else {
                    $query->where('promotes.course_id', $course)
                        ->where('promotes.semester_id', $semester_id);
                }
                $students = $query->where('promotes.ac_id', $ac_id)
                    ->select('students.student_id','students.adno','students.name','students.rollno','students.clno','courses.course_name','promotes.course_id','promotes.semester_id')
                    ->groupBy('promotes.student_id')
                    ->orderBy('students.clno', 'ASC')
                    ->get(); 
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('fyugp.print_stud_sub_exam_mark_print',compact('students','exam_name','ac_id','ins_det','cur_acyear','course_name','sem_name','exam_id','examsubjects','course','semester_id','subject_name','sub_id','subject_categ'));
    } 
    
    
     public function reportcard()
    {
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
        

       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::where('category','0')->get();
               }
               else
               {
                  
                   $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
               }
           }
       }
        return view('fyugp.reportcard',compact('courses','ac_id'));
    }
    
     public function get_reportcard(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
      
        
        $ac_id = getAcyear();
        $semesters = Semester::where('course_id',$course)->get();
       
       
        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->orderBy('students.clno', 'ASC')->get();
       
        return view('fyugp.view_report_card',compact('course','semester_id','ac_id','semesters','students'));
         
     }
     
      public function reportcardprint($course,$semester_id,$stud_id){
          
        $ins_det = instituteDetails();
        $ac_id = getAcyear();
        
        $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
        $student_det = Promote::where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id,'promotes.student_id'=>$stud_id))->select('promotes.*')->first();
        $exams = FyugpExams::where('course',$course)->where('sem',$semester_id)->where('ac_id',$ac_id)->first();
        $fa = FA_ASSIGN::where('ac_id',$ac_id)->whereNull('deleted_at')->get();
        $sa = SA_ASSIGN::where('ac_id',$ac_id)->whereNull('deleted_at')->get();
        $sem_id = $student_det->semester_id;
        $course_id=$student_det->course_id;
        $examsubjects=[];
        /*if($exams)
        {
        $examsubjects = FyugpExamSubject::Join('subjects','fyugp_examsubject.subject','=','subjects.subject_id')->where(array('fyugp_examsubject.exam_id'=>$exams->id))->select('fyugp_examsubject.*')->get();
        }*/
        $semester = Semester::find($semester_id);
                         $semesterIds = Semester::where('semester_name', $semester->semester_name)->pluck('semester_id')->toArray();
    $deptsubQuery = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
    ->where('subject_categ', 1)
    ->where('subjects.department_id', $course_name->department_id)
    ->where('course_subject.course_id', $course)
    ->where('course_subject.semester_id', $sem_name->semester_name)
    ->select('subjects.subject_id','subjects.subject_code', 'subjects.subject_name','subjects.subject_credit','subjects.subject_categ','subjects.subtyp_id','subjects.seclang','subjects.department_id'); // Fetch all columns from 'subjects'

$studsub = FYUGPStudSub::join('subjects', 'subjects.subject_id', '=', 'fyugp_stud_sub.sub_id')
    ->where('fyugp_stud_sub.stud_id', $stud_id)
    ->where('fyugp_stud_sub.course', $course)
    ->where('fyugp_stud_sub.sem', $semester_id)
    ->where('fyugp_stud_sub.acyear_id', $ac_id)
     ->select('subjects.subject_id','subjects.subject_code', 'subjects.subject_name','subjects.subject_credit','subjects.subject_categ','subjects.subtyp_id','subjects.seclang','subjects.department_id')// Fetch all columns from 'subjects'
    ->union($deptsubQuery);

$examsubjects = Subject::whereIn('subject_id', $studsub->pluck('subject_id'))
    ->with([
        'subcreditsstd',        
        'exmarksstd',           
        'examSubjects' => function ($query) use ($ac_id, $semesterIds) {
            $query->whereHas('exam', function ($examQuery) use ($ac_id, $semesterIds) {
                $examQuery->where('ac_id', $ac_id)  
                          ->whereIn('sem', $semesterIds); 
            });
        }
    ])
    ->get();
        
        
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('fyugp.print_report_card',compact('ac_id','ins_det','cur_acyear','course_name','sem_name','course','semester_id','student_det','exams','examsubjects','fa','sa','semesterIds'));
    } 
    
     public function minorstudsub(){
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id;  
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
                }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
            }
           else
           {
               if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
               }
           }
       }
       
       $pathway = FYUGPPATHWAY::all();
       $subCategories = SubCategory::whereIn('id', [2, 3, 4])->whereNull('deleted_at')->get();
       
        return view('fyugp.student.minorstudsub_view',compact('courses','subCategories','pathway'));
    }
    
    public function get_fyugpminorstudsub(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $category_id = $request->category_id;
        $sub_id = $request->sub_id;
        $pathway = FYUGPPATHWAY::all();
        $ac_id = getAcyear();
        $subjects = Subject::where('course_id',$course)->where('semester_id',$semester_id)->get();
        $total_seat = Seatallotment::where('course_id',$course)->where('ac_id',$ac_id)->first();
        $categ_name = SubCategory::where('id',$category_id)->first();
        $sem_name = Semester::where('semester_id',$semester_id)->first();
        $sem_cnt =[];
        $sem_array = Semester::where('semester_name',$sem_name->semester_name)->get(); 
        foreach($sem_array as $sem)
        {
          $sem_cnt[]  = $sem->semester_id;
        }
        $fyugpstudsubjects = FyugpStudSub::Join('course_subject','fyugp_stud_sub.sub_id','=','course_subject.subject_id')->where('course_subject.semester_id',$sem_name->semester_name)->where('fyugp_stud_sub.sub_id',$sub_id)->where('fyugp_stud_sub.acyear_id',$ac_id)->whereIn('fyugp_stud_sub.sem',$sem_cnt)->select('fyugp_stud_sub.*')->get();
        $stud_array = array();
        if($sem_name->semester_name =='1st Semester')
        {
            foreach($fyugpstudsubjects as $fyugpsub)
            {
                $student_percent = Student::where('student_id',$fyugpsub->stud_id)->first();
                if($fyugpsub->studn)
                {
                 $adno = $fyugpsub->studn->adno;
                 $name = $fyugpsub->studn->name;
                }
                else
                {
                  $adno=""; $name =""; 
                }
                $stud_array[$fyugpsub->id] =['acyear_id'=>$fyugpsub->acyear_id,'course'=>$fyugpsub->course,'sem'=>$fyugpsub->sem,'stud_id'=>$fyugpsub->stud_id,'percentage'=>$student_percent->plustwo,'adno'=>$adno,'name'=>$name,'sub_id'=>$fyugpsub->sub_id,'course_name'=>$fyugpsub->coursen->course_name];
                
            }
        }
        else
        {
            foreach($fyugpstudsubjects as $fyugpsub)
            {
                if($fyugpsub->studn)
                {
                 $adno = $fyugpsub->studn->adno;
                 $name = $fyugpsub->studn->name;
                }
                else
                {
                  $adno=""; $name =""; 
                }
                $stud_array[$fyugpsub->id] =['acyear_id'=>$fyugpsub->acyear_id,'course'=>$fyugpsub->course,'sem'=>$fyugpsub->sem,'stud_id'=>$fyugpsub->stud_id,'percentage'=>$fyugpsub->p_sgpa,'adno'=>$adno,'name'=>$name,'sub_id'=>$fyugpsub->sub_id,'course_name'=>$fyugpsub->coursen->course_name];

            }
            
        }
        usort($stud_array, function ($a, $b) {
        return $b['percentage'] <=> $a['percentage'];
    });
        return view('fyugp.student.minorstudsub_get',compact('course','semester_id','category_id','sub_id','subjects','ac_id','fyugpstudsubjects','pathway','stud_array','total_seat','categ_name'));
        
     }
     
      public function minorstudsub_save(Request $request)
      {
        $crs_id = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $category_id = decrypt($request->category_id);
        $sub_id = decrypt($request->sub_id);
        $ac_id = getAcyear();
        $i=0;
       
        if($request->posted !='')
        {
            foreach($request->posted as $ids)
            {
                
                 $check = FyugpStudSub::where([
                    'acyear_id' => $ac_id,
                    'sub_id' => $sub_id,
                    'sub_cat' => $category_id,
                    'stud_id' => $ids
                    ])->first();
                    if($check)
                    { 
                        $minorsub = $request->input("minorI".$ids); 
                        $check->update([
                            'sub_id' => $minorsub,
                            'status' => 1,
                            ]);
                            $i++;
                    }
            }
        }
        
       if($i>0){
            $msg_array = array('message'=>'Student Subject has been Updated Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Student Subject Could not be Updated !','alert-type'=>'error');
        }
          return redirect()->route('fyugp.minorstudsub')->with($msg_array);
      }
      
      public function minorstudsub_pdf($course,$semester_id,$category_id,$sub_id)
      { 
         $ins_det = instituteDetails();
         $pathway = FYUGPPATHWAY::all();
         $ac_id = getAcyear();
         $subjects = Subject::where('course_id', $course)->where('semester_id', $semester_id)->get();
         $total_seat = Seatallotment::where('course_id', $course)->where('ac_id', $ac_id)->first();
         $categ_name = SubCategory::find($category_id);
         $sem_name = Semester::find($semester_id);

         $sem_ids = Semester::where('semester_name', $sem_name->semester_name)->pluck('semester_id');

        $fyugpstudsubjects = FyugpStudSub::with(['studn', 'coursen', 'student'])
        ->join('course_subject', 'fyugp_stud_sub.sub_id', '=', 'course_subject.subject_id')
        ->where('course_subject.semester_id', $sem_name->semester_name)
        ->where('fyugp_stud_sub.sub_id', $sub_id)
        ->where('fyugp_stud_sub.acyear_id', $ac_id)
        ->whereIn('fyugp_stud_sub.sem', $sem_ids)
        ->select('fyugp_stud_sub.*')
        ->get();

        $preferences = FyugpStudSubPreferences::join('subjects', 'fyugp_stud_sub_preferences.pref_Id', '=', 'subjects.subject_id')
        ->where('fyugp_stud_sub_preferences.sub_cat', $category_id)->where('fyugp_stud_sub_preferences.acyear_id',$ac_id)->whereIn('fyugp_stud_sub_preferences.sem', $sem_ids)
        ->whereIn('fyugp_stud_sub_preferences.stud_id', $fyugpstudsubjects->pluck('stud_id')->unique())
        ->select('subjects.subject_code', 'subjects.subject_name', 'fyugp_stud_sub_preferences.type', 'fyugp_stud_sub_preferences.stud_id', 'fyugp_stud_sub_preferences.acyear_id')
        ->get()
        ->groupBy('stud_id');        
        $stud_array = $fyugpstudsubjects->map(function ($fyugpsub) use ($sem_name, $preferences) {
        $stud_id = $fyugpsub->stud_id;
        $prefs = $preferences->get($stud_id, collect());

        $first_pref = $prefs->firstWhere('type', 1);
        $second_pref = $prefs->firstWhere('type', 2);
        $third_pref = $prefs->firstWhere('type', 3);
        $fourth_pref = $prefs->firstWhere('type', 4);

         return [
            'acyear_id' => $fyugpsub->acyear_id,
            'course' => $fyugpsub->course,
            'sem' => $fyugpsub->sem,
            'stud_id' => $stud_id,
            'percentage' => $sem_name->semester_name === '1st Semester' ? $fyugpsub->student->plustwo : $fyugpsub->p_sgpa,
            'adno' => $fyugpsub->studn->adno ?? '',
            'name' => $fyugpsub->studn->name ?? '',
            'first_pref' => $first_pref ? "{$first_pref->subject_code} - {$first_pref->subject_name}" : '',
            'second_pref' => $second_pref ? "{$second_pref->subject_code} - {$second_pref->subject_name}" : '',
            'third_pref' => $third_pref ? "{$third_pref->subject_code} - {$third_pref->subject_name}" : '',
             'fourth_pref' => $fourth_pref ? "{$fourth_pref->subject_code} - {$fourth_pref->subject_name}" : '',
            'course_name' => $fyugpsub->coursen->course_name ?? '',
        ];
    })->sortByDesc('percentage')->values();
    

    
    
         $pdf = PDF::loadView('fyugp.student.minorstudsub_pdf', compact(
        'course', 'semester_id', 'category_id', 'sub_id', 'subjects', 'ac_id', 'fyugpstudsubjects', 'pathway', 'stud_array', 'total_seat', 'categ_name','sem_name', 'ins_det'
    )) ->setOptions([
       'defaultFont' => 'NotoSansMalayalam',
    ]);
   
    $pdf->setPaper('A3', 'landscape');

    return $pdf->download("studentPreferences_{$categ_name->category}.pdf");
 } 
      
      
      
    public function crsminorstudsub(){
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
          
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
               
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
                  
               }
           }
       }
       $pathway = FYUGPPATHWAY::all();
       $subCategories = SubCategory::whereIn('id', [2, 3, 4])->whereNull('deleted_at')->get();
       $ac_id = getAcyear();
       return view('fyugp.student.crsminorstudsub_view',compact('courses','subCategories','pathway'));
    }
    
    public function get_fyugpcrsminorstudsub(Request $request)
    {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $category_id = $request->category_id;
        $ac_id = getAcyear();
        $user = Auth::user(); 
        $userId = $user->user_id;
        $sem_name = Semester::where('semester_id', $semester_id)->first();
        $sem_all = Semester::where('semester_name', $sem_name->semester_name)->get();
        $sem_array =[];
        foreach ($sem_all as $sm) {
            $sem_array[] = $sm->semester_id;
        }
        $total_seat = Seatallotment::where('course_id',$course)->where('ac_id',$ac_id)->first();
        
        $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
        $classtch_cnt = ClassTeacher::where('user_id',$userId)->where('ac_id',$ac_id)->where('course_id',$course)->where('semester_id',$semester_id)->count();  
        if($user->staftyp_id == '1')
        {
            if($user->type_id == '17' || $hod_cnt > 0 || $classtch_cnt > 0 || $user->type_id == '13')
            {
                $subjects = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')->where('subjects.subject_categ', $category_id)->where('course_subject.semester_id', $sem_name->semester_name)->where('course_subject.course_id', $course)->select('subjects.*')->get();
  
            }
            else
            {
                $subjects = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')->join('staff_subject', 'staff_subject.subject_id', '=', 'subjects.subject_id')->where('subjects.subject_categ', $category_id)->where('staff_subject.course_id', $course)->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->where('course_subject.semester_id', $sem_name->semester_name)->where('course_subject.course_id', $course)->select('subjects.*')->get();
 
            }
        }
        else
        {
            $subjects = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')->where('subjects.subject_categ', $category_id)->where('course_subject.semester_id', $sem_name->semester_name)->where('course_subject.course_id', $course)->select('subjects.*')->get();
        }
        return view('fyugp.student.crsminorstudsub_get',compact('course','semester_id','category_id','subjects','ac_id','total_seat','sem_name','sem_array'));

        
    }
    public function get_fyugpcrsstud(Request $request)
    {
      
        $course = decrypt($request->course);
        $semester_id = decrypt($request->semester_id);
        $category_id = decrypt($request->category_id);
        $sub_id = decrypt($request->sub_id);
        $pathway = FYUGPPATHWAY::all();
        $ac_id = getAcyear();
        $subjects = Subject::where('course_id',$course)->where('semester_id',$semester_id)->get();
        $total_seat = Seatallotment::where('course_id',$course)->where('ac_id',$ac_id)->first();
        $categ_name = SubCategory::where('id',$category_id)->first();
        $sem_name = Semester::where('semester_id',$semester_id)->first();
        $sem_cnt =[];
        $sem_array = Semester::where('semester_name',$sem_name->semester_name)->get(); 
        foreach($sem_array as $sem)
        {
          $sem_cnt[]  = $sem->semester_id;
        }
        $fyugpstudsubjects = FyugpStudSub::Join('course_subject','fyugp_stud_sub.sub_id','=','course_subject.subject_id')->where('course_subject.semester_id',$sem_name->semester_name)->where('fyugp_stud_sub.sub_id',$sub_id)->where('fyugp_stud_sub.acyear_id',$ac_id)->whereIn('fyugp_stud_sub.sem',$sem_cnt)->select('fyugp_stud_sub.*')->get();
        $stud_array = array();
        if($sem_name->semester_name =='1st Semester')
        {
            foreach($fyugpstudsubjects as $fyugpsub)
            {
                $student_percent = Student::where('student_id',$fyugpsub->stud_id)->first();
                $stud_array[$fyugpsub->id] =['acyear_id'=>$fyugpsub->acyear_id,'course'=>$fyugpsub->course,'sem'=>$fyugpsub->sem,'stud_id'=>$fyugpsub->stud_id,'percentage'=>$student_percent->plustwo,'adno'=>$fyugpsub->studn->adno,'name'=>$fyugpsub->studn->name,'sub_id'=>$fyugpsub->sub_id,'course_name'=>$fyugpsub->coursen->course_name];
                
            }
        }
        else
        {
            foreach($fyugpstudsubjects as $fyugpsub)
            {
                $stud_array[$fyugpsub->id] =['acyear_id'=>$fyugpsub->acyear_id,'course'=>$fyugpsub->course,'sem'=>$fyugpsub->sem,'stud_id'=>$fyugpsub->stud_id,'percentage'=>$fyugpsub->p_sgpa,'adno'=>$fyugpsub->studn->adno,'name'=>$fyugpsub->studn->name,'sub_id'=>$fyugpsub->sub_id,'course_name'=>$fyugpsub->coursen->course_name];

            }
        }
        usort($stud_array, function ($a, $b) {
        return $b['percentage'] <=> $a['percentage'];
    });
        return view('fyugp.student.studall_get',compact('course','semester_id','category_id','sub_id','subjects','ac_id','fyugpstudsubjects','pathway','stud_array','total_seat','categ_name'));

    }
    public function crsminorstudsub_save(Request $request)
    {
    $crs_id = $request->course;
    $sem_id = $request->sem_id;
    $category_id = $request->category_id;
    $sub_id = $request->sub_id;
    $ac_id = getAcyear();
    $i = 0;
    
 
    if (!empty($request->posted)) {
        foreach ($request->posted as $student) {
            $student_id = $student['student_id'];  
            $minor_id = $student['minor_id'];     

           
            $check = FyugpStudSub::where([
                'acyear_id' => $ac_id,
                'sub_id' => $sub_id,
                'sub_cat' => $category_id,
                'stud_id' => $student_id
            ])->first();

            
            if ($check) {
                $check->update([
                    'sub_id' => $minor_id,  
                    'status' => 1,         
                ]);
                $i++;  
            }
        }
    }

    
    return true;
}

 public function studsubaec(){
      
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCourses = Course::where('department_id',$user->dept_id)->get();
           $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
           $courses = $deptCourses->merge($staffCourses)->unique('course_id')->where('category','0');  
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCourses = Course::where('department_id',$hod_dept->id)->get();
               $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
               $courses = $deptCourses->merge($staffCourses)->unique('course_id')->where('category','0'); 
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $deptCourses = Course::where('department_id',$user->dept_id)->get();
                   $staffCourses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->distinct()->select('courses.*')->get();
                   $courses = $deptCourses->merge($staffCourses)->unique('course_id')->where('category','0');
               }
           }
       }
       
        return view('fyugp.studsubaec_add',compact('courses'));
    }  
    
    

public function get_fyugpstudsubaec(Request $request)
     {
      
        $course = $request->course;
        $semester_id = $request->semester_id;
        $pathway = FYUGPPATHWAY::all();
        $ac_id = getAcyear();
        $subjects = Subject::where('course_id',$course)->where('semester_id',$semester_id)->get();
        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->orderBy('students.clno', 'ASC')->get();

        return view('fyugp.studsubaec_get',compact('course','semester_id','subjects','ac_id','students','pathway'));
         
     }
     
      public function studsubaec_save(Request $request){
        $course = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $ac_id = getAcyear();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$sem_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->get();
        $i=0;
        if (is_array($request->posted)) {
        foreach($request->posted as $ids)
        {
            
                $check = FyugpStudSub::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => 5,
                'stud_id' => $ids
            ])->first();
             $minorI = $request->input("minorI".$ids);
              if(!$check){
                     if (!is_null($minorI)) {
                         $minorIlist = FyugpStudSub::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'sub_id' => $minorI,
                        'sub_cat' =>5,
                        'status' =>1,
                        
                    ]);
                    if($minorIlist){ $i++; }
                     }
                 }
                 else
                {
                    $check->update([
                    'sub_id' => $minorI,
                    'status' =>1,
                ]);
                 $i++;
                }
              $checkII = FyugpStudSub::where([
                'acyear_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'sub_cat' => 6,
                'stud_id' => $ids
            ])->first();
             $minorII = $request->input("minorII".$ids);
              if(!$checkII){
                     if (!is_null($minorII)) {
                         $minorIIlist = FyugpStudSub::create([
                        'stud_id' => $ids,
                        'acyear_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'sub_id' => $minorII,
                        'sub_cat' =>6,
                        'status' =>1,
                        
                    ]);
                    if($minorIIlist){ $i++; }
                     }
                 }
                 else
                {
                    $checkII->update([
                    'sub_id' => $minorII,
                    'status' =>1,
                ]);
                 $i++;
                }  
                
                
                
        } }
         if($i>0){
            $msg_array = array('message'=>'FYUGP has been Saved Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'FYUGP Could not be Saved !','alert-type'=>'error');
        }
          return redirect()->route('fyugp.studsubaec')->with($msg_array);
          
      }
     
       public function ranklist_sgpa(){
        
       
        $ac_id = getAcyear();
        $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
           }
           else
           {
               if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '22' || $user->type_id == '13')
               {
               $courses = Course::all();
               }
               else
               {
                 $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
               }
           }
       }
       $pathway = FYUGPPATHWAY::all();
       $subCategories = SubCategory::whereIn('id', [2, 3, 4])->whereNull('deleted_at')->get();
       
        return view('fyugp.preferences.ranklist_sgpa',compact('courses','subCategories','pathway'));
    }  
    
    public function get_ranklist(Request $request)
    {
       // $available_fonts = \Barryvdh\DomPDF\Facade\Pdf::getFontMetrics()->getFontFamilies();
//dd($available_fonts);
$dompdf = new Dompdf();
$fontMetrics = $dompdf->getFontMetrics();
$fonts = $fontMetrics->getFontFamilies();
print_r($fonts);
       $course_id = $request->course;
       $semester_id = $request->semester_id; 
       $category_id = $request->category_id; 
       $sub_id = $request->sub_id; 
       $ac_id = getAcyear();
       $students = array();
       $sem_name = Semester::where('semester_id',$semester_id)->first();
       $sem_cnt =[];
        $sem_array = Semester::where('semester_name',$sem_name->semester_name)->get(); 
        foreach($sem_array as $sem)
        {
          $sem_cnt[]  = $sem->semester_id;
        }
       $fyugpstudsubjects = FyugpStudSub::Join('course_subject','fyugp_stud_sub.sub_id','=','course_subject.subject_id')->where('course_subject.semester_id',$sem_name->semester_name)->where('fyugp_stud_sub.sub_id',$sub_id)->where('fyugp_stud_sub.acyear_id',$ac_id)->whereIn('fyugp_stud_sub.sem',$sem_cnt)->select('fyugp_stud_sub.*')->get();
       $rank_array = array();
       foreach($fyugpstudsubjects as $fyugpsub)
       {
           
            
            $rank_array[$fyugpsub->id] =['acyear_id'=>$fyugpsub->acyear_id,'course'=>$fyugpsub->course,'sem'=>$fyugpsub->sem,'stud_id'=>$fyugpsub->stud_id,'percentage'=>$fyugpsub->p_sgpa ?? null,'adno'=>$fyugpsub->studn->adno,'name'=>$fyugpsub->studn->name,'course_name'=>$fyugpsub->coursen->course_name];

          
       }
        usort($rank_array, function ($a, $b) {
        return $b['percentage'] <=> $a['percentage'];
    });
    $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
        $previoussem ="";
    if($sem_name->semester_name == '2nd Semester')
        {
            $previoussem = "1st Semester";
        }
        else if($sem_name->semester_name == '3rd Semester')
        {
           $previoussem = "2nd Semester"; 
        }
        else if($sem_name->semester_name == '4th Semester')
        {
           $previoussem = "3rd Semester"; 
        }
        else if($sem_name->semester_name == '5th Semester')
        {
           $previoussem = "4th Semester"; 
        }
        else if($sem_name->semester_name == '6th Semester')
        {
           $previoussem = "5th Semester"; 
        }
        else if($sem_name->semester_name == '7th Semester')
        {
           $previoussem = "6th Semester"; 
        }
        else if($sem_name->semester_name == '8th Semester')
        {
           $previoussem = "7th Semester"; 
        }
       return view('fyugp.preferences.ranklist_get',compact('course_id','semester_id','ac_id','rank_array','previoussem','category_id','sub_id'));
    }
    
    public function ranklistsgpa_print($course,$semester_id,$category_id,$sub_id){
          
        $ins_det = instituteDetails();
        $ac_id = getAcyear();
        
        $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first();
        $subcateg_name = SubCategory::where('id',$category_id)->whereNull('deleted_at')->first();
        $subject_name = Subject::where('subject_id',$sub_id)->whereNull('deleted_at')->first(); 
        $sem_cnt =[];
        $sem_array = Semester::where('semester_name',$sem_name->semester_name)->get(); 
        foreach($sem_array as $sem)
        {
          $sem_cnt[]  = $sem->semester_id;
        }
        $previoussem ="";
        if($sem_name->semester_name == '2nd Semester')
        {
            $previoussem = "1st Semester";
        }
        else if($sem_name->semester_name == '3rd Semester')
        {
           $previoussem = "2nd Semester"; 
        }
        else if($sem_name->semester_name == '4th Semester')
        {
           $previoussem = "3rd Semester"; 
        }
        else if($sem_name->semester_name == '5th Semester')
        {
           $previoussem = "4th Semester"; 
        }
        else if($sem_name->semester_name == '6th Semester')
        {
           $previoussem = "5th Semester"; 
        }
        else if($sem_name->semester_name == '7th Semester')
        {
           $previoussem = "6th Semester"; 
        }
        else if($sem_name->semester_name == '8th Semester')
        {
           $previoussem = "7th Semester"; 
        }
       
       $fyugpstudsubjects = FyugpStudSub::Join('course_subject','fyugp_stud_sub.sub_id','=','course_subject.subject_id')->where('course_subject.semester_id',$sem_name->semester_name)->where('fyugp_stud_sub.sub_id',$sub_id)->where('fyugp_stud_sub.acyear_id',$ac_id)->whereIn('fyugp_stud_sub.sem',$sem_cnt)->select('fyugp_stud_sub.*')->get();
       $rank_array = array();
       foreach($fyugpstudsubjects as $fyugpsub)
       {
           
            $rank_array[$fyugpsub->id] =['acyear_id'=>$fyugpsub->acyear_id,'course'=>$fyugpsub->course,'sem'=>$fyugpsub->sem,'stud_id'=>$fyugpsub->stud_id,'percentage'=>$fyugpsub->p_sgpa ?? null,'adno'=>$fyugpsub->studn->adno,'name'=>$fyugpsub->studn->name,'course_name'=>$fyugpsub->coursen->course_name];

          
       }
        usort($rank_array, function ($a, $b) {
        return $b['percentage'] <=> $a['percentage'];
    });
       
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('fyugp.preferences.ranklistsgpa_print',compact('ac_id','ins_det','cur_acyear','course_name','sem_name','course','semester_id','rank_array','previoussem','subject_name','subcateg_name'));
    } 
    
     public function previous_sgpa(){
        
       
        $ac_id = getAcyear();
        $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->where('category','0')->get();
           }
           else
           {
               if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '22' || $user->type_id == '13')
               {
               $courses = Course::all();
               }
               else
               {
                 $courses = Course::where('department_id',$user->dept_id)->where('category','0')->get();
               }
           }
       }
       $pathway = FYUGPPATHWAY::all();
       $subCategories = SubCategory::whereIn('id', [2, 3, 4])->whereNull('deleted_at')->get();
       
        return view('fyugp.preferences.previous_sgpa',compact('courses','subCategories','pathway'));
    } 
      public function get_previoussgpa(Request $request)
    {
       $course_id = $request->course;
       $semester_id = $request->semester_id; 
      
       $ac_id = getAcyear();
       $students = array();
       $sem_name = Semester::where('semester_id',$semester_id)->first();
       $sem_cnt =[];
        $sem_array = Semester::where('semester_name',$sem_name->semester_name)->get(); 
        foreach($sem_array as $sem)
        {
          $sem_cnt[]  = $sem->semester_id;
        }
       $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course_id,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->orderBy('students.clno', 'ASC')->get();
        $category_id=2;
       $rank_array = array();
       foreach($students as $student)
       {
           $p_sgpa = $student->minpreferences->where('acyear_id',$ac_id)->where('sub_cat',$category_id)->where('course',$course_id)->where('sem',$semester_id)->where('type',1)->pluck('sgpa')->first();
            
            $rank_array[$student->student_id] =['acyear_id'=>$ac_id,'course'=>$student->course_id,'sem'=>$student->semester->semester_name,'stud_id'=>$student->student_id,'percentage'=>$p_sgpa ?? null,'adno'=>$student->adno,'name'=>$student->name,'course_name'=>$student->course->course_name];

          
       }
        usort($rank_array, function ($a, $b) {
        return $b['percentage'] <=> $a['percentage'];
    });
    $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
        $previoussem ="";
    if($sem_name->semester_name == '2nd Semester')
        {
            $previoussem = "1st Semester";
        }
        else if($sem_name->semester_name == '3rd Semester')
        {
           $previoussem = "2nd Semester"; 
        }
        else if($sem_name->semester_name == '4th Semester')
        {
           $previoussem = "3rd Semester"; 
        }
        else if($sem_name->semester_name == '5th Semester')
        {
           $previoussem = "4th Semester"; 
        }
        else if($sem_name->semester_name == '6th Semester')
        {
           $previoussem = "5th Semester"; 
        }
        else if($sem_name->semester_name == '7th Semester')
        {
           $previoussem = "6th Semester"; 
        }
        else if($sem_name->semester_name == '8th Semester')
        {
           $previoussem = "7th Semester"; 
        }
       return view('fyugp.preferences.previoussgpa_get',compact('course_id','semester_id','ac_id','rank_array','previoussem'));
    }
    public function previoussgpa_print($course,$semester_id){
          
        $ins_det = instituteDetails();
        $ac_id = getAcyear();
        
        $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first();
       
        $sem_cnt =[];
        $sem_array = Semester::where('semester_name',$sem_name->semester_name)->get(); 
        foreach($sem_array as $sem)
        {
          $sem_cnt[]  = $sem->semester_id;
        }
        $previoussem ="";
        if($sem_name->semester_name == '2nd Semester')
        {
            $previoussem = "1st Semester";
        }
        else if($sem_name->semester_name == '3rd Semester')
        {
           $previoussem = "2nd Semester"; 
        }
        else if($sem_name->semester_name == '4th Semester')
        {
           $previoussem = "3rd Semester"; 
        }
        else if($sem_name->semester_name == '5th Semester')
        {
           $previoussem = "4th Semester"; 
        }
        else if($sem_name->semester_name == '6th Semester')
        {
           $previoussem = "5th Semester"; 
        }
        else if($sem_name->semester_name == '7th Semester')
        {
           $previoussem = "6th Semester"; 
        }
        else if($sem_name->semester_name == '8th Semester')
        {
           $previoussem = "7th Semester"; 
        }
       
       $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->orderBy('students.clno', 'ASC')->get();
        $category_id=2;
       $rank_array = array();
       foreach($students as $student)
       {
           $p_sgpa = $student->minpreferences->where('acyear_id',$ac_id)->where('sub_cat',$category_id)->where('course',$course)->where('sem',$semester_id)->where('type',1)->pluck('sgpa')->first();
            
            $rank_array[$student->student_id] =['acyear_id'=>$ac_id,'course'=>$student->course_id,'sem'=>$student->semester->semester_name,'stud_id'=>$student->student_id,'percentage'=>$p_sgpa ?? null,'adno'=>$student->adno,'name'=>$student->name,'course_name'=>$student->course->course_name];

          
       }
        usort($rank_array, function ($a, $b) {
        return $b['percentage'] <=> $a['percentage'];
    });
       
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('fyugp.preferences.previoussgpa_print',compact('ac_id','ins_det','cur_acyear','course_name','sem_name','course','semester_id','rank_array','previoussem'));
    } 
}
