<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Course;
use App\Models\Acyear;
use App\Models\User;
use App\Models\StudentExam;
use App\Models\Semester;
use App\Models\SubCategory;
use App\Models\Subject;
use App\Models\SubjectType;
use App\Models\StudentExamSubject;
use App\Models\Student;
use App\Models\Enrolment;
use App\Models\AcademicCalendar;
use App\Models\Promote;
use App\Models\MainstreamExamMarks;
use App\Models\StudentSeminar;
use App\Models\StudentSeminarMarks;
use App\Models\StudentInterAssignment;
use App\Models\StudAssignmentsInter;
use App\Models\StudentProject;
use App\Models\StudentViva;
use App\Models\StudentAttendance;
use App\Models\AttendanceGrade;
use App\Models\MasterContiEvaluation;
use App\Models\PracticalExam;
use App\Models\MainstreamPracExamMarks;
use App\Models\StudentExamSubjectPract;
use App\Models\StudentAttendanceGP;
use App\Models\InternalMarks;


use App\Models\HOD;
use App\Models\ClassTeacher;
use App\Models\StaffSubject;
use DB;
use Illuminate\Support\Facades\Auth;

 
class InternalAssessment extends Controller
{
    public function studentexam_add()
    {
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
        return view('internalassessment.studentexam_add',compact('courses'));
        
    }

    public function studentexam_add_save(Request $request)
{
        $course = $request->course;
        $sem_id = $request->sem_id;
       
        $exam_name =$request->exam_name;
        $ac_id = getAcyear();
        $i=0;
      
        $check = StudentExam::where([
                'ac_id' => $ac_id,
                'sem' => $sem_id,
                'course' => $course,
                'exam_name' => $exam_name
               
            ])->first();
            if(!$check){
                
                 $examlist = StudentExam::create([
                        'course' => $course,
                        'ac_id' => $ac_id,
                        'course' => $course,
                        'sem' => $sem_id,
                        'exam_name' => $exam_name,
                        
                    ]);
            }
            else {
  
    $examlist = $check;
}
        foreach($request->posted as $ids)
        {
            $max_mark = $request->input("max_mark".$ids);
            $exam_date = $request->input("exam_date".$ids);
            $s_time = $request->input("s_time".$ids);
            $e_time = $request->input("e_time".$ids);
            if($max_mark =='')
            {
               $max_mark = 0; 
            }
                        $exmsub = StudentExamSubject::create([
                            'exam_id' => $examlist->exam_id,
                            'subject_id' => $ids,
                            'max_mark' => $max_mark,
                            'date' => $exam_date,
                            's_time'=>$s_time,
                            'e_time'=>$e_time,
                        ]);
                        
                         $accalendar = AcademicCalendar::create([
                            'type' => 4,
                            'tb_id' => $exmsub->examsub_id,
                            'event' => $exam_name,
                            'ev_date' => $exam_date,
                            'ac_id' => $ac_id,
                           
                        ]);   
                        $i++;
                 
                
           
            
        }
        if($i>0){
            $msg_array = array('message'=>'Exam addedd Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Exam Could not be Saved !','alert-type'=>'error');
        }
        return redirect()->route('exam.add')->with($msg_array);
    
      
}
  public function studentexam_get(Request $request)
  {
        $course =$request->course;
     
        $semester_id = $request->semester_id;
        $exam_name = $request->exam_name;
         
       
        $ac_id = getAcyear();
         $subjects = collect();
        $sem_name = Semester::where('semester_id',$request->semester_id)->first();
         $subcategories = SubCategory::all();
         foreach ($subcategories as $subcategory) {
                 $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                                ->where('subjects.subject_categ', $subcategory->id)
                                ->where('course_subject.semester_id', $sem_name->semester_name);
                if (!in_array($subcategory->id, [2, 3, 4])) {
                    $query->where('course_subject.course_id', $sem_name->course_id);
                }
             $subjects = $subjects->merge($query->select('subjects.*')->get());
            }
            return view('internalassessment.studentexam_get',compact('course','semester_id','subjects','ac_id','exam_name'));
  }
    
    public function studentexam_view()
    {
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
        return view('internalassessment.studentexam_view',compact('ac_id','courses'));
    }
    
     
    public function studentexamviewget(Request $request)
    {
        $course_id=  $request->get('course');
        $sem_id=   $request->get('semester_id');
        $ac_id = getAcyear();
        $exam = array();
        $rows = StudentExam::where('course', $course_id)->where('sem', $sem_id)->where('ac_id', $ac_id)->get();
        foreach($rows as $row){
        $exam[$row->exam_id ] = $row->exam_name;
        }
      
        return json_encode($exam);
    }
    
    public function stuexamviewget(Request $request)
    {
        $course =$request->cid;
      
        $semester_id = $request->sid;
        $exam_id = $request->eid;
        
        $ac_id = getAcyear();
        $exam_name = StudentExam::where('exam_id',$request->eid)->first();
       
        $examsubjects = StudentExamSubject::where('exam_id',$request->eid)->get();
        $subjects = collect();
    
        $sem_name = Semester::where('semester_id',$request->sid)->first();
        $subcategories = SubCategory::all();
        foreach ($subcategories as $subcategory) {
             $query = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                            ->where('subjects.subject_categ', $subcategory->id)
                            ->where('course_subject.semester_id', $sem_name->semester_name);
            if (!in_array($subcategory->id, [2, 3, 4])) {
                $query->where('course_subject.course_id', $sem_name->course_id);
            }
         $subjects = $subjects->merge($query->select('subjects.*')->get());
        }
       
        return view('internalassessment.stuexamviewget',compact('course','semester_id','examsubjects','ac_id','exam_id','exam_name','subjects'));
         
    }
    
    public function examdelete($id)
    {
       $subjectexam= StudentExamSubject::find($id)->delete();
       if($subjectexam)
       {
           $msg_array=array('message','Exam deleted successfully!!','success');
       }
        else
       {
           $msg_array=array('message','Exam could not be deleted!!','error');
       }
       return redirect()->route('exam.view')->with($msg_array);
    }
    
    
   public function examupdate(Request $request)
{
      
        $crs_id = decrypt($request->course);
        $sem_id = decrypt($request->sem_id);
        $exam_id = decrypt($request->exam_id);
        
         $exmnamecheck = StudentExam::where([
                'exam_id' => $exam_id])->first();
         
              if($exmnamecheck){
            $exmnamecheck->update([
                'exam_name' => $request->exam_name,
            ]);
            
             }
        $ac_id = getAcyear();
        $eseexamsub = StudentExamSubject::where('exam_id',$exam_id)->get();
      
        $i=0;
        
        foreach($eseexamsub as $essm)
        {
            $exmcheck = StudentExamSubject::where([
                'examsub_id' => $essm->examsub_id
               
            ])->first();
             if($exmcheck){
            $exmcheck->update([
                'max_mark' => $request->input("max_mark$essm->examsub_id"),
                'date' => $request->input("exam_date$essm->examsub_id"),
                's_time' => $request->input("s_time$essm->examsub_id"),
                'e_time' => $request->input("e_time$essm->examsub_id"),
            ]);
             $accheck = AcademicCalendar::where('tb_id', $exmcheck->examsub_id)->where('type', 4)->first();
             if ($accheck) {
                $accheck->update([
            'event' => $request->exam_name,
            'ev_date' => $request->input("exam_date$essm->examsub_id"),
            ]);
            } else {
        
        AcademicCalendar::create([
            'type' => 4,
            'tb_id' => $exmcheck->examsub_id,
            'event' => $request->exam_name,
            'ev_date' => $request->input("exam_date$essm->examsub_id"),
            'ac_id' => $ac_id,
        ]);
    }
             $i++; 
             }
        }
       
      if($i>0){
            $msg_array = array('message'=>'Exam Details has been Updated Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Exam Details Could not be Updated !','alert-type'=>'error');
        }
          
          return redirect()->route('exam.view')->with($msg_array);  
  
           
}
 public function examchart()
 {
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
     
     return view('internalassessment.examchart',compact('courses'));
 }
 
 public function examchart_get(Request $request)
 {
     $crs=Course::find($request->cid);
     $sem=Semester::find($request->sid);
     $exm=$request->eid;
     $course_id=$request->cid;
     $sem_id=$request->sid;
     $exam=StudentExam::join('student_exam_subjects','student_exam_subjects.exam_id','=','add_exam.exam_id')
     ->where('add_exam.course',$request->cid)
     ->where('add_exam.sem',$request->sid)
     ->where('add_exam.exam_id',$exm)
     ->select('student_exam_subjects.*','add_exam.*')
     ->get();
   
     return view('internalassessment.examchart_get',compact('exam','sem','crs','course_id','sem_id','exm'));
    
 }
 
 public function admitcard()
 {
     $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
    return view('internalassessment.admitcard',compact('courses'));
 }
 
public function admitcard_get(Request $request)
{
    $crs=Course::find($request->cid);
    $sem=Semester::find($request->sid);
    $exm=StudentExam::find($request->eid);
    $ac_id = getAcyear();
    $student=Student::join('promotes','promotes.student_id','=','students.student_id')
    ->where('promotes.ac_id',$ac_id)
    ->where('promotes.semester_id',$request->sid)
    ->where('promotes.course_id',$request->cid)
    ->select('promotes.*','students.adno','students.name','students.rollno','students.clno')
    ->get();
    return view('internalassessment.admitcard_get',compact('student','crs','sem','exm'));
}
 
 public function admitcard_print($id,$exmid)
 {
     $student_id=Student::find($id);
     $exm=StudentExam::find($exmid);
    
     $register_no=Enrolment::where('student_id',$id)->first();
     $ac_id = getAcyear();
     $students=Student::where('student_id',$id)->first();
     $ins_det = instituteDetails();
    $acyear=Acyear::where('ac_id',$ac_id)->first();
    $sdate=$acyear->sdate;
    $edate=$acyear->edate;
     $exam=StudentExam::join('student_exam_subjects','student_exam_subjects.exam_id','=','add_exam.exam_id')
     ->join('subjects','subjects.subject_id','=','student_exam_subjects.subject_id')
     ->where('student_exam_subjects.exam_id',$exmid)
     ->where('add_exam.ac_id',$ac_id)
     ->select('subjects.subject_name','student_exam_subjects.*','add_exam.exam_name')
     ->get();
    return view('internalassessment.admitcard_print',compact('exam','students','exm','ac_id','sdate','edate','ins_det','register_no'));
     
 }
 
 public function exam_marks()
 {
      $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
     return view('internalassessment.exam_marks',compact('courses'));
 }
 
 public function exam_marks_get(Request $request)
 {
       
        $course_id=  $request->get('course');
        $sem_id=   $request->get('semester_id');
        $ac_id = getAcyear();
        $exam = array();
        $rows = StudentExam::where('course', $course_id)->where('sem', $sem_id)->where('ac_id', $ac_id)->get();
        foreach($rows as $row){
            $exam[$row->exam_id ] = $row->exam_name;
        }
        return json_encode($exam); 
 }
 public function subwise_exm_mrks(Request $request)
 {
       $course = $request->course;
        $semester_id = $request->semester_id;
        $exam_id = $request->exam_id;
        
        $ac_id = getAcyear();
        $semesters = Semester::where('course_id',$course)->get();
        $exam_name = StudentExam::where('exam_id',$exam_id)->first();
        $examsubjects = StudentExamSubject::where('exam_id',$exam_id)->get();

        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.rollno','students.clno','students.adno','students.name')->orderBy('students.clno', 'ASC')->get();
  $marks = MainstreamExamMarks::where([
        'ac_id' => $ac_id,
        'course_id' => $course,
        'semester_id' => $semester_id,
        'exam_id' => $exam_id
    ])->get();     
    $marksByStudent = [];
    foreach ($marks as $mark) {
        $marksByStudent[$mark->student_id][$mark->subject_id] = $mark->mark;
    }
         return view('internalassessment.subwise_exm_mrks',compact('marksByStudent','course','semester_id','examsubjects','ac_id','semesters','exam_id','students','exam_name','marks'));
 }
 public function subwise_exm_mrks_save(Request $request)
 {
    
  $crs_id = decrypt($request->course);
    $sem_id = decrypt($request->sem_id);
    $exm_id = decrypt($request->exam_id);
    $ac_id = getAcyear();
    
    $examsubject = StudentExamSubject::where('exam_id', $exm_id)->get();
    
   
    if (!empty($request->posted)) {
        foreach ($request->posted as $ids) {
           
            foreach ($examsubject as $exam) {
                
                
                $check = MainstreamExamMarks::where([
                    'ac_id' => $ac_id,
                    'course_id' => $crs_id,
                    'semester_id' => $sem_id,
                    'exam_id' => $exm_id,
                    'subject_id' => $exam->subject_id,
                    'student_id' => $ids,
                ])->first();

               
                $MarkValue = $request->input("mark" . $ids . "_" . $exam->subject_id);

                if($MarkValue == "AB" || $MarkValue == "ab" || $MarkValue == "Ab")
                    {
                        $MarkValue = -1;
                    }
                if ($MarkValue !== null && $MarkValue !== '') {
                    if (!$check) {
                       
                        MainstreamExamMarks::create([
                            'student_id' => $ids,
                            'ac_id' => $ac_id,
                            'course_id' => $crs_id,
                            'semester_id' => $sem_id,
                            'exam_id' => $exm_id,
                            'subject_id' => $exam->subject_id,  
                            'mark' => $MarkValue,
                        ]);
                    } else {
                       
                        $check->update(['mark' => $MarkValue]);
                    }
                }
            }
        }
        
     
        $msg_arry=array('message'=>'Marks have been successfully saved!','success');
    } else {
      
       $msg_arry=array('message'=>'Marks could not save!','error');
    }
    
  
    return redirect()->back()->with($msg_arry);  
 }
 
 
 public function exam_marks_subject()
 {
      $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $courses = Course::where('department_id',$user->dept_id)->get();
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $courses = Course::where('department_id',$hod_dept->id)->get();
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               {
                   $courses = Course::where('department_id',$user->dept_id)->get();
               }
           }
       }
     return view('internalassessment.exam_marks_subject',compact('courses'));
 }
  
  public function exam_marks_subject_ajx(Request $request)
  {
        $exam_id=   $request->get('exam_id');
        $course_id=  $request->get('course');
        $sem_id=   $request->get('semester_id');
        $ac_id = getAcyear();
        $examsub = array();
        $rows = StudentExamSubject::where('exam_id', $exam_id)->get();
        foreach($rows as $row){
            
            $examsub[$row->subject_id] = $row->esesubn->subject_code.' - '.$row->esesubn->subject_name;
        }
        
        return json_encode($examsub);
  }
 public function mainstexmsbwise(Request $request)
 {
       $course = $request->course;
        $semester_id = $request->semester_id;
        $exam_id = $request->exam_id;
        $sub_id = $request->sub_id;
       
        $ac_id = getAcyear();
        $semesters = Semester::where('course_id',$course)->get();
        $exam_name = StudentExam::where('exam_id',$exam_id)->first();
        $examsubjects = StudentExamSubject::where('exam_id',$exam_id)->where('subject_id',$sub_id)->first();
       
        $subject_name = Subject::where('subject_id',$sub_id)->first();

        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.rollno','students.clno','students.adno','students.name')->orderBy('students.clno', 'ASC')->get();
       
        return view('internalassessment.mainstexmsbwise',compact('course','semester_id','examsubjects','ac_id','semesters','exam_id','students','exam_name','sub_id','subject_name'));
         
 }
  
  
  public function mainstexmsbwise_save(Request $request)
  {
      
    
   $crs_id = decrypt($request->course);
    $sem_id = decrypt($request->sem_id);
    $exm_id = decrypt($request->exam_id);
    $sub_id = decrypt($request->sub_id);
    $ac_id = getAcyear();
    
    $examsubject = StudentExamSubject::where('exam_id', $exm_id)->where('subject_id',$sub_id)->get();
    
   
    if (!empty($request->posted)) {
        foreach ($request->posted as $ids) {
           
            foreach ($examsubject as $exam) {
                
                
                $check = MainstreamExamMarks::where([
                    'ac_id' => $ac_id,
                    'course_id' => $crs_id,
                    'semester_id' => $sem_id,
                    'exam_id' => $exm_id,
                    'subject_id' => $sub_id,
                    'student_id' => $ids,
                ])->first();

               
                $MarkValue = $request->input("mark" . $ids . "_" . $sub_id);
                 if($MarkValue=="ab" || $MarkValue=="AB" || $MarkValue=="Ab")
                 {
                     $MarkValue="-1";
                 }
                
                if ($MarkValue !== null && $MarkValue !== '') {
                    if (!$check) {
                       
                        MainstreamExamMarks::create([
                            'student_id' => $ids,
                            'ac_id' => $ac_id,
                            'course_id' => $crs_id,
                            'semester_id' => $sem_id,
                            'exam_id' => $exm_id,
                            'subject_id' => $sub_id,  
                            'mark' => $MarkValue,
                        ]);
                    } else {
                       
                        $check->update(['mark' => $MarkValue]);
                    }
                }
            }
        }
        
     
        $msg_arry=array('message'=>'Marks have been successfully saved!','success');
    } else {
      
       $msg_arry=array('message'=>'Marks could not save!','error');
    }
    
  
    return redirect()->back()->with($msg_arry);  
 
  }
  
  public function subwise_exm_mrks_print($course_id,$sem_id,$exm_id)
  {
       $ins_det = instituteDetails();
        $ac_id = getAcyear();
        
        $course_name = Course::where('course_id',$course_id)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$sem_id)->whereNull('deleted_at')->first(); 
        $exam_name = StudentExam::where('exam_id',$exm_id)->first();
        $examsubjects = StudentExamSubject::where('exam_id',$exm_id)->get();
       $marks = MainstreamExamMarks::where([
        'ac_id' => $ac_id,
        'course_id' => $course_id,
        'semester_id' => $sem_id,
        'exam_id' => $exm_id
    ])->get();     
    $marksByStudent = [];
    foreach ($marks as $mark) {
        $marksByStudent[$mark->student_id][$mark->subject_id] = $mark->mark;
    }

        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course_id,'promotes.semester_id'=>$sem_id))->select('promotes.*','students.rollno','students.clno','students.adno','students.name')->orderBy('students.clno', 'ASC')->get();
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
        return view('internalassessment.subwise_exm_mrks_print',compact('marksByStudent','students','exam_name','ac_id','ins_det','cur_acyear','course_name','sem_name','exm_id','examsubjects','course_id','sem_id'));
  }
  
  public function mainstexmsbwise_print($course,$semester_id,$exam_id,$sub_id)
  {
        $ins_det = instituteDetails();
        
       
        $ac_id = getAcyear();
         $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
        $exam_name = StudentExam::where('exam_id',$exam_id)->first();
        $subject_name=Subject::where('subject_id',$sub_id)->whereNull('deleted_at')->first();
        $examsubjects = StudentExamSubject::where('exam_id',$exam_id)->where('subject_id',$sub_id)->first();

        $students = array();
        $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$semester_id))->select('promotes.*','students.rollno','students.clno','students.adno','students.name')->orderBy('students.clno', 'ASC')->get();
               $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 

        return view('internalassessment.mainstexmsbwise_print',compact('sem_name','course_name','cur_acyear','ins_det','examsubjects','course','semester_id','examsubjects','ac_id','exam_id','students','exam_name','sub_id','subject_name'));
  }
  
  public function seminar_add()
  {
     $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
     return view('internalassessment.seminar_add',compact('courses'));
  }
  public function seminar_sub_get(Request $request)
  {
      $course_id=$request->course;
      $sem_id=$request->semester_id;
       $subjects = [];
        $ac_id = getAcyear();
        $user = Auth::user(); 
        $userId = $user->user_id;  
        $sem_name = Semester::where('semester_id',$sem_id)->first();
        $subcategories = SubCategory::all();
        $staff_type = auth()->user()->type_id;
        foreach ($subcategories as $subcategory) {
        
        if (in_array($subcategory->id, [2, 3, 4])) {
            $rows = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                ->where([
                    'subjects.subject_categ' => $subcategory->id,
                    'course_subject.semester_id' => $sem_name->semester_name,
                ])
                ->select('subjects.*')
                ->get();
        } else {
            $rows = Subject::join('course_subject', 'subjects.subject_id', '=', 'course_subject.subject_id')
                ->where([
                    'course_subject.course_id' => $sem_name->course_id,
                    'subjects.subject_categ' => $subcategory->id,
                    'course_subject.semester_id' => $sem_name->semester_name,
                ])
                ->select('subjects.*')
                ->get();
        }
        $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
        $classtch_cnt = ClassTeacher::where('user_id',$userId)->where('ac_id',$ac_id)->where('course_id',$course_id)->where('semester_id',$sem_id)->count();     
       if($user->staftyp_id == '1')
       {
        
           if($user->type_id == '17' || $hod_cnt > 0 || $classtch_cnt > 0 || $user->type_id == '13')
           {
               foreach ($rows as $row) {
                $subjects[$row->subject_id] = $row->subject_name;
              }
           }
           else
            {
                foreach ($rows as $row) {
                     $staffsubject=StaffSubject::join('users','users.user_id','=','staff_subject.user_id')->join('courses','courses.course_id','=','staff_subject.course_id')->where('staff_subject.subject_id',$row->subject_id)->where('staff_subject.user_id',$userId)->where('staff_subject.acyear_id',$ac_id)->first();    
                    if($staffsubject)
                    {
                    $subjects[$row->subject_id] = $row->subject_name;
                    }
                }
            }
        }
        else
        {
            foreach ($rows as $row) {
                $subjects[$row->subject_id] = $row->subject_name;
            }
        }
    }
     
      return json_encode($subjects);
  }
  public function seminar_add_get(Request $request)
  {
   
  $course=$request->course;
  $sem=$request->semester_id;
  $sub=$request->sub_id;
  $ac_id = getAcyear();
  $students = Promote::join('students', 'students.student_id', '=', 'promotes.student_id')
    ->leftJoin('student_seminar', function ($join) use ($sub) {
        $join->on('student_seminar.student_id', '=', 'students.student_id')
             ->where('student_seminar.subject_id', '=', $sub);
    })
    ->where([
        'promotes.ac_id' => $ac_id,
        'promotes.course_id' => $course,
        'promotes.semester_id' => $sem
    ])
    ->select('promotes.*','students.adno','students.name','students.clno','students.rollno','student_seminar.seminar_topic as seminar_topics','student_seminar.submit_date as date')->orderBy('students.clno', 'ASC')
    ->get();
$max_marks = StudentSeminar::where('course_id', $course)
    ->where('semester_id', $sem)
    ->where('subject_id', $sub)
    ->where('ac_id', $ac_id)
    ->select('max_marks')
    ->first();
  
  return view('internalassessment.seminar_add_get',compact('max_marks','course','sem','sub','ac_id','students'));
       
  }
   public function seminar_save(Request $request)
{
$crs_id = $request->course;
$sem_id = $request->sem;
$sub_id = $request->sub;
$student_id = $request->student_id;
$max_mark=$request->max_marks;
$ac_id = getAcyear();

if (!empty($request->posted)) {
     StudentSeminar::where([
        'ac_id' => $ac_id,
        'course_id' => $crs_id,
        'semester_id' => $sem_id,
        'subject_id' => $sub_id,
    ])->update(['max_marks' => $max_mark]);  

    
    
    foreach ($request->posted as $ids) {
        $topic = $request->input("seminar" . $ids);
        $submitdate=$request->input("sdate" . $ids);
     
        $existing = StudentSeminar::where([
            'ac_id' => $ac_id,
            'course_id' => $crs_id,
            'semester_id' => $sem_id,
            'subject_id' => $sub_id,
            'student_id' => $ids,
        ])->first(); 

        if (!$existing) {
          
            $save = StudentSeminar::create([
                'ac_id' => $ac_id,
                'course_id' => $crs_id,
                'semester_id' => $sem_id,
                'subject_id' => $sub_id,
                'student_id' => $ids,
                'seminar_topic' => $topic,
                'max_marks'=>$max_mark,
                'submit_date'=>$submitdate
                
            ]);

            $msg_arry = ['message' => 'Seminar Topics have been successfully saved!', 'success'];
        } else {
           
            $existing->update([
                'seminar_topic' => $topic,
                'max_marks'=>$max_mark,
                'submit_date'=>$submitdate
            ]);

            $msg_arry = ['message' => 'Seminar Topics have been successfully updated!', 'success'];
        }
    }
}

return redirect()->back()->with($msg_arry);
}
public function seminar_print($crs_id,$sem_id,$sub_id)
{
    $ins_det = instituteDetails();
     $ac_id = getAcyear();
      $course_name = Course::where('course_id',$crs_id)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$sem_id)->whereNull('deleted_at')->first(); 
        $subject_name=Subject::where('subject_id',$sub_id)->whereNull('deleted_at')->first();
  $students = Promote::join('students', 'students.student_id', '=', 'promotes.student_id')
        ->leftJoin('student_seminar', 'student_seminar.student_id', '=', 'students.student_id')
        ->where(['promotes.ac_id' => $ac_id, 'promotes.course_id' => $crs_id, 'promotes.semester_id' => $sem_id])
        ->select('promotes.*','students.adno','students.name','students.rollno','students.clno','student_seminar.seminar_topic as seminar_topics','student_seminar.submit_date')->orderBy('students.clno', 'ASC')
        ->get();
         $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 

        return view('internalassessment.seminar_print',compact('subject_name','sem_name','course_name','ins_det','crs_id','sem_id','sub_id','ac_id','students','cur_acyear'));
}


public function seminar_add_marks()
{
    $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
     return view('internalassessment.seminar_add_marks',compact('courses'));
}
public function seminar_add_marks_get(Request $request)
{
     $course=$request->course;
  $sem=$request->semester_id;
  $sub=$request->sub_id;
  $ac_id = getAcyear();
  

  
  $students=Promote::join('students', 'students.student_id', '=', 'promotes.student_id')
  ->join('student_seminar','student_seminar.student_id','=','students.student_id')
  ->where([
      
      'student_seminar.ac_id'=>$ac_id,
      'student_seminar.course_id'=>$course,
      'student_seminar.semester_id'=>$sem,
      'student_seminar.subject_id'=>$sub
  ])
  ->select('student_seminar.seminar_topic','promotes.*','students.adno','students.rollno','students.name','students.clno')->orderBy('students.clno', 'ASC')->get();
 
$existingMarks = StudentSeminarMarks::where([
        'ac_id' => $ac_id,
        'course_id' => $course,
        'semester_id' => $sem,
        'subject_id' => $sub,
    ])->get()->keyBy('student_id');

  
  return view('internalassessment.seminar_add_marks_get',compact('existingMarks','course','sem','sub','ac_id','students'));
}

public function seminar_add_marks_save(Request $request)
{
   $crs_id = $request->course;
$sem_id = $request->sem;
$sub_id = $request->sub;
$student_id = $request->student_id;
$ac_id = getAcyear(); 
if (!empty($request->posted)) {

    
    
    foreach ($request->posted as $ids) {
        $grade = $request->input("grade" . $ids);
        $gradepoint= $request->input("gradepoint" . $ids);
        $presentdndate=$request->input("pdate" . $ids);
        $studentseminar=StudentSeminar::where([
            'ac_id' => $ac_id,
            'course_id' => $crs_id,
            'semester_id' => $sem_id,
            'subject_id' => $sub_id,
            'student_id' => $ids,
        ])->first(); 
        $seminar_id=$studentseminar->seminar_id;
        
        $existing = StudentSeminarMarks::where([
            'ac_id' => $ac_id,
            'course_id' => $crs_id,
            'semester_id' => $sem_id,
            'subject_id' => $sub_id,
            'student_id' => $ids,
        ])->first(); 

        if (!$existing) {
          
            $save = StudentSeminarMarks::create([
                'ac_id' => $ac_id,
                'course_id' => $crs_id,
                'semester_id' => $sem_id,
                'subject_id' => $sub_id,
                'student_id' => $ids,
                'seminar_id' => $seminar_id,
                'gradepoint'=>$gradepoint,
                'grade'=>$grade,
                'presentation_date'=>$presentdndate
                
            ]);

            $msg_arry = ['message' => 'Seminar Marks have been successfully saved!', 'success'];
        } else {
           
            $existing->update([
                'gradepoint' => $gradepoint,
                'grade'=>$grade,
                'presentation_date'=>$presentdndate
            ]);

            $msg_arry = ['message' => 'Seminar Marks have been successfully updated!', 'success'];
        }
    }
}

return redirect()->back()->with($msg_arry);



}
public function assignment_add()
{
    $ac_id = getAcyear();
    $user = Auth::user(); 
    $userId = $user->user_id; 
    if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
    return view('internalassessment.assignment_add',compact('courses'));
    
}

public function assignment_save(Request $request)
{
    
    
    
      $validated = $request->validate([
        'course_id' => 'required',
        'semester_id' => 'required',
        'sub_id' => 'required',
        'assig_topic' => 'required|string|max:255', 
        'date' => 'required|date', 
        'submit_date' => 'required|date|after_or_equal:date', 
    ]);
    $course=$request->course_id;
    $sem=$request->semester_id;
    $sub=$request->sub_id;
    $topic=$request->assig_topic;
    $current_date=$request->date;
    $submit_date=$request->submit_date;
    $ac_id=getAcyear();
    $assignmentadd=StudentInterAssignment::create([
        'course_id'=>$course,
        'semester_id'=>$sem,
        'subject_id'=>$sub,
        'ac_id'=>$ac_id,
        'assignment_topic'=>$topic,
        'added_date'=>$current_date,
        'submit_date'=>$submit_date,
        ]);
        
        if($assignmentadd)
        {
            $msg_array=array('message'=>'Assignment Topic Added Successfully','success');
        }
         else
        {
            $msg_array=array('message'=>'Assignment Topic could not be added','error');
        }
    return redirect()->back()->with($msg_array);
    
}
public function assignment_view()
{
    $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
    return view('internalassessment.assignment_view',compact('courses'));
}
public function assignment_view_get(Request $request)
{
  
    $crs_id=$request->course;
   
    $sem_id=$request->semester_id;
    $sub_id=$request->sub_id;
    $ac_id=getAcyear();
    $assignmt=StudentInterAssignment::where([
        'course_id'=>$crs_id,
        'semester_id'=>$sem_id,
        'subject_id'=>$sub_id,
        'ac_id'=>$ac_id,
        ])
        ->get();
       return view('internalassessment.assignment_view_get',compact('crs_id','sem_id','sub_id','ac_id','assignmt'));
}
public function assignment_update(Request $request)
{
    $assig_id = $request->assig_id;
    $topic = $request->assignment_topic;
    $submit_date = $request->submit_date;

    $assignment = StudentInterAssignment::where('assig_id', $assig_id)->first();

    if ($assignment) {
        $assignment->update([
            'assignment_topic' => $topic,
            'submit_date' => $submit_date,
        ]);

        return response()->json([
            'message' => 'Updated Successfully',
            'success' => true,
            'updated_assignment' => $assignment,
        ]);
    }

    return response()->json([
        'message' => 'Assignment not found',
        'success' => false,
    ]);
}
public function assignment_delete($id)
{
    $assignment = StudentInterAssignment::where('assig_id', $id)->first();
    $assignment->delete();
    if($assignment)
    {
        $msg_array=array('message'=>'Assignment Deleted successfully!','success');
    }
   return back()->with($msg_array);
}

public function submitted_assig()
{
       $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
    return view('internalassessment.submitted_assig',compact('courses'));
    
}

public function submitted_assig_get(Request $request)
{
    $courseId=$request->course;
    $semId=$request->semester_id;
    $subId=$request->sub_id;
    $ac_id=getAcyear();
    $students=Student::join('promotes','promotes.student_id','=','students.student_id')
    ->join('student_submitted_assig_inter','student_submitted_assig_inter.student_id','=','students.student_id')
    ->join('student_assignment_inter_add','student_assignment_inter_add.assig_id','=','student_submitted_assig_inter.assig_id')
    ->where([
        'student_assignment_inter_add.ac_id'=>$ac_id,
        'student_submitted_assig_inter.course_id'=>$courseId,
        'student_submitted_assig_inter.semester_id'=>$semId,
        'student_submitted_assig_inter.subject_id'=>$subId
        ])
        ->select('promotes.*','students.name','students.adno','students.clno','students.rollno','student_assignment_inter_add.assignment_topic','student_assignment_inter_add.submit_date','student_submitted_assig_inter.submitted_date','student_submitted_assig_inter.assignment','student_submitted_assig_inter.assig_id','students.student_id')
        ->orderBy('students.clno', 'ASC')->get();
       $existingMarks = [];

foreach ($students as $student) {
    $marks = StudAssignmentsInter::where([
        'ac_id' => $ac_id,
        'course_id' => $courseId,
        'semester_id' => $semId,
        'subject_id' => $subId,
        'assig_id' => $student->assig_id 
    ])->first();

    if ($marks) {
         $existingMarks[$student->student_id][$student->assig_id] = $marks;
    }
}


       return view('internalassessment.submitted_assig_get',compact('existingMarks','students','courseId','semId','subId','ac_id'));
}

public function submitted_assig_save(Request $request)
{
   
    
    
     $crs_id = $request->course;
    $sem_id = $request->sem;
    $sub_id = $request->sub;
    $ac_id = getAcyear(); 
$student_id = $request->student_id;

    
    if (!empty($request->posted)) {
        foreach ($request->posted as $student_id) {
            
           
                $assig_id = $request->assig_id[$student_id];
                
            
                $grade = $request->input("grade." . $student_id);
                 
                $gradepoint = $request->input("gradepoint." . $student_id);

              
                $marks = StudAssignmentsInter::where([
                    'ac_id' => $ac_id,
                    'course_id' => $crs_id,
                    'semester_id' => $sem_id,
                    'subject_id' => $sub_id,
                    'student_id' => $student_id,
                    'assig_id' => $assig_id
                ])->first();

              
               
                    $marks->update([
                        'grade' => $grade,
                        'gradepoint' => $gradepoint,
                    ]);
                
            
        }

        return redirect()->back()->with(['message' => 'Assignment Marks have been successfully saved!', 'success']);
    }
}
public function practicalrecord()
{
    
    $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
    return view('internalassessment.practicalrecord',compact('courses'));
    
}
public function practicalrecord_get(Request $request)
{
    
     
     $course=$request->course;
  $sem=$request->semester_id;
  $sub=$request->sub_id;
  $ac_id = getAcyear();
  $students = Promote::join('students', 'students.student_id', '=', 'promotes.student_id')
    ->leftJoin('student_project', function ($join) use ($sub) {
        $join->on('student_project.student_id', '=', 'students.student_id')
             ->where('student_project.subject_id', '=', $sub);
    })
    ->where([
        'promotes.ac_id' => $ac_id,
        'promotes.course_id' => $course,
        'promotes.semester_id' => $sem
    ])
    ->select('promotes.*','students.adno','students.name','students.rollno','students.clno','student_project.grade','student_project.gradepoint','student_project.submitted_date as date')
    ->orderBy('students.clno', 'ASC')->get();
$existingMarks=[];
foreach ($students as $student) {
    $marks = StudentProject::where([
        'ac_id' => $ac_id,
        'course_id' => $course,
        'semester_id' => $sem,
        'subject_id' => $sub,
          'student_id' => $student->student_id, 
    ])->first();

    if ($marks) {
         $existingMarks[$student->student_id]= $marks;
    }
}



    return view('internalassessment.practicalrecord_get',compact('students','course','sem','sub','ac_id','existingMarks'));
}

public function practicalrecord_save(Request $request)
{
    
$crs_id = $request->course;
$sem_id = $request->sem;
$sub_id = $request->sub;
$student_id = $request->student_id;
$ac_id = getAcyear(); 
if (!empty($request->posted)) {

    
    
    foreach ($request->posted as $ids) {
        $grade = $request->input("grade" . $ids);
        $gradepoint= $request->input("gradepoint" . $ids);
        $submittedDate=$request->input("submitted_date" . $ids);

        
        $existing = StudentProject::where([
            'ac_id' => $ac_id,
            'course_id' => $crs_id,
            'semester_id' => $sem_id,
            'subject_id' => $sub_id,
            'student_id' => $ids,
        ])->first(); 

        if (!$existing) {
          
            $save = StudentProject::create([
                'ac_id' => $ac_id,
                'course_id' => $crs_id,
                'semester_id' => $sem_id,
                'subject_id' => $sub_id,
                'student_id' => $ids,
                'gradepoint'=>$gradepoint,
                'grade'=>$grade,
                'submitted_date'=>$submittedDate
                
            ]);

            $msg_arry = ['message' => 'Project Marks have been successfully saved!', 'success'];
        } else {
           
            $existing->update([
                'gradepoint' => $gradepoint,
                'grade'=>$grade,
                'submitted_date'=>$submittedDate
            ]);

            $msg_arry = ['message' => 'Project Marks have been successfully updated!', 'success'];
        }
    }
}

return redirect()->back()->with($msg_arry);

}
public function viva()
{
    $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
    return view('internalassessment.viva',compact('courses'));
}
public function viva_get(Request $request)
{
      $course=$request->course;
  $sem=$request->semester_id;
  $sub=$request->sub_id;
  $ac_id = getAcyear();
  $students = Promote::join('students', 'students.student_id', '=', 'promotes.student_id')
    ->leftJoin('viva_marks', function ($join) use ($sub) {
        $join->on('viva_marks.student_id', '=', 'students.student_id')
             ->where('viva_marks.subject_id', '=', $sub);
    })
    ->where([
        'promotes.ac_id' => $ac_id,
        'promotes.course_id' => $course,
        'promotes.semester_id' => $sem
    ])
    ->select('promotes.*','students.adno','students.name','students.rollno','students.clno','viva_marks.grade','viva_marks.gradepoint','viva_marks.conducted_date as date')->orderBy('students.clno', 'ASC')
    ->get();
$existingMarks=[];
foreach ($students as $student) {
    $marks = StudentViva::where([
        'ac_id' => $ac_id,
        'course_id' => $course,
        'semester_id' => $sem,
        'subject_id' => $sub,
         'student_id' => $student->student_id, 
    ])->first();

    if ($marks) {
         $existingMarks[$student->student_id]= $marks;
    }
}



    return view('internalassessment.viva_get',compact('students','course','sem','sub','ac_id','existingMarks'));
}
public function viva_save(Request $request)
{
    $crs_id = $request->course;
$sem_id = $request->sem;
$sub_id = $request->sub;
$student_id = $request->student_id;
$ac_id = getAcyear(); 
if (!empty($request->posted)) {

    
    
    foreach ($request->posted as $ids) {
        $grade = $request->input("grade" . $ids);
        $gradepoint= $request->input("gradepoint" . $ids);
        $conductedDate=$request->input("conducted_date" . $ids);

        
        $existing = StudentViva::where([
            'ac_id' => $ac_id,
            'course_id' => $crs_id,
            'semester_id' => $sem_id,
            'subject_id' => $sub_id,
            'student_id' => $ids,
        ])->first(); 

        if (!$existing) {
          
            $save = StudentViva::create([
                'ac_id' => $ac_id,
                'course_id' => $crs_id,
                'semester_id' => $sem_id,
                'subject_id' => $sub_id,
                'student_id' => $ids,
                'gradepoint'=>$gradepoint,
                'grade'=>$grade,
                'conducted_date'=>$conductedDate
                
            ]);

            $msg_arry = ['message' => 'Viva Marks have been successfully saved!', 'success'];
        } else {
           
            $existing->update([
                'gradepoint' => $gradepoint,
                'grade'=>$grade,
                'conducted_date'=>$conductedDate
            ]);

            $msg_arry = ['message' => 'Viva Marks have been successfully updated!', 'success'];
        }
    }
}

return redirect()->back()->with($msg_arry);
}

public function attendance()
{
   $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
    return view('internalassessment.attendance',compact('courses'));  
}
public function attendance_get(Request $request)
{
    
  $course=$request->course;
  $sem=$request->semester_id;
  $sub=$request->sub_id;
  $ac_id = getAcyear();
  $attendanceGrades = AttendanceGrade::where('ac_id', $ac_id)->get();
   $students = Student::join('promotes','promotes.student_id','=','students.student_id')->
  where('promotes.course_id',$course)
                        ->where('promotes.semester_id',$sem)->where('promotes.ac_id',$ac_id)
                        ->get();
  $studentAttendance = StudentAttendance::where('course_id',$course)
                                          ->where('semester_id',$sem)
                                          ->where('subject_id',$sub)
                                          ->where('ac_id',$ac_id)
                                          ->get()
                                          ->groupBy('student_id');
                                          
                                           $attendanceSummary = [];
             $markedDays = StudentAttendance::where('course_id',$course)
                                   ->where('semester_id',$sem)
                                   ->where('subject_id',$sub)
                                    ->where('ac_id',$ac_id)
                                   ->distinct('date')
                                   ->count('date');
                                   
 foreach ($students as $student) {
    $presentDays = 0;
    $absentDays = 0;
$halfDayLeaves=0;
    

 if (isset($studentAttendance[$student->student_id])) {
        foreach ($studentAttendance[$student->student_id] as $attendance) {
          
          
            if ($attendance->am == 0 && $attendance->pm == 0) {
                $presentDays++;
            } 
         
            elseif ($attendance->am == 1 && $attendance->pm == 1) {
                $absentDays++;
            }
           
            elseif (($attendance->am == 1 && $attendance->pm == 0) || ($attendance->am == 0 && $attendance->pm == 1)) {
                $halfDayLeaves++;
            }
        }
    }



   $totalDays = $presentDays + $absentDays + ($halfDayLeaves * 0.5); 
    $attendancePercentage = $totalDays > 0 ? ($presentDays + ($halfDayLeaves * 0.5)) / $totalDays * 100 : 0;

   
     $gradePoint = '';
    $letterGrade = '';
    foreach ($attendanceGrades as $grade) {
        if ($attendancePercentage >= $grade->gr_from && $attendancePercentage <= $grade->gr_to) {
            $gradePoint = $grade->grade_point;
            $letterGrade = $grade->letter_grade;
            break;
        }
    }

    $attendanceSummary[] = [
        'student_id'=>$student->student_id,
        'student_name' => $student->name,
        'admission_number' => $student->adno,
        'present_days' => $presentDays,
        'absent_days' => $absentDays,
         'half_day_leaves' => $halfDayLeaves,
        'attendance_percentage' => round($attendancePercentage, 2),
       'gradepoint'=>$gradePoint,
       'lettergrade'=>$letterGrade,
    ];
}
  
    return view('internalassessment.attendance_get',compact('ac_id','course','sem','sub','attendanceSummary','markedDays'));
                                 

}

public function internalmarks()
{
    $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
    $subtype = SubjectType::all();
    return view('internalassessment.internalmarks',compact('courses','subtype'));  
}


public function internalmarks_get(Request $request)
{
    $course = $request->course;
    $sem = $request->semester_id;
    $sub = $request->sub_id;
    $subtyp_id = $request->subtyp_id;
    $ac_id = getAcyear(); 
    
    $students = array();
    $students = Promote::Join('students','promotes.student_id','=','students.student_id')->where(array('promotes.ac_id'=>$ac_id,'promotes.course_id'=>$course,'promotes.semester_id'=>$sem))->select('promotes.*','students.adno','students.name','students.rollno','students.clno')->orderBy('students.clno', 'ASC')->get();
    
    
    return view('internalassessment.internalmarks_get', compact('course','sem','sub','ac_id','students','subtyp_id'));
    
}

 public function internalmarks_save(Request $request)
 {
    $course = decrypt($request->course);
    $sem_id = decrypt($request->sem);
    $sub_id = decrypt($request->sub);
    $subtyp_id = decrypt($request->subtyp_id);
    $ac_id = getAcyear();
    $i=0;
    if (is_array($request->posted)) 
    {
        foreach($request->posted as $ids)
        {
            $test1 = !is_null($request->input("test1".$ids)) ? $request->input("test1".$ids) : ''; 
            $test2 = !is_null($request->input("test2".$ids)) ? $request->input("test2".$ids) : ''; 
            $assignment = !is_null($request->input("assignment".$ids)) ? $request->input("assignment".$ids) : ''; 
            $attendance = !is_null($request->input("attendance".$ids)) ? $request->input("attendance".$ids) : ''; 
            $check = InternalMarks::where([
                'stud_id' => $ids,
                'course_id' => $course,
                'sem_id' => $sem_id,
                'subtyp_id'=>$subtyp_id,
                'sub_id' => $sub_id,
                'ac_id'=>$ac_id
            ])->first(); 
             if(!$check){
                $internal = InternalMarks::create([
                        'stud_id' => $ids,
                        'course_id' => $course,
                        'sem_id' => $sem_id,
                        'subtyp_id'=>$subtyp_id,
                        'sub_id' => $sub_id,
                        'test1' => $test1,
                        'test2' => $test2,
                        'assignment' => $assignment,
                        'attendance' => $attendance,
                        'ac_id'=>$ac_id,
                        
                    ]);
                    if($internal){ $i++; } 
                 
             }
             else
             {
                 $check->update([
                    'test1' => $test1,
                    'test2' => $test2,
                    'assignment' => $assignment,
                    'attendance' => $attendance,
                   
                ]);
                 $i++;
             }
        }
    }
    if($i>0){
            $msg_array = array('message'=>'Student Internal Mark has been Saved Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Student Internal Mark Could not be Saved !','alert-type'=>'error');
        }
          return redirect()->route('inter.internalmrk')->with($msg_array);
 }
 
public function internalmarks_view()
{
    $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $courses = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $courses = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
    $subtype = SubjectType::all();
    return view('internalassessment.internalmarks.view.internalmarks_view',compact('courses','subtype'));  
}
 
public function internalmarks_get_view(Request $request)
{
    $course = $request->course;
    $sem = $request->semester_id;
    $sub = $request->sub_id;
    $subtyp_id = $request->subtyp_id;
    $ac_id = getAcyear(); 
    
   
    $internalmarks_det = InternalMarks::where('course_id',$course)->where('sem_id',$sem)->where('sub_id',$sub)->where('subtyp_id',$subtyp_id)->where('ac_id',$ac_id)->get();
    
    
    return view('internalassessment.internalmarks.view.internalmarks_get_view', compact('course','sem','sub','ac_id','internalmarks_det','subtyp_id'));
    
} 
 
public function internalmarks_print($course,$semester_id,$subtype_id,$sub_id)
{ 
  $ins_det = instituteDetails();
  $ac_id = getAcyear();
  $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 
  $course_name = Course::where('course_id',$course)->whereNull('deleted_at')->first(); 
  $sem_name = Semester::where('semester_id',$semester_id)->whereNull('deleted_at')->first(); 
  $subjects = Subject::where('subject_id',$subtype_id)->whereNull('deleted_at')->first();
  $internalmarks_det = InternalMarks::where('course_id',$course)->where('sem_id',$semester_id)->where('sub_id',$sub_id)->where('subtyp_id',$subtype_id)->where('ac_id',$ac_id)->get();
  return view('internalassessment.internalmarks.view.internalmarks_print', compact('course','semester_id','sub_id','ac_id','internalmarks_det','subtype_id','ins_det','cur_acyear','course_name','sem_name','subjects'));   
}
private function getGradePoint($percentage)
{
    if ($percentage >= 90) return 10;
    if ($percentage >= 80) return 9;
    if ($percentage >= 70) return 8;
    if ($percentage >= 60) return 7;
    if ($percentage >= 50) return 6;
    if ($percentage >= 40) return 5;
    return 4; 
}










public function attendance_save(Request $request)
{
 
    $request->validate([
        'course' => 'required',
        'sub' => 'required',
        'sem' => 'required',
        'ac_id' => 'required',
        'gradepoint' => 'array|required',
        'grade' => 'array|required',
        'attendance' => 'array|nullable', 
    ]);

    foreach ($request->attendance as $student_id => $attendance_value) {
        if ($attendance_value == 1) { 
            $attendance_data = [
                'course_id' => $request->course,
                'semester_id' => $request->sem,
                'subject_id' => $request->sub,
                'student_id' => $student_id,
                'ac_id' => $request->ac_id,
                'gradepoint' => $request->gradepoint[$student_id],
                'grade' => $request->grade[$student_id],
                'created_at' => now(),
                'updated_at' => now(),
            ];

            $existingAttendance = StudentAttendanceGP::where('student_id', $student_id)
                ->where('ac_id', $request->ac_id)
                ->where('course_id', $request->course)
                ->where('semester_id', $request->sem)
                ->where('subject_id', $request->sub)
                ->first();

            if ($existingAttendance) {
                $existingAttendance->update($attendance_data);
                
            } else {
                StudentAttendanceGP::create($attendance_data);
            }
        }
    }

    return redirect()->back()->with('success', 'Attendance and grades saved successfully.');
}
   
    
    
   public function examchart_print($semid,$crsid,$exmid)
   {
        $ins_det = instituteDetails();
       $crs=Course::find($crsid);
       $sem=Semester::find($semid);
       $exm=StudentExam::find($exmid);
        $course_name = Course::where('course_id',$crsid)->whereNull('deleted_at')->first(); 
        $sem_name = Semester::where('semester_id',$semid)->whereNull('deleted_at')->first(); 
        $exam=StudentExam::join('student_exam_subjects','student_exam_subjects.exam_id','=','add_exam.exam_id')
     ->where('add_exam.course',$crsid)
     ->where('add_exam.sem',$semid)
     ->where('add_exam.exam_id',$exmid)
     ->select('student_exam_subjects.*','add_exam.*')
     ->get();
    $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first(); 

      return view('internalassessment.examchart_print',compact('exm','exmid','cur_acyear','exam','ins_det','course_name','sem_name'));
   }














}
