<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Course; 
use App\Models\Semester; 
use App\Models\Student; 
use App\Models\Acyear; 
use App\Models\Stafftype; 
use App\Models\UserType; 
use App\Models\User; 
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Mail;
use App\Mail\CustomMail;

use DB;

class Logincd extends Controller
{
   public function student_login_details()
   {
       $course = Course::all();
       return view('logincd.student_login_details',compact('course'));
   }

   public function student_login_details_get(Request $request)
   {
       $course=Course::find($request->cid);
       $sem=Semester::find($request->sid);
       $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first();
       $ac_id=$cur_acyear->ac_id;
       $student=Student::join('promotes','promotes.student_id','=','students.student_id')
       ->where('promotes.ac_id',$ac_id)
       ->where('promotes.course_id',$request->cid)
       ->where('promotes.semester_id',$request->sid)
       ->where('students.tcstatus','0')
       ->where('students.status','1')
       ->select('students.*')
       ->get();
       return view('logincd.student_login_details_get',compact('student','course','sem'));
   }
    
   public function student_login_details_edit($student_id) 
   {
       $student=Student::find($student_id);
       $student_det=Student::where('student_id',$student_id)->first();
       return view('logincd.student_login_details_edit',compact('student_det','student'));
   }
    
    public function student_login_details_update(Request $request)
    {
        $student_id = $request->student_id;
            
        $validated = $request->validate([
            'name' => 'required',
            'mobile' => 'nullable|numeric',
            'email' => 'nullable|email',
            'password' => 'required',
        ]);
        
        $student = Student::find($student_id);
        $update = $student->update([
                'name' => $request->name,
                'mobile' => $request->mobile,
                'email' => $request->email,
                'password' => bcrypt($request->password),
            ]);
        if($update){
            DB::table('student_log')->updateOrInsert(['student_id' => $student_id], ['password' => $request->password]);
            
            $msg_array = ['message' => 'Student Login Details Updated Successfully!', 'alert-type' => 'success'];
        } else {
            $msg_array = ['message' => 'Student Login Details Could not be Updated!', 'alert-type' => 'error'];
        }
            
        return redirect()->route('student.logindetails')->with($msg_array);
    }
    
    public function student_login_details_print($course_id,$sem_id)
    {
        $ins_det = instituteDetails();
        $course=Course::find($course_id);
        $sem=Semester::find($sem_id);
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first();
        $ac_id=$cur_acyear->ac_id;
        $student=Student::join('promotes','promotes.student_id','=','students.student_id')
                    ->leftJoin('student_log','students.student_id','=','student_log.student_id')
                    ->where('promotes.ac_id',$ac_id)
                    ->where('promotes.course_id',$course_id)
                    ->where('promotes.semester_id',$sem_id)
                    ->where('students.tcstatus','0')
                    ->where('students.status','1')
                    ->select('students.*','student_log.password as pswd')
                    ->get();
            
        return view('logincd.student_login_details_print',compact('student','ins_det','course','sem')); 
    }
    
  /*  public function student_login_details_print($course_id,$sem_id)
    {
        $ins_det = instituteDetails();
        $course=Course::find($course_id);
        $sem=Semester::find($sem_id);
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first();
        $ac_id=$cur_acyear->ac_id;
        $students = Student::join('promotes','promotes.student_id','=','students.student_id')
                    ->leftJoin('student_log','students.student_id','=','student_log.student_id')
                    ->where('promotes.ac_id',$ac_id)
                    ->where('promotes.course_id',$course_id)
                    ->where('promotes.semester_id',$sem_id)
                    ->where('students.tcstatus','0')
                    ->where('students.status','1')
                    ->select('students.*','student_log.password as pswd')
                    ->get();
        $msg_array = [];            
        
        
            
        return redirect()->route('student.logindetails')->with($msg_array); 
    }*/
    
public function staff_login_details()
{
 $stafftype=Stafftype::all();
  $staffdesignation=UserType::all();
  return view('logincd.staff_login_details',compact('stafftype','staffdesignation'));
}
public function staff_login_get(Request $request)
{
      $stafftype=Stafftype::find($request->tid);
      $staffdesig=UserType::find($request->did);
     $users=User::where('type_id',$request->did)->where('staftyp_id',$request->tid)->get();
   return view('logincd.staff_login_get',compact('users'));
}
public function student_login_details_update_direct(Request $request)
{
      $validator = Validator::make($request->all(), [
            'student_id' => 'required|exists:students,student_id',
            'field' => 'required|in:email,password',
            'value' => 'required|string|max:255',
        ]);


        if ($validator->fails()) {
            return response()->json(['success' => false, 'errors' => $validator->errors()], 400);
        }

      
        $student = Student::find($request->student_id);

        $password = '';
        if ($request->field === 'email') {
            $student->email = $request->value;
        } elseif ($request->field === 'password') {
            $password = $request->value;
            $student->password = bcrypt($request->value); 
        }

      
        $saved = $student->save();
        if($saved){
            DB::table('student_log')->updateOrInsert(['student_id' => $request->student_id], ['password' => $password]);
        }

        return response()->json(['success' => true, 'message' => 'Update successful']);
    }
    
    




    
}
