<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Acyear;
use App\Models\Letterhead;
use App\Models\Course;
use App\Models\Semester;
use App\Models\Promote;
use App\Models\StaffSubject;
use App\Models\Subject;
use App\Models\Econtent;
use App\Models\EcontentStud;
use App\Models\HOD;
use Image;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Carbon\Carbon;
class Other extends Controller
{
   public function letter_head()
   {
       $institution = instituteDetails();
       return view('Other.letter_head',compact('institution'));
   }
   public function letter_head_save(Request $request)
   {
        $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
         $ac_id = $cur_acyear->ac_id;
       $date=$request->date;
      $userId = Auth::id();
       $lettercontent=$request->letter_content;
       $letterhead=Letterhead::create([
           'date'=>$date,
           'letter_content'=>$lettercontent,
           'ac_id'=>$ac_id,
           'created_by'=>$userId,
           ]);
           if($letterhead)
           {
               $msg_array=array('message'=>'Letter Head Saved successfully!','success');
           }
           else
           {
                $msg_array=array('message'=>'Letter Head Could not be Saved successfully!','error');
           }
           return redirect()->route('others.letterhead')->with($msg_array);
   }
   
   public function letter_head_view()
   {
       $userId = Auth::id();
       $institution = instituteDetails();
       $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
         $ac_id = $cur_acyear->ac_id;
       $letterhead=Letterhead::where('ac_id',$ac_id)->where('created_by',$userId)->get();
       return view('Other.letter_head_view',compact('letterhead','institution'));
       
   }
   public function letter_head_view_single($id)
   {
       $letterhead_id=Letterhead::find($id);
        $institution = instituteDetails();
        $letterhead=Letterhead::where('letterhead_id',$id)->first();
        return view('Other.letter_head_view_single',compact('letterhead','institution'));
   }
  public function letter_head_edit($id)
  {
      $letterhead_id=Letterhead::find($id);
      $institution = instituteDetails();
       $letterhead=Letterhead::where('letterhead_id',$id)->first();
       return view('Other.letter_head_edit',compact('letterhead','institution','letterhead_id'));
  }
    public function letter_head_update(Request $request)
    {
        $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
        $ac_id = $cur_acyear->ac_id;
        $date=$request->date;
        $letterhead_id=$request->letterhead_id;
        $userId = Auth::id();
        $lettercontent=$request->letter_content;
        $letterheadeupdate=Letterhead::where('letterhead_id',$letterhead_id)->first();
        $letterheadeupdate->update([
            'date'=>$date,
            'letter_content'=>$lettercontent,
            'ac_id'=>$ac_id,
            'created_by'=>$userId,
        ]);
        
        if($letterheadeupdate){
            $msg_array=array('message'=>'Letter Head updated successfully','success');
        }else{
            $msg_array=array('message'=>'Letter Head Could not update','error');
        }
        
        return redirect()->route('others.letterhead.view')->with($msg_array);
    }
   
    public function econtent()
    {
        // $userId = Auth::id();
        // $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
        // $ac_id = $cur_acyear->ac_id;
        
        // $staffsubjects = StaffSubject::join('courses','courses.course_id','=','staff_subject.course_id')
        //     ->join('semesters','semesters.semester_id','=','staff_subject.semester_id')
        //     ->where('staff_subject.acyear_id',$ac_id)
        //     ->where('staff_subject.user_id',$userId)
        //     ->select('courses.course_name','staff_subject.*','semesters.semester_name')
        //     ->get();
           $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           { 
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $staffsubject = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       } 
        return view('Other.econtent',compact('staffsubject'));
    }
    
    public function econtent_save(Request $request)
    {
        $validated = $request->validate([
            
           'url' => 'required',
            'batch_id' => 'nullable',
        ]);
        
        $cur_acyear = Acyear::where('default1', 1)->whereNull('deleted_at')->first();
        $ac_id = $cur_acyear->ac_id;
        $userId = Auth::id();
       
        $file_name="";
        if($request->hasFile('file')){
            $file = $request->file;
            $ext = $file->extension();
            $file_name = 'file_'.time().'.'.$ext;
            $file->storeAs('staff/econtent',$file_name);
        }
        
        $i=0;
        
        $subcategory = Subject::where('subject_id',$request->subject_id)->first();
    $sub_cat_id = $subcategory->subject_categ;
    // Fetch students who need the task
    $students = array();
        
         $subject = Subject::find($request->subject_id);
        $semester = Semester::find($request->semester_id);
                $semesterIds = Semester::where('semester_name', $semester->semester_name)->pluck('semester_id')->toArray();
       $query = Promote::join('students', 'promotes.student_id', '=', 'students.student_id')
                    ->join('courses', 'promotes.course_id', '=', 'courses.course_id');
                if(in_array($subject->subject_categ, [2,3,4,5,6])) {
                    $query->join('fyugp_stud_sub', 'promotes.student_id', '=', 'fyugp_stud_sub.stud_id');
                if ($request->batch_id != null && $request->batch_id != '') {
                    $courses = DB::table('group_courses')->where('group_id',$request->batch_id)->pluck('course_id')->toArray();
                    $query->whereIn('promotes.course_id', $courses);
                }
                $query->where('fyugp_stud_sub.acyear_id', $ac_id)
                      ->where('fyugp_stud_sub.sub_id', $request->subject_id)
                      ->whereIn('promotes.semester_id', $semesterIds)
                      ->whereIn('fyugp_stud_sub.sem', $semesterIds);
                } else {
                    $query->where('promotes.course_id', $request->course_id)
                        ->where('promotes.semester_id', $request->semester_id);
                }
                $students = $query->where('promotes.ac_id', $ac_id)
                    ->select('students.student_id','students.adno','students.name','students.rollno','courses.course_name','promotes.course_id','promotes.semester_id')
                    ->groupBy('promotes.student_id')
                    ->orderBy('students.rollno', 'ASC')
                    ->get();     
        
        $contentsave = Econtent::create([
            'course_id' => $request->course_id,
            'semester_id' => $request->semester_id,
            'subject_id' => $request->subject_id,
             'batch_id' => $request->batch_id,
            'ac_id' => $ac_id,
            'user_id' => $userId,
            'url' => $request->url,
            'description' => $request->description,
            'file' => $file_name,
            'date' => Carbon::now(), 
        ]);
        
        if($contentsave){
            
             foreach ($students as $stud) {
                $econtentstudexists = EcontentStud::where([
                    'econtent_id' => $contentsave->econtent_id,
                    'stud_id' => $stud->student_id,
                ])->first();

                if (!$econtentstudexists) {
                    EcontentStud::create([
                        'econtent_id' => $contentsave->econtent_id,
                        'stud_id' => $stud->student_id,
                        
                    ]);
                    $i++;
                }
            }
           
        }
        
          if ($i > 0) {
        $msg_array=array('message'=>'E-Content posted successfully', 'alert-type' => 'success');
            } else {
               $msg_array=array('message'=>'E-Content could not post', 'alert-type' => 'error');
            }
           
        return redirect()->route('others.econtent')->with($msg_array);
    }
   
    public function econtent_getsem($id)
    {
        $userId = Auth::id();
        $semesters = array();
        $rows = Semester::join('staff_subject','staff_subject.semester_id','=','semesters.semester_id')
            ->where('staff_subject.course_id',$id)
            ->where('user_id',$userId)
            ->get();
            
        foreach($rows as $row){
            $semesters[$row->semester_id] = $row->semester_name;
        }
        return json_encode($semesters);
    }
  
    public function econtent_getsub(Request $request)
    {
        $course = Course::find($request->course);
        $userId = Auth::id();
        $sem = Semester::find($request->semester_id);
        $subject = array();
        $rows = Subject::join('staff_subject','staff_subject.subject_id','=','subjects.subject_id')
            ->where('staff_subject.course_id',$request->course)
            ->where('staff_subject.semester_id',$request->semester_id)
            ->where('user_id',$userId)
            ->get();
            
        foreach($rows as $row){
            $subject[$row->subject_id] = $row->subject_name;
        }
        
        return json_encode($subject);
    }
    
    public function econtent_view()
    {
        $userId = Auth::id();
        $subjects = Econtent::join('users','users.user_id','=','econtent.user_id')
            
           
            ->where('econtent.user_id',$userId)
            ->select('econtent.*','users.name')
            ->get();
            
        return view('Other.econtent_view',compact('subjects'));
    }
  
}