<?php

namespace App\Http\Controllers\Student;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use App\Models\EcontentStud;
use App\Models\Acyear;
use App\Models\Student;
use App\Models\NotificationStudent;
use Carbon\Carbon;


use DB;
class Notification extends Controller
{

public function getNotifications()
{
    try {
        $studentId = Auth::guard('student')->id();
        $ac_id = getAcyear();
        
        $student = Student::find($studentId);
        if (!$student) {
            return response()->json(['error' => 'Student not found.'], 404);
        }

        $notifications = NotificationStudent::join('promotes as pro', function ($join) {
                $join->on('pro.course_id', '=', 'student_notification_entry.course_id')
                     ->on('pro.semester_id', '=', 'student_notification_entry.semester_id');
            })
            ->join('users', 'users.user_id', '=', 'student_notification_entry.user_id')
            ->join('user_types', 'user_types.type_id', '=', 'users.type_id')
            ->where(function($query) use ($ac_id, $studentId) {
                $query->where('pro.ac_id', $ac_id)
                      ->where('pro.student_id', $studentId);
            })
            
            ->select(
                'student_notification_entry.notification',
                'student_notification_entry.created_at',
                'student_notification_entry.date',
                'users.name as sender_name',
                'user_types.type_name as sender_role'
            )
            ->distinct()
            ->get();

        $formattedNotifications = $notifications->map(function ($notification) {
            $formattedDate = $notification->date ? Carbon::parse($notification->date)->format('d-m-Y') : 'Unknown date';
            $days = Carbon::parse($notification->date)->diffInDays(Carbon::now());

            $notificationMessage = $notification->notification;
            $senderInfo = "Sent by: " . $notification->sender_name . ", " . $notification->sender_role;

            return [
                'notification' => $notificationMessage,
                'color' => 'info',
                'sender_info' => $senderInfo,
                'date' => $formattedDate,
                'days' => $days, 
            ];
        });

        return response()->json($formattedNotifications);

    } catch (\Exception $e) {
        return response()->json(['error' => 'Failed to fetch notifications. ' . $e->getMessage()], 500);
    }
}

 public function getNotifications2()
{
    try {
        $studentId = Auth::guard('student')->id();
        $ac_id = getAcyear();
        
        $student = Student::find($studentId);
        if (!$student) {
            return response()->json(['error' => 'Student not found.'], 404);
        }

        $notifications = NotificationStudent::join('users','users.user_id','=','student_notification_entry.user_id')
       ->join('user_types', 'user_types.type_id', '=', 'users.type_id')
            ->where('course_id',0)->where('semester_id',0)
        
            ->select(
                'student_notification_entry.notification',
                'student_notification_entry.created_at',
                'student_notification_entry.date',
                'users.name as sender_name',
                'user_types.type_name as sender_role'
            )
            ->distinct()
            ->get();

        $formattedNotifications = $notifications->map(function ($notification) {
            $formattedDate = $notification->date ? Carbon::parse($notification->date)->format('d-m-Y') : 'Unknown date';
            $days = Carbon::parse($notification->date)->diffInDays(Carbon::now());

            $notificationMessage = $notification->notification;
            $senderInfo = "Sent by: " . $notification->sender_name . ", " . $notification->sender_role;

            return [
                'notification' => $notificationMessage,
                'color' => 'info',
                'sender_info' => $senderInfo,
                'date' => $formattedDate,
                'days' => $days, 
            ];
        });

        return response()->json($formattedNotifications);

    } catch (\Exception $e) {
        return response()->json(['error' => 'Failed to fetch notifications. ' . $e->getMessage()], 500);
    }
}
    

}