<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Student;
use App\Models\DuplicateTc;
use App\Models\Paymentmode;
use App\Models\DuplicateTcFees;
use App\Models\FeeType;
use App\Models\Acyear;
use App\Models\MenuAccess;
use App\Models\TcRequestStudent;
use App\Models\Voucher;
use App\Models\Accounttype;
use App\Models\Financialyear;


use Illuminate\Support\Facades\Auth;
class Tc extends Controller
{
    protected $accountId;
    protected $fyearId;
    protected $fsDate;
    protected $feDate;

    public function __construct()
    {
        $this->accountId = Accounttype::getDefaultAccountId();
        $this->fyearId = Financialyear::getDefaultFyearId($this->accountId);
        $fyear = Financialyear::find($this->fyearId);
        if ($fyear) {
            $this->fsDate = $fyear->sdate;
            $this->feDate = $fyear->edate;
        } else {
            // Handle missing Financial Year data gracefully
            abort(404, 'Financial Year not found');
        }
    }
   
   public function duplicate_tc()
   {
       $students=Student::where('tcstatus','1')->get();
       $duplicatetc=DuplicateTc::all();
       return view('tc.duplicate_tc',compact('students','duplicatetc'));
       
   }
   
   public function duplicate_tc_save(Request $request)
   {
    
       
          $validated=$request->validate([
          'student_id'=>'required',
          'upload1'=>'required|mimes:doc,docx,pdf,jpeg,jpg,png|max:5120',
          'upload2'=>'required|mimes:doc,docx,pdf,jpeg,jpg,png|max:5120',
          ]); 
           $upload1 = "";
    $upload2 = "";
          if ($request->hasFile('upload1')) {
        $file1 = $request->file('upload1');
        $ext = $file1->extension();
        $upload1 = 'upload1_' . time() . '.' . $ext;
        $file1->storeAs('public/uploads/duplicatetc/attachments/', $upload1);
    }
         
          if ($request->hasFile('upload2')) {
        $file2 = $request->file('upload2');
        $ext = $file2->extension();
        $upload2 = 'upload2_' . time() . '.' . $ext;
        $file2->storeAs('public/uploads/duplicatetc/attachments/', $upload2);
    }
         $tc = DuplicateTc::create([
        'student_id' => $request->student_id,
        'upload1' => $upload1, 
        'upload2' => $upload2,
        'status' => 0,
    ]);
          
          
           
if ($tc) {
        $msg_array = ['message' => 'Request added successfully', 'status' => 'success'];
    } else {
        $msg_array = ['message' => 'Request could not be added', 'status' => 'error'];
    }
 return redirect()->route('duplicate.tc')->with($msg_array);
 
   }
   
   
   
   public function duplicate_tc_pending()
   {
       
       $duplicatetc=DuplicateTc::where('status','0')->get();
       return view('tc.duplicate_tc_pending',compact('duplicatetc'));
       
   }
   
   public function duplicate_tc_pending_view($tc_id)
   {
      
    $tc_id=DuplicateTc::join('students','duplicate_tc_request.student_id','=','students.student_id')->where('duplicate_tc_request.duptc_id',$tc_id)->select('students.name','students.adno','students.fname','students.mname','students.course_id','duplicate_tc_request.*')->first();
 
    $tc=DuplicateTc::where('duptc_id',$tc_id)->first();
   
    return view('tc.duplicate_tc_pending_view',compact('tc_id','tc'));
   }
   
   
   public function duplicate_tc_pending_approve($tc_id)
   {
     $request = DuplicateTC::find($tc_id);

        
        if ($request) {
          
            $request->status = 1;
            $request->save();
            
        
            return redirect()->route('duplicate.tc.pending')->with('success','Request approved successfully.');
        }

   }
   
   public function duplicate_tc_pending_reject($tc_id)
   {
        $request = DuplicateTC::find($tc_id);

        if ($request) {
            $request->status = 2;
            $request->save();
            
          
            return redirect()->back()->with('success', 'Request rejected successfully.');
        }
   }
   
  
    public function duplicate_tc_payment()
    {
        $paymentmodes = Paymentmode::where('status',1)->get();
        $students = Student::where('tcstatus','1')->get();
        $receipt_no = DuplicateTcFees::max('receipt_no') + 1 ?? 1;
        
        return view('tc.duplicate_tc_payment',compact('paymentmodes','students','receipt_no'));
    }
   
    public function duplicate_tc_payment_save(Request $request)
    {
        $validated = $request->validate([
                'student_id' => 'required',
                'receipt_no'=>'required|unique:duplicate_tc_fees,receipt_no,NULL,dtcfees_id,deleted_at,NULL',
                'paid_date' => 'required|date',
                'amount'=>'required',
                'mode_id' => 'required',
            ]);
            
        $rec_no = DuplicateTcFees::max('receipt_no') + 1 ?? 1;
        $group_id = DuplicateTcFees::withTrashed()->max('group_id') + 1 ?? 1;
            
        $duplicate_payment = DuplicateTcFees::create([
                'group_id' => $group_id,
                'student_id' => $validated['student_id'],
                'receipt_no' => $validated['receipt_no'],
                'paid_date' => $validated['paid_date'],
                'amount' => $validated['amount'],
                'mode_id' => $validated['mode_id'],
            ]);
        
       if($duplicate_payment){
            if($validated['amount'] > 0){
                $vgroup_id = Voucher::withTrashed()->max('group_id') + 1 ?? 1;
                $vno = Voucher::where('vtype_id', 2)
                      ->where('account_id', $this->accountId)
                      ->whereBetween('vdate', [$this->fsDate, $this->feDate])
                      ->max('vno') + 1 ?? 1;
                    
                $vdata = [
                        'group_id' => $vgroup_id,
                        'vtype_id' => 2,
                        'vno' => $vno,
                        'vorder' => 1,
                        'vdate' => $validated['paid_date'],
                        'dr_ledger' => $validated['mode_id'],
                        'cr_ledger' => 16,
                        'vamount' => $validated['amount'],
                        'table_name' => 'duplicate_tc_fees',
                        'table_group_id' => $group_id,
                        'account_id' => $this->accountId,
                        'created_by' => auth()->user()->user_id
                    ];
                Voucher::create($vdata);
            }
           
            $msg_array = array('message'=>'Fees Submitted Successfully !','alert-type'=>'success');
        }else{
            $msg_array = array('message'=>'Fees Submit Failure!','alert-type'=>'error');
        }
        return redirect()->route('duplicate.tc.payment')->with($msg_array);
    }

    public function duplicate_tc_payment_report()
    {
        $duplicatetc_fees = DuplicateTcFees::all();
        
        return view('tc.duplicate_tc_payment_report',compact('duplicatetc_fees'));
    }
    
    public function duplicate_tc_payment_print($id)
    {
       $duplicatetc_fee=DuplicateTcFees::where('dtcfees_id',$id)->first();
       
        $ins_det = instituteDetails();
        return view('tc.duplicate_tc_payment_print',compact('ins_det','duplicatetc_fee'));
    }
    
    public function tc_issued()
    {
        return view('tc.tc_issued');
    }
    
   public function tc_issued_ajax(Request $request)
   {
        $col_order = ['adno','name','address','mobile','course_name','semester_name'];
        $total_data = Student::whereNull('deleted_at')->count();
        $limit = $request->input('length');
        $start = $request->input('start');
        $order = $col_order[$request->input('order.0.column')];
        $dir = $request->input('order.0.dir');
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first();
        $current_academic_year_id = $cur_acyear->ac_id;

        
        
        $query=Student::join('promotes','students.student_id','=','promotes.student_id')->
                    join('courses','promotes.course_id','=','courses.course_id')->
                    join('semesters','promotes.semester_id','=','semesters.semester_id')->where('promotes.ac_id',$current_academic_year_id)->
                    where('students.tcstatus','1');

                    if(!empty($request->input('search.value'))){
                    $search = $request->input('search.value');
                    $query->where(function ($qry) use ($search){
                    $qry->where('adno','like','%'.$search.'%')->
                    orWhere('name','like','%'.$search.'%')->
                    orWhere('paddress','like','%'.$search.'%')->
                    orWhere('mobile','like','%'.$search.'%')->
                    orWhere('course_name','like','%'.$search.'%')->
                    orWhere('semester_name','like','%'.$search.'%');
                        });
                    }
        $total_filtered = $query->count();
        $students  =   $query->select('students.*','courses.course_name','semesters.semester_name')->
                    offset($start)->limit($limit)->orderBy($order,$dir)->get();
        
        $view=$edit=$delete=$tc=0;
        if(MenuAccess::have_access(56) == true){ $view=1; }
        if(MenuAccess::have_access(24) == true){ $delete=1; }

        $data = array();
        if($students){
            foreach($students as $student){
                $row['adno'] = $student->adno;
                $row['name'] = wordwrap(strtoupper($student->name), 20, "<br />\n");
                $row['address'] = wordwrap(strtoupper($student->paddress), 20, "<br />\n");
                $row['mobile'] = $student->mobile;
                $row['course'] = wordwrap($student->course_name, 20, "<br />\n");
                $row['semester'] = $student->semester_name;
                $tcst=$tccl='';
                if($student->tcstatus==1){ $tccl='badge-warning'; $tcst='Issued'; }
                $row['tcstatus'] = '<div class="badge '.$tccl.' p-1">'.$tcst.'</div>';
                $html="";
               
                if($view==1){
                    $html .= '<a href="'.route('student.view',encrypt($student->student_id)).'" title="View"><i class="icon-sm icon-magnifier text-primary"></i></a>&nbsp;&nbsp;&nbsp;';
                }
                if($edit==1){
                    $html .= '<a href="'.route('student.edit',encrypt($student->student_id)).'" title="Edit"><i class="icon-sm icon-pencil text-success"></i></a>&nbsp;&nbsp;&nbsp;';
                }
                if($delete==1){
                    $html .= '<a href="'.route('student.delete',encrypt($student->student_id)).'" title="Delete" onClick="return confirm(\'Are you sure you want to delete?\');"><i class="icon-sm icon-trash text-danger"></i></a>';
                }
                $row['action'] = $html;
                $st='';
                if($student->status==1){ $st='text-success'; }else if($student->status==0){ $st='text-warning'; }
                $row['status'] = '<i class="icon icon-check text-sm '.$st.'"></i>';
                
                $data[] = $row;
            }
        }
        
        $json = array(
            'draw' => intval($request->input('draw')),
            'recordsTotal' => intval($total_data),
            'recordsFiltered' => intval($total_filtered),
            'data' => $data
        );
            
        echo json_encode($json);
   }
    
  public function tc_generate()
  {
      return view('tc.tc_generate');
  }
    
 public function tc_generate_ajax(Request $request)
 {
      
        $col_order = ['adno','name','address','mobile','course_name','semester_name'];
        $total_data = Student::whereNull('deleted_at')->count();
        $limit = $request->input('length');
        $start = $request->input('start');
        $order = $col_order[$request->input('order.0.column')];
        $dir = $request->input('order.0.dir');
        $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first();
        $current_academic_year_id = $cur_acyear->ac_id;

        
        // $query  =   Student::join('courses','students.course_id','=','courses.course_id')->
        //             leftJoin('semesters','students.semester_id','=','semesters.semester_id');
        $query=Student::join('promotes','students.student_id','=','promotes.student_id')->
                    join('courses','promotes.course_id','=','courses.course_id')->
                    join('semesters','promotes.semester_id','=','semesters.semester_id') ->where('promotes.ac_id',$current_academic_year_id)->
                    where('students.tcstatus','0');

                    if(!empty($request->input('search.value'))){
                    $search = $request->input('search.value');
                    $query->where(function ($qry) use ($search){
                    $qry->where('adno','like','%'.$search.'%')->
                    orWhere('name','like','%'.$search.'%')->
                    orWhere('paddress','like','%'.$search.'%')->
                    orWhere('mobile','like','%'.$search.'%')->
                    orWhere('course_name','like','%'.$search.'%')->
                    orWhere('semester_name','like','%'.$search.'%');
                        });
                    }
        $total_filtered = $query->count();
        $students  =   $query->select('students.*','courses.course_name','semesters.semester_name')->
                    offset($start)->limit($limit)->orderBy($order,$dir)->get();
        
        $view=$delete=$tc=0;
        if(MenuAccess::have_access(56) == true){ $view=1; }
        if(MenuAccess::have_access(24) == true){ $delete=1; }
        if(MenuAccess::have_access(58) == true){ $tc=1; }
        
        $data = array();
        if($students){
            foreach($students as $student){
                $row['adno'] = $student->adno;
                $row['name'] = wordwrap($student->name, 20, "<br />\n");
                $row['address'] = wordwrap($student->paddress, 20, "<br />\n");
                $row['mobile'] = $student->mobile;
                $row['course'] = wordwrap($student->course_name, 20, "<br />\n");
                $row['semester'] = $student->semester_name;
                $tcst=$tccl='';
                if($student->tcstatus==0){ $tccl='badge-warning'; $tcst='Not Issued'; }
                $row['tcstatus'] = '<div class="badge '.$tccl.' p-1">'.$tcst.'</div>';
                $html="";
                if($student->tcstatus==0 && $tc==1){
                    $html .= '<a href="'.route('tc.generate',encrypt($student->student_id)).'" title="Generate TC"><i class="icon-sm icon-share-alt text-info"></i></a>&nbsp;&nbsp;&nbsp;';
                }
                if($view==1){
                    $html .= '<a href="'.route('student.view',encrypt($student->student_id)).'" title="View"><i class="icon-sm icon-magnifier text-primary"></i></a>&nbsp;&nbsp;&nbsp;';
                }
                if($delete==1){
                    $html .= '<a href="'.route('student.delete',encrypt($student->student_id)).'" title="Delete" onClick="return confirm(\'Are you sure you want to delete?\');"><i class="icon-sm icon-trash text-danger"></i></a>';
                }
                $row['action'] = $html;
                $st='';
                if($student->status==1){ $st='text-success'; }else if($student->status==0){ $st='text-warning'; }
                $row['status'] = '<i class="icon icon-check text-sm '.$st.'"></i>';
                
                $data[] = $row;
            }
        }
        
        $json = array(
            'draw' => intval($request->input('draw')),
            'recordsTotal' => intval($total_data),
            'recordsFiltered' => intval($total_filtered),
            'data' => $data
        );
            
        echo json_encode($json);
 }
 public function tclist()
 {
 
     $userId = Auth::id();
       $cur_acyear = Acyear::where('default1',1)->whereNull('deleted_at')->first();
    $current_academic_year_id = $cur_acyear->ac_id;
     $studentList=TcRequestStudent::join('promotes','promotes.student_id','=','tc_request_student.request_from')
     ->join('students','tc_request_student.request_from','=','students.student_id')
     ->join('courses','courses.course_id','=','promotes.course_id')
     ->join('semesters','semesters.semester_id','=','promotes.semester_id')
     ->where('promotes.ac_id',$cur_acyear->ac_id)->where('user_id',$userId)->
     select('courses.course_name','semesters.semester_name','tc_request_student.*','students.student_id','students.tcstatus')->
     where('students.tcstatus','0')->
     where('tc_request_student.status','0')->
     get();
   

     return view('tc.tclist',compact('studentList','userId'));
 }
 public function requesttccancel($id)
 {
      $request = TcRequestStudent::find($id); 

    if ($request) {
        $request->status = 2; 
        $request->save();

        return redirect()->route('tc.list')->with('success', 'Request canceled successfully.');
    }

    return redirect()->back()->with('error', 'Request not found.');
 }
 
 
    
}
