<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\StaffSubject;
use App\Models\AddTutorial;
use App\Models\Course;
use App\Models\HOD;
use App\Models\ClassTeacher;
use App\Models\User;
use App\Models\Subject;
use App\Models\Semester;
use App\Models\Promote;
use App\Models\Group;
use App\Models\TutorialStud;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;



class Tutorial extends Controller
{
    public function tutorial_add()
    {
         $ac_id = getAcyear();
       $user = Auth::user(); 
       $userId = $user->user_id; 
       if($user->type_id == '17')
       {
           $deptCoursesQuery = Course::where('department_id',$user->dept_id)->select('course_id','course_name');
           $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
       
       }
       else
       {
           $hod_cnt = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->count();
           
           if($hod_cnt > 0)
           {
               $hod_dept = HOD::where('user_id',$userId)->where('ac_id',$ac_id)->first();
               
               $deptCoursesQuery = Course::where('department_id',$hod_dept->id)->select('course_id','course_name');
               $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();
           
           }
           else
           {
              if($user->type_id == '1' || $user->type_id == '2' || $user->type_id == '13' || $user->type_id == '14')
               {
                    $staffsubject = Course::all();
               }
               else
               { 
                   $deptCoursesQuery = Course::where('department_id', $user->dept_id)->select('course_id', 'course_name');

                   $staffsubject = StaffSubject::join('courses', 'courses.course_id', '=', 'staff_subject.course_id')->where('staff_subject.user_id', $userId)->where('staff_subject.acyear_id', $ac_id)->select('courses.course_id', 'courses.course_name')->distinct()->union($deptCoursesQuery) ->get();

               }
           }
       }
        
        return view('tutorial.tutorial_add',compact('staffsubject'));
    }

    public function tutorial_save(Request $request)
    {
        $validated = $request->validate([
            'course_id'=>'required',
            'semester_id'=>'required',
            'subject_id'=>'required',
             'batch_id'=>'nullable',
            'title'=>'required',
            'content'=>'required',
            'file' => 'required|mimes:pdf,doc,docx,jpg,jpeg,png|max:5120',
        ]);
            
        $filename="";
        if($request->hasFile('file')){
            $file = $request->file;
            $ext = $file->extension();
            $filename = 'attachment_'.time().'.'.$ext;
            $file->storeAs('staff/tutorial',$filename);
        }
         else {
        $filename = null;
    }
        
         $ac_id = getAcyear();
       $subject = Subject::find($validated['subject_id']); 
       
       
    $subcategory = Subject::where('subject_id',$validated['subject_id'])->first();
    $sub_cat_id = $subcategory->subject_categ;
    // Fetch students who need the task
    $students = array();
       $i=0; 
         $subject = Subject::find($validated['subject_id']);
        $semester = Semester::find($validated['semester_id']);
                $semesterIds = Semester::where('semester_name', $semester->semester_name)->pluck('semester_id')->toArray();
       $query = Promote::join('students', 'promotes.student_id', '=', 'students.student_id')
                    ->join('courses', 'promotes.course_id', '=', 'courses.course_id');
                if(in_array($subject->subject_categ, [2,3,4,5,6])) {
                    $query->join('fyugp_stud_sub', 'promotes.student_id', '=', 'fyugp_stud_sub.stud_id');
                if ($validated['batch_id'] != null && $validated['batch_id'] != '') {
                    $courses = DB::table('group_courses')->where('group_id',$validated['batch_id'])->pluck('course_id')->toArray();
                    $query->whereIn('promotes.course_id', $courses);
                }
                $query->where('fyugp_stud_sub.acyear_id', $ac_id)
                      ->where('fyugp_stud_sub.sub_id', $validated['subject_id'])
                      ->whereIn('promotes.semester_id', $semesterIds)
                      ->whereIn('fyugp_stud_sub.sem', $semesterIds);
                } else {
                    $query->where('promotes.course_id', $validated['course_id'])
                        ->where('promotes.semester_id', $validated['semester_id']);
                }
                $students = $query->where('promotes.ac_id', $ac_id)
                    ->select('students.student_id','students.adno','students.name','students.rollno','courses.course_name','promotes.course_id','promotes.semester_id')
                    ->groupBy('promotes.student_id')
                    ->orderBy('students.rollno', 'ASC')
                    ->get();     
       
        
        $tutorial = AddTutorial::create([
            'course_id' => $validated['course_id'],
            'semester_id' => $validated['semester_id'],
            'subject_id' => $validated['subject_id'],
            'batch_id' => $validated['batch_id'],
            'user_id' => Auth::id(),
            'title' => $validated['title'],
            'content' => $validated['content'],
            'file' => $filename,
            'ac_id'=>$ac_id,
        ]);
            
        if($tutorial){
            
                // Assign task to each student
            foreach ($students as $stud) {
                $tutorialstudexists = TutorialStud::where([
                    'tutorial_id' => $tutorial->tutorial_id,
                    'stud_id' => $stud->student_id,
                ])->first();

                if (!$tutorialstudexists) {
                    TutorialStud::create([
                        'tutorial_id' => $tutorial->tutorial_id,
                        'stud_id' => $stud->student_id,
                        
                    ]);
                    $i++;
                }
            }
            
        }
          if ($i > 0) {
        $msg_array = ['message' => 'Tutorial added successfully!', 'alert-type' => 'success'];
    } else {
       $msg_array = ['message' => 'The tutorial could not be added.', 'alert-type' => 'error'];
    }
        return redirect()->route('tutorial')->with($msg_array);
    }
        
    public function tutorial_view()
    {
        $userId = Auth::id();
        $tutorials = AddTutorial::where('user_id',$userId)->get();
            
        return view('tutorial.tutorial_view',compact('tutorials','userId'));
    }
    
    public function tutorial_delete($id)
    {
        $tutorial = AddTutorial::find($id);
        if($tutorial->delete()){
            $msg_array = ['message' => 'Tutorial Deleted Successfully.', 'alert-type' => 'success'];
        }else{
            $msg_array = ['message' => 'Tutorial could not be Deleted.', 'alert-type' => 'error'];
        }
            
        return redirect()->route('tutorial.view')->with($msg_array);
    }
        
}