<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Econtent extends Model
{
    use HasFactory, SoftDeletes;
    
    protected $table = 'econtent';
    
    protected $primaryKey = 'econtent_id'; 
    
    protected $guarded = [];
    
    protected $hidden = ['econtent_id'];
  
    public function staff()
    {
        return $this->hasOne(User::class,'user_id','user_id');
    }
    public function subject()
    {
        return $this->hasOne(Subject::class,'subject_id','subject_id');
    }
     public function batch(){
        return $this->belongsTo(Group::class,'batch_id','id')->withDefault(['name' => '']);
    }
}
