<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
class FyugpStudSub extends Model
{
   use HasFactory, SoftDeletes;
    protected $table = 'fyugp_stud_sub';
    
    protected $primaryKey = 'id'; 
    
    protected $guarded = [];
    
    protected $hidden = ['id'];
     public function coursen(){
        return $this->belongsTo(Course::class,'course','course_id');
    }
    
    public function semestern(){
        return $this->belongsTo(Semester::class,'sem','semester_id');
    }
   public function studn(){
        return $this->belongsTo(Student::class,'stud_id','student_id');
    }
    public function subn(){
        return $this->belongsTo(Subject::class,'sub_id','subject_id');
    }
    public function coursesubjects()
    {
        return $this->hasMany(CourseSubject::class, 'subject_id', 'sub_id');
    }
    public function student()
    {
        return $this->belongsTo(Student::class, 'stud_id', 'student_id');
    }
}
