<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
class FyugpTimetable extends Model
{
    use HasFactory,SoftDeletes;
    
    protected $table = 'fyugp_timetable';
      protected $primaryKey = 'id'; 
      protected $guarded = [];
      
      public function periodnames(){
        return $this->hasOne(Periods::class,'id','period_id');
    }
    public function subjectcateg(){
        return $this->hasOne(SubCategory::class,'id','categ_id');
    }
    
    public function coursedet(){
        return $this->belongsTo(Course::class,'course','course_id')->withDefault(['name' => '']);
    }
    
    public function semesterdet(){
        return $this->belongsTo(Semester::class,'semester','semester_id')->withDefault(['name' => '']);
    }
    
    public function category(){
        return $this->belongsTo(SubCategory::class,'categ_id','id')->withDefault(['name' => '']);
    }
    
    public function group(){
        return $this->belongsTo(Group::class,'group_id','id')->withDefault(['name' => '']);
    }
    
    public function user(){
        return $this->belongsTo(User::class,'user_id','user_id')->withDefault(['name' => '']);
    }
    
     public function subject(){
        return $this->belongsTo(Subject::class,'subject_id','subject_id')->withDefault(['name' => '']);
    }
}
