<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Facades\Auth;

use App\Models\StaffSubject;
class Semester extends Model
{
    use HasFactory, SoftDeletes;
    
    protected $table = 'semesters';
    
    protected $primaryKey = 'semester_id'; 
    
    protected $guarded = [];
    
    protected $hidden = ['semester_id'];
    
    public function course(){
        return $this->hasOne(Course::class,'course_id','course_id');
    }
    
    public static function semesterName($sid){
        $sem="";
        $row = self::find($sid);
        if($row){
            $sem = $row->semester_name;
        }
        
        return $sem;
    }
    public static function getStaffSemesters($courseId) {
        $user = Auth::user();
        $acyearId = getAcyear();
        $query = self::where('course_id', $courseId);
        
        if(in_array($user->type_id, [12,20,21,36])) {
            $sems = StaffSubject::where('user_id', $user->user_id)->where('acyear_id', $acyearId)->where('course_id', $courseId)->pluck('semester_id')->toArray();
            $query->whereIn('semester_id', $sems);
        }
        
        $semesters = $query->distinct('semester_id')->get();
        
        return $semesters;
    }
}
