<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class StaffSubject extends Model
{
    use HasFactory, SoftDeletes;
    
    protected $table = 'staff_subject';
    
    protected $primaryKey = 'stfsub_id'; 
    
    protected $guarded = [];
   
    public function course()
    {
        return $this->belongsTo(Course::class,'course_id','course_id')->withDefault(['name' => '']);
    }
    
    public function semester()
    {
        return $this->belongsTo(Semester::class,'semester_id','semester_id')->withDefault(['name' => '']);
    }
    
    public function user()
    {
        return $this->belongsTo(User::class,'user_id','user_id')->withDefault(['name' => '']);
    }
    
    // public function category()
    // {
    //     return $this->belongsTo(SubCategory::class,'category_id','id')->withDefault(['name' => '']);
    // }
    public function category()
{
    return $this->belongsTo(SubCategory::class, 'category_id', 'id')->withDefault(); 
}
    
    public function subject()
    {
        return $this->belongsTo(Subject::class,'subject_id','subject_id')->withDefault(['name' => '']);
    }
}
