<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
class Timetable extends Model
{
    use HasFactory,SoftDeletes;
    
    protected $table = 'timetable';
    
    protected $guarded = [];
   
    public function subject(){
        return $this->belongsTo(Subject::class,'subject_id','subject_id')->withDefault(['name' => '']);
    }
    
    public function unames(){
        return $this->belongsTo(User::class,'user_id','user_id')->withDefault(['name' => '']);
    }
    
    public function periodnames(){
        return $this->belongsTo(Periods::class,'period_id','id')->withDefault(['name' => '']);
    }
    
    public function cnames(){
        return $this->belongsTo(Course::class,'course','course_id')->withDefault(['name' => '']);
    }
    
    public function semnames(){
        return $this->belongsTo(Semester::class,'semester','semester_id')->withDefault(['name' => '']);
    }
    
}
