<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class TimetableInterchange extends Model
{
    use HasFactory,SoftDeletes;
    
    protected $table = 'timetable_inter';
    
    protected $primaryKey = 'id'; 
    
    protected $guarded = [];
   
    public function period(){
        return $this->belongsTo(Periods::class,'period_id','id')->withDefault(['name' => '']);
    }
    
    public function course(){
        return $this->belongsTo(Course::class,'course_id','course_id')->withDefault(['name' => '']);
    }
    
    public function semester(){
        return $this->belongsTo(Semester::class,'semester_id','semester_id')->withDefault(['name' => '']);
    }
    
    public function subject(){
        return $this->belongsTo(Subject::class,'subject_id','subject_id')->withDefault(['name' => '']);
    }
    
    public function user(){
        return $this->belongsTo(User::class,'user_id','user_id')->withDefault(['name' => '']);
    }
}