$(document).ready(function () {
    
    var baseUrl = window.location.origin;
    
    function loadAssignmentDetails() {
        $.ajax({
            url: baseUrl+'/student/assignment-counts',
            type: 'GET',
            success: function (data) {
                let assignmentHtml = '';
                data.forEach(function (item) {
                    assignmentHtml += `
                       <div class="alert alert-${item.color} mb-2">
                        <h5 class="alert-heading">
                            New Assignment
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </h5>
                        <hr>
                        <p>${item.name} - ${item.days}</p>
                    </div>`;
                });
                    
                $('#assignmentDetails').html(assignmentHtml);
            },
            error: function (xhr, status, error) {
                console.error("Error loading assignment details:", error);
            }
        });
    }
        
    loadAssignmentDetails();
        
    setInterval(loadAssignmentDetails, 300000);
        
    function loadSpecialclassDetails() {
    $.ajax({
        url: baseUrl + '/student/specialclass-counts',
        type: 'GET',
        success: function (data) {
            let specialclassHtml = '';
            data.forEach(function (item) {
                // Skip past classes
                if (item.color === 'danger') {
                    return;  // Do not render past classes
                }

                specialclassHtml += `
                    <div class="alert alert-${item.color} mb-2">
                        <h5 class="alert-heading">
                            Special Class
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </h5>
                        <hr>
                        <p><strong>${item.name}</strong></p>
                        <p><strong>Scheduled Time:</strong> ${item.datetime_and_duration}</p>
                        <p><strong>Status:</strong> ${item.status}</p>
                    </div>
                `;
            });

            $('#specialClassDetails').html(specialclassHtml);
        },
        error: function (xhr, status, error) {
            console.error("Error loading special class details:", error);
        }
    });
}

loadSpecialclassDetails();
setInterval(loadSpecialclassDetails, 300000);  // Refresh every 5 minutes
    
    
    function loadmainstreamassigDetails() {
        $.ajax({
            url: baseUrl+'/student/mainstreamassig-counts',
            type: 'GET',
            success: function (data) {
                let mainstreamassigHtml  = '';
                data.forEach(function (item) {
                    mainstreamassigHtml  += `
                       <div class="alert alert-${item.color} mb-2">
                        <h5 class="alert-heading">
                            New Assignment
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </h5>
                        <hr>
                        <p>${item.name} - ${item.days}</p>
                    </div>`;
                });
                    
                $('#mainstreamAssigDetails').html(mainstreamassigHtml );
            },
            error: function (xhr, status, error) {
                console.error("Error loading assignment details:", error);
            }
        });
    }

    loadmainstreamassigDetails();
        
    setInterval(loadmainstreamassigDetails, 300000); 
    
    
    function loadrolloutwarning() {
    $.ajax({
        url: baseUrl + '/student/rollout-warning', 
        type: 'GET',
        success: function (data) {
            let rolloutHtml = '';
            
            data.forEach(function (item) {
                rolloutHtml += `
                    <div class="alert alert-${item.color} mb-2">
                        <h5 class="alert-heading">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </h5>
                        <hr>
                        <p>${item.name} - ${item.days}</p>
                    </div>`;
            });

           
            $('#rolloutwarning').html(rolloutHtml);
        },
    });
}

loadrolloutwarning();
setInterval(loadrolloutwarning, 300000); 

    



 
    

// loadnotification();

// setInterval(loadnotification, 300000);

    function loadnotification() {
    $.ajax({
        url: baseUrl + '/student/notification',
        type: 'GET',
        success: function (data) {
            let notificationHtml = '';
            
            if (data.length > 0) {
                data.forEach(function (item) {
                    if (item.days <= 5) {
                        notificationHtml += `
                            <div class="alert alert-${item.color} mb-2">
                                <h5 class="alert-heading">
                                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </h5>
                                <p><strong>Notification:</strong> ${item.notification}</p>
                                <p><small><strong>${item.sender_info}</strong> - ${item.days} days ago</small></p>
                            </div>`;
                    }
                });
            } else {
                notificationHtml = '<p></p>';
            }

            $('#notification').html(notificationHtml);
        },
        error: function (xhr, status, error) {
            console.log('Error fetching notifications:', error);
        }
    });
}

loadnotification();
setInterval(loadnotification, 300000); 

    
        function loadnotification2() {
    $.ajax({
        url: baseUrl + '/student/notification2',
        type: 'GET',
        success: function (data) {
            let notification2Html = '';
            
            if (data.length > 0) {
                data.forEach(function (item) {
                    if (item.days <= 5) {
                        notification2Html += `
                            <div class="alert alert-${item.color} mb-2">
                                <h5 class="alert-heading">
                                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </h5>
                                <p><strong>Notification:</strong> ${item.notification}</p>
                                <p><small><strong>${item.sender_info}</strong> - ${item.days} days ago</small></p>
                            </div>`;
                    }
                });
            } else {
                notification2Html = '<p></p>';
            }

            $('#notification2').html(notification2Html);
        },
        error: function (xhr, status, error) {
            console.log('Error fetching notifications:', error);
        }
    });
}
loadnotification2();
setInterval(loadnotification2, 300000); 

    
    
    
    
    
    
    $.ajax({
        url: baseUrl+'/student/task-counts',
        type: 'GET',
        success: function(response) {
            $('#taskcount').text(response);
        },
        error: function() {
            $('#taskcount').text('Error loading task count.');
        }
    });
    
});

var baseUrl1 = window.location.origin;

function loadAttendance(){
    var semester = $('#semester').val();
    var spinner = '<div class="spinner-grow sp sp-1 text-dark" role="status"><span class="sr-only">Loading...</span></div><div class="spinner-grow sp sp-2 text-dark" role="status"><span class="sr-only">Loading...</span></div><div class="spinner-grow sp sp-3 text-dark" role="status"><span class="sr-only">Loading...</span></div>';
    $("#attendance").html(spinner);
    
    $.ajax({
        type: 'GET',
        url: baseUrl1+'/student/home/attendance',
        data: { semester: semester },
        success: function(response) {
            $("#attendance").html(response);
        }
    });
}

loadAttendance();