@extends('layouts.settings-template')
@section('title','Programme')
@section('heading','Programme')
@section('breadcrumb','Settings / Programme')
@section('content')
    <div class="row">
        <div class="col-12">
            <div class="form-group">
                <a href="{{ url()->previous() }}" class="btn btn-sm btn-danger">Cancel</a>
            </div>
        </div>
    </div>
    <div class="card card-primary">
        <div class="card-header">New Programme</div>
        <div class="card-body">
            <form action="{{ route('course.save') }}" method="post">
                @csrf
                <div class="row">
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="department_id" class="required">Department</label>
                            <select class="js-example-basic-single" id="department_id" name="department_id" style="width:100%">
                                <option value="">Select</option>
                                @foreach($departments as $dept)
                                    <option value="{{ $dept->id }}" {{ old('department_id') == $dept->id ? "selected":"" }}>{{ $dept->dept_name }}</option>
                                @endforeach
                            </select>
                            @error('department_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="course_name" class="required">Programme Name</label>
                            <input type="text" class="form-control @error('course_name') border-danger @enderror" id="course_name" name="course_name" value="{{ old('course_name') }}">
                            @error('course_name')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="course_code" class="required">Programme Code</label>
                            <input type="text" class="form-control @error('course_code') border-danger @enderror" id="course_code" name="course_code" value="{{ old('course_code') }}">
                            @error('course_code')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="group_id">Group</label>
                            <select class="js-example-basic-single" id="group_id" name="group_id" style="width:100%">
                                <option value="">Select</option>
                                @foreach($groups as $group)
                                    <option value="{{ $group->id }}" {{ old('group_id') == $group->id ? "selected":"" }}>{{ $group->name }}</option>
                                @endforeach
                            </select>
                            @error('group_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                     <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="category_id">Category</label>
                            <select class="js-example-basic-single" id="category_id" name="category_id" style="width:100%">
                                <option value="">Select</option>
                               <option value="UG">UG</option>
                                <option value="PG">PG</option>
                            </select>
                            @error('category_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <div class="form-group">
                            <button type="submit" class="btn btn-sm btn-success float-right">Submit</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
@endsection