@extends('layouts.template')
@section('title','Home')
@section('heading','Enquiry')
@section('breadcrumb','Home/Enquiry/Followup')
@section('content')

<div class="card" style="border-top:3px solid #004170">
    <div class="card-body">
<form action="{{ route('followup.save') }}" method="post" enctype="multipart/form-data">
    @csrf
    <input type="hidden" class="form-control text" id="enq_id" name="enq_id" value="{{ $enquiry->id }}" required>
     <div class="row">
    <div class="col-md-12">
    <div class="form-group">
        <p style="background:#005A9C;color:white;"><b>Enquiry Details</b></p>
        <hr>
    <table id="table-fine" width="100%" cellpadding="10px">
   
    <tr>
      <td width="15%"><b>Enquiry No</b></td>
       <td width="2%"><b>:</b></td>
      <td width="23%"><b>{{ $enquiry->enq_no }}</b></td>
        <td width="15%"><b>Gender</b></td>
       <td width="2%"><b>:</b></td>
      <td width="23%"><b>{{ strtoupper($enquiry->gender) }}</b></td>
     </tr>
     
      <tr>
      <td width="15%"><b>Visitor Name</b></td>
       <td width="2%"><b>:</b></td>
      <td width="23%"><b>{{ strtoupper($enquiry->visitor_name) }}</b></td>
      <td width="15%"><b>Address</b></td>
       <td width="2%"><b>:</b></td>
      <td width="43%"><b>{{ strtoupper($enquiry->address) }}</b></td>
     
     </tr>
     
     <tr>
      <td width="15%"><b>Mobile</b></td>
       <td width="2%"><b>:</b></td>
      <td width="23%"><b>{{ $enquiry->mobile }}</b></td>
      <td width="15%"><b>Landline</b></td>
       <td width="2%"><b>:</b></td>
      <td width="43%"><b>{{ $enquiry->landline }}</b></td>
     
     </tr>
     
      <tr>
      <td width="15%"><b>Email</b></td>
       <td width="2%"><b>:</b></td>
      <td width="23%"><b>{{ $enquiry->email }}</b></td>
      <td width="15%"><b>Handled_by</b></td>
       <td width="2%"><b>:</b></td>
      <td width="43%"><b>{{ strtoupper($enquiry->staname->name.' '.$enquiry->staname->lname) }}</b></td>
     
     </tr>
     
      <tr>
      <td width="15%"><b>Meeting status</b></td>
       <td width="2%"><b>:</b></td>
      <td width="23%"><b>{{ $enquiry->meeting_status }}</b></td>
      <td width="15%"><b>Program</b></td>
       <td width="2%"><b>:</b></td>
      <td width="43%"><b>{{ strtoupper($enquiry->cname->course_name) }}</b></td>
     
     </tr>
     
      <tr>
      <td width="15%"><b>Remark</b></td>
       <td width="2%"><b>:</b></td>
      <td width="23%"><b>{{ strtoupper($enquiry->remarks) }}</b></td>
      <td width="15%"><b>Qualification</b></td>
       <td width="2%"><b>:</b></td>
      <td width="43%"><b>{{ strtoupper($enquiry->qualification) }}</b></td>
     
     </tr>
     
     <tr>
      <td width="15%"><b>Enquiry Status</b></td>
       <td width="2%"><b>:</b></td>
      <td width="23%"><b>{{ $enquiry->getenqstatus() }}</b></td>
      <td width="15%"><b>Date</b></td>
       <td width="2%"><b>:</b></td>
      <td width="43%"><b>{{ date('d-m-Y',strtotime($enquiry->en_date)) }}</b></td>
     
     </tr>
   
    </table>
    </div>
    </div>
    </div>
    <br>
    <hr>
     <div class="row">
    <div class="col-md-12">
    <div class="form-group">
        <p style="background:#005A9C;color:white;"><b>Enquiry Followups</b></p>
        <hr>
         <table id="table-fine" class="table table-bordered" cellpadding="7px">
            <tr>
                <th>#</th>
                <th>Date</th>
                <th>Time</th>
                <th>Status</th>
             </tr>
             @php $i=0; @endphp
            @foreach($enquiryfollowup as $enqflwp)
            @php $i++; @endphp
             <tr>
                 <td>{{$i}}</td>
                 <td>{{date('d-m-Y',strtotime($enqflwp->date))}}</td>
                 <td>{{date('h:i A', strtotime($enqflwp->time))}}</td>
                 <td>{{$enqflwp->status}}</td>
             </tr>
              @endforeach
        </table>
        <br>
        <div class="row">
    
         <div class="col-md-3">
                                <div class="form-group">
                                    <label for="date"><b>Date</b></label>
                                   <input type="date" class="form-control text" id="date" name="date" value="{{ $cur_date }}" required>
                                </div>
                            </div>
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="time"><b>Time</b></label>
                                     <input type="time" class="form-control text" id="time" name="time"  value="{{$currentTime}}" required>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="status"><b>Remark</b></label>
                                     <textarea class="form-control text" id="status" name="status"  rows="2"></textarea>
                                </div>
                            </div>
                            
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <div class="form-group">
                                    <button type="submit" class="btn btn-primary float-right">Save</button>
                                </div>
                            </div>
                        </div>
        
        
        
    </div>
    </div>
    </div>
 </form>
 
 </div>
 </div>
   
@endsection