@extends('layouts.template')
@section('title','Home')
@section('heading','Student  fee-structure')
@section('breadcrumb','Home/Fees/Student  fee-structure')
@section('content')

            <div class="row">
            <div class="col-lg-12 grid-margin stretch-card">
            <div class="card">
            <div class="card-header" style="background-color:#005A9C;color:white"><b>Select the Criteria</b></div>
            <div class="card-body">
            <div class="row">
            <div class="col-md-3">
            <div class="form-group">
            <label for="ac_id" class="required"><b>Academic Year</b></label>
                                        <select class="form-control" id="ac_id" name="ac_id" required>
                                        @foreach($acyears as $acyear)
                                        <option value="{{ $acyear->ac_id }}" {{ old('ac_id')==$acyear->ac_id ? "selected":"" }}>{{ $acyear->start_date_formatted.' - '.$acyear->end_date_formatted }}</option>
                                        @endforeach
                                        </select>
                                        @error('ac_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                       </div>
                                       </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="course_id" class="required"><b>Program</b></label>
                                    <select class="form-control" id="course" name="course_id" required>
                                        <option value="">Select</option>
                                        @foreach($courses as $course)
                                            <option value="{{ $course->course_id }}" {{ old('course_id')==$course->course_id ? "selected":"" }}>{{ $course->course_name }}</option>
                                        @endforeach
                                    </select>
                                    @error('course_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="semester_id" class="required"><b>Semester</b></label>
                                    <select class="form-control" id="semester_id" name="semester_id" required>
                                        <option value="">Select</option>
                                    </select>
                                    @error('semester_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="student_id" class="required"><b>Student</b></label>
                                    <select class="form-control" id="stud_id" name="student_id" required>
                                        <option value="">Select</option>
                                    </select>
                                    @error('student_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                                <div class="col-md-3">
                                <div class="form-group">
                                <label for="category_id" class="required"><b>Fee Category</b></label>
                                <select class="form-control" id="cat_id" name="category_id" required>
                                        <option value="">Select</option>
                                        @foreach($categories as $category)
                                        <option value="{{ $category->category_id }}" {{ old('category_id')==$category->category_id ? "selected":"" }}>{{ $category->category_name }}</option>
                                        @endforeach
                                        </select>
                                        @error('category_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                           
                           <div class="col-md-3">
                                <div class="form-group">
                                    <label for="term_id" class="required"><b>Fee Term</b></label>
                                    <select class="form-control" id="term_id" name="term_id" required>
                                        <option value="">Select</option>
                                        @foreach($terms as $term)
                                            <option value="{{ $term->term_id }}" {{ old('term_id')==$term->term_id ? "selected":"" }}>{{ $term->term_name }}</option>
                                        @endforeach
                                    </select>
                                    @error('term_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                           
                           
                            </div>
                           
                        <div class="row">
                            <div class="col-md-12">
                                <div class="form-group">
                                    <button type="button" class="btn btn-primary float-right" id="btn-get">Get Details</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-lg-12 grid-margin stretch-card" id="result">
            
            </div>
        </div>
        
        
        
        
        
    <script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
     <script src="{{ asset('public/js/semester.js') }}"></script> 
    <script src="{{ asset('public/js/stud.js') }}"></script> 
    <!--<script src="{{ asset('public/js/studget.js') }}"></script> -->
<script>
    $(document).ready(function(){

    $("#btn-get").on('click', function() {
        var aid = $('#ac_id').val(); 
       var cid = $('#course').val();
       var sid = $('#semester_id').val();
       var stuid = $('#stud_id').val();
       var ctid=$('#cat_id').val();
       var tid=$('#term_id').val();
     
        $("#result").html('');
        $("#result").append('<div class="overlay"><div class="spinner-border"></div></div>');
        
        if (aid === '' ||cid === ''||sid === ''||stuid === ''||ctid ===''||tid==='') {
            alert('Please select all mandatory fields!');
        } else {
            $.ajax({
                type: 'GET',
                url: '../getstudentfeestructure',
                data: { aid: aid,cid:cid,sid:sid,stuid:stuid,ctid:ctid,tid:tid},
                success: function(response) {
                    $("#result").html('');
                    $("#result").append(response);
                }
            });
        }
    });
});
</script>
      <style>
                        .card-body{
            border-left:1px solid #DCDCDC;
            border-right:1px solid #DCDCDC;
            border-bottom:1px solid #DCDCDC;
        }

    </style>
@endsection