@extends('layouts.settings-template')
@section('title','Group')
@section('heading','Group')
@section('breadcrumb','Settings / Group / Edit')
@section('content')
    <div class="card card-primary">
        <div class="card-header">Edit Group</div>
        <div class="card-body">
            <form action="{{ route('group.update', encrypt($group->id)) }}" method="post">
                @csrf
                @method('PUT')
                <div class="row">
                    <div class="col-12 col-md-8">
                        <div class="form-group">
                            <label for="name" class="required">Group Name</label>
                            <div class="row">
                                <div class="col-12 col-md-6">
                                    <div class="form-group">
                                        <input type="text" class="form-control @error('name') border-danger @enderror" id="name" name="name" value="{{ old('name') ?? $group->name }}">
                                        @error('name')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                    </div>
                                </div> 
                                <div class="col-12 col-md-6">
                                    <div class="form-group">
                                        <button type="submit" class="btn btn-sm btn-success">Update</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
@endsection