@extends('layouts.settings-template')
@section('title','Group')
@section('heading','Group')
@section('breadcrumb','Settings / Group')
@section('content')
    <div class="card card-primary">
        <div class="card-header">New Group</div>
        <div class="card-body">
            <form action="{{ route('group.save') }}" method="POST">
                @csrf
                <div class="row">
                    <div class="col-12 col-sm-8">
                        <div class="form-group">
                            <label for="name" class="required">Group Name</label>
                            <div class="row">
                                <div class="col-12 col-sm-6">
                                    <div class="form-group">
                                        <input type="text" class="form-control @error('name') border-danger @enderror" id="name" name="name" value="{{ old('name') }}">
                                        @error('name')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                    </div>
                                </div>
                                <div class="col-12 col-sm-6">
                                    <div class="form-group">
                                        <button type="submit" class="btn btn-sm btn-success">Save</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
    <br>
    <div class="card">
        <div class="card-body">
            <table class="table table-bordered">
                <thead>
                <tr>
                    <th>#</th>
                    <th>Group Name</th>
                    <th>Actions</th>
                </tr>
                </thead>
                <tbody>
                    @forelse($groups as $group)
                        <tr>
                            <td align="center">{{ $loop->iteration }}</td>
                            <td>{{ $group->name }}</td>
                            <td align="center">{{ app_table_links($group->id, array(755, 756)) }}</td>
                        </tr>
                    @empty
                        <tr>
                            <td colspan="3" align="center">No Result Found !</td>
                        </tr>
                    @endforelse
                </tbody>
            </table>
        </div>
    </div>
@endsection