<div class="card" style="border-top:3px solid #004170">
    <div class="card-body">
        @if($assignmt && $assignmt->isNotEmpty())
        <input type="hidden" id="course" name="course" value="{{ $crs_id }}">
        <input type="hidden" id="sub" name="sub" value="{{$sub_id}}">
        <input type="hidden" id="sem" name="sem" value="{{$sem_id}}">
        <input type="hidden" id="ac_id" name="ac_id" value="{{$ac_id}}">

        <div class="row">
            <div class="col-md-12">
                <div class="form-group">
                    <br>
                    <table id="table-fine" class="table table-bordered">
                        <thead style="background-color:#8FBC8F">
                            <tr>
                                <th>Program</th>
                                <th>Semester</th>
                                <th>Course</th>
                                <th>Topic</th>
                                <th>Submission date</th>
                                <th colspan="2">Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($assignmt as $assignmts)
                            <input type="hidden" name="assig_id" value="{{$assignmts->assig_id}}">
                            <tr>
                                <td>{{ $assignmts->course->course_name }}</td>
                                <td>{{ $assignmts->sem->semester_name }}</td>
                                <td style="word-wrap: break-word; word-break: break-all; white-space: normal;">{{ $assignmts->subject->subject_name }}</td>
                                <td style="word-wrap: break-word; word-break: break-all; white-space: normal;">{{$assignmts->assignment_topic}}</td>
                                <td>{{date('d-m-Y',strtotime($assignmts->submit_date))}}</td>
                                <td>
        <a href="#" onclick="showEditForm({{$assignmts->assig_id}}, '{{$assignmts->assignment_topic}}', '{{$assignmts->submit_date}}')"><i class="icon-pencil"></i></a>
                                </td>
                                <td><a href="{{route('inter.assignment.delete',['id'=>$assignmts->assig_id])}}"><i class="icon-trash"></i></a></td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        @else
        <div class="row">
            <div class="col-12">
                <div class="alert alert-danger">Assignment not Found !</div>
            </div>
        </div>
    @endif
    </div>
</div>

<!-- Edit Modal -->
<div class="modal fade" id="editModal" tabindex="-1" aria-labelledby="editModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content bg-white">
            <div class="modal-header" style="background:#004170;color:white">
                <h5 class="modal-title" id="editModalLabel">Edit Assignment</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                <input type="hidden" name="assig_id" id="assig_id">
                <input type="hidden" id="course" name="course" value="{{ $crs_id }}">
                <input type="hidden" id="sub" name="sub" value="{{$sub_id}}">
                <input type="hidden" id="sem" name="sem" value="{{$sem_id}}">

                <div class="mb-3">
                    <label for="assignment_topic" class="form-label">Topic</label>
                    <input type="text" class="form-control" id="assignment_topic" name="assignment_topic" value="" required>
                </div>

                <div class="mb-3">
                    <label for="submit_date" class="form-label">Submission date</label>
                    <input type="date" class="form-control" id="submit_date" name="submit_date" required>
                </div>

                <button type="button" class="btn btn-primary" id="form-get">Save Changes</button>
            </div>
        </div>
    </div>
</div>


<script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>

<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"></script>
 <script src="{{ asset('public/js/getassigview.js') }}"></script>
<script>
  
function showEditForm(assignmtId, topic, submitDate) {
    $('#assig_id').val(assignmtId); 
    $('#assignment_topic').val(topic); 
    $('#submit_date').val(submitDate);
    $('#editModal').modal('show'); 
}

$('#editModal').modal({
    backdrop: 'static',
    keyboard: false  
});


function hideAbsentForm() {
    $('#editModal').hide();
}

</script>

<style>
    /* Your custom styles */
    .totalstudent {
        color: black; 
        font-size: 22px; 
        font-weight: bold;
        padding: 10px; 
        margin: 5px; 
        background-color: #eaf0f1; 
        border: 2px solid #3498db; 
        border-radius: 5px; 
        text-shadow: 1px 1px 2px rgba(0, 0, 0, 0.3); 
        font-family: 'Arial', sans-serif; 
        display: inline-block; 
    }

    input[type="checkbox"] {
        width: 2em;
        height: 2rem;
        display: inline-block; 
        margin: 0;
        accent-color: green;
    }
    .container {
        display: flex; /* Flexbox for better alignment */
        align-items: center; /* Center align vertically */
        justify-content: center; /* Center align horizontally */
    }
</style>
