<div class="card" style="border-top:3px solid #004170">
    <div class="card-body">
        @if($attendanceSummary && collect($attendanceSummary)->isNotEmpty())
        <form action="{{ route('stu.attendance.grade.save') }}" method="POST">
            @csrf
            <input type="hidden" id="course" name="course" value="{{ $course }}">
            <input type="hidden" id="sub" name="sub" value="{{ $sub }}">
            <input type="hidden" id="sem" name="sem" value="{{ $sem }}">
            <input type="hidden" id="ac_id" name="ac_id" value="{{ $ac_id }}">

            <div class="row">
                <div class="col-md-12">
                    <div class="form-group">
                        <br>
                        <table id="table-fine" class="table table-bordered">
                            <thead style="background-color:#8FBC8F">
                                <tr>
                                    <th><input type="checkbox" id="checkAll"> </th> 
                                    <th>#</th>
                                    <th>Student Name</th>
                                    <th>Adno</th>
                                    <th>Attendance Percentage</th>
                                    <th>Grade-Point</th>
                                    <th>Letter Grade</th>
                                </tr>
                            </thead>
                            <tbody>
                               @foreach($attendanceSummary as $summary)
                                <tr>
                                    <td><input type="checkbox" class="student-checkbox" name="attendance[{{ $summary['student_id'] }}]" value="1"></td> <!-- Student Checkbox -->
                                    <td>{{ $loop->iteration }}</td>
                                    <td>{{ strtoupper($summary['student_name']) }}</td>
                                    <td>{{ $summary['admission_number'] }}</td>
                                    <td>{{ $summary['attendance_percentage'] }}%</td>
                                    <td>
                                        <input type="text" name="gradepoint[{{ $summary['student_id'] }}]" value="{{ $summary['gradepoint'] }}" class="form-control">
                                    </td>
                                    <td>
                                        <input type="text" name="grade[{{ $summary['student_id'] }}]" value="{{ $summary['lettergrade'] }}" class="form-control">
                                    </td>
                                </tr>
                               @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>

            <input type="submit" name="submit" value="Save" class="btn btn-primary">
        </form>
    @else
        <div class="row">
            <div class="col-12">
                <div class="alert alert-danger">Attendance not Found !</div>
            </div>
        </div>
    @endif
    </div>
</div>

<script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>

<script>
    $('#checkAll').change(function() {
        var isChecked = $(this).prop('checked');
        
        $('.student-checkbox').prop('checked', isChecked);
    });
</script>

<style>
    input[type="checkbox"] {
        width: 2.5em;   
        height: 2.5em;  
        display: inline-block; 
        margin: 0;
        accent-color: green;
    }
    
    #checkAll {
        width: 2.5em;   /* Adjust width */
        height: 2.5em;  /* Adjust height */
    }
</style>
