<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>OPAC</title>
    <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
    <style>
        body{
            padding: 20px;
            background-color: #e8e8e8;
        }
        .card{
            margin-bottom: 5px;
        }
        .pagination .page-link {
            font-size: 14px; /* Adjust font size */
            padding: 0.5rem 0.75rem; /* Adjust padding */
        }
        
        .pagination .page-item {
            margin: 0 2px; /* Adjust spacing */
        }
        .title{
            font-size: 18px;
            font-weight: 600;
        }
        
        @media only screen  and (max-width : 480px) {
            body{
                padding: 10px;
            }
            
            .title{
                font-size: 16px;
            }
        }
        
    </style>
</head>
<body>
    <div class="card">
        <div class="card-body">
            <div class="row">
                <div class="col-12 text-center">
                    <img src="{{ asset('public/uploads/logo/'.instituteDetails()->image) }}" alt="Logo" class="img-fluid">
                </div>
            </div>
            <br>
            <div class="row">
                <div class="col-12 text-center">
                    <div class="title">ONLINE PUBLIC ACCESS CATALOG (OPAC)</div>
                </div>
            </div>
        </div>
    </div>
    <div class="card">
        <div class="card-body">
            <form method="get">
                <div class="row">
                    <div class="col-12 col-sm-1">
                        <div class="form-group">
                            <b>Search</b>
                        </div>
                    </div>
                    <div class="col-12 col-sm-2">
                        <div class="form-group">
                            <select class="form-control" id="stype" name="stype">
                                <option value="">Library Catalog</option>
                                <option value="title" {{ $stype == 'title' ? 'selected':'' }}>Title</option>
                                <option value="author" {{ $stype == 'author' ? 'selected':'' }}>Author</option>
                                <option value="subject" {{ $stype == 'subject' ? 'selected':'' }}>Subject</option>
                                <option value="access_no" {{ $stype == 'access_no' ? 'selected':'' }}>Access No</option>
                                <option value="call_no" {{ $stype == 'call_no' ? 'selected':'' }}>Call No</option>
                                <option value="isbn" {{ $stype == 'isbn' ? 'selected':'' }}>ISBN</option>
                            </select>
                        </div>
                    </div>
                    <div class="col-12 col-sm-7">
                        <div class="form-group">
                            <input type="text" class="form-control" id="skey" name="skey" value="{{ $skey }}" placeholder="Search">
                        </div>
                    </div>
                    <div class="col-12 col-sm-2">
                        <div class="form-group">
                            <button type="submit" class="btn btn-success">Submit</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
    @if($books->count() > 0)
        <div class="card">
            <div class="card-body">
                <div class="row">
                    <div class="col-12">
                        <div style="overflow-x:scroll;">
                            <table class="table table-bordered">
                                <thead class="thead-dark">
                                    <tr>
                                        <th>Image</th>
                                        <th>Access No</th>
                                        <th>Call No</th>
                                        <th>Title</th>
                                        <th>Author</th>
                                        <th>Subject</th>
                                        <th>ISBN</th>
                                        <th>Category</th>
                                        <th>Sub Category</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach($books as $book)
                                        <tr>
                                            <td align="center">
                                                @if($book->image)
                                                    <img src="{{ asset('public/uploads/books/image/'.$book->image) }}" width="100px;">
                                                @endif
                                            </td>
                                            <td align="center">{{ $book->access_no }}</td>
                                            <td align="center">{{ $book->call_no }}</td>
                                            <td>{{ $book->title }}</td>
                                            <td>{{ $book->author }}</td>
                                            <td>{{ $book->subject }}</td>
                                            <td>{{ $book->isbn }}</td>
                                            <td align="center">{{ $book->category->name }}</td>
                                            <td align="center">{{ $book->subcategory->name }}</td>
                                        </tr>
                                    @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <div class="form-group">
                            {{ $books->appends(['stype' => $stype, 'skey' => $skey])->links() }}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    @endif
</body>
</html>