@extends('layouts.settings-template')
@section('title','OBE')
@section('heading','Add Program Specific OutCome')
@section('breadcrumb','Settings / OBE / PSO')
@section('content')
<head>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0-beta3/css/all.min.css">

</head>
    <div class="row">
    <div class="col-lg-12 grid-margin stretch-card">
    <div class="card">
         <div class="card-header" style="border:1px solid #DCDCDC;background-color:white">
           {{ app_button_links_v(array(239,238,240)) }}
    </div>  
    <div class="card-body">




    <div class="row">
        <div class="col-lg-12 grid-margin stretch-card">
            <div class="card">
                
          
            <div class="card-header" style="background:#005A9C;color:white;"><b>Add Program Specific OutCome</b></div>
   
                <div class="card-body">
                    <form action="{{ route('pso.save') }}" method="post">
                        @csrf
                        
                        <div class="row">
                            
                           
                            
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="course" class="required"><b>Program</b></label>
                                    <select class="js-example-basic-single" id="course" name="course" style="width:100%" required>
                                        <option value="">SELECT</option>
                                      
                                       @foreach($courses as $crs)
                                            <option value="{{ $crs->course_id  }}" {{ old('course') == $crs->course_id  ? "selected":"" }}>{{ $crs->course_name}}</option>
                                        @endforeach
                                    </select>
                                    @error('course')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            
                            
                          <div class="col-md-3">
                                        <div class="form-group">
                                            <label for="pso_no" class="required"><b>PSO No.</b></label>
                                            <input type="text" class="form-control @error('pso_no') border-danger @enderror" id="pso_no" name="pso_no" value="{{ old('pso_no') }}" required>
                                            @error('pso_no')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label for="pso_name" class="required"><b>Program Specific Outcome</b></label>
                                            <input type="text" class="form-control @error('pso_name') border-danger @enderror" id="pso_name" name="pso_name" value="{{ old('pso_name') }}" required>
                                            @error('pso_name')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                        </div>
                                    </div>
                                </div>
                               <div class="row">     
                                    
                                    <div class="col-md-12">
                                        <div class="form-group">
                                             <label></label>
                                            <button type="submit" class="btn btn-primary float-right">Save</button>
                                        </div>
                                    </div>
                                </div>   
                          </div>
                    </form>
                </div>
            </div>
        </div>
       
         <div class="row">
        <div class="col-lg-12 grid-margin stretch-card">
            <div class="card" style="border-top:2px solid #004170">
                <div class="card-body">
                    <table class="table table-bordered">
                        <thead>
                        <tr>
                          
                            <th><b>Program</b></th>
                            <th><b>PSO NO.</b></th>
                            <th><b>Program Specific Outcome</b></th>
                            <th><b>Actions</b></th>
                        </tr>
                        </thead>
                        <tbody>
                            @forelse($pso as $ps)
                                <tr>
                                  <td>{{$ps->coursen->course_name}}</td>
                                    <td>{{$ps->pso_no}}</td>
                                    <td>{{$ps->pso_name}}</td>
                                    
                                    <td>{{app_table_links($ps->id,array(228,227)) }}</td>

                                </tr>
                            @empty
                                <tr>
                                    <td colspan="2">No Result Found !</td>
                                </tr>
                            @endforelse
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
    
    
    
    
    
     </div>
            </div>
        </div>
    </div>
    <style>
          .card-body{
            border-left:1px solid #DCDCDC;
            border-right:1px solid #DCDCDC;
            border-bottom:1px solid #DCDCDC;
        }
        table.table-bordered {
            border: 1px solid #D8D8D8;
        }
        table.table-bordered th,
        table.table-bordered td {
            border: 1px solid #D8D8D8;
        }
        table.table-bordered th{
            background-color:#FEBE10;
        }
        table.table-bordered tr:nth-child(even){background-color: #F8F8F8;}
        .form-control{
            border:1px solid #E8E8E8;
        }
    </style>
    @endsection