@extends('layouts.template')
@section('title','OBE')
@section('heading','Outcome Based Education')
@section('breadcrumb','Home / OBE / Studentwise Internal Mark')
@section('content')
<head>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0-beta3/css/all.min.css">

</head>
    <div class="row">
    <div class="col-lg-12 grid-margin stretch-card">
    <div class="card">
<div class="card-header" style="border:1px solid #DCDCDC;background-color:white">
        
          {{ app_button_links_v(array(273,274,275,283,284,285,286,289,290,291)) }}
        
    </div>  
    <div class="card-body">


        <div class="row">
        <div class="col-lg-12 grid-margin stretch-card">
        <div class="card">
           
                 
        <div class="card-header" style="background-color:#005A9C;color:white"><b>Add Internal Mark</b></div>
        <div class="card-body">
        <form action="{{ route('studinternalmark.get') }}" method="post">
        @csrf
        <div class="row">
        <div class="col-md-3">
        <div class="form-group">
        <label for="course" class="required"><b>Program</b></label>
        <select class="form-control" id="course" name="course" required>
        <option value="">Select</option>
        @foreach($courses as $crs)
         <option value="{{ $crs->course_id }}" {{ old('course') == $crs->course_id ? 'selected' : '' }}>
           {{ $crs->course_name }}
        </option>
        @endforeach
        </select>
        @error('course')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
        </div>
        </div>
        <div class="col-md-3">
        <div class="form-group">
        <label for="semester_id" class="required"><b>Semester</b></label>
        <select class="form-control" id="semester_id" name="semester_id" required>
        <option value="">select</option>
        
        </select>
        </div>
        </div>
                            
          <div class="col-md-3">
                                <div class="form-group">
                                    <label for="subtyp_id" class="required"><b>Course Type</b></label>
                                    <select class="form-control" id="subtyp_id" name="subtyp_id" required>
                                    <option value="">select</option>
                                    @foreach($subtype as $subjectType)
                                    <option value="{{ $subjectType->subtyp_id}}" {{ old('subtyp_id')==$subjectType->subtyp_id ? "selected":"" }}>{{ $subjectType->subject_type}}</option>
                                    @endforeach 
                                    </select>
                                        @error('subtyp_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>                       
    
        
       <div class="col-md-3">
        <div class="form-group">
        <label for="sub_id" class="required"><b>Course</b></label>
        <select class="form-control" id="sub_id" name="sub_id" required>
        <option value="">select</option>
        
        </select>
        </div>
        </div>
        
        <div class="col-md-3">
        <div class="form-group">
        <label for="batch_id" class="required"><b>Batch</b></label>
        <select class="form-control" id="batch_id" name="batch_id" required>
        <option value="">select</option>
        
        </select>
        </div>
        </div>
        
        
         <div class="col-md-3">
           <div class="form-group">
            <label for="assmnt_method" class="required"><b>Assessment Method</b></label>
             <select class="form-control" id="assmnt_method" name="assmnt_method" required>
               <option value="">select</option>
                @foreach($assessmentmethods as $assmnt)
               <option value="{{ $assmnt->id}}" {{ old('assmnt_method')==$assmnt->id ? "selected":"" }}>{{ $assmnt->method}}</option>
                @endforeach 
             </select>
                @error('assmnt_method')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
          </div>
         </div>  
                            
                          
        
        <div class="col-md-3">
         <div class="form-group">
          <label for="term_id" class="required"><b>Term</b></label>
            <select class="form-control" id="term_id" name="term_id" required>
                <option value="">select</option>
                @foreach($terms as $trm)
                <option value="{{ $trm->id}}" {{ old('term_id')==$trm->id ? "selected":"" }}>{{ $trm->term}}</option>
                @endforeach 
            </select>
                @error('term_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
         </div>
        </div>
        
        
         <div class="col-md-3">
           <div class="form-group">
            <label for="exam_id" class="required"><b>Exam</b></label>
            <select class="form-control" id="exam_id" name="exam_id" required>
             <option value="">select</option>
             
            </select>
           </div>
         </div>
        
      <div class="col-md-3">
           <div class="form-group">
            <label for="stud_id" class="required"><b>Students</b></label>
            <select class="form-control" id="stud_id" name="stud_id" required>
             <option value="">select</option>
             
            </select>
           </div>
         </div>
      
        </div>
        
        <div id="moreadd"></div> 
        <div class="row">
        <div class="col-md-12">
        <div class="form-group">
          <button type="button" class="btn btn-primary float-right" id="btn-get">Submit</button>
        </div>
        </div>
        </div>
        </form>
        </div>
        </div>
        </div>
    </div>
    
     <div class="row">
            <div class="col-lg-12 grid-margin stretch-card" id="result">
            
            </div>
        </div>
        
    
    
    
    </div>
        </div>
        </div>
    </div>
    
   <script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
    <script src="{{ asset('public/js/semester.js') }}"></script> 
  
    <script src="{{ asset('public/js/bsubj.js') }}"></script>
    <script src="{{ asset('public/js/batch.js') }}"></script>
    <script src="{{ asset('public/js/obeexam.js') }}"></script>
    <script src="{{ asset('public/js/obestud.js?ver=1.9') }}"></script>
    <script src="{{ asset('public/js/viewstudinternalmarks.js?ver=1.8') }}"></script>


    <style>
                                .card-body{
            border-left:1px solid #DCDCDC;
            border-right:1px solid #DCDCDC;
            border-bottom:1px solid #DCDCDC;
        }

    </style>
    
    
 
    <style>
          .card-body{
            border-left:1px solid #DCDCDC;
            border-right:1px solid #DCDCDC;
            border-bottom:1px solid #DCDCDC;
        }
        table.table-bordered {
            border: 1px solid #D8D8D8;
        }
        table.table-bordered th,
        table.table-bordered td {
            border: 1px solid #D8D8D8;
        }
        table.table-bordered th{
            background-color:#FEBE10;
        }
        table.table-bordered tr:nth-child(even){background-color: #E0E0E0;}
        .form-control{
            border:1px solid #E8E8E8;
        }
    </style>
@endsection