@extends('layouts.template')
@section('title','Home')
@section('heading','Add PTA')
@section('breadcrumb','Home/PTA/Add PTA')
@section('content')





    <div class="row">
    <div class="col-lg-12 grid-margin stretch-card">
    <div class="card">
    <div class="card-header"  style="background:#005A9C;color:white;"><b>Add PTA Meeting</b></div>
    <div class="card-body">
   <form action="{{ route('pta.save') }}" method="post" enctype="multipart/form-data">
                        @csrf

    <div class="row">
    <div class="col-md-2">
    <label for="ac_id" class="required"><b>Academic Year</b></label>
    </div>
    <div class="col-md-6">
    <div class="form-group">

    <select class="form-control" id="ac_id" name="ac_id" required>
    @foreach($acyears as $acyear)
    <option value="{{ $acyear->ac_id }}" {{ old('ac_id')==$acyear->ac_id ? "selected":"" }}>{{ $acyear->start_date_formatted.' - '.$acyear->end_date_formatted }}</option>
    @endforeach
    </select>
    @error('ac_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
    </div>
    </div>
    </div>
    <div class="row">
    <div class="col-md-2">
    <label for="course_id" class="required"><b>Program</b></label>
    </div>
    <div class="col-md-6">
    <div class="form-group">
    <select class="form-control" id="course_id" name="course_id" required>
    <option value="">Select</option>
    @foreach($courses as $course)
    <option value="{{ $course->course_id }}" {{ old('course_id')==$course->course_id ? "selected":"" }}>{{ $course->course_name }}</option>
    @endforeach
    </select>
    @error('course_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
    </div>
    </div>
    </div>
                            
    <div class="row">
    <div class="col-md-2">
    <label for="name" class="required"><b>Name</b></label>  
    </div>
    <div class="col-md-6">
    <div class="form-group">
    <input type="text" class="form-control @error('name') border-danger @enderror" placeholder="Name" id="name" name="name" value="{{ old('name') }}">
    @error('name')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
     </div>
     </div>
     </div>
    <div class="row">
    <div class="col-md-2">
    <label for="date" class="required"><b>Date</b></label>
    </div>
     <div class="col-md-6">

    <div class="form-group">
    <input type="date" class="form-control @error('date') border-danger @enderror" id="date" name="date" value="{{ \Carbon\Carbon::now()->format('Y-m-d')  }}">
    @error('date')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
    </div>
    </div>
    </div>
    <div class="row">
    <div class="col-md-2">
    <label for="venue" class="required"><b>Venue</b></label>  
    </div> 
    <div class="col-md-6">
    <div class="form-group">
    <input type="text" class="form-control @error('venue') border-danger @enderror" id="venue" placeholder="Venue" name="venue" value="{{ old('venue') }}">
    @error('venue')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
    </div>
    </div> 
    </div>
    <div class="row">
    <div class="col-md-2">
    <label for="agenda" class="required"><b>Agenda</b></label>  
    </div>
    <div class="col-md-6">
    <div class="form-group">
    <textarea name="agenda" class="form-control"  placeholder="Agenda">{{old('agenda')}}</textarea>
    @error('agenda')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
     </div>
     </div>   
     </div>
    <div class="row">
    <div class="col-md-2">
    <label for="attachment" class="required"><b>Letter/Attachment</b></label>  
    </div>
                <div class="col-md-6">
                                <div class="form-group">
                                 <input type="file" class="form-control @error('attachment') border-danger @enderror" id="attachment" name="attachment" value="{{ old('attachment') }}">
             
                                     @error('attachment')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
     </div>
     </div> 
     </div>
     <div class="row">
     <div class="col-md-2">
    <label for="from" class="required"><b>From</b></label>  
    </div>
                 <div class="col-md-6">
                                <div class="form-group">
                                 <input type="time" class="form-control @error('from') border-danger @enderror" id="time" name="from" value="{{ old('from') }}">
             
                                     @error('from')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
     </div>
     </div>                           
       </div>  
        <div class="row">
          <div class="col-md-2">
                <label for="to" class="required"><b>To</b></label>  
    </div>
                   <div class="col-md-6">
                                <div class="form-group">
                                 <input type="time" class="form-control @error('to') border-danger @enderror" id="time" name="to" value="{{ old('to') }}">
             
                                     @error('to')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
     </div>
     </div>                                
  </div>
      <div class="row">
                            <div class="col-md-5">
                                <div class="form-group">
                                    <button type="submit" class="btn btn-primary float-right">Post</button>
                                </div>
                            </div>
                        </div>                        
                            



</form>
</div>
</div>
</div>
</div>





  <script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
<script>
        function getCurrentTime() {
            const now = new Date();
            let hours = now.getHours().toString().padStart(2, '0');
            let minutes = now.getMinutes().toString().padStart(2, '0');
            return `${hours}:${minutes}`;
        }

        document.getElementById('time').value = getCurrentTime();
    </script>
<style>
     .card-body{
            border-left:1px solid #DCDCDC;
            border-right:1px solid #DCDCDC;
            border-bottom:1px solid #DCDCDC;
             
          
        }
</style>
@endsection