@extends('layouts.template')
@section('title','Home')
@section('heading','Leave')
@section('breadcrumb','Home/Staff/Leave')
@section('content')


@if(session('success'))
    <div class="alert alert-success">
        {{ session('success') }}
    </div>
@endif

@if(session('error'))
    <div class="alert alert-danger">
        {{ session('error') }}
    </div>
@endif

<div class="row">
    <div class="col-lg-12 grid-margin stretch-card">
    
         <div class="card-tools">
    {{ app_button_links(array(330,331,332,333)) }}
    </div>
        
        
        
        
        
        
        </div>
       
        </div>
    <div class="row">
    <div class="col-lg-12 grid-margin stretch-card">
    <div class="card">
    <div class="card-header" style="background:#073980;color:white;"><b>Pending Request</b></div>
    <div class="card-body">
      
 @if(auth()->user()->type_id == 17)

        
    <table class="table table-bordered">
                        <thead>
                        <tr>
                            <th><b>Applied By</b></th>
                            <th><b>employee ID</b></th>
                            <th><b>Forwarded By</b></th>
                            <th><b>Applied On</b></th>
                            <th><b>Leave From</b></th>
                            <th><b>Leave Until</b></th>
                            <th><b>Status</b></th>
                            <th colspan="2"><b>Actions</b></th>

                        </tr>
                        </thead>
                        <tbody>
                            @forelse($staffleavreport as $request)
                               
                                
                                
                                <tr>
                                    <td>{{$request->staff->name}}</td>
                                    <td>{{$request->staff->employee_id_num}}</td>
                                     <td></td>
                                    <td>{{date('d-m-Y',strtotime($request->applied_on))}}</td>
                                    <td>{{date('d-m-Y',strtotime($request->lfrom))}}</td>
                                    <td>{{date('d-m-Y',strtotime($request->luntil))}}</td>
                                   <td>
                                       @if($request->status==0)
                                        <span class="text-primary">Pending</span>
                                       @endif
                                       @if($request->status==1)
                                        <span class="text-primary">Approved</span>
                                       @endif
                                         @if($request->status==2)
                                        <span class="text-primary">Rejected</span>
                                       @endif
                                   </td>   
                                    
                                  
                                        <td>
                                        <button type="button" class="btn view-btn" data-url="{{ route('staff.leave.status.pending', ['stfleavereq_id' => $request->stfleavereq_id]) }}">
                                            <i class="fa-solid fa-magnifying-glass"></i>
                                        </button>
                                        </td>
                                        <td>
                                            <form action="{{ route('staff.leave.request.forward',['stfleavereq_id' => $request->stfleavereq_id]) }}"  method="post">
                                @csrf
                                 <input type="hidden" name="applied_by" value="{{$request->staff->user_id}}">
                               
                                <div class="dropdown d-inline">
                                        <label for="forwardTo">Forward To</label>
                               <select class="form-control" id="forwardTo" name="user_id">
                                    <option value="{{ $user->user_id }}">{{ $user->name }}</option>
                                </select>
                                    </div>
                                    <input type="submit" name="sub" value="Submit" class="btn btn-success btn-sm"> 
                                      </form>      
                                        </td>
                                   

                                 
                                </tr>
                            @empty
                                <tr>
                                    <td colspan="2">No Result Found !</td>
                                </tr>
                            @endforelse
                        </tbody>
                    </table> 
        
         @elseif(auth()->user()->type_id == 1)
        
         <table class="table table-bordered">
                        <thead>
                        <tr>
                            <th><b>Applied By</b></th>
                            <th><b>employee ID</b></th>
                            <th><b>Forwarded By</b></th>
                            <th><b>Status</b></th>
                            <th colspan="2"><b>Actions</b></th>

                        </tr>
                        </thead>
                        <tbody>
                            @forelse($staffforward as $request)
                               
                                
                                
                                <tr>
                                    <td>{{$request->staffs->name}}</td>
                                    <td>{{$request->staffs->employee_id_num}}</td>
                                     <td>{{$request->forwardedbyUser->name}}</td>
                                   <td>
                                       @if($request->status==0)
                                        <span class="text-primary">Pending</span>
                                       @endif
                                       @if($request->status==1)
                                        <span class="text-primary">Approved</span>
                                       @endif
                                         @if($request->status==2)
                                        <span class="text-primary">Rejected</span>
                                       @endif
                                   </td>   
                                    
                                  
                                        <td>
                                        <button type="button" class="btn view-btns" data-url="{{ route('staff.leave.forward.pending', ['stfleavfrwd' => $request->stfleavfrwd]) }}">
                                            <i class="fa-solid fa-magnifying-glass"></i>
                                        </button>
                                        </td>
                                         <td>
                                       
                                        </td>
                                      
                                </tr>
                            @empty
                                <tr>
                                    <td colspan="2">No Result Found !</td>
                                </tr>
                            @endforelse
                        </tbody>
                    </table> 
        
        
       
        
        
        
        
       @elseif(auth()->user()->type_id == 13)
        
         <table class="table table-bordered">
                        <thead>
                        <tr>
                            <th><b>Applied By</b></th>
                            <th><b>employee ID</b></th>
                            <th><b>Reason</b></th>
                            <th><b>Applied On</b></th>
                            <th><b>Leave From</b></th>
                            <th><b>Leave Until</b></th>
                            <th><b>Status</b></th>
                            <th colspan="2"><b>Actions</b></th>

                        </tr>
                        </thead>
                        <tbody>
                            @forelse($staffleavreport as $request)
                               
                                
                                
                                <tr>
                                     <td>{{$request->staff->name}}</td>
                                    <td>{{$request->staff->employee_id_num}}</td>
                                     <td>{{$request->reason}}</td>
                                    <td>{{date('d-m-Y',strtotime($request->applied_on))}}</td>
                                    <td>{{date('d-m-Y',strtotime($request->lfrom))}}</td>
                                    <td>{{date('d-m-Y',strtotime($request->luntil))}}</td>
                                   <td>
                                       @if($request->status==0)
                                        <span class="text-primary">Pending</span>
                                       @endif
                                       @if($request->status==1)
                                        <span class="text-primary">Approved</span>
                                       @endif
                                         @if($request->status==2)
                                        <span class="text-primary">Rejected</span>
                                       @endif
                                   </td>   
                                    
                                    
                                  
                                        <td>
                                        <button type="button" class="btn view-btn" data-url="{{ route('staff.leave.status.pending', ['stfleavereq_id' => $request->stfleavereq_id]) }}">
                                            <i class="fa-solid fa-magnifying-glass"></i>
                                        </button>
                                        </td>
                                      
                                </tr>
                            @empty
                                <tr>
                                    <td colspan="2">No Result Found !</td>
                                </tr>
                            @endforelse
                        </tbody>
                    </table> 
        
        
        @endif
        
        
        
        
        
        
        
        
        

  
        
        
        
        


</div>
        </div>
        </div>
        </div>




<div class="modal fade" id="viewModal" tabindex="-1" role="dialog" aria-labelledby="viewModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-xl" role="document">
            <div class="modal-content">
                <div class="modal-header" style="background-color:#005A9C;color:white;">
                    <h5 class="modal-title" id="viewModalLabel"><b>REQUEST DETAILS</b></h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                   
                </div>
            </div>
        </div>
    </div>







<div class="modal fade" id="viewModal" tabindex="-1" role="dialog" aria-labelledby="viewModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-xl" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="viewModalLabel">Request Details</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                   
                </div>
            </div>
        </div>
    </div>







<style>
    
      .card-body{
            border-left:1px solid #DCDCDC;
            border-right:1px solid #DCDCDC;
            border-bottom:1px solid #DCDCDC;
             
          
        }
       
       
        .form-control{
            border:1px solid #E8E8E8;
        }
.modal-dialog.modal-sm {
    max-width: 50%; 
}
</style>
<!--<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>-->
<!-- Bootstrap JavaScript -->
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.9.3/dist/umd/popper.min.js"></script>

<!--<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>-->
<!--<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>-->
<script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
<script>
    $(document).ready(function() {
        $('.view-btn').on('click', function(e) {
            e.preventDefault();
            var url = $(this).data('url');

            $.get(url, function(data) {
                $('#viewModal .modal-body').html(data);
                $('#viewModal').modal('show');
            });
        });
  
          $('.view-btns').on('click', function(e) {
            e.preventDefault();
            var url = $(this).data('url');

            $.get(url, function(data) {
                $('#viewModal .modal-body').html(data);
                $('#viewModal').modal('show');
            });
        });

  
  
  
  
  
    });
</script>

@endsection       
        
        
        
        
        
      