@extends('layouts.template')
@section('title','Attendance')
@section('heading','Attendance')
@section('breadcrumb','Home / Student / Hourly Attendance')
@section('content')
    <style>
        .scroll {
            overflow-x: auto;
            -webkit-overflow-scrolling: touch;
        }
        .custom-check{
            width: 20px;
            height: 20px;
            accent-color: #38ce3c;
            cursor: pointer;
        }
        .custom-check:checked {
            accent-color: #38ce3c;
        }
        .square{
            width: 20px;
            height: 20px;
        }
    </style>
    <div class="row">
        <div class="col-12">
            <div class="form-group">
                <a href="{{ route('staff.student.attendance.all',['course'=>$course->course_id, 'semester'=>$semester->semester_id, 'date'=>$date]) }}" class="btn btn-sm btn-danger">Back</a>
            </div>
        </div>
    </div>
    <div class="card">
        <div class="card-body">
            <div class="row">
                <div class="col-12 col-sm-4">
                    <div class="form-group row">
                        <label class="col-5">Program :</label>
                        <label class="col-7 text-danger">{{ $course->course_name }}</label>
                    </div>
                </div>
                <div class="col-12 col-sm-4">
                    <div class="form-group row">
                        <label class="col-5">Semester :</label>
                        <label class="col-7 text-danger">{{ $semester->semester_name }}</label>
                    </div>
                </div>
                <div class="col-12 col-sm-4">
                    <div class="form-group row">
                        <label class="col-5">Course :</label>
                        <label class="col-7 text-danger">{{ $subject->subject_name }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12 col-sm-4">
                    <div class="form-group row">
                        <label class="col-5">Date :</label>
                        <label class="col-7 text-danger">{{ date('d/m/Y',strtotime($date)) }}</label>
                    </div>
                </div>
                <div class="col-12 col-sm-4">
                    <div class="form-group row">
                        <label class="col-5">Day :</label>
                        <label class="col-7 text-danger">{{ date('l',strtotime($date)) }}</label>
                    </div>
                </div>
                <div class="col-12 col-sm-4">
                    <div class="form-group row">
                        <label class="col-5">Period :</label>
                        <label class="col-7 text-danger">{{ $period->period }}</label>
                    </div>
                </div>
            </div>
          <div class="row">
            <div class="col-12 col-sm-4">
                <div class="form-group row">
                    <label class="col-5">Staff :</label>
                    @if($staff)
                        <label class="col-7 text-danger">{{ $staff->name }}</label>
                    @else
                        <label class="col-7 text-danger">Staff not found</label>
                    @endif
                </div>
            </div>
         </div>
        </div>
    </div>
    @if(!empty($students))
        <div class="card mt-2">
            <div class="card-body">
                <form action="{{ route('staff.student.attendance.all.save') }}" method="post">
                    @csrf
                    <input type="hidden" id="course" name="course" value="{{ $course->course_id }}">
                    <input type="hidden" id="semester" name="semester" value="{{ $semester->semester_id }}">
                    <input type="hidden" id="subject" name="subject" value="{{ $subject->subject_id }}">
                    <input type="hidden" id="date" name="date" value="{{ $date }}">
                    <input type="hidden" id="period" name="period" value="{{ $period->id }}">
                    <input type="hidden" id="staff" name="staff" value="{{ $staff?$staff->user_id:'' }}">
                    <div class="scroll">
                        <table class="table table-bordered">
                            <thead>
                            <tr>
                                <th>#</th>
                                <th>Adm No.</th>
                                <th>Roll No.</th>
                                <th>Name</th>
                                <th>
                                    <input type="checkbox" class="custom-check" onclick="checkAll(this);" checked> Attendance
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                                @php $pcount=0; @endphp
                                @foreach($students as $student)
                                    <tr>
                                        <td align="center">{{ $loop->iteration }}</td>
                                        <td align="center">{{ $student['adno'] }}</td>
                                        <td align="center">{{ $student['rollno'] }}</td>
                                        <td>{{ strtoupper($student['name']) }}</td>
                                        <td align="center">
                                            @if($student['status']=='')
                                                @php $pcount++; @endphp
                                                <input type="checkbox" class="custom-check checkSub" name="posted[]" value="{{ $student['student_id'] }}" onclick="studDet('{{ $student['student_id'] }}')" checked>
                                            @elseif($student['status']=='P')
                                                <div class="square bg-success" onclick="studDet('{{ $student['student_id'] }}')"></div>
                                            @elseif($student['status']=='A')
                                                <div class="square bg-danger" onclick="studDet('{{ $student['student_id'] }}')"></div>
                                            @endif
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                    @if($pcount>0)
                        <br>
                        <div class="row">
                            <div class="col-12">
                                <div class="form-group">
                                    <button type="submit" class="btn btn-sm btn-success float-right">Save</button>
                                </div>
                            </div>
                        </div>
                    @endif
                </form>
            </div>
        </div>
        <div class="modal fade" id="attendanceModal" tabindex="-1" role="dialog" aria-labelledby="attendanceModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="attendanceModalLongTitle">Student Attendance</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        
                    </div>
                </div>
            </div>
        </div>
    @else
        <div class="alert alert-danger mt-2">No Students Found in Selected Course !</div>
    @endif
    <script>
        function checkAll(source){
            const checkboxes = document.querySelectorAll('.checkSub');
            checkboxes.forEach(checkbox => checkbox.checked = source.checked);
        }
        
        function studDet(sid){
            var course = $('#course').val();
            var semester = $('#semester').val();
            var subject = $('#subject').val();
            var staff = $('#staff').val();
            var date = $('#date').val();
            var period = $('#period').val();
            
            var baseUrl = window.location.origin;
            
            if(course!='' && semester!='' && subject!='' && staff!='' && date!='' && period!='' && sid!=''){
                $.ajax({
                    type : 'GET',
                    url : baseUrl+'/staff/student-attendance-all-details',
                    data : { course: course, semester: semester, subject: subject, staff: staff, date: date, period: period, sid: sid },
                    success : function(response){
                        $('.modal-body').html(response);
                        $('#attendanceModal').modal('show');
                    },
                    error: function (xhr, status, error) {
                        alert('Could not able to fetch data. Try again later !');
                    }
                });
            }else{
                alert('Invalid Data');
            }
        }
    </script>
@endsection