@extends('layouts.template')
@section('title','Attendance')
@section('heading','Prior Attendance')
@section('breadcrumb','Home / Student / Prior Attendance')
@section('content')
    <div class="card">
        <div class="card-body">
            <form action="{{ route('staff.student.attendance.prior.save') }}" method="post">
                @csrf
                <div class="row">
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="course" class="required">Program</label>
                            <select class="form-control js-example-basic-single @error('course') border-danger @enderror" id="course" name="course" required>
                                <option value="">Select</option>
                                @foreach($courses as $course)
                                    <option value="{{ $course->course_id }}" {{ $course->course_id==old('course') ? 'selected':'' }}>{{ $course->course_name }}</option>
                                @endforeach
                            </select>
                            @error('course')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="semester" class="required">Semester</label>
                            <select class="form-control js-example-basic-single @error('semester') border-danger @enderror" id="semester" name="semester" required>
                                <option value="">Select</option>
                                @foreach($semesters as $semester)
                                    <option value="{{ $semester->semester_id }}" {{ $semester->semester_id==old('semester') ? 'selected':'' }}>{{ $semester->semester_name }}</option>
                                @endforeach
                            </select>
                            @error('semester')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="student" class="required">Student</label>
                            <select class="form-control js-example-basic-single @error('student') border-danger @enderror" id="student" name="student" required>
                                <option value="">Select</option>
                                @foreach($students as $student)
                                    <option value="{{ $student->student_id }}" {{ $student->student_id==old('student') ? 'selected':'' }}>{{ $student->name }}</option>
                                @endforeach
                            </select>
                            @error('student')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="leave">Leave Type</label>
                            <select class="form-control js-example-basic-single @error('leave') border-danger @enderror" id="leave" name="leave">
                                <option value="">Select</option>
                                @foreach($leaves as $leave)
                                    <option value="{{ $leave->stuleav_id }}" {{ $leave->stuleav_id==old('leave') ? 'selected':'' }}>{{ $leave->leave_name }}</option>
                                @endforeach
                            </select>
                            @error('leave')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="fdate" class="required">From Date</label>
                            <input type="date" class="form-control @error('from_date') border-danger @enderror" id="fdate" name="from_date" value="{{ old('from_date') ?? $fdate }}" required>
                            @error('from_date')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="tdate" class="required">To Date</label>
                            <input type="date" class="form-control @error('to_date') border-danger @enderror" id="tdate" name="to_date" value="{{ old('to_date') ?? $tdate }}" required>
                            @error('to_date')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    <div class="col-12 col-sm-6">
                        <div class="form-group">
                            <label for="reason" class="required">Reason</label>
                            <textarea class="form-control @error('reason') border-danger @enderror" id="reason" name="reason" rows="3" required>{{ old('reason') }}</textarea>
                            @error('reason')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <div class="form-group">
                            <button type="submit" class="btn btn-sm btn-success float-right">Save</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
    <script src="{{ asset('public/js/class-teacher.js?ver=1.3') }}"></script>
@endsection