@extends('layouts.template')
@section('title','Home')
@section('heading','Leave Request')
@section('breadcrumb','Home/Student/Leave Request')
@section('content')
@if($request->isNotEmpty())
    <div class="card">
        <div class="card-body">
            <div class="scroll">
                <table class="table table-bordered" width="100%">
                    <thead>
                        <tr>
                            <th>#</th>
                            <th>Date</th>
                            <th>Adno</th>
                            <th>Student Name</th>
                            <th>Leave From</th>
                            <th>Leave Until</th>
                            <th>Reason</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    <tbody>
                        @forelse($request as $leave)
                        
                            <tr>
                                <td align="center">{{ $loop->iteration }}</td>
                                <td align="center">{{ date('d-m-Y', strtotime($leave->date)) }}</td>
                                <td align="center">{{ $leave->student->adno }}</td>
                                <td>{{ strtoupper($leave->student->name) }}</td>
                                <td align="center">{{ date('d-m-Y', strtotime($leave->lfrom)) }}</td>
                                <td align="center">{{ date('d-m-Y', strtotime($leave->luntil)) }}</td>
                                <td style="word-wrap: break-word; word-break: break-all; white-space: normal;">{{ $leave->reason }}</td>
                                <td align="center">
                                    <button type="button" class="btn view-btns" data-url="{{ route('request.leave.reply', ['id' => $leave->stulvreq_id  ]) }}">
                                        <i class="fa-solid fa-magnifying-glass"></i>
                                    </button>
                                </td>
                            </tr>
                        @empty
                            <tr>
                                <td colspan="8">No Result Found!</td>
                            </tr>
                        @endforelse
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    @else
     <div class="row">
            <div class="col-12">
                <div class="alert alert-danger">Student Leave Request not Found !</div>
            </div>
        </div>
    @endif
    <div class="modal fade" id="viewModal" tabindex="-1" role="dialog" aria-labelledby="viewModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-xl" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="viewModalLabel">Action</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body"></div>
            </div>
        </div>
    </div>
   
    <script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
    <script>
        $(document).ready(function() {
            $('.view-btns').on('click', function(e) {
                e.preventDefault();
                var url = $(this).data('url');
                $.get(url, function(data) {
                    $('#viewModal .modal-body').html(data);
                    $('#viewModal').modal('show');
                });
            });
        });
    </script>
@endsection