
@extends('layouts.template')
@section('title', 'Dashboard')
@section('heading', 'Students')
@section('breadcrumb', 'Home / Students')
@section('content')
    <div class="card card-primary">
        <div class="card-header">Students</div>
        <div class="card-body">
            <table class="table table-bordered" id="studentTable" width="100%">
                <thead>
                <tr>
                    <th>Adm No.</th>
                    <th>Roll No.</th>
                    <th>Name</th>
                    <th>Father's Name</th>
                    <th>Mother's Name</th>
                    <th>Mobile</th>
                    <th>Program</th>
                    <th>Semester</th>
                </tr>
                </thead>
                <tbody>
                </tbody>
            </table>
        </div>
    </div>
    <script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
    <script>
        $(function () {
            var studentTable = $("#studentTable").DataTable({
                lengthChange: true,
                lengthMenu: [ [50, 100, 500, 1000, -1], [50, 100, 500, 1000, 'All'],],
                scrollX: true,
                searching: true,
                processing : true,
                serverSide : true,
                columnDefs : [{ targets: 'no-sort', orderable: false }],
                ajax : {
                    url : '{{ route('dash.totalajax.student') }}',
                    dataType : 'json',
                    type : 'GET',
                },
                order: [[1, 'asc']],
                columns : [
                    { data : 'adno' },
                    { data : 'rollno' },
                    { data : 'name' },
                    { data : 'fathername' },
                    { data : 'mothername' },
                    { data : 'mobile' },
                    { data : 'course' },
                    { data : 'semester' },
                ]
            });
        });
    </script>
@endsection