@extends('layouts.template')
@section('title','Attendance')
@section('heading','Attendance')
@section('breadcrumb','Home / Student / Attendance')
@section('content')
    <div class="card">
        <div class="card-body">
            <form method="get">
                <div class="row">
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="course">Program</label>
                            <select class="form-control js-example-basic-single" id="course" name="course">
                                <option value="">Select</option>
                                @foreach($courses as $course)
                                    <option value="{{ $course->course_id }}" {{ $course->course_id==$courseId ? "selected":"" }}>{{ $course->course_name }}</option>
                                @endforeach
                            </select>
                            @error('course')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="semester">Semester</label>
                            <select class="form-control js-example-basic-single" id="semester" name="semester">
                                <option value="">Select</option>
                                @foreach($semesters as $semester)
                                    <option value="{{ $semester->semester_id }}" {{ $semester->semester_id==$semesterId ? "selected":"" }}>{{ $semester->semester_name }}</option>
                                @endforeach
                            </select>
                            @error('semester')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="subject">Course</label>
                            <select class="form-control js-example-basic-single" id="subject" name="subject">
                                <option value="">Select</option>
                                @foreach($subjects as $subject)
                                    <option value="{{ $subject->subject_id }}" {{ $subject->subject_id==$subjectId ? "selected":"" }}>{{ $subject->subcategoryname->category.' - '.$subject->subject_name }}</option>
                                @endforeach
                            </select>
                            @error('subject')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                    
                    <div class="col-md-3">
                        <div class="form-group">
                            <label for="batch_id"><b>Batch</b></label>
                            <select class="js-example-basic-single form-control" id="batch_id" name="batch_id">
                                <option value="">select</option>
                                @foreach($batchs as $bat)
                                    <option value="{{ $bat->id }}" {{ $bat->id==$batchId ? "selected":"" }}>{{ $bat->name }}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                    
                    
                    <div class="col-12 col-sm-3">
                        <div class="form-group">
                            <label for="month">Month</label>
                            <input type="month" class="form-control" id="month" name="month" value="{{ $month }}">
                            @error('month')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <div class="form-group">
                            <button type="submit" class="btn btn-sm btn-success float-right">Submit</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
    <br>
    @if(!empty($weeks))
        <div class="card">
            <div class="card-body">
                <div class="row">
                    <div class="col-12">
                        <div class="form-group text-center">
                            <h5>{{ date('F Y',strtotime($month)) }}</h5>
                        </div>
                    </div>
                </div>
                <div class="row">
                    @foreach($weeks as $week)
                        <div class="col-12 col-sm-2">
                            <div class="form-group">
                            <button type="button" class="btn btn-block btn-danger week-btn" id="week-{{ $loop->iteration }}" onclick="showAttendance('{{ $week['start'] }}','{{ $week['end'] }}','{{ $loop->iteration }}');">Week {{ $loop->iteration }}<br><br>{{ date('d',strtotime($week['start'])).' - '.date('d',strtotime($week['end'])) }}</button>                            </div>
                        </div>
                    @endforeach
                    <div class="col-12 col-sm-2">
                        <div class="form-group">
                             <button type="button" class="btn btn-block btn-danger week-btn" id="week-all" onclick="showMonthAttendance('{{ date('Y-m-01',strtotime($month)) }}', '{{ date('Y-m-t',strtotime($month)) }}');">All<br><br>{{ '01 - '.date('t',strtotime($month)) }}</button>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <div id="result"></div>
                    </div>
                </div>
            </div>
        </div>
    @else
        <div class="alert alert-warning">No Result Found !</div>
    @endif
    <script src="{{ asset('public/js/student-attendance.js?ver=1.42') }}"></script>
    @if(!empty($weeks))
   
        <script>
           showAttendance('{{ $weeks[0]['start'] }}','{{ $weeks[0]['end'] }}',1) 
        </script>
    @endif
@endsection