@extends('layouts.student-template')
@section('title','Task')
@section('heading','Pending Task')
@section('breadcrumb','Home / Pending Task')
@section('content')
@if($pendingtasks->isNotEmpty())
<div class="card">
            <div class="card-body">
                 <form action="{{ route('save.task.pending') }}" method="post">
                 @csrf
                <table class="table table-bordered">
                    <thead>
                    <tr>
                        <th rowspan="2">
                            <div class="form-check form-check-success d-flex justify-content-center align-items-center">
                              <label class="container"> <input type="checkbox" class="form-check-input" id="checkAll"></label>
                            </div>
                        </th>
                        <th>Course</th>
                        <th>Task</th>
                        <th>Description</th>
                        <th>Deadline</th>
                        <th>Status</th>
                        <th>Remarks</th>
                        
                    </tr>
                    </thead>
                    <tbody>
                        @foreach($pendingtasks as $tsk)
                         @php
                         $datetime = new DateTime($tsk->dead_line);
                         
                         @endphp
                        <tr>
                            <td align="center" >
                                <div class="form-check form-check-success d-flex justify-content-center align-items-center">
                                 <label class="container"><input type="checkbox" class="form-check-input checkSub" name="posted[]" value="{{ $tsk->id }}"></label>
                                </div>
                            </td> 
                            <td>{{$tsk->subject_name}}</td>
                            <td>{{$tsk->task_name}}</td>
                            <td>{{$tsk->descrption}}</td>
                            <td>{{$datetime->format('d-m-Y h:i A')}}</td>
                            <td>
                                 <select class="form-control" id="status{{$tsk->id}}" name="status{{$tsk->id}}" required>
                                    <option value="">Select Status</option>
                                    <option value="0" {{ old('status', $tsk->status) == 0 ? "selected" : "" }}>Pending</option>
                                    <option value="1" {{ old('status', $tsk->status) == 1 ? "selected" : "" }}>Completed</option>
                                </select>
                            </td>
                            <td><textarea class="form-control remark" id="{{ 'remark'. $tsk->id}}" name="remark{{$tsk->id}}" onkeypress="return isNumberKey(event);">{{$tsk->remark}}</textarea> 
</td>
                        </tr>
                        
                        @endforeach
                    </tbody>
                </table>
                <br>
                <div class="row">
                             
               <div class="col-md-12">
                  <div class="form-group">
                    <button type="submit" class="btn btn-primary float-right">Submit</button>
                 </div>
               </div>
    </div>
    </form>
            </div>
        </div>
        @else
        <div class="row">
            <div class="col-12">
                <div class="alert alert-danger">Pending Task not Found !</div>
            </div>
        </div>
    @endif
        <style>
input[type="checkbox"] {
  width: 1.5em;
  height: 1.5rem;
   display: inline-block; 
   margin: 0;
  accent-color: green;
}   
</style>
     <script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
            <script>
            $(document).ready(function(){
                
               
                $("#checkAll").on('click',function () {
                    if($(this).is(':checked')){
                        $('.checkSub').each(function(){
                            this.checked = true;
                        });
                    }else{
                        $('.checkSub').each(function(){
                            this.checked = false;
                        });
                    }
                });
            });
            </script>
    </script>
@endsection