<div class="card">
    <div class="card-body">
        @if ($pathway_det)
            <form action="{{ route('studentlog.preferences.save') }}" method="post" enctype="multipart/form-data">
                @csrf
                <input type="hidden" id="course" name="course" value="{{ encrypt($course) }}">
                <input type="hidden" id="sem_id" name="sem_id" value="{{ encrypt($semester_id) }}">
                <div class="row">
                    <div class="col-12 text-center">
                        <div class="form-group">
                            <h4>PATHWAY : {{ $pathway_det?->pathwayName->pathway }}</h4>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12 col-md-4">
                        <div class="form-group">
                            <label for="sgpa" class="required">Previous Percentage</label>
                            <input type="text" class="form-control @error('sgpa') border-danger @enderror" id="sgpa" name="sgpa" value="{{ isset($studminorI_first) ? $studminorI_first->sgpa : '' }}" required>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12 col-md-4">
                        <div class="form-group">
                            <label for="minorI2">DSC B - Minor I</label>
                            <select class="js-example-basic-single form-control" id="minorI2" name="minorI2" style="width:100%">
                                <option value="">Select</option>
                                @foreach($minorIsub as $minI)
                                    <option value="{{ $minI->subject_id  }}" {{ isset($studminorI_first) && $studminorI_first->pref_Id==$minI->subject_id  ? "selected":"" }}>{{ $minI->subject_code.' - '.$minI->subject_name }}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                    <div class="col-12 col-md-4">
                        <div class="form-group">
                            <label for="minorI2">DSC C - Minor II</label>
                            <select class="js-example-basic-single form-control" id="minorII2" name="minorII2" style="width:100%">
                                <option value="">Select</option>
                                @foreach($minorIIsub as $minII)
                                    <option value="{{ $minII->subject_id  }}" {{ isset($studminorII_first) && $studminorII_first->pref_Id==$minII->subject_id  ? "selected":"" }}>{{ $minII->subject_code.' - '.$minII->subject_name }}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                    <div class="col-12 col-md-4">
                        <div class="form-group">
                            <label for="mdcI2">MDC I</label>
                            <select class="js-example-basic-single form-control" id="mdcI2" name="mdcI2" style="width:100%">
                                <option value="">Select</option>
                                @foreach($mdcIsub as $mdcI)
                                    <option value="{{ $mdcI->subject_id  }}" {{ isset($studmdcI_first) && $studmdcI_first->pref_Id==$mdcI->subject_id  ? "selected":"" }}>{{ $mdcI->subject_code.' - '.$mdcI->subject_name }}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <div class="form-group">
                            <button type="submit" class="btn btn-success float-right">Submit</button>
                        </div>
                    </div>
                </div>
            </form>
        @else
            <div class="alert alert-danger"><h4>Please Set Pathway !</h4></div>
        @endif
    </div>
</div>

<!--
<div class="card" style="border-top:3px solid #004170">
    <div class="card-body">
     <div align="right">
   @if ($pathway_det)
   <form action="{{ route('studentlog.preferences.save') }}" method="post" enctype="multipart/form-data" class="styled-form">
    @csrf
    <input type="hidden" id="course" name="course" value="{{ encrypt($course) }}">
    <input type="hidden" id="sem_id" name="sem_id" value="{{ encrypt($semester_id) }}">
    <div class="form-header">
   
  
    <table width="100%"><tr><td>
    <b>PATHWAY : {{ $pathway_det->pathwayName->pathway}}</b></td></tr></table> </div>
    <hr>
    <div class="row">
        <div class="col-md-3">
            <div class="form-group">
                <label for="sgpa" class="required"><b>Previous Percentage</b></label>
                <input type="text" class="form-control @error('sgpa') border-danger @enderror" id="sgpa" name="sgpa" value="{{ isset($studminorI_first) ? $studminorI_first->sgpa : '' }}" required>
            </div>
        </div>
    </div>
    
     <div class="preferences-section">
    <h5 class="section-title">Minor I Preferences</h5>
                            <div class="row">
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="minorI2"><b>Minor I(DSC A) [1'st Preference]</b></label>
                                     <select class="form-control" id="minorI2" name="minorI2">
                                        <option value="">Select</option>
                                         @foreach($minorIsub as $minI)
                                            <option value="{{ $minI->subject_id  }}" {{ isset($studminorI_first) && $studminorI_first->pref_Id==$minI->subject_id  ? "selected":"" }}>{{ $minI->subject_code.' - '.$minI->subject_name }}</option>
                                              @endforeach
                                     </select>
                                </div>
                            </div>
                            
                            
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="minorI_prefII2"><b>Minor I(DSC A) [2'nd Preference]</b></label>
                                     <select class="form-control" id="minorI_prefII2" name="minorI_prefII2">
                                        <option value="">Select</option>
                                          @foreach($minorIsub as $minI)
                                            <option value="{{ $minI->subject_id  }}" {{ isset($studminorI_second) && $studminorI_second->pref_Id==$minI->subject_id  ? "selected":"" }}>{{ $minI->subject_code.' - '.$minI->subject_name }}</option>
                                              @endforeach
                                     </select>
                                </div>
                            </div>
                            
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="minorI_prefIII2"><b>Minor I(DSC A) [3'rd Preference]</b></label>
                                     <select class="form-control" id="minorI_prefIII2" name="minorI_prefIII2">
                                        <option value="">Select</option>
                                          @foreach($minorIsub as $minI)
                                            <option value="{{ $minI->subject_id  }}" {{ isset($studminorI_third) && $studminorI_third->pref_Id==$minI->subject_id  ? "selected":"" }}>{{ $minI->subject_code.' - '.$minI->subject_name }}</option>
                                              @endforeach
                                     </select>
                                </div>
                            </div>
                            
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="minorI_prefIV2"><b>Minor I(DSC A) [4'th Preference]</b></label>
                                     <select class="form-control" id="minorI_prefIV2" name="minorI_prefIV2">
                                        <option value="">Select</option>
                                          @foreach($minorIsub as $minI)
                                            <option value="{{ $minI->subject_id  }}" {{ isset($studminorI_four) && $studminorI_four->pref_Id==$minI->subject_id  ? "selected":"" }}>{{ $minI->subject_code.' - '.$minI->subject_name }}</option>
                                              @endforeach
                                     </select>
                                </div>
                            </div>
                        </div>
                        <br>
                       <div class="row">
                         <div class="col-md-3">
                                <div class="form-group">
                                    <label for="minorI_prefV2"><b>Minor I(DSC A) [5'th Preference]</b></label>
                                     <select class="form-control" id="minorI_prefV2" name="minorI_prefV2">
                                        <option value="">Select</option>
                                          @foreach($minorIsub as $minI)
                                            <option value="{{ $minI->subject_id  }}" {{ isset($studminorI_five) && $studminorI_five->pref_Id==$minI->subject_id  ? "selected":"" }}>{{ $minI->subject_code.' - '.$minI->subject_name }}</option>
                                              @endforeach
                                     </select>
                                </div>
                            </div>
                        </div>
                        
                       
                        <h5 class="section-title">Minor II Preferences</h5>
                            <div class="row">
                           
                           
                           
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="minorII2"><b>Minor II(DSC B) [1'st Preference]</b></label>
                                     <select class="form-control" id="minorII2" name="minorII2">
                                        <option value="">Select</option>
                                         @foreach($minorIIsub as $minII)
                                        <option value="{{ $minII->subject_id  }}" {{ isset($studminorII_first) && $studminorII_first->pref_Id==$minII->subject_id  ? "selected":"" }}>{{ $minII->subject_code.' - '.$minII->subject_name }}</option>
                                          @endforeach
                                     </select>
                                </div>
                            </div>
                            
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="minorII_prefII2"><b>Minor II(DSC B) [2'nd Preference]</b></label>
                                     <select class="form-control" id="minorII_prefII2" name="minorII_prefII2">
                                        <option value="">Select</option>
                                         @foreach($minorIIsub as $minII)
                                        <option value="{{ $minII->subject_id  }}" {{ isset($studminorII_second) && $studminorII_second->pref_Id==$minII->subject_id  ? "selected":"" }}>{{ $minII->subject_code.' - '.$minII->subject_name }}</option>
                                          @endforeach
                                     </select>
                                </div>
                            </div>
                            
                            
                              
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="minorII_prefIII2"><b>Minor II(DSC B) [3'rd Preference]</b></label>
                                     <select class="form-control" id="minorII_prefIII2" name="minorII_prefIII2">
                                        <option value="">Select</option>
                                         @foreach($minorIIsub as $minII)
                                        <option value="{{ $minII->subject_id  }}" {{ isset($studminorII_third) && $studminorII_third->pref_Id==$minII->subject_id  ? "selected":"" }}>{{ $minII->subject_code.' - '.$minII->subject_name }}</option>
                                          @endforeach
                                     </select>
                                </div>
                            </div>    
                                
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="minorII_prefIV2"><b>Minor II(DSC B) [4'th Preference]</b></label>
                                     <select class="form-control" id="minorII_prefIV2" name="minorII_prefIV2">
                                        <option value="">Select</option>
                                         @foreach($minorIIsub as $minII)
                                        <option value="{{ $minII->subject_id  }}" {{ isset($studminorII_four) && $studminorII_four->pref_Id==$minII->subject_id  ? "selected":"" }}>{{ $minII->subject_code.' - '.$minII->subject_name }}</option>
                                          @endforeach
                                     </select>
                                </div>
                            </div>
                        </div>
                       
                        
                        
                           <div class="row">
                                
                            
                          
                                
                          
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="minorII_prefV2"><b>Minor II(DSC B) [5'th Preference]</b></label>
                                     <select class="form-control" id="minorII_prefV2" name="minorII_prefV2">
                                        <option value="">Select</option>
                                         @foreach($minorIIsub as $minII)
                                        <option value="{{ $minII->subject_id  }}" {{ isset($studminorII_five) && $studminorII_five->pref_Id==$minII->subject_id  ? "selected":"" }}>{{ $minII->subject_code.' - '.$minII->subject_name }}</option>
                                          @endforeach
                                     </select>
                                </div>
                            </div>
                            
                         
                        </div>
                        
                        
                         <br>
                        
                        <h5 class="section-title">MDC I Preferences</h5>
                            <div class="row">
                                
                                 <div class="col-md-3">
                                <div class="form-group">
                                    <label for="mdcI2"><b>MDC I [1'st Preference]</b></label>
                                     <select class="form-control" id="mdcI2" name="mdcI2">
                                        <option value="">Select</option>
                                          @foreach($mdcIsub as $mdcI)
                                            <option value="{{ $mdcI->subject_id  }}" {{ isset($studmdcI_first) && $studmdcI_first->pref_Id==$mdcI->subject_id  ? "selected":"" }}>{{ $mdcI->subject_code.' - '.$mdcI->subject_name }}</option>
                                              @endforeach
                                     </select>
                                </div>
                            </div>
                            
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="mdcI_prefII2"><b>MDC I [2'nd Preference]</b></label>
                                     <select class="form-control" id="mdcI_prefII2" name="mdcI_prefII2">
                                        <option value="">Select</option>
                                          @foreach($mdcIsub as $mdcI)
                                            <option value="{{ $mdcI->subject_id  }}" {{ isset($studmdcI_second) && $studmdcI_second->pref_Id==$mdcI->subject_id  ? "selected":"" }}>{{ $mdcI->subject_code.' - '.$mdcI->subject_name }}</option>
                                              @endforeach
                                     </select>
                                </div>
                            </div>
                                
                                
                               <div class="col-md-3">
                                    <div class="form-group">
                                       <label for="mdcI_prefIII2"><b>MDC I [3'rd Preference]</b></label>
                                         <select class="form-control" id="mdcI_prefIII2" name="mdcI_prefIII2">
                                            <option value="">Select</option>
                                              @foreach($mdcIsub as $mdcI)
                                                <option value="{{ $mdcI->subject_id  }}" {{ isset($studmdcI_third) && $studmdcI_third->pref_Id==$mdcI->subject_id  ? "selected":"" }}>{{ $mdcI->subject_code.' - '.$mdcI->subject_name }}</option>
                                                  @endforeach
                                         </select>
                                    </div>
                                </div>
                                <div class="col-md-3">
                                    <div class="form-group">
                                       <label for="mdcI_prefIV2"><b>MDC I [4'th Preference]</b></label>
                                         <select class="form-control" id="mdcI_prefIV2" name="mdcI_prefIV2">
                                            <option value="">Select</option>
                                              @foreach($mdcIsub as $mdcI)
                                                <option value="{{ $mdcI->subject_id  }}" {{ isset($studmdcI_four) && $studmdcI_four->pref_Id==$mdcI->subject_id  ? "selected":"" }}>{{ $mdcI->subject_code.' - '.$mdcI->subject_name }}</option>
                                                  @endforeach
                                         </select>
                                    </div>
                                </div>
                                <div class="col-md-3">
                                    <div class="form-group">
                                       <label for="mdcI_prefV2"><b>MDC I [5'th Preference]</b></label>
                                         <select class="form-control" id="mdcI_prefV2" name="mdcI_prefV2">
                                            <option value="">Select</option>
                                              @foreach($mdcIsub as $mdcI)
                                                <option value="{{ $mdcI->subject_id  }}" {{ isset($studmdcI_five) && $studmdcI_five->pref_Id==$mdcI->subject_id  ? "selected":"" }}>{{ $mdcI->subject_code.' - '.$mdcI->subject_name }}</option>
                                                  @endforeach
                                         </select>
                                    </div>
                                </div>
                                
                            </div>
                      
                        </div>
                        
                        <div class="row">
                            <div class="col-md-12">
                                <div class="form-group">
                                    <button type="submit" class="btn btn-primary float-right">Submit</button>
                                </div>
                            </div>
                        </div>
                    
    
    
    
    </form>
    @else
     <div class="alert alert-warning" align="center">
                        <strong><font color="red" size="5">Please Set Pathway!</font></strong>
                    </div>
    @endif
    </div>
    </div>
    <style>
    .styled-form {
        border: 2px solid #004170;
        padding: 20px;
        border-radius: 10px;
        background: #f9f9f9;
        box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
    }

    .form-header {
        font-size: 18px;
        margin-bottom: 10px;
    }

    .section-title {
        background-color: #004170;
        color: white;
        padding: 10px;
        border-radius: 5px;
        font-size: 16px;
        margin-bottom: 15px;
        text-align:left;
    }

    .form-group {
        margin-bottom: 15px;
    }

    .form-footer {
        margin-top: 20px;
    }

    .form-footer .btn {
        font-size: 16px;
        padding: 10px 20px;
    }
</style>-->
<script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
