@extends('layouts.template')
@section('title','Home')
@section('heading',' Import Student Details')
@section('breadcrumb','Home/Student/Import Student Details')
@section('content')
   @if(session('error'))
    <div class="alert alert-danger">
        {{ session('error') }}
    </div>
@endif

        <form action="{{ route('importstudent.save') }}" method="post" enctype="multipart/form-data">
        @csrf
        <div class="row">
        <div class="col-lg-12 grid-margin stretch-card">
        <div class="card">
        <div class="card-header" style="background-color:#005A9C;color:white;"><b>Select the Criteria</b></div>
        <div class="card-body">
                                <div class="row">
                                <div class="col-md-3">
                                <div class="form-group">
                                <label for="ac_id" class="required"><b>Academic Year</b></label>
                                <select class="form-control" id="ac_id" name="ac_id" required>
                                <option value="">Select</option>
                                @foreach($acyears as $acyear)
                                <option value="{{ $acyear->ac_id }}" {{ old('ac_id')==$acyear->ac_id ? "selected":"" }}>{{ $acyear->start_date_formatted.' - '.$acyear->end_date_formatted }}</option>
                                @endforeach
                                </select>
                                @error('ac_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                       
                       
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="course_id" class="required"><b>Program</b></label>
                                    <select class="form-control" id="course_id" name="course_id" required>
                                         <option value="">Select</option>
                                        @foreach($course as $crs)
                                            <option value="{{ $crs->course_id}}" {{ old('course_id')==$crs->course_id ? "selected":"" }}>{{ $crs->course_name }}</option>
                                        @endforeach
                                    </select>
                                    @error('course_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            
                            
                            <div class="col-md-3">
    <div class="form-group">
    <label for="semester_id" class="required"><b>Semester</b></label>
    <select class="form-control" id="semester_id" name="semester_id" required>
    </select>
    @error('semester_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
    </div>
    </div>
                             
                            <!-- <div class="col-md-3">-->
                            <!--    <div class="form-group">-->
                            <!--        <label for="category_id" class="required"><b>Fee Category</b></label>-->
                            <!--        <select class="form-control" id="category_id" name="category_id" required>-->
                            <!--            <option value="">Select</option>-->
                            <!--            @foreach($categories as $category)-->
                            <!--                <option value="{{ $category->category_id }}" {{ old('category_id')==$category->category_id ? "selected":"" }}>{{ $category->category_name }}</option>-->
                            <!--            @endforeach-->
                            <!--        </select>-->
                            <!--        @error('category_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror-->
                            <!--    </div>-->
                            <!--</div>-->
                            
                       
                            <div class="col-md-3">
                            <div class="form-group">
                                    <label for="evidence"><b>Excel File</b></label>
                                    <input type="file"  id="exl" name="exl">
                                    @error('exl')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                            </div>
                            </div> 
                            
                            </div>
                            <div class="row">
                            <div class="col-md-12">
                            <div class="form-group">
                            <button type="submit" class="btn btn-primary float-right" style="display: inline-block;">Upload</button>
                            </div>
                            </div>
                            </div>
                            </div>
        </div>
        </div>
        </div>
        </form>
            <div class="row">
            <div class="col-lg-12 grid-margin stretch-card fld-form" width="100%">
            <div class="card over-flow">
                    <div class="card-header" style="background-color:#004170;color:white;"><b>Excel File Format</b></div>
                    <div class="card-body" style="background-color:white">
                    <a style="float:center" href="{{ route('importstudent.download') }}"class="tip" data-original-title='Sample Excel Sheet'><i class="fas fa-file-excel" style="font-size:30px" ></i>  
                        <span class="text-danger fw-bold">Sample File</span></a>
                        <div class="div_scroller">
                        <table class="table table-bordered" id="tableex" width="100%" style="">
                        <tr style="white-space:nowrap;background-color:silver">
                        <thead style="background-color: #FEBE10">
                        <th></th>
<th>A</th>
<th>B</th>
<th>C</th>
<th>D</th>
<th>E</th>
<th>F</th>
<th>G</th>
<th>H</th>
<th>I</th>
<th>J</th>
<th>K</th>
<th>L</th>
<th>M</th>
<th>N</th>
<th>O</th>
<th>P</th>
<th>Q</th>
<th>R</th>
<th>S</th>
<th>T</th>
<th>U</th>
<th>V</th>
<th>W</th>
<th>X</th>
<th>Y</th>
<th>Z</th>
<th>AA</th>
<th>AB</th>
<th>AC</th>
<th>AD</th>
<th>AE</th>
<th>AF</th>
<th>AG</th>
<th>AH</th>
<th>AI</th>
<th>AJ</th>
<th>AK</th>
<th>AL</th>
<th>AM</th>
</thead>
</tr>
<tr style="white-space:nowrap;">
<th>1</th>
<th>Admission No</th>
<th>Admission Date <br>(dd-mm-YYYY)</th>
<th>ABC ID</th>
<th>ID Card No</th>
<th>Name</th>
<th>Gender </th>
<th>Date Of Birth <br>(dd-mm-YYYY)</th>
<th>Address</th>
<th>Mobile</th>
<th>Email ID</th>
<th>Aadhar No</th>
<th>Linked to Aadhar</th>
<th>Religion</th>
<th>Community</th>
<th>Caste</th>
<th>Father Name</th>
<th>Mother Name</th>
<TH>Fee Category</TH>
<th>Plus Two</th>
<th>Degree</th>
<th>NSS or NCC</th>
<th>ARTS or SPORTS</th>
<th>Second Language</th>
<th>Pathway</th>
<th>MinorI Title</th>
<th>MinorI Code</th>
<th>MinorI Credit</th>
<th>MinorII Title</th>
<th>MinorII Code</th>
<th>MinorII Credit</th>
<th>MDC Title</th>
<th>MDC Code</th>
<th>MDC Credit</th>
<th>AEC I Title</th>
<th>AEC I Code</th>
<th>AEC I Credit</th>
<th>AEC II Title</th>
<th>AEC II Code</th>
<th>AEC II Credit</th>

</tr>
 <tr>
<td>2</td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
</tr>
</table> 
<br>
<br>
<h5>Format-Specific Options:</h5>
<ul>
<li>The first line of the file contains the column names or an empty row</li>
<li>The second line of the file contains the part of the data</li>
<li>Do not import empty rows</li>
<li>Class name field must be same as you entered in this software</li>
<li>Excel date format : <span class="red"> dd-mm-YYYY  </span>, Language :  <span class="red">English (United Kingdom) </span></li>
</ul>

</div>
                        
                        
                        </div>
                        </div>
                        </div>
                        </div>
    
    
    
    
    
    
    
    <script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
    <script src="{{ asset('public/js/sem.js') }}"></script> 
    <style>
     
                .card-body{
            border-left:1px solid #DCDCDC;
            border-right:1px solid #DCDCDC;
            border-bottom:1px solid #DCDCDC;
            
        }
#tableex th,
         #tableex td{
             border:1px solid #B8B8B8;
         }
            .div_scroller{
    	overflow:auto; 
    	scrollbar-width: initial; /* Make the scrollbar thinner */
    scrollbar-color: #888 #f1f1f1; /* thumb color and track color */
      }     
    </style>
    
   
    
    
@endsection