@extends('layouts.template')
@section('title','Home')
@section('heading','Promotion')
@section('breadcrumb','Home/Student/Promotion')
@section('content')



    <div class="row">
        <div class="col-lg-12 grid-margin stretch-card">
            <div class="card">
                <div class="card-header" style="background: #005A9C;color:white;">
                    <b>Select the Criteria</b>
                </div>
                <div class="card-body">
                    <form action="{{ route('promote.get') }}" method="post">
                        @csrf
                        <div class="row">
                            <div class="col-md-4">
                                <label for="course_id" class="required"><b>Program</b></label>
                                <div class="form-group">
                                    <select class="form-control" id="course_id" name="course_id" required>
                                        <option value="">Select</option>
                                        @foreach($courses as $course)
                                            <option value="{{ $course->course_id }}" {{ old('course_id')==$course->course_id ? "selected":"" }}>{{ $course->course_name }}</option>
                                        @endforeach
                                    </select>
                                    @error('course_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            <div class="col-md-8">
                                <label for="semester_id" class="required"><b>Semester</b></label>
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <select class="form-control" id="semester_id" name="semester_id">
                                                <option value="">Select</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <button type="submit" class="btn btn-primary" name="action" value="btnget">Get Details</button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    
    
    
    
    
    <script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
    <script src="{{ asset('public/js/promote.js') }}"></script>
    <style>
        .card-body{
            border-left:1px solid #DCDCDC;
            border-right:1px solid #DCDCDC;
            border-bottom:1px solid #DCDCDC;
          
        }

    </style>
@endsection