@extends('layouts.template')
@section('title','Student Profile')
@section('heading','Student Profile')
@section('breadcrumb','Home / Search Student / Profile')
@section('content')
    <div class="card">
        <div class="card-body">
            <div class="row">
                <div class="col-12 col-sm-3">
                    <div class="form-group text-center">
                        @php $photo = $student->photo ?? 'student.png'; @endphp
                        <img class="rounded-circle image-fluid" src="{{ asset('public/uploads/student/photo/'.$photo) }}" alt="Profile image" height="120px">
                    </div>
                </div>
                <div class="col-12 col-sm-4">
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Adm No. </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger">{{ $student->adno }}</span></label>
                    </div>
                     <div class="form-group row">
                        <label class="col-5 col-sm-3">Roll No. </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger">{{ $student->rollno }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Name </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger">{{ strtoupper($student->name) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Mobile </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger">{{ $student->mobile }}</span></label>
                    </div>
                </div>
                <div class="col-12 col-sm-4">
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Major 1 </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger">{{ $student->course->course_name }}</span></label>
                    </div>
                    @if($student->major_ii)
                        <div class="form-group row">
                            <label class="col-5 col-sm-3">Major 2 </label>
                            <label class="col-7 col-sm-9">: <span class="text-danger">{{ $student->majorii->course_name }}</span></label>
                        </div>
                    @endif
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Semester </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger">{{ $promote->semester->semester_name }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Email </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger">{{ $student->email }}</span></label>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <br>
    <div class="row">
        <div class="col-12">
            <div class="row">
                <div class="col-12 col-sm-4 col-lg-3">
                    <div class="form-group">
                        <a href="{{ route('searchstudent.get.view', ['student_id' => encrypt($student->student_id)])}}" style="text-decoration:none;"><span type="button" class="btn btn-sm btn-block btn-danger">PROFILE</span></a>
                    </div>
                </div>
                @if($user->staftyp_id!=1)
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="{{ route('searchstudent.payment',['student_id'=>encrypt($student->student_id)])}}" style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">PAYMENTS</span></a>
                        </div>
                    </div>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="{{ route('searchstudent.feereport',['student_id'=>encrypt($student->student_id)])}}" style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">FEE REPORT</span></a>
                        </div>
                    </div>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="{{ route('searchstudent.duereport',['student_id'=>encrypt($student->student_id)])}}" style="text-decoration:none"> <span type="button" class="btn btn-sm btn-block btn-success">DUE REPORT</span></a>
                        </div>
                    </div>
                @endif
                <div class="col-12 col-sm-4 col-lg-3">
                    <div class="form-group">
                        <a href="{{ route('searchstudent.attendance',['student_id'=>encrypt($student->student_id)])}}"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">ATTENDANCE REPORT</span></a>
                    </div>
                </div>
                 <div class="col-12 col-sm-4 col-lg-3">
                    <div class="form-group">
                        <a href="{{ route('searchstudent.changepathway.view',['student_id'=>encrypt($student->student_id)])}}"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">CHANGE PATHWAY</span></a>
                    </div>
                </div>
                @if($student->ac_id >= 6)
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="{{ route('searchstudent.fyexam.report',['student_id'=>encrypt($student->student_id)])}}"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">PROGRESS REPORT-FYUGP</span></a>
                        </div>
                    </div>
                @else
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="{{ route('searchstudent.exam.report',['student_id'=>encrypt($student->student_id)])}}"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">PROGRESS REPORT</span></a>
                        </div>
                    </div>
                @endif
                @if($user->staftyp_id!=1)
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="{{ route('searchstudent.hostel.payment',['student_id'=>encrypt($student->student_id)])}}"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">HOSTEL FEE PAYMENT</span></a>
                        </div>
                    </div>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="{{ route('searchstudent.hostel.payment.report',['student_id'=>encrypt($student->student_id)])}}"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">HOSTEL FEE REPORT</span></a>
                        </div>
                    </div>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="{{ route('searchstudent.hostel.payment.duereport',['student_id'=>encrypt($student->student_id)])}}"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">HOSTEL DUE REPORT</span></a>
                        </div>
                    </div>
                @endif
                <div class="col-12 col-sm-4 col-lg-3">
                    <div class="form-group">
                        <a href="{{ route('searchstudent.library.due',['student_id'=>encrypt($student->student_id)])}}"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">BOOK ISSUE REPORT</span></a>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="card card-primary">
        <div class="card-header">Personal Information</div>
        <div class="card-body">
            <div class="row">
                <div class="col-12 col-sm-6">
                    <div class="form-group row">
                        <label class="col-5">Gender </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->gender) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Permanent Address </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->paddress) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Communication Address </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->caddress) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Mobile </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->mobile }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Email </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->email }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Aadhar No </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->aadhar }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Date of Birth </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->dob_formatted }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Blood Group </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->bgroup) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Religion </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->religion?->religion_name) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Community </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->community?->community) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Caste </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->caste?->caste) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">APL/BPL </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->pline }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Annual Income </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->income }}</span></label>
                    </div>
                </div>
                <div class="col-12 col-sm-6">
                    <div class="form-group row">
                        <label class="col-5">Father's Name </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->fname) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Father's Mobile </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->fmobile }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Father's Occupation </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->foccupation) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Mother's Name </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->mname) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Mother's Occupation </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->moccupation) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Guardian Name </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->gname) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Guardian Address </label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->gaddress) }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Guardian Mobile </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->gmobile }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Day Scholar </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->dscholar }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">NCC/NSS </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->ncc_nss }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">ABC ID </label>
                        <label class="col-7">: <span class="text-danger">{{ $student->abc_id }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Arts/Sports</label>
                        <label class="col-7">: <span class="text-danger">{{ strtoupper($student->arts_sports) }}</span></label>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <br>
    <div class="card card-primary">
        <div class="card-header">Academic Information</div>
        <div class="card-body">
            <div class="row">
                <div class="col-12 col-sm-6">
                    <div class="form-group row">
                        <label class="col-5">Institution Last Studied</label>
                        <label class="col-7">: <span class="text-danger">{{ $student->lastinst }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Program Last Studied</label>
                        <label class="col-7">: <span class="text-danger">{{ $student->lastcourse }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Year of Study</label>
                        <label class="col-7">: <span class="text-danger">{{ $student->lastyear }}</span></label>
                    </div>
                </div>
                <div class="col-12 col-sm-6">
                    <div class="form-group row">
                        <label class="col-5">SSLC Marks (%)</label>
                        <label class="col-7">: <span class="text-danger">{{ $student->sslc }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Plus Two Marks (%)</label>
                        <label class="col-7">: <span class="text-danger">{{ $student->plustwo }}</span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5">Degree Marks (%)</label>
                        <label class="col-7">: <span class="text-danger">{{ $student->degree }}</span></label>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection