@extends('layouts.template')
@section('title','Home')
@section('heading','Edit Staff Details')
@section('breadcrumb','Home')
@section('content')

 <link href="{{ asset('public/css/custom.css') }}">


    <form action="{{ route('user.update') }}" method="post" enctype="multipart/form-data">
                        @csrf
                        <div class="row">
        <div class="col-lg-12 grid-margin stretch-card">
            <div class="card">
                <div class="card-header" style="background: #005A9C;color:white;"><b>Edit Staff Details</b></div>
                <div class="card-body">
                        <input type="hidden" name="user_id" value="{{ encrypt($user->user_id) }}"> 
                        <div class="row">
                            <div class="col-md-3">
                              <div class="form-group">  
                               @if ($user->image)
                               <img src="{{ asset('public/uploads/staff/photo/' . $user->image) }}" alt="User Image" class="img-thumbnail" style="width: 150px; height: 150px;">
                                @else
                                 @php $uphoto ="image_1720437570.png"; @endphp
                                <img src="{{ asset('public/uploads/staff/photo/' . $uphoto) }}" alt="User Image" class="img-thumbnail" style="width: 150px; height: 150px;">
                                @endif
                              </div>  
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="staftyp_id" class="required">Staff Type</label>
                                    <select class="js-example-basic-single form-control" id="stype_id" name="staftyp_id" required style="width:100%;border:1px solid #E0E0E0;">
                                        <option value="">Select</option>
                                        @foreach($stafftyp as $stafftyps)
                                            <option value="{{ $stafftyps->staftyp_id  }}" {{ $user->staftyp_id==$stafftyps->staftyp_id ? "selected":"" }}>{{ $stafftyps->type_name }}</option>
                                        @endforeach
                                    </select>
                                    @error('staftyp_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>    
                            
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="type_id" class="required"><b>Designation</b></label>
                                    <select class="js-example-basic-single" id="type_id" name="type_id" required style="width:100%">
                                        <option value="">Select</option>
                                        @foreach($utypes as $utype)
                                            <option value="{{ $utype->type_id }}" {{ $user->type_id==$utype->type_id ? "selected":"" }}>{{ $utype->type_name }}</option>
                                        @endforeach
                                    </select>
                                    @error('type_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="employee_id_num" class="required">Employee ID</label>
                                    <input type="text" class="form-control" id="employee_id_num" placeholder="Employee ID" name="employee_id_num" value="{{$user->employee_id_num}}">
                                    @error('employee_id_num')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div> 
                            
                            </div>
                            <div class="row">
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="working_type" class="required">Working Type</label>
                                    <div class="row">
                                        <div class="col-md-6">
                                            <div class="form-check form-check-success">
                                                <label class="form-check-label"><input type="radio" class="form-check-input" id="permanent" name="working_type" value="permanent" {{ $user->working_type =='permanent' ? "checked":"" }}> Permanent </label>
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="form-check form-check-success">
                                                <label class="form-check-label"><input type="radio" class="form-check-input" id="temporary" name="working_type" value="temporary" {{ $user->working_type =='temporary' ? "checked":"" }}> Temporary </label>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            
                              <div class="col-md-3">
                                <div class="form-group">
                                    <label for="name" class="required"><b>First Name</b></label>
                                    <input type="text" class="form-control" id="name" name="name" value="{{ $user->name }}" required autocomplete="off">
                                    @error('name')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="lname">Last Name</label>
                                    <input type="text" class="form-control" id="lname" name="lname" placeholder="Last Name" value="{{ $user->lname }}">
                                    @error('lname')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            
                              <div class="col-md-3">
                                <div class="form-group">
                                    <label for="father_guardian">Father/Spouse</label>
                                    <input type="text" class="form-control" id="father_guardian" name="father_guardian" placeholder="Father/Spouse" value="{{$user->father_guardian }}">
                                    @error('father_guardian')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                          
                            </div>
                           <div class="row">
                         
                              <div class="col-md-3">
                                    <div class="form-group">
                                         <label for="dob">Date of Birth</label>  
                                        <input type="date" class="form-control" id="dob"  name="dob" value="{{ $user->dob }}" autocomplete="off">
                                        @error('dob')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                    </div>
                                </div> 
                                
                                  <div class="col-md-3">
                                <div class="form-group">
                                     <label for="text" class="required">Age</label>  
                                    <input type="age" class="form-control" id="age"  name="age" value="{{ $user->age }}" placeholder="Age" required autocomplete="off">
                                    @error('age')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div> 
                            
                              <div class="col-md-3">
                                <div class="form-group">
                                    <label for="blood_group">Blood Group</label>  
                                    <input type="text" class="form-control" id="blood_group"  name="blood_group" value="{{ $user->blood_group }}" placeholder="Blood Group" autocomplete="off">
                                    @error('blood_group')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="address">Address</label>
                                    <textarea class="form-control" id="address" name="address" placeholder="Address">{{ $user->address }}</textarea>
                                    @error('address')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div> 
                            
                            </div> 
                            
                            <div class="row">
                                
                            
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="male" class="required">Gender</label>
                                    <div class="row">
                                        <div class="col-md-6">
                                            <div class="form-check form-check-success">
                                                <label class="form-check-label"><input type="radio" class="form-check-input" id="male" name="gender" value="male" {{ $user->gender=='male' ? "checked":"" }}> Male </label>
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="form-check form-check-success">
                                                <label class="form-check-label"><input type="radio" class="form-check-input" id="female" name="gender" value="female" {{ $user->gender=='female' ? "checked":"" }}> Female </label>
                                            </div>
                                        </div>
                                    </div>
                                </div>    
                            </div>
                            
                            
                              <div class="col-md-3">
                                <div class="form-group">
                                    <label for="phy_handi">Physically Handicapped<br>(if yes,furnish details)</label>
                                    <div class="row">
                                        <div class="col-md-3">
                                            <div class="form-check form-check-success">
                                                <label class="form-check-label"><input type="radio" class="form-control hand @error('phy_handi') border-danger @enderror" id="textCheckbox" name="phy_handi" style="height:15px;width:15px"  value="yes" {{$user->phy_handi=='yes' ? "checked":"" }}> yes </label>
                                            </div>
                                        </div>
                                        <div class="col-md-3">
                                            <div class="form-check form-check-success">
                                                <label class="form-check-label"><input type="radio" class="form-control hand @error('phy_handi') border-danger @enderror"  name="phy_handi"  style="height:15px;width:15px"  value="no" {{$user->phy_handi=='no' ? "checked":"" }}> no </label>
                                            </div>
                                        </div>
                                    </div>
                                    <textarea name="phyhandi_det" id="textBox" class="form-control" style="display:none;">{{$user->phyhandi_det}}</textarea>
                                </div>
                            </div>
                            
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="mother_tongue">Mother Tongue</label>
                                    <input type="text" class="form-control" id="mother_tongue" name="mother_tongue" value="{{ $user->mother_tongue}}" required autocomplete="off">
                                    @error('mother_tongue')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="nationality">Nationality</label>
                                    <input type="text" class="form-control" id="nationality" name="nationality" value="{{ $user->nationality }}" required autocomplete="off">
                                    @error('nationality')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div> 
                            
                            </div>
                            
                            
                           
                          
                               
                            
                          
                          <div class="row">
                             
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="state">State</label>
                                    <input type="text" class="form-control" id="state" name="state" value="{{ $user->state }}" required autocomplete="off">
                                    @error('state')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>   
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="dateof_join" class="required">Date of Joining</label>
                                    <input type="date" class="form-control" id="dateof_join" name="dateof_join" value="{{ $user->dateof_join }}" required autocomplete="off">
                                    @error('dateof_join')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>   
                            
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="email_id"><b>Email ID</b></label>
                                    <input type="email" class="form-control" id="email" name="email" value="{{ $user->email }}" required autocomplete="off">
                                    @error('email')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="dept_id" class="required">Department</label>
                                    <select class="js-example-basic-single form-control" id="dept_id" name="dept_id" style="width:100%;border:1px solid #E0E0E0;">
                                        <option value="">Select</option>
                                        @foreach($dept as $depts)
                                            <option value="{{ $depts->id  }}" {{ $user->dept_id==$depts->id ? "selected":"" }}>{{ $depts->dept_name }}</option>
                                        @endforeach
                                    </select>
                                    @error('dept_id')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>    
                            
                           
                        </div>
                           
                            <div class="row">
                              <div class="col-md-3">
                                <div class="form-group">
                                    <label for="qualification" class="required">Qualification</label>
                                    <input type="text" class="form-control @error('qualification') border-danger @enderror" id="qualification" placeholder="Qualification" name="qualification" value="{{ $user->qualification }}" autocomplete="off">
                                    @error('qualification')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                             <div class="col-md-3">
                                <div class="form-group">
                                    <label for="experience">Experience</label>
                                    <input type="text" class="form-control @error('experience') border-danger @enderror" id="experience" placeholder="Experience" name="experience" value="{{ $user->experience }}" autocomplete="off">
                                    @error('experience')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            
                                
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="mobile"><b>Mobile</b></label>
                                    <input type="text" class="form-control" id="mobile" name="mobile" value="{{ $user->mobile }}" required autocomplete="off">
                                    @error('mobile')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            
                              <div class="col-sm-3">
                                <div class="form-group">
                                    <label for="status" >Status</label>
                                    <div>
                                      <div class="custom-control custom-checkbox checkbox-success d-inline-block mr-3 mb-3">
                                                <input type="checkbox" class="custom-control-input" id="status" name="status" {{ $user->status==1 ? "checked":"" }} value="1">
                                                <label class="custom-control-label" for="status"><b>Active</b></label>
                                      </div>
                                    </div>
                                </div>
                            </div>
                              
                            
                        </div>
                        
                        <div class="row">
                             
                          
                            
                           
                            
                            
                        </div>
                        
                        
                         </div>
            </div>
        </div>
    </div>
    
                        
                        
                        
                        <div class="row">
                        <div class="col-lg-12 grid-margin stretch-card">
                            <div class="card">
                                <div class="card-header" style="background:#004170;color:white;"><b>Qualification Details</b></div>
                                    <div class="card-body">
                                    <div class="row">
                                        <div class="col-md-3">
                                            <div class="form-group">
                                                <label for="net_qualified" class="required">1. Net Qualified</label>
                                                <div class="row">
                                                    <div class="col-md-3">
                                                        <div class="form-check form-check-success">
                                                            <label class="form-check-label"><input type="radio" class="form-check-input" id="yes" name="net_qualified" value="yes" {{ $user->net_qualified == 'yes' ? "checked":"" }}> Yes </label>
                                                        </div>
                                                    </div>
                                                    <div class="col-md-3">
                                                        <div class="form-check form-check-success">
                                                            <label class="form-check-label"><input type="radio" class="form-check-input" id="no" name="net_qualified" value="no" {{ $user->net_qualified == 'no' ? "checked":"" }}> No </label>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>    
                                        </div>
                                        
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label for="doing_research" class="required">2. Doing Research</label>
                                            <div class="row">
                                                <div class="col-md-3">
                                                    <div class="form-check form-check-success">
                                                        <label class="form-check-label"><input type="radio" class="form-check-input" id="yes" name="doing_research" value="yes" {{ $user->doing_research == 'yes' ? "checked":"" }}> Yes </label>
                                                    </div>
                                                </div>
                                                <div class="col-md-3">
                                                    <div class="form-check form-check-success">
                                                        <label class="form-check-label"><input type="radio" class="form-check-input" id="no" name="doing_research" value="no" {{ $user->doing_research == 'no' ? "checked":"" }}> No </label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>    
                                    </div>
                                        
                                    </div>
                            @foreach($staff_qualifdet as $qualif)       
                                    <div class="row">
                            <div class="col-md-2">
                                <div class="form-group">
                                    <label for="qualificationloop">Qualification</label>
                                    <input type="text" class="form-control @error('qualificationloop') border-danger @enderror" placeholder="Qualification" value="{{$qualif->qualificationloop}}" id="qualificationloop" name="qualificationloop[]" autocomplete="off">
                                    @error('qualificationloop')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            <div class="col-md-2">
                                <div class="form-group">
                                    <label for="institute">Institute</label>
                                    <input type="text" class="form-control @error('institute') border-danger @enderror" id="institute" placeholder="Institute" value="{{$qualif->institute}}" name="institute[]" autocomplete="off">
                                    @error('institute')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            <div class="col-md-2">
                                <div class="form-group">
                                    <label for="uni_board">University/Board</label>
                                    <input type="text" class="form-control @error('uni_board') border-danger @enderror" id="uni_board" placeholder="University/Board" value="{{$qualif->uni_board}}" name="uni_board[]" autocomplete="off">
                                    @error('uni_board')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            <div class="col-md-2">
                                <div class="form-group">
                                    <label for="mark_grade">Mark/Grade</label>
                                    <input type="text" class="form-control @error('mark_grade') border-danger @enderror" id="mark_grade" placeholder="Mark/Grade" value="{{$qualif->mark_grade}}" name="mark_grade[]" autocomplete="off">
                                    @error('mark_grade')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                            <div class="col-md-4">
                                <label for="passotyr">Pass out Year</label>
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <input type="text" class="form-control @error('passotyr') border-danger @enderror" id="passotyr" placeholder="Pass out Year" value="{{$qualif->passotyr}}"  name="passotyr[]" autocomplete="off">
                                            @error('passotyr')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <button type="button" class="btn btn-sm btn-success"  id="addquali"><i class="icon icon-plus"></i></button>
                                        </div>
                                    </div>
                                    
                                     </div>
                            </div>
                        </div>
                        @endforeach
                        <div id="moreappend"></div> 
                                    
                                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-lg-12 grid-margin stretch-card">
                <div class="card">
                    <div class="card-header" style="background:#004170;color:white"><b>Uploads</b></div>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="biodata" >Biodata</label>
                                    <input type="file" class=" @error('biodata') border-danger @enderror" id="biodata" name="biodata" autocomplete="off">
                                    @error('biodata')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                                @php $furl = asset('public/uploads/staff/biodata/'.$user->biodata); @endphp
                                @if($user->biodata)
                                    <a href="{{$furl}}" target="_blank"><u>Download Biodata</u></a>
                                    @endif
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="image" >Upload Photo</label>
                                    <input type="file" class="@error('image') border-danger @enderror" id="image" name="image" autocomplete="off">
                                    @error('image')<div class="text-daborder-danger small mt-1 text-danger">{{ $message }}</div>@enderror
                                </div>
                            </div>
                           
                           
                        </div>
                    </div>               
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div class="form-group">
                    <button type="submit" class="btn btn-primary float-right">Update</button>
                </div>
            </div>
        </div>
                       
            </form>
               
    
    
   
    <style>
    .form-control{
            border:1px solid #E0E0E0;
            
             background-color:white;
        }
         .card-body{
            border-left:1px solid #DCDCDC;
            border-right:1px solid #DCDCDC;
            border-bottom:1px solid #DCDCDC;

          
        }
    </style>
     <script src="{{ asset('public/template/plugins/jquery/jquery.min.js') }}"></script>
    <script src="{{ asset('public/js/user/add.js') }}"></script>
@endsection