
<?php $__env->startSection('title','Report'); ?>
<?php $__env->startSection('heading','Report'); ?>
<?php $__env->startSection('breadcrumb','Home / Library / Report'); ?>
<?php $__env->startSection('content'); ?>
    <div class="card">
        <div class="card-body">
            <div class="row">
                <div class="col-12 col-md-3">
                    <div class="form-group">
                        <label for="mtype">Member Type</label>
                        <select class="js-example-basic-single form-control" id="mtype">
                            <option value="">All</option>
                            <?php $__currentLoopData = $types; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $type): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                <option value="<?php echo e($type->id); ?>"><?php echo e($type->member_type); ?></option>
                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                        </select>
                    </div>
                </div>
                <div class="col-12 col-md-3">
                    <div class="form-group">
                        <label for="member">Member</label>
                        <select class="js-example-basic-single form-control" id="member">
                            <option value="">Select</option>
                        </select>
                    </div>
                </div>
                <div class="col-12 col-md-3">
                    <div class="form-group">
                        <label for="book">Book</label>
                        <select class="js-example-basic-single form-control" id="book">
                            <option value="">Select</option>
                        </select>
                    </div>
                </div>
                <div class="col-12 col-md-3">
                    <div class="form-group">
                        <label for="status">Status</label>
                        <select class="js-example-basic-single form-control" id="status">
                            <option value="">All</option>
                            <option value="Issued">Issued</option>
                            <option value="Returned">Returned</option>
                        </select>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12 col-md-3">
                    <div class="form-group">
                        <label for="ifdate">Issue Date From</label>
                        <input type="date" class="form-control" id="ifdate">
                    </div>
                </div>
                <div class="col-12 col-md-3">
                    <div class="form-group">
                        <label for="itdate">Issue Date To</label>
                        <input type="date" class="form-control" id="itdate">
                    </div>
                </div>
                <div class="col-12 col-md-3">
                    <div class="form-group">
                        <label for="dfdate">Due Date From</label>
                        <input type="date" class="form-control" id="dfdate">
                    </div>
                </div>
                <div class="col-12 col-md-3">
                    <div class="form-group">
                        <label for="dtdate">Due Date To</label>
                        <input type="date" class="form-control" id="dtdate">
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12 col-md-3">
                    <div class="form-group">
                        <label for="rfdate">Return Date From</label>
                        <input type="date" class="form-control" id="rfdate">
                    </div>
                </div>
                <div class="col-12 col-md-3">
                    <div class="form-group">
                        <label for="rtdate">Return Date To</label>
                        <input type="date" class="form-control" id="rtdate">
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <button type="button" class="btn btn-sm btn-success float-right" id="filter">Filter</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <br>
    <div class="card">
        <div class="card-body">
            <table class="table table-bordered" id="reportTable" width="100%">
                <thead>
                <tr>
                    <th>Member No</th>
                    <th>Member</th>
                    <th>Book</th>
                    <th>Author</th>
                    <th>Issue Date</th>
                    <th>Due Date</th>
                    <th class="no-sort">Fine</th>
                    <th>Return Date</th>
                    <th>Status</th>
                </tr>
                </thead>
                <tbody>
                </tbody>
            </table>
        </div>
    </div>
    <script src="<?php echo e(asset('public/js/library/report.js')); ?>"></script>
    <script>
        $(function () {
            var reportTable = $("#reportTable").DataTable({
                lengthChange: true,
                lengthMenu: [ [10, 50, 100, 500, -1], [10, 50, 100, 500, 'All'],],
                scrollX: true,
                searching: true,
                processing : true,
                serverSide : true,
                stateSave : true,
                columnDefs : [
                    { targets: 'no-sort', orderable: false },
                    { targets: [0, 4, 5, 6, 7, 8], className: 'text-center' }
                ],
                ajax : {
                    url : '<?php echo e(route('library.report.ajax')); ?>',
                    dataType : 'json',
                    type : 'GET',
                    data: function(data){
                        data.mtype = $('#mtype').val(),
                        data.member = $('#member').val(),
                        data.book = $('#book').val(),
                        data.status = $('#status').val(),
                        data.ifdate = $('#ifdate').val();
                        data.itdate = $('#itdate').val();
                        data.dfdate = $('#dfdate').val();
                        data.dtdate = $('#dtdate').val();
                        data.rfdate = $('#rfdate').val();
                        data.rtdate = $('#rtdate').val();
                    }
                },
                columns : [
                    { data : 'mno' },
                    { data : 'member' },
                    { data : 'book' },
                    { data : 'author' },
                    { data : 'issue' },
                    { data : 'due' },
                    { data : 'fine' },
                    { data : 'return' },
                    { data : 'status' },
                ]
            });
            
            $('#filter').click(function(){
                reportTable.draw();
            });
            
            $('#export').click(function(){
                var category = $('#category').val();
                var subcategory = $('#subcategory').val();
                var location = $('#location').val();
                var sublocation = $('#sublocation').val();
                var skey = $('#skey').val();
                
                window.location = '/library/book/export?category='+category+'&subcategory='+subcategory+'&location='+location+'&sublocation='+sublocation+'&skey='+skey;
            });
        });
    </script>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('layouts.template', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/relents/public_html/brennencollege.relents.in/resources/views/library/issue/report.blade.php ENDPATH**/ ?>