<!DOCTYPE html>
<html>
<head>
    <title>College Feedback Report From Student</title>
    <style>
         body {
            font-family: Arial, sans-serif;
            border: 1px solid #000;
            padding: 20px;
            overflow-x: auto; 
        }
       
        .page-header {
            text-align: center;
            margin-bottom: 20px;
        }

        table {
            width: 100%; 
            border-collapse: collapse; 
            table-layout: fixed; 
        }

        th, td {
           
            padding: 3px; 
            text-align: center;
            word-wrap: break-word; 
        }

        thead {
            background-color: #fed35c;
        }

        h4 {
            margin-top: 20px;
        }

    </style>
</head>
<body>
    <div>
    <div class="container">
      <div class="page-header"> 
      <p style="text-center"><b><?php echo e($ins_det->name); ?></b></p>
      <p style="text-center"><b><?php echo e($ins_det->affiliation); ?></b></p>
      <p style="text-center"><b><?php echo e($ins_det->address); ?></b></p>
      <p style="text-center"><b><?php echo e('Ph : '.$ins_det->mobile.' '.$ins_det->landline); ?></b></p>
    </div> 
    </div>
    
    <div class="page-header">
        <h4 align="center">COLLEGE EVALUATION REPORT FROM STUDENTS</h4>
        <h4 align="center">ACADEMIC YEAR <?php echo e($currentAcademicYear); ?></h4>
    </div>
      <div class="content">
    <hr>
        <div class="row">
            <div class="col-md-12">
                 <table class="table table-bordered" style="border:1px solid black;">
                            <thead style="background-color:#fed35c;">
                               
                                <tr>
                                    <th  width="10%"><b>#</b></th>
                                    <th  width="20%" style="word-wrap: break-word; word-break: break-all; white-space: normal;"><b>FEEDBACK CRITERIA</b></th>
                                    <th  width="10%" style="word-wrap: break-word; word-break: break-all; white-space: normal;"><b>OUTSTANDING</b></th>
                                    <th  width="10%"  style="word-wrap: break-word; word-break: break-all; white-space: normal;"><b>VERY GOOD</b></th>
                                    <th width="10%"   style="word-wrap: break-word; word-break: break-all; white-space: normal;"><b>GOOD</b></th>
                                    <th  width="10%"  style="word-wrap: break-word; word-break: break-all; white-space: normal;"><b>AVERAGE</b></th>
                                    <th  width="10%" style="word-wrap: break-word; word-break: break-all; white-space: normal;"><b>TOTAL RESPONSE</b></th>
                                    <th   width="10%" style="word-wrap: break-word; word-break: break-all; white-space: normal;"><b>TOTAL GRADE POINT</b></th>
                                    <th  width="10%"  style="word-wrap: break-word; word-break: break-all; white-space: normal;"><b>TYPICAL SCORE</b></th>
                                    
                                </tr>
                            </thead>
                             <tbody>
                <?php
     $gradePoints = [
    'Outstanding' =>  5.0,
    'Very Good' => 3.5,
    'Good' => 3.0,
    'Average' => 2.0,
];
  $totalGradePoints = 0;


$totalResponses = 0; 
$i=1;
                ?>
                <?php $__currentLoopData = $criteriaWithSubcriteria; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $criteria): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                    <?php $__currentLoopData = $criteria['subcriteria']; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $subcriterion): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                        <!--<h5 style="margin-top: 20px;"><?php echo e($subcriterion->sub_criteria); ?></h5>-->
                       
                                 
                                <?php
                                    $outstanding = $criteria['ratingCounts'][$subcriterion->sub_criteria]['Outstanding'] ?? 0;
                                    $veryGood = $criteria['ratingCounts'][$subcriterion->sub_criteria]['Very Good'] ?? 0;
                                    $good = $criteria['ratingCounts'][$subcriterion->sub_criteria]['Good'] ?? 0;
                                    $average = $criteria['ratingCounts'][$subcriterion->sub_criteria]['Average'] ?? 0;
                                    $total = $outstanding + $veryGood + $good + $average;
                                    
                                    $gradePointsTotal = (
                                        ($outstanding * $gradePoints['Outstanding']) +
                                        ($veryGood * $gradePoints['Very Good']) +
                                        ($good * $gradePoints['Good']) +
                                        ($average * $gradePoints['Average'])
                                    );
                                    $totalGradePoints += $gradePointsTotal;
                                    $totalResponses += $total;
                                ?>
                                <tr>
                                    <td width="10%"><?php echo e($i++); ?></td>
                                    <td width="20%" style="word-wrap: break-word; word-break: break-all; white-space: normal;"><?php echo e(strtoupper($subcriterion->sub_criteria)); ?></td>
                                    <td width="10%"><?php echo e($outstanding); ?></td>
                                    <td width="10%" ><?php echo e($veryGood); ?></td>
                                    <td width="10%" ><?php echo e($good); ?></td>
                                    <td width="10%"><?php echo e($average); ?></td>
                                    <td width="10%"><?php echo e($total); ?></td> 
                                    <td width="10%"><?php echo e($gradePointsTotal); ?></td>
                                    <td width="10%">
                        <?php if($total > 0): ?>
                            <?php echo e(number_format($gradePointsTotal / $total, 2)); ?>

                        <?php else: ?>
                            0.00
                        <?php endif; ?>
                    </td>
                                </tr>
                               
                            
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                </tbody>
                        </table>
            <h4 class="mt-4" STYLE="background:#fed35c"><b>Cumulative Grade Point Average (CGPA): </b>
                    <?php if($totalResponses > 0): ?>
                        <?php echo e(number_format($totalGradePoints / $totalResponses, 2)); ?> / 5.00
                    <?php else: ?>
                        0.00 / 5.00
                    <?php endif; ?>
                </h4>
            </div>
            
        </div>
        </div>
          </body>
    </html><?php /**PATH /home/relents/public_html/brennencollege.relents.in/resources/views/feedback/college_feedback_pdf.blade.php ENDPATH**/ ?>