
<?php $__env->startSection('title','Home'); ?>
<?php $__env->startSection('heading','Book Issue Report'); ?>
<?php $__env->startSection('breadcrumb','Home/Search Student/Book Issue Report'); ?>
<?php $__env->startSection('content'); ?>
    <div class="card">
        <div class="card-body">
            <div class="row">
                <div class="col-12 col-sm-3">
                    <div class="form-group text-center">
                        <?php $photo = $student->photo ?? 'student.png'; ?>
                        <img class="rounded-circle image-fluid" src="<?php echo e(asset('public/uploads/student/photo/'.$photo)); ?>" alt="Profile image" height="120px">
                    </div>
                </div>
                <div class="col-12 col-sm-4">
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Adm No. </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger"><?php echo e($student->adno); ?></span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Roll No. </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger"><?php echo e($student->rollno); ?></span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Name </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger"><?php echo e(strtoupper($student->name)); ?></span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Mobile </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger"><?php echo e($student->mobile); ?></span></label>
                    </div>
                </div>
                <div class="col-12 col-sm-4">
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Major 1 </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger"><?php echo e($student->course->course_name); ?></span></label>
                    </div>
                    <?php if($student->major_ii): ?>
                        <div class="form-group row">
                            <label class="col-5 col-sm-3">Major 2 </label>
                            <label class="col-7 col-sm-9">: <span class="text-danger"><?php echo e($student->majorii->course_name); ?></span></label>
                        </div>
                    <?php endif; ?>
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Semester </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger"><?php echo e($promote->semester->semester_name); ?></span></label>
                    </div>
                    <div class="form-group row">
                        <label class="col-5 col-sm-3">Email </label>
                        <label class="col-7 col-sm-9">: <span class="text-danger"><?php echo e($student->email); ?></span></label>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <br>
    <div class="row">
        <div class="col-12">
            <div class="row">
                <div class="col-12 col-sm-4 col-lg-3">
                    <div class="form-group">
                        <a href="<?php echo e(route('searchstudent.get.view', ['student_id' => encrypt($student->student_id)])); ?>" style="text-decoration:none;"><span type="button" class="btn btn-sm btn-block btn-success">PROFILE</span></a>
                    </div>
                </div>
                <?php if($user->staftyp_id!=1): ?>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="<?php echo e(route('searchstudent.payment',['student_id'=>encrypt($student->student_id)])); ?>" style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">PAYMENTS</span></a>
                        </div>
                    </div>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="<?php echo e(route('searchstudent.feereport',['student_id'=>encrypt($student->student_id)])); ?>" style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">FEE REPORT</span></a>
                        </div>
                    </div>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="<?php echo e(route('searchstudent.duereport',['student_id'=>encrypt($student->student_id)])); ?>" style="text-decoration:none"> <span type="button" class="btn btn-sm btn-block btn-success">DUE REPORT</span></a>
                        </div>
                    </div>
                <?php endif; ?>
                <div class="col-12 col-sm-4 col-lg-3">
                    <div class="form-group">
                        <a href="<?php echo e(route('searchstudent.attendance',['student_id'=>encrypt($student->student_id)])); ?>"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">ATTENDANCE REPORT</span></a>
                    </div>
                </div>
                 <div class="col-12 col-sm-4 col-lg-3">
                    <div class="form-group">
                        <a href="<?php echo e(route('searchstudent.changepathway.view',['student_id'=>encrypt($student->student_id)])); ?>"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">Change Pathway</span></a>
                    </div>
                </div>
                <?php if($student->ac_id >= 6): ?>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="<?php echo e(route('searchstudent.fyexam.report',['student_id'=>encrypt($student->student_id)])); ?>"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">PROGRESS REPORT-FYUGP</span></a>
                        </div>
                    </div>
                <?php else: ?>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="<?php echo e(route('searchstudent.exam.report',['student_id'=>encrypt($student->student_id)])); ?>"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">PROGRESS REPORT</span></a>
                        </div>
                    </div>
                <?php endif; ?>
                <?php if($user->staftyp_id!=1): ?>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="<?php echo e(route('searchstudent.hostel.payment',['student_id'=>encrypt($student->student_id)])); ?>"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">HOSTEL FEE PAYMENT</span></a>
                        </div>
                    </div>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="<?php echo e(route('searchstudent.hostel.payment.report',['student_id'=>encrypt($student->student_id)])); ?>"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">HOSTEL FEE REPORT</span></a>
                        </div>
                    </div>
                    <div class="col-12 col-sm-4 col-lg-3">
                        <div class="form-group">
                            <a href="<?php echo e(route('searchstudent.hostel.payment.duereport',['student_id'=>encrypt($student->student_id)])); ?>"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-success">HOSTEL DUE REPORT</span></a>
                        </div>
                    </div>
                <?php endif; ?>
                <div class="col-12 col-sm-4 col-lg-3">
                    <div class="form-group">
                        <a href="<?php echo e(route('searchstudent.library.due',['student_id'=>encrypt($student->student_id)])); ?>"  style="text-decoration:none"><span type="button" class="btn btn-sm btn-block btn-danger">BOOK ISSUE REPORT</span></a>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <?php if($membership): ?>
        <div class="card">
            <div class="card-body">
                <div class="scroll">
                    <table class="table table-bordered" id="reportTable" width="100%">
                        <thead>
                        <tr>
                            <th>Book No</th>
                            <th>Book Title</th>
                            <th>Author</th>
                            <th>Issue Date</th>
                            <th>Return Date</th>
                            <th>Returned Date</th>
                            <th class="no-sort">Fine</th>
                            <th>Status</th>
                        </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        <script src="<?php echo e(asset('public/template/plugins/jquery/jquery.min.js')); ?>"></script>
        <script src="<?php echo e(asset('public/js/semester.js')); ?>"></script>
        <script>
            $(function () {
                var memberId = '<?php echo e($membership->id); ?>'; 
                var reportTable = $("#reportTable").DataTable({
                    lengthChange: true,
                    scrollX: true,
                    searching: true,
                    processing : true,
                    serverSide : true,
                    columnDefs : [{ targets: 'no-sort', orderable: false }],
                    ajax : {
                        url: '<?php echo e(route('searchstudent.book.duereport.get')); ?>', 
                        data: { memberId : memberId },
                        dataType : 'json',
                        type : 'GET',
                    },
                    columns : [
                        { data : 'book_no' },
                        { data : 'title' },
                        { data : 'author' },
                        { data : 'issue' },
                        { data : 'due' },
                        { data : 'return' },
                        { data : 'fine' },
                        { data : 'status' },
                    ]
                });
                
                $('#getData').click(function(){
                    reportTable.draw();
                });
            });
        </script>
    <?php else: ?>
        <div class="alert alert-danger">Membership not Found !</div>
    <?php endif; ?>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('layouts.template', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/relents/public_html/govtcollegecalicut.relents.in/resources/views/students/searchlibrary.blade.php ENDPATH**/ ?>