<style>
    * {
        font-family: Arial, sans-serif;
    }
    .container {
        width: 100%;
        text-align: center;
    }
    .id-card {
        padding: 20px;
        width: 350px;
        margin: auto;
        border-radius: 10px;
        background: #fff;
        box-shadow: 0 4px 10px rgba(0, 0, 0, 0.1);
    }
    .header {
        background: maroon;
        padding: 5px;
        border-radius: 10px 10px 0 0;
        color: #FFFF00;
    }
    .header h2 {
        margin: 0;
        font-size: 20px;
    }
    .photo {
        margin-bottom: 10px;
    }
    .staff-details {
        text-align: center;
        margin: 10px 0;
    }
    .staff-info {
        margin-top: 10px;
        font-size: 14px;
        text-align: center; /* Centering the content */
    }
    .signature-table {
        width: 100%;
        margin-top: 5px; 
    }
    .footer {
        background: maroon; 
        color: #FFFF00; 
        padding: 10px; 
        margin-top: 20px; 
        font-size: 12px; 
        border-radius: 0 0 10px 10px;
    }
</style>

<body onload="print()">
    <div class="container">
        <div class="id-card">
            <div class="header">
                <h2>IDENTITY CARD</h2>
            </div>
            <table width="100%" style="background:#FFFFF0">
                <tr>
                    <td width="25%" rowspan="4" align="center" style="vertical-align: middle;">
                        <img src="<?php echo e(asset('public/uploads/logo/'.$ins_det->logo)); ?>" alt="<?php echo e($ins_det->logo); ?>" height="30px">
                    </td>
                    <td width="50%" align="center" style="font-weight: bold; font-size: 15px;"><?php echo e($ins_det->name); ?></td>
                    <td width="25%" rowspan="3" align="center"></td>
                </tr>
                <tr>
                    <td align="center" style="font-size: 13px;"><?php echo e($ins_det->affiliation); ?></td>
                </tr>
                <tr>
                    <td align="center" style="font-size: 13px;"><?php echo e($ins_det->address); ?></td>
                </tr>
            </table>
            <br>
           
            <div class="staff-details">
                <div class="photo">
                    <img src="<?php echo e(asset('public/uploads/student/photo/'.$student->photo)); ?>" alt="<?php echo e($student->photo); ?>" height="150px" width="150px" style="border: 1px solid #000;">
                </div>
                <div class="staff-info">
                    <div><b><span style="font-size:20px"><?php echo e(strtoupper($student->name)); ?></span></b></div>
                    <div><b><span style="font-size:18px"><?php echo e($student->adno); ?></span></b></div>
                    <table style="margin: auto;"> 
                        <tr>
                            <td style="text-align: left;">Program</td>
                            <td style="text-align: left;">: <?php echo e(strtoupper($student->course_code)); ?></td>
                        </tr>
                        <tr>
                            <td style="text-align: left;">Blood Group</td>
                            <td style="text-align: left;">: <?php echo e(strtoupper($student->blood_group)); ?></td>
                        </tr>
                        <tr>
                            <td style="text-align: left;">Phone</td>
                            <td style="text-align: left;">: <?php echo e($student->phone); ?></td>
                        </tr>
                    </table>
                </div>
            </div>
            <div>
                <br>
                <table class="signature-table" style="width: 100%;">
                    <tr>
                        <td style="text-align: left; vertical-align: bottom;">
                            <img src="<?php echo e(asset('public/uploads/student/signature/common_sig.png')); ?>" alt="<?php echo e($student->signature); ?>" height="20px" width="50px">
                            <div style="text-align: left; font-size: 12px;">Holder's Signature</div>
                        </td>
                        <td style="text-align: right; vertical-align: bottom;">
                            <img src="<?php echo e(asset('public/uploads/staff/signature/auth.png')); ?>" alt="<?php echo e($student->authorised_signature); ?>" height="20px" width="50px">
                            <div style="text-align: right; font-size: 12px;">Authorised Signature</div>
                        </td>
                    </tr>
                </table>
            </div>
            <div class="footer">
                &copy; <?php echo e(date('Y')); ?> <?php echo e($ins_det->name); ?> | All rights reserved
            </div>
        </div>
    </div>
</body>
<?php /**PATH /home/relents/public_html/govtcollegecalicut.relents.in/resources/views/idcard/idcard_print_student.blade.php ENDPATH**/ ?>