
<?php $__env->startSection('title','Department Time Table'); ?>
<?php $__env->startSection('heading','Department Time Table'); ?>
<?php $__env->startSection('breadcrumb','Home / Time Table / Department'); ?>
<?php $__env->startSection('content'); ?>
    <style>
        .timetable {
            text-transform: uppercase;
            text-align: center;
            align-items: center;
            font-size: 13px;
        }
        .tt-row{
            display: flex;
            gap: 10px;
        }
        .tt-block {
            flex: 1 1 calc(100% / 7);
        }
        .tt-period {
            background-color: #2D2870;
            color: #FFF;
            font-weight: 700;
            padding: 10px 15px;
            border-radius: 10px;
            margin: 5px 0;
        }
        .tt-day {
            background-color: #DC4F4B;
            color: #FFF;
            font-weight: 700;
            padding: 10px 15px;
            border-radius: 10px;
            margin: 5px 0;
            height: auto;
            min-height: 180px;
            align-items: center;
        }
        .tt-content {
            background-color: #F1FAEE;
            border-radius: 10px;
            margin: 5px 0;
            padding: 5px;
            height: auto;
            min-height: 180px;
        }
        .tt-item {
            background-color: #c7e9ff;
            border-radius: 5px;
            margin: 3px 0;
        }
        .tt-item:hover {
            cursor: pointer;
        }
        .tt-inter {
            background-color: #eec7ff;
        }
        .tt-category {
            font-weight: 600;
        }
        .tt-user {
            
        }
        .tt-button {
            background-color: green;
            color: #FFF;
            padding: 2px 10px;
            border: 0px;
            border-radius: 5px;
        }
        
        @media (max-width: 480px) {
            .tt-row{
                gap: 5px;
            }
            .tt-block {
                flex: 1 1 100%;
            }
        }
    </style>
    <div class="card">
        <div class="card-body">
            <form method="get">
                <div class="row">
                    <div class="col-12 col-sm-8">
                        <div class="form-group">
                            <label for="department" class="required">Department</label>
                            <div class="row">
                                <div class="col-12 col-sm-6">
                                    <div class="form-group">
                                        <select class="form-control" id="department" name="department" required>
                                            <option value="">Select</option>
                                            <?php $__currentLoopData = $departments; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $department): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                                <option value="<?php echo e($department->id); ?>" <?php echo e($department->id==$departmentId ? 'selected':''); ?>><?php echo e($department->dept_name); ?></option>
                                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                        </select>
                                        <?php $__errorArgs = ['department'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?><div class="text-daborder-danger small mt-1 text-danger"><?php echo e($message); ?></div><?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                    </div>
                                </div>
                                <div class="col-12 col-sm-6">
                                    <div class="form-group">
                                        <button type="submit" class="btn btn-sm btn-success">Submit</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
    <?php if(!empty($data)): ?>
        <br>
        <div class="card">
            <div class="card-body">
                <div class="row">
                    <div class="col-12 text-center">
                        <h4><?php echo e($depart ? $depart->dept_name . ' DEPARTMENT' : ''); ?></h4>
                    </div>
                </div>
                <div class="timetable">
                    <div class="tt-row">
                        <div class="tt-block">
                            <div class="tt-head"></div>
                        </div>
                        <?php $__currentLoopData = $periods; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $period): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                            <div class="tt-block">
                                <div class="tt-period"><?php echo e($period->period); ?></div>
                            </div>
                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    </div>
                    <?php $__currentLoopData = $days; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $day): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                        <div class="tt-row">
                            <div class="tt-block">
                                <div class="tt-day"><?php echo e($day->day); ?></div>
                            </div>
                            <?php $__currentLoopData = $periods; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $period): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                <div class="tt-block">
                                    <div class="tt-content">
                                        <?php if(!empty($data[$day->day][$period->id])): ?>
                                            <?php $__currentLoopData = $data[$day->day][$period->id]; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $detail): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                                <div class="tt-item">
                                                    <div><?php echo e($detail['semester']); ?></div>
                                                    <div class="tt-category">
                                                        <?php echo e($detail['category']); ?>

                                                        <?php if($detail['type']==1): ?> 
                                                            <?php echo e(' - PR'); ?>

                                                        <?php endif; ?>
                                                    </div>
                                                    <div class="tt-user">
                                                        <?php if($detail['group']!=''): ?>
                                                            <?php echo e($detail['group'].' - '); ?>

                                                        <?php endif; ?>
                                                        <?php echo e($detail['scode']); ?>

                                                    </div>
                                                </div>
                                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                        </div>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                </div>
                <br>
                <div class="row">
                    <?php $__currentLoopData = $staffs; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $staff): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                        <div class="col-12 col-sm-4">
                            <div class="form-group">
                                <span class="text-danger"><?php echo e(strtoupper($staff->code)); ?> : </span><?php echo e(strtoupper($staff->name)); ?>

                            </div>
                        </div>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                </div>
            </div>
        </div>
    <?php endif; ?>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('layouts.template', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/relents/public_html/govtcollegecalicut.relents.in/resources/views/fyugp/timetable/department.blade.php ENDPATH**/ ?>